<?php 
defined('_JEXEC') or die();

/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v2.0
 * @author		Joomlabamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

$doc = JFactory::getDocument();



	/**
	 * Non-google font array
	 *
	 * Zen Grid Framework v1.1
	 *  I'm sure this can be improved but cuts down on code used in 1.1.
	 */

	$nongoogle = array('Cambria, Georgia, Times, Times New Roman, serif',
	'Adobe Caslon Pro, Georgia, Garamond, Times, serif',
	'Courier new, Courier, Andale Mono',
	'Garamond, ‘Times New Roman’, Times, serif',
	'Georgia, Times, ‘Times New Roman’, serif', 
	'GillSans, Calibri, Trebuchet, arial sans-serif', 
	'Helvetica Neue, Helvetica, Arial, sans-serif',
	'Lucida Grande, Geneva, Helvetica, sans-serif', 
	'Palatino, ‘Times New Roman’, serif', 
	'Tahoma, Verdana, Geneva',
	'Trebuchet ms, Tahoma, Arial, sans-serif,',
	'------------------- Standard ---------------------',
	'--------------------- Serif ---------------------',
	'------------------- Sans Serif -------------------',
	'------------------- Handwriting -------------------',
	'------------------- Display -------------------',
	'sans-serif'
	);
	
	
	// Sets a default value for the fonstackbody, fontstacknav etc
	$fsb = 1;
	$fsn = 1;
	$fsh = 1;
	$fsc1 = 1;
	$fsc2 = 1;
	$fsc3 = 1;
	$fsl = 1;
	
	
	$gfonts = array();
	
	if(in_array($fontStackBody, $nongoogle)) { 
		$fontStackRBody = "";
		$fsb=0;
	} else {
		$gfonts[] = "'$fontStackBody'";
	}
	
	if(in_array($fontStackNav, $nongoogle)) { 
		$fontStackRNav = "";
		$fsn=0;
	} else {
		$gfonts[] = "'$fontStackNav'";
	}
		
	if(in_array($fontStackHeading, $nongoogle)) { 
		$fontStackRHeading = "";
		$fsh = 0;
	} else {
		$gfonts[] = "'$fontStackHeading'";
	}
		
	if(in_array($fontStackCustom1, $nongoogle)) { 
		$fontStackRCustom1 = "";
		$fsc1 = 0;
	} else {
		$gfonts[] = "'$fontStackCustom1'";
	}
		
	if(in_array($fontStackCustom2, $nongoogle)) { 
		$fontStackRCustom2 = "";
		$fsc2 = 0;
	} else {
		$gfonts[] = "'$fontStackCustom2'";
	}
		
	if(in_array($fontStackCustom3, $nongoogle)) { 
		$fontStackRCustom3 = "";
		$fsc3 = 0;
	} else {
		$gfonts[] = "'$fontStackCustom3'";
	}
	
	if(in_array($fontStackLogo, $nongoogle)) { 
		$fontStackRLogo = "";
		$fsl = 0;
	} else {
		$gfonts[] = "'$fontStackLogo'";
	}
	
	$lastfont = end($gfonts);
	
	$googlefonts = $fsb + $fsn +$fsh + $fsc1 + $fsc2 + $fsc3 + $fsl;


	// Font name clean up for body tag so we dont have , and spaces in the body class.
	if(in_array($fontStackBody, $nongoogle)) { 
		$fontStackBody = explode(',', $fontStackBody);
		$fontStackBody = str_replace(' ','', ''.$fontStackBody[0].'');
	}


	/**
 	* Clean up the font names and make them suitable for css files
 	*
 	* Zen Grid Framework v2.2
 	*  
 	*/

	$fontCssreplaceBody =  str_replace('+',' ', ''.$this->params->get("fontStackBody").'');
	$fontCssreplaceNav =  str_replace('+',' ', ''.$this->params->get("fontStackNav").'');
	$fontCssreplaceHeading =  str_replace('+',' ', ''.$this->params->get("fontStackHeading").'');
		
	if ($logoType =="text") {
		$fontCssreplaceLogo =  str_replace('+',' ', ''.$this->params->get("fontStackLogo").'');
		$fontStackLogo =  str_replace('+','', ''.$this->params->get("fontStackLogo").'');
	}
	elseif ($logoType =="image") {
		$fontCssreplaceLogo ="";	
	}
	
	

	// ------------------------------------------------------------------------  

	/**
	 * The css rules based on logic above
	 *
	 * Zen Grid Framework v1.1
	 *  
	 */
	$fontStackBody[1];
	$fontOutput ="";
	if($fontStackBody[1] !=="-") $fontOutput .= "body,span.$fontStackBody {font-family: $fontCssreplaceBody }";
	if($fontStackHeading[1] !=="-")  $fontOutput .=  "h1,h2,h3,h4, h5,h6,.blockquote, .componentheading, .contentheading {font-family:  $fontCssreplaceHeading}";
	if($fontStackNav[1] !=="-") $fontOutput .= "#nav, .moduletable-superfish,.moduletable-menu,#togglemenu  {font-family: $fontCssreplaceNav}";

	if ($logoType =="text" && $fontStackLogo[1] !=="-") {
		$fontOutput .= "#logo $logoClass a.$fontStackLogo,#logo $logoClass a span.$fontStackLogo  {font-family: $fontCssreplaceLogo;font-size: $logoFontSize}";
	}
		
	
	if($fontStackSelector1 !=="" && $fontStackCustom1[1] !=="-") {
		$fontStackCustom1 = str_replace('+',' ', ''.$fontStackCustom1.'');
		$fontOutput .= "$fontStackSelector1 {font-family: $fontStackCustom1}";
	}
	
	if($fontStackSelector2 !=="" && $fontStackCustom2[1] !=="-") {
		$fontStackCustom2 = str_replace('+',' ', ''.$fontStackCustom2.'');
		$fontOutput .= "$fontStackSelector2 {font-family: $fontStackCustom2}";
	}
	if($fontStackSelector3 !=="" && $fontStackCustom3[1] !=="-") {
		$fontOutput .= "$fontStackSelector3 {font-family: $fontStackCustom3}";
		$fontStackCustom3 = str_replace('+',' ', ''.$fontStackCustom3.'');
	}
	

	/**
	 * Creates the font.css file
	 *
	 * Zen Grid Framework v1.1
	 *  
	 */


 	JFile::write(JPATH_ROOT.'/media/zengridframework/css/fonts.css', $fontOutput); ?>