# ************************************************************
# Sequel Pro SQL dump
# Version 3408
#
# http://www.sequelpro.com/
# http://code.google.com/p/sequel-pro/
#
# Host: localhost (MySQL 5.5.9)
# Database: qs17_Shopignition
# Generation Time: 2012-04-05 05:06:19 +0000
# ************************************************************


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


# Dump of table #__assets
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__assets`;

CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__assets` WRITE;
/*!40000 ALTER TABLE `#__assets` DISABLE KEYS */;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`)
VALUES
	(1,0,1,418,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(2,1,1,2,1,'com_admin','com_admin','{}'),
	(3,1,3,6,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(4,1,7,8,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(5,1,9,10,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(6,1,11,12,1,'com_config','com_config','{}'),
	(7,1,13,16,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(8,1,17,20,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
	(9,1,21,22,1,'com_cpanel','com_cpanel','{}'),
	(10,1,23,24,1,'com_installer','com_installer','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1},\"core.delete\":[],\"core.edit.state\":[]}'),
	(11,1,25,26,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(12,1,27,28,1,'com_login','com_login','{}'),
	(13,1,29,30,1,'com_mailto','com_mailto','{}'),
	(14,1,31,32,1,'com_massmail','com_massmail','{}'),
	(15,1,33,34,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),
	(16,1,35,36,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(17,1,37,38,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(18,1,39,40,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(19,1,41,44,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(20,1,45,46,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(21,1,47,48,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),
	(22,1,49,50,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
	(23,1,51,52,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(24,1,53,54,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.own\":{\"6\":1},\"core.edit.state\":[]}'),
	(25,1,55,58,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
	(26,1,59,60,1,'com_wrapper','com_wrapper','{}'),
	(27,8,18,19,2,'com_content.category.2','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(28,3,4,5,2,'com_banners.category.3','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(29,7,14,15,2,'com_contact.category.4','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(30,19,42,43,2,'com_newsfeeds.category.5','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(31,25,56,57,2,'com_weblinks.category.6','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(32,0,419,420,0,'com_content.category.7','Demo Content','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(33,0,421,422,0,'com_content.category.8','Blog','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(34,0,423,424,0,'com_content.category.9','Setting Up','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(35,0,425,426,0,'com_content.category.10','Services','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(36,0,427,430,0,'com_content.category.11','Slideshow','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(37,0,431,432,0,'com_content.category.12','Features','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(38,0,433,434,0,'com_content.category.13','Top Microblog','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(39,0,435,436,0,'com_content.category.14','Bottom Microblog','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(40,0,437,438,0,'com_content.article.32','Zen Grid Framework','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(41,0,439,440,0,'com_content.article.33','Themes','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(43,0,441,442,0,'com_content.article.35','Extensions','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(44,0,443,444,0,'com_content.article.36','Typography','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(45,0,445,446,0,'com_content.article.37','K2 Support','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(48,0,447,448,0,'com_content.article.41','jTweet','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(49,0,449,450,0,'com_content.article.42','JB Library','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(53,0,451,452,0,'com_content.article.46','Module Examples','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(54,36,428,429,1,'com_content.article.47','Dignissim orci','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(55,0,453,454,0,'com_content.article.48','Sit amet ','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(56,0,455,456,0,'com_content.article.49','Rock Steady','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(57,0,457,458,0,'com_content.article.50','iPhone Version coming soon','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(58,0,459,460,0,'com_content.article.51','National 98','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(59,0,461,462,0,'com_content.article.52','Delivery Rates','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(60,0,463,464,0,'com_content.article.53','Newsletter Signup','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(61,0,465,466,0,'com_content.article.54','Meet the Players','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(62,0,467,468,0,'com_content.article.55','Hero','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(63,0,469,470,0,'com_content.article.56','Suscipit Donec eget nibh arcu, sit amet dignissim orci. ','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(64,0,471,472,0,'com_content.article.57','Maecenas neque augue.','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(65,0,473,474,0,'com_content.article.58','Down in the hood','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(66,0,475,476,0,'com_content.article.59','Red Shop Template','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(67,0,477,478,0,'com_contact.category.15','Contacts','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(69,1,414,415,1,'com_k2','k2','{}'),
	(70,1,416,417,1,'com_redshop','redshop','{}');

/*!40000 ALTER TABLE `#__assets` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__banner_clients
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banner_clients`;

CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__banner_tracks
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banner_tracks`;

CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__banners
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banners`;

CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__categories
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__categories`;

CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__categories` WRITE;
/*!40000 ALTER TABLE `#__categories` DISABLE KEYS */;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`)
VALUES
	(1,0,0,0,29,0,'','system','ROOT',X'726F6F74','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'2009-10-18 16:07:09',0,'0000-00-00 00:00:00',0,'*'),
	(2,27,1,19,20,1,'uncategorised','com_content','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:26:37',0,'0000-00-00 00:00:00',0,'*'),
	(3,28,1,21,22,1,'uncategorised','com_banners','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:35',0,'0000-00-00 00:00:00',0,'*'),
	(4,29,1,23,24,1,'uncategorised','com_contact','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:57',0,'0000-00-00 00:00:00',0,'*'),
	(5,30,1,25,26,1,'uncategorised','com_newsfeeds','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:15',0,'0000-00-00 00:00:00',0,'*'),
	(6,31,1,27,28,1,'uncategorised','com_weblinks','Uncategorised',X'756E63617465676F7269736564','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:33',0,'0000-00-00 00:00:00',0,'*'),
	(7,32,1,3,18,1,'demo-content','com_content','Demo Content',X'64656D6F2D636F6E74656E74','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(8,33,7,4,5,2,'demo-content/blog','com_content','Blog',X'626C6F67','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(9,34,7,6,7,2,'demo-content/setting-up','com_content','Setting Up',X'73657474696E672D7570','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(10,35,7,8,9,2,'demo-content/services','com_content','Services',X'7365727669636573','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(11,36,7,10,11,2,'demo-content/slideshow','com_content','Slideshow',X'736C69646573686F77','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(12,37,7,12,13,2,'demo-content/features','com_content','Features',X'6665617475726573','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(13,38,7,14,15,2,'demo-content/top-microblog','com_content','Top Microblog',X'746F702D6D6963726F626C6F67','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(14,39,7,16,17,2,'demo-content/bottom-microblog','com_content','Bottom Microblog',X'626F74746F6D2D6D6963726F626C6F67','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(15,67,1,1,2,1,'contacts','com_contact_details','Contacts',X'636F6E7461637473','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*');

/*!40000 ALTER TABLE `#__categories` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__contact_details
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__contact_details`;

CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__content
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content`;

CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__content` WRITE;
/*!40000 ALTER TABLE `#__content` DISABLE KEYS */;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`)
VALUES
	(32,40,'Zen Grid Framework',X'7A656E2D677269642D6672616D65776F726B',X'','<p><img alt=\"zenGrid\" src=\"images/democontent/zenGrid.gif\" width=\"380\" height=\"198\" />The Zen Grid Framework is the evolution of the Zen Grid Template that we  implemented way back in November 2009. Since then the template has  undergone some enormous change and is now a standalone template  framework that has been designed to be used in conjunction with Zen Grid  Framework compatible templates. The new framework offers an  extraordinary number of features with a simple to use interface.</p>\r\n','\r\n<strong> </strong>\r\n<p> </p>\r\n<h3>Feature rich and easy to use</h3>\r\n<p>The Zen Grid Framework is a feature rich Joomla 1.5 template framework</p>\r\n&nbsp;created for the easy deployment and development of joomla templates for you and your clients. It features a very smooth and easy to use joomla template admin which makes controlling the template a breeze for you and your clients.\r\n<p> </p>\r\n<p>Be sure to check out the <a href=\"documentation/zen-grid-2-documentation/zen-grid-framework-and-child-theme-installation\">Zen Grid knowledgebase</a> for more indepth instructions on how to use the zen grid framework with your Zen Grid compatible Joomla template.</p>\r\n<br />\r\n<h3>The basics</h3>\r\n<div class=\"featureRight\">\r\n<p class=\"modules\">The framework itself is an installable package that sits in the template folder on your Joomla site and allows compatible templates to tap into it. The template framework provides the markup, core css and core javascript that are common to all of our joomla templates, while any compatible joomla template simply hooks in and pulls out what it needs.</p>\r\n<p class=\"modules\">The compatible Joomla template can override css, html markup and add extra js which makes it an incredibly flexible system with a low overhead. The beauty of this is that the core is easily maintained and easily upgradeable from version to version. In most cases the style of the Joomla template is truly separated from the layout which gives designers the opportunity to create the Joomla template of their dreams without needing to reinvent the wheel from a coding perspective.</p>\r\n<p class=\"modules\"> </p>\r\n</div>\r\n<div class=\"features\">\r\n<div class=\"featureLeft\">\r\n<h3>Appearance</h3>\r\n<p class=\"typography\">The zen grid framework makes it very easy to make layout and colour  changes to your site with zero Joomla &nbsp;templating or coding knowledge. There are options within the template parameters itself to add your own css, while coding your own theme is as simple as creating a new colour hilite for the default theme and making changes to the css.</p>\r\n<p class=\"typography\">The logo is also easily controllable also and can be referenced from the template folder or any other folder in the main Joomla images folder which makes it easy for new users to upload their own logo via the Joomla media manager - which of course does away with the need for ftp knowledge.</p>\r\n<p class=\"typography\"> </p>\r\n</div>\r\n<div class=\"featureRight\">\r\n<h3></h3>\r\n<h3>Layout</h3>\r\n<p>The layout itself is based on the 960 Grid system but we have adapted it to apply to any template width you require. The template calculates the column width based on your settings and gives you the option of assigning specific widths for specific module positions or to create evenly spaced layouts which are dependant upon the number of modules you have published in any given row.</p>\r\n</div>\r\n</div>\r\n<div class=\"features\">\r\n<div class=\"featureLeft\">\r\n<h3></h3>\r\n<h3>Script compression and performance tweaks</h3>\r\n<p class=\"menus\">We have also included the ability to compress the css and javascript used in the core template as well as remove mootools from the Joomla front end as well as some other smaller/useful optimisation techniques. The template also includes built in ie6pngfix and the ability to add raw javascript directly into the template so you no longer need a third party plugin or module to simply add code to your template.</p>\r\n<p class=\"menus\"> </p>\r\n</div>\r\n<div class=\"featureRight\">\r\n<h3></h3>\r\n<h3>Features Include</h3>\r\n<ul class=\"package\">\r\n<li>xhtml and css valid Joomla 1.5 Template markup</li>\r\n<li>Comprehensive theming options</li>\r\n<li>Extensive Font Stack options</li>\r\n<li>Core theme layout overrides and extensive layout control</li>\r\n<li>Extensive Logo control</li>\r\n<li>Tagline</li>\r\n<li>Css Overrides</li>\r\n<li>Html overrides</li>\r\n<li>ie6 PNG Fix</li>\r\n<li>JB Drop Panel</li>\r\n<li>Google Analytics</li>\r\n<li>Extra Scripts Option</li>\r\n<li>CSS and JS compression</li>\r\n<li>Remove mootools</li>\r\n<li>Remove Joomla metatag generator</li>\r\n</ul>\r\n</div>\r\n</div>',1,0,0,12,'2010-05-03 04:17:35',62,'','2011-03-28 12:51:17',62,0,'0000-00-00 00:00:00','2010-05-03 04:17:35','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',19,0,1,'','',1,146,'',1,'*',''),
	(33,41,'Themes',X'7468656D6573',X'','<p><img class=\"border\" alt=\"colourSchemes\" height=\"250\" width=\"378\" src=\"images/democontent/documentation/colourSchemes.jpg\" /></p>\r\n<p> </p>\r\n<p>The Shop Ignition template comes with six colour variations to choose from.</p>\r\n<p> </p>\r\n','\r\n<p><strong>Click the thumbnails below to launch the full size image in a lightbox.</strong></p>\r\n<p>{loadposition themes}</p>\r\n<p> </p>\r\n<p><strong>Tienda Template Views</strong></p>\r\n<p>The following screenshots are taken from the various views available from within Tienda itself.</p>\r\n<p> </p>\r\n<p>{loadposition views}</p>',1,0,0,12,'2010-05-03 04:25:43',62,'','2011-03-28 04:54:59',62,0,'0000-00-00 00:00:00','2010-05-03 04:25:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',19,0,6,'','',1,194,'',0,'*',''),
	(35,43,'Extensions',X'657874656E73696F6E73',X'','<p><img class=\"border\" alt=\"gallery\" height=\"216\" width=\"480\" src=\"images/democontent/gallery.jpg\" />JoomlaBamboo offers numerous extensions to enhance your websites, and not all of them are displayed in the demo.  We have provided a quick overview of the extensions we have to offer.</p>\r\n<p> </p>\r\n','\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-type-joomla-typography-plugin\" class=\"contentpagetitle\"> JB Type - Joomla typography plugin</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-type-joomla-typography-plugin\"><img original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbtype/jbType.jpg\" class=\"sectionImage\" src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbtype/jbType.jpg\" alt=\"images/jbtype/jbType.jpg\" /></a>\r\n<div class=\"sectionIntro\">a free Joomla 1.5  content typography plugin - Free extension\r\n<p><strong>JB Type</strong> is a Joomla style and typography plugin for  your content. By using some simple Joomla syntax you can create some  awesome typography for your site without knowing any html at all.</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jflickr\" class=\"contentpagetitle\"> jflickr - free jQuery Joomla flickr module</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jflickr\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jflickr/jflickr.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jflickr/jflickr.jpg\" class=\"sectionImage\" alt=\"images/jflickr/jflickr.jpg\" /></a>\r\n<div class=\"sectionIntro\">\r\n<p>a free Joomla 1.5 flickr image gallery module -  Free extension</p>\r\n<p><strong>JFlickr</strong> is a free Joomla <a href=\"http://www.flickr.com/\">Flickr</a> image module that delivers a  Flickr-driven photo gallery onto your website. The module is based on  the script by <a href=\"http://www.projectatomic.com/2008/04/jquery-flickr/\" target=\"_blank\">Project Atomic</a> and uses JQuery to do all of the  heavy lifting. You can set the image gallery module to display images by  photoset, user, group or by free text. This great free Flickr module  for Joomla can boost your site with your custom photo stream.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jtweet-free-joomla-twitter-module\" class=\"contentpagetitle\"> jTweet - free joomla twitter module</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jtweet-free-joomla-twitter-module\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jTweet/jtweet.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jTweet/jtweet.jpg\" class=\"sectionImage\" alt=\"images/jTweet/jtweet.jpg\" /></a>\r\n<div class=\"sectionIntro\">a free Joomla 1.5 twitter module - Free extension\r\n<p><strong>jTweet</strong> is our very popular free <a href=\"http://twitter.com/\">Twitter</a> module for Joomla. Its based on  the <a target=\"_blank\" href=\"http://tweet.seaofclouds.com/\" style=\"font-weight: normal; font-family: inherit; font-style: inherit; font-size: 13px; outline-width: 0px; color: #3e173f; padding: 0px; margin: 0px;\">sea of clouds</a> twitter script. The jTweet script  has a good range of options to help you to personalise your twitter  stream making it a flexible and stylish option for integrating your  tweets into your site. It utilizes jQuery, and is a must have for anyone  who needs a Joomla twitter module.</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/captifycontent-beautiful-captions-for-your-content\" class=\"contentpagetitle\"> captifyContent - beautiful captions </a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/captifycontent-beautiful-captions-for-your-content\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/captify/captify.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/captify/captify.jpg\" class=\"sectionImage\" alt=\"images/captify/captify.jpg\" /></a>\r\n<div class=\"sectionIntro\">\r\n<p>a free Joomla 1.5 image gallery module for  captions - Free extension</p>\r\n<p>The <strong>captifyContent </strong>module is a slick new way to  display sections, categories, or content on your Joomla site visually.  The module resizes the image that you have assigned to the section,  category or content, lays it out in a simple lineup and then the captify  script generates the sliding effect that you see above when you roll  over the image. Its a beautiful module that puts great captions in  Joomla.</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-faq-free-jquery-joomla-faq-module\" class=\"contentpagetitle\"> JB FAQ - free jQuery Joomla faq module</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-faq-free-jquery-joomla-faq-module\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbfaq/jbfaq.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbfaq/jbfaq.jpg\" class=\"sectionImage\" alt=\"images/jbfaq/jbfaq.jpg\" /></a>\r\n<div class=\"sectionIntro\">a free Joomla 1.5 faq content module - Free  extension\r\n<p><strong>JB FAQ</strong> is a free Joomla FAQ module that gives you a  simple way to display some of your most common articles on your website.  It takes your Joomla content and puts the articles into a clean module  that allows you to select an article and expand to view the text. It  helps to reduce the amount of space wasted, but also helps highlight the  most common articles. It doesn\'t have to be used for FAQ files, it  could be used for any Joomla content!</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-maps-free-google-maps-module-for-joomla\" class=\"contentpagetitle\"> JB Maps - free google maps module for Joomla</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-maps-free-google-maps-module-for-joomla\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbmaps/jbmaps.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbmaps/jbmaps.jpg\" class=\"sectionImage\" alt=\"images/jbmaps/jbmaps.jpg\" /></a>\r\n<div class=\"sectionIntro\">a free Joomla 1.5 google maps module - Free  extension\r\n<p><strong>JB Maps</strong> provides you with a simple module to insert a  map on your Joomla website. Its a free Joomla module from JoomlaBamboo,  and allows you to set the height, width, starting point, and up to 3  markers on the map. It also allows you set directions between the  markers. Its for Joomla 1.0 and 1.5, and its free!</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-library-plugin-a-free-joomla-jquery-plugin\" class=\"contentpagetitle\"> JB Library Plugin - a free joomla jquery plugin</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-library-plugin-a-free-joomla-jquery-plugin\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jblibrary/jblibrary.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jblibrary/jblibrary.jpg\" class=\"sectionImage\" alt=\"images/jblibrary/jblibrary.jpg\" /></a>\r\n<div class=\"sectionIntro\">a free Joomla 1.5 jquery plugin - Free extension\r\n<p>The <strong>JB Library </strong>plugin is a system utility we use in  our Joomla templates to help ease the pain of javascript conflicts and  the common occurrence of having multiple versions of a javascript  library loaded into your Joomla site. The <a href=\"http://www.jquery.com/\">jQuery</a> library plugin neatly loads the  native version of mootools first and then it loads the latest version of  jQuery from the Google api, but only when necessary. Many of our Joomla  modules require this library, but you can use it on any Joomla site.</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/prettybox\" class=\"contentpagetitle\"> PrettyBox</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/prettybox\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/prettyBox/prettyBox.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/prettyBox/prettyBox.jpg\" class=\"sectionImage\" alt=\"images/prettyBox/prettyBox.jpg\" /></a>\r\n<div class=\"sectionIntro\">Joomla 1.5 lightbox image gallery module - Club  extension\r\n<p><strong>PrettyBox</strong> is an extremely flexible and effective  module gallery for Joomla. It can display images from a folder you  nominate in a module or in your content using the loadposition code for  Joomla 1.5 or the mosloadposition for Joomla 1.0. Its a simple extension  that has a lot of powerful features that can really spice up your image  gallery. Why load up on bulky image gallery extensions when you just  need something simple, lightweight, and beautiful?</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jtweet\" class=\"contentpagetitle\"> jTweet - free joomla twitter module</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jtweet\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jTweet/jtweet.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jTweet/jtweet.jpg\" class=\"sectionImage\" alt=\"images/jTweet/jtweet.jpg\" /></a>\r\n<div class=\"sectionIntro\">Free Joomla 1.0 and Joomla 1.5 Module\r\n<p>jTweet is our very popular free twitter module for Joomla. Its based  on the <a target=\"_blank\" href=\"http://tweet.seaofclouds.com/\" style=\"font-weight: normal; font-family: inherit; font-style: inherit; font-size: 13px; outline-width: 0px; color: #3e173f; padding: 0px; margin: 0px;\">sea of clouds</a>. The jTweet script has a good range  of options to help you to personalise your twitter stream making it a  flexible and stylish option for integrating your tweets into your site.</p>\r\n<div class=\"actionButtons\">\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-maps-free-google-maps-module-for-joomla\" class=\"contentpagetitle\"> Date title</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-maps-free-google-maps-module-for-joomla\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbmaps/jbmaps.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbmaps/jbmaps.jpg\" class=\"sectionImage\" alt=\"images/jbmaps/jbmaps.jpg\" /></a>\r\n<div class=\"sectionIntro\">Free Joomla 1.0 and Joomla 1.5 Module\r\n<p>We recently stumbled upon the awesome jQuery twitter script by sea of  clouds . The Tweet script has a nice range of options to personalise  your twitter stream which make twitter integration into your joomla site  a good deal more flexible.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/hoverbox\" class=\"contentpagetitle\"> Hoverbox</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/hoverbox\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/templateImages/landscape.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/templateImages/landscape.jpg\" class=\"sectionImage\" alt=\"images/templateImages/landscape.jpg\" /></a>\r\n<div class=\"sectionIntro\">Free Joomla 1.0 and Joomla 1.5 Module\r\n<p>Introducing the new and improved Hover Box Version 2.0. A simple  gallery using pure css to display images using hover andthe mootools  slimbox extended effect. This <a style=\"padding: 2px 4px; outline-width: 0px; font-weight: inherit; font-style: inherit; font-size: 13px; font-family: inherit; vertical-align: baseline; text-decoration: none; color: #666666; background-color: #eeeeee; margin: 0px;\" title=\"Free Joomla Modules and extensions\" href=\"http://joomlabamboo.com/free-joomla-addons/\">module</a> is based  on the work by StuNicholls at <a style=\"padding: 2px 4px; outline-width: 0px; font-weight: inherit; font-style: inherit; font-size: 13px; font-family: inherit; vertical-align: baseline; text-decoration: none; color: #333333; background-color: #eeeeee; margin: 0px;\" href=\"http://www.cssplay.co.uk/menu/photo_simplemygallery\">cssplay</a>.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-faq\" class=\"contentpagetitle\"> JB FAQ</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-faq\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbfaq/jbfaq.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/jbfaq/jbfaq.jpg\" class=\"sectionImage\" alt=\"images/jbfaq/jbfaq.jpg\" /></a>\r\n<div class=\"sectionIntro\">Free Joomla 1.0 and Joomla 1.5 Module\r\n<p class=\"demobuttons\">The JB FAQ module is an update to our two previous modules Bamboo FAQ  and Moo FAQ. It represents a significant update for a number of  reasons.</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/jb-slideshow-v3\" class=\"contentpagetitle\"> JB Slideshow v3</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/jb-slideshow-v3\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/templateImages/slideshow.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/templateImages/slideshow.jpg\" class=\"sectionImage\" alt=\"images/templateImages/slideshow.jpg\" /></a>\r\n<div class=\"sectionIntro\">Joomla 1.5 image and content slideshow module -  Club extension\r\n<p>The <strong>JB Slideshow3</strong> module is a slick, lightweight  content fading, sliding, scrolling module for Joomla 1.5. We\'ve added  quite a few features to the slideshow and its implementation is slightly  different also so if you are used to using JB Slideshow be sure to  check the instructions below because they have changed.</p>\r\n<p> </p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\"></div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/minimoo2-gallery\" class=\"contentpagetitle\"> Minimoo2 Gallery</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/minimoo2-gallery\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/minimoo2/minimoo2.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/minimoo2/minimoo2.jpg\" class=\"sectionImage\" alt=\"images/minimoo2/minimoo2.jpg\" /></a>\r\n<div class=\"sectionIntro\">\r\n<p>Joomla 1.5 image slider module - Club Extension</p>\r\n<p><strong>Minimoo2</strong> uses Jquery and the <a target=\"_blank\" href=\"http://shiftingpixel.com/2008/03/03/smart-image-resizer/\">shifting  pixel</a> resize script to load images into the gallery which make  creating a sliding image gallery almost effortless. Minimoo2 uses jQuery  in no conflict mode so it should work with any other script. This  beautiful, simple image slider is perfect for showcasing your images  without the hassle of major extensions, and comes with an amazing set of  features that will satisfy your every need.</p>\r\n<div class=\"actionButtons\"></div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/bamboo-box\" class=\"contentpagetitle\"> Bamboo Box</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/bamboo-box\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/bambooBox/bambooBox.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/bambooBox/bambooBox.jpg\" class=\"sectionImage\" alt=\"images/bambooBox/bambooBox.jpg\" /></a>\r\n<div class=\"sectionIntro\">Joomla 1.5 content gallery module - Club extension\r\n<p>The <strong>Bamboo Box </strong>module is an incredibly flexible  gallery module for Joomla that uses your very own Joomla content to  create a slick gallery for your site using nothing more than a module  and your Joomla content. It pulls information either directly from  articles or from a directory, and can be integrated with our great  captify effect and lightbox. Its an unbelievable gallery that has  unlimited potential with your Joomla website.</p>\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/microblog\" class=\"contentpagetitle\"> Microblog</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/microblog\"><img original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/microblog/microblog.jpg\" class=\"sectionImage\" src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/microblog/microblog.jpg\" alt=\"images/microblog/microblog.jpg\" /></a>\r\n<div class=\"sectionIntro\">Joomla 1.5 micro news module - Club extension\r\n<p>The JB <strong>Microblog </strong>module is a very handy club  extension that allows you to display your Joomla or K2 content in a  module in a number of different ways. You can choose between the flat  list layout, column layout, date and title and also the leading plus  links layouts. You can also choose to display the intro and full text  parts of the content item in a floating lightbox that sits above the  main website.</p>\r\n</div>\r\n<div class=\"article_row\">\r\n<div class=\"article_column column1 cols1\">\r\n<h2 class=\"contentheading\"><a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/pretty-slider\" class=\"contentpagetitle\"> Pretty Slider</a></h2>\r\n<a href=\"http://www.joomlabamboo.com/joomla-extensions/club-extensions/pretty-slider\"><img src=\"http://www.joomlabamboo.com/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/prettySlider/prettySlider.jpg\" style=\"display: block;\" original=\"/image.php?width=520&amp;height=190&amp;cropratio=2:1&amp;image=//images/prettySlider/prettySlider.jpg\" class=\"sectionImage\" alt=\"images/prettySlider/prettySlider.jpg\" /></a>\r\n<div class=\"sectionIntro\">Joomla 1.5 image slider module - Club extension\r\n<p><strong>Pretty Slider</strong> Gallery is a Joomla module that will  have your images sliding and fading in no time. It is coupled with the <a href=\"http://www.no-margin-for-errors.com/projects/prettyPhoto-jquery-lightbox-clone/\">prettyPhoto  overlay</a> and the <a href=\"http://shiftingpixel.com/2008/03/03/smart-image-resizer/\">image  resize script from Shifting Pixel</a> so the module is able to resize  your images on the fly and display the  full size original in an elegant  lightbox. This great Joomla image  slider module will spice up any  image gallery with smooth effects and  no need for extra bulky  components.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<!-- End Main Content -->\r\n<p><!-- End Main Content --></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<!-- End Main Content -->',1,0,0,12,'2010-05-03 04:27:32',62,'','2010-05-06 05:17:24',62,0,'0000-00-00 00:00:00','2010-05-03 04:27:32','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,5,'','',1,5,'',0,'*',''),
	(36,44,'Typography',X'7479706F677261706879',X'','<p><img src=\"images/democontent/jbType.png\" width=\"550\" height=\"216\" alt=\"jbType\" class=\"border\" />This page gives you an overview of all of the typographical elements included with the template. You can apply these styles in your Joomla website easily if you use the content editor, and we recommend using <a href=\"http://www.joomlacontenteditor.net/\">JCE</a> as the default editor. It provides the best features, at a price you can\'t beat, free!</p>\r\n<p> </p>\r\n','\r\n<h1>Heading 1</h1>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<h2>Heading 2</h2>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<h3>Heading 3</h3>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<h4>Heading 4</h4>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<h5>Heading 5</h5>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<h6>Heading 6</h6>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<blockquote>\r\n<p>This is a blockquote. To use this class use the following html:  &lt;blockquote&gt;&lt;p&gt;This is where you put the  content&lt;/p&gt;&lt;/blockquote&gt;. You can also use this html to  havejust an opening quotation mark &lt;p class=\"blockquote&gt;Some more  content here&lt;/p&gt;</p>\r\n</blockquote>\r\n<smallquote></smallquote>\r\n<p>This is an unordered list:</p>\r\n<ul>\r\n<li>Donec imperdiet ipsum eu mauris.</li>\r\n<li>Morbi facilisis purus in dui.</li>\r\n<li>Donec pharetra orci eu justo.</li>\r\n<li>Donec porta tellus id leo.</li>\r\n<li>Aenean commodo sagittis orci.</li>\r\n</ul>\r\n<p>This is an order list</p>\r\n<ol>\r\n<li>Donec imperdiet ipsum eu mauris.</li>\r\n<li>Morbi facilisis purus in dui.</li>\r\n<li>Donec pharetra orci eu justo.</li>\r\n<li>Donec porta tellus id leo.</li>\r\n<li>Aenean commodo sagittis orci.</li>\r\n</ol>\r\n<p><strong>This is some bold text.</strong></p>\r\n<p><em>This is some italicised text.</em></p>\r\n<p><span style=\"text-decoration: underline;\">This is some underlined text. </span></p>\r\n<p><strong>The following styles are generated using our free JB Type plugin</strong></p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p> </p>\r\n<h3></h3>\r\n<p>{twitter_search}joomlabamboo{/twitter_search}</p>\r\n<h3><b>v1.1 of JB Type features 25 new icons plus a nifty new twitter display.</b></h3>\r\n<p><b><br /></b></p>\r\n<p>{jb_iconic_info}This is some text rendered using the jb_iconic_info syntax.{/jb_iconic_info}</p>\r\n<p>{jb_iconic_star}This is some text rendered using the jb_iconic_star syntax.{/jb_iconic_star}</p>\r\n<p>{jb_iconic_heart}This is some text rendered using the jb_iconic_heart syntax.{/jb_iconic_heart}</p>\r\n<p>{jb_iconic_tag}This is some text rendered using the jb_iconic_tag syntax.{/jb_iconic_tag}</p>\r\n<p>{jb_iconic_arrival}This is some text rendered using the jb_iconic_arrival syntax.{/jb_iconic_arrival}</p>\r\n<p>{jb_iconic_truck}This is some text rendered using the jb_iconic_truck syntax.{/jb_iconic_truck}</p>\r\n<p>{jb_iconic_arrow}This is some text rendered using the jb_iconic_arrow syntax.{/jb_iconic_arrow}</p>\r\n<p>{jb_iconic_article}This is some text rendered using the jb_iconic_article syntax.{/jb_iconic_article}</p>\r\n<p>{jb_iconic_email}This is some text rendered using the jb_iconic_email syntax.{/jb_iconic_email}</p>\r\n<p>{jb_iconic_beaker}This is some text rendered using the jb_iconic_beaker syntax.{/jb_iconic_beaker}</p>\r\n<p>{jb_iconic_book}This is some text rendered using the jb_iconic_book syntax.{/jb_iconic_book}</p>\r\n<p>{jb_iconic_bolt}This is some text rendered using the jb_iconic_bolt syntax.{/jb_iconic_bolt}</p>\r\n<p>{jb_iconic_box}This is some text rendered using the jb_iconic_box syntax.{/jb_iconic_box}</p>\r\n<p>{jb_iconic_calendar}This is some text rendered using the jb_iconic_calendar syntax.{/jb_iconic_calendar}</p>\r\n<p>{jb_iconic_comment}This is some text rendered using the jb_iconic_comment syntax.{/jb_iconic_comment}</p>\r\n<p>{jb_iconic_tick}This is some text rendered using the jb_iconic_tick syntax.{/jb_iconic_tick}</p>\r\n<p>{jb_iconic_cloud}This is some text rendered using the jb_iconic_cloud syntax.{/jb_iconic_cloud}</p>\r\n<p>{jb_iconic_document}This is some text rendered using the jb_iconic_document syntax.{/jb_iconic_document}</p>\r\n<p>{jb_iconic_image}This is some text rendered using the jb_iconic_image syntax.{/jb_iconic_image}</p>\r\n<p>{jb_iconic_lightbulb}This is some text rendered using the jb_iconic_lightbulb syntax.{/jb_iconic_lightbulb}</p>\r\n<p>{jb_iconic_search}This is some text rendered using the jb_iconic_search syntax.{/jb_iconic_search}</p>\r\n<p>{jb_iconic_mail}This is some text rendered using the jb_iconic_mail syntax.{/jb_iconic_mail}</p>\r\n<p>{jb_iconic_dash}This is some text rendered using the jb_iconic_dash syntax.{/jb_iconic_dash}</p>\r\n<p>{jb_iconic_movie}This is some text rendered using the jb_iconic_movie syntax.{/jb_iconic_movie}</p>\r\n<p>{jb_iconic_download}This is some text rendered using the jb_iconic_download syntax.{/jb_iconic_download}</p>\r\n<p> </p>\r\n<p>{jb_quote}jb_quote - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_quote}</p>\r\n<p>{jb_quoteleft}jb_quoteleft - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_quoteleft}</p>\r\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.</p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p>{jb_quoteright}jb_quoteright - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_quoteright}</p>\r\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.</p>\r\n<p>{jb_clear}{/jb_clear}  {jb_info}jb_info - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_info}</p>\r\n<p>{jb_warning}jb_warning - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_warning}  {jb_film}jb_film - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_film}</p>\r\n<p>{jb_pin}jb_pin - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_pin}</p>\r\n<p>{jb_lightbulb}jb_lightbulb - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_lightbulb}</p>\r\n<p>{jb_recycle}jb_recycle - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_recycle}</p>\r\n<p>{jb_camera}jb_camera - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_camera}</p>\r\n<p>{jb_comment}jb_comment - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_comment}</p>\r\n<p>{jb_chat}jb_chat - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_chat}</p>\r\n<p>{jb_document}jb_document - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_document}</p>\r\n<p>{jb_accessible}jb_accessible - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_accessible}</p>\r\n<p>{jb_star}jb_star - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_star}</p>\r\n<p>{jb_heart}jb_heart - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_heart}</p>\r\n<p>{jb_previous}jb_previous - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_previous}</p>\r\n<p>{jb_cart}jb_cart - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_cart}</p>\r\n<p>{jb_sound}jb_sound - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_sound}</p>\r\n<p>{jb_new}jb_new - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_new}</p>\r\n<p>{jb_code}jb_code - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_code}</p>\r\n<p>{jb_attachment}jb_attachment - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_attachment}  {jb_calculator}jb_calculator - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_calculator}  {jb_cut}jb_cut - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_cut}  {jb_dollar}jb_dollar - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_dollar}  {jb_pound}jb_pound - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_pound}  {jb_euro}jb_euro - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_euro}  {jb_mail}jb_mail Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_mail}  {jb_support}jb_support - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_support}  {jb_next}jb_next - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_next}  {jb_blackbox}jb_blackbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_blackbox}  {jb_greenbox}jb_greenbox - tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_greenbox}  {jb_redbox}jb_redbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_redbox}  {jb_purplebox}jb_purplebox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_purplebox}  {jb_bluebox}jb_bluebox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_bluebox}</p>\r\n<p>{jb_brownbox}jb_brownbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_brownbox}</p>\r\n<p>{jb_yellowbox}jb_yellowbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_yellowbox}  {jb_dropcap}T{/jb_dropcap}his is the jb_dropcapDonec tempus fringilla neque ac iaculis. Aenean eget ipsum elit, ac dapibus turpis. Nulla non felis est. Duis lacinia felis eu metus suscipit volutpat. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.</p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p>{jb_left45}jb_left45 - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_left45}</p>\r\n<p>{jb_right45}jb_right45 - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_right45}</p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p>{jb_black}jb_black - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_black}</p>\r\n<p>{jb_blue}jb_blue - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_blue}</p>\r\n<p>{jb_red}jb_red - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_red}</p>\r\n<p>{jb_green}jb_green - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_green}</p>\r\n<p>{jb_yellow}jb_yellow - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_yellow}</p>\r\n<p>{jb_white}jb_white - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_white}</p>\r\n<p>{jb_brown}jb_brown - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_brown}</p>\r\n<p>{jb_purple}jb_purple - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_purple}</p>\r\n<p> </p>\r\n{/jb_one}',1,0,0,12,'2010-05-03 04:28:29',62,'','2011-03-28 12:56:36',62,0,'0000-00-00 00:00:00','2010-05-03 04:28:29','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',19,0,4,'','',1,116,'',0,'*',''),
	(37,45,'K2 Support',X'6B322D737570706F7274',X'','<img alt=\"k2\" height=\"216\" width=\"400\" src=\"images/democontent/k2.jpg\" />\r\n<p>This template provides additional styles for <a href=\"http://www.getk2.org/\">K2</a> from <a href=\"http://www.joomlaworks.gr/\">JoomlaWorks</a>. This very popular extension gives you additional means to control and create content. You are free to use this template without K2, but we have done the extra work to style K2 to fit the whole theme. Here is an excerpt about K2 and what it can do for you.</p>\r\n<p> </p>\r\n','\r\n<blockquote>\r\n<p>\"It provides an out-of-the box integrated solution featuring rich content  forms for items (think of Joomla! articles with additional fields for  article images, videos, image galleries and attachments), nested-level  categories, tags, comments, a system to extend the item base form with  additional fields (similar to <a target=\"_blank\" href=\"http://drupal.org/project/cck\">CCK</a> for those acquainted with <a target=\"_blank\" href=\"http://drupal.org/\">Drupal</a>), a powerful  plugin API to extend item, category and user forms, ACL, frontend  editing, sub-templates and a lot more! 						<br /><br /> Using K2, you can transform your Joomla! website to a  news/magazine site with author blogs, product catalogs, work portfolio,  knowledge base, download/document manager, directory listing, event  listing and more, all this bundled under one package! Since K2 is  extensible with additional fields to its base item form, you can easily  create category-specific content types, e.g. article, blog post, product  page, directory listing.\"</p>\r\n</blockquote>\r\n<p>Here is a list of some of its features:</p>\r\n<ul>\r\n<li>Content creation</li>\r\n<li>Custom fields</li>\r\n<li>Image galleries</li>\r\n<li>Add videos to items</li>\r\n<li>Author profiles</li>\r\n<li>Social bookmarking</li>\r\n<li>Dozens of modules to display K2 content</li>\r\n<li>And more!</li>\r\n</ul>\r\n<h3>Using Shop Ignition and K2</h3>\r\n<p>If you use a quickstart package, then K2 will be installed and the demo content will have the overrides enabled by default. However, you have to assign the template by editing the category or the menu item linking to K2. We provide support for anything specific to the template overrides in Shop Ignition.</p>\r\n<p>K2 has a growing community of users and places to get help. The first place you might want to check out is the <a href=\"http://community.getk2.org/\">K2 Community</a>. There you will find a lively community that may have already answered your questions, and can help pinpoint new issues.</p>',1,0,0,12,'2010-05-03 04:30:55',62,'','2011-03-28 12:53:01',62,0,'0000-00-00 00:00:00','2010-05-03 04:30:55','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',13,0,3,'','',1,47,'',0,'*',''),
	(41,48,'jTweet',X'6A7477656574',X'','<img height=\"216\" width=\"480\" class=\"floatleft border\" src=\"images/democontent/jTweet.png\" alt=\"jTweet\" original=\"/images/jTweet/jtweet.jpg\" />\r\n<p>jTweet is our very popular free twitter module for Joomla. Its based  on the <a target=\"_blank\" href=\"http://tweet.seaofclouds.com/\">sea of  clouds</a>. The jTweet script has a good range of options to help you to  personalise your twitter stream making it a flexible and stylish option  for integrating your tweets into your site.</p>\r\n<p> </p>\r\n','\r\n<p>You can see an example of the jTweet  script on the left sidebar of the Landscape template\'s demo site.</p>\r\n<p><strong>Here is a quick overview of  some of the features available for this module but please check the  parameter settings below for a more detailed explanation.</strong></p>\r\n<ul class=\"blue\">\r\n<li>Set the number of tweets to display</li>\r\n<li>Choose whether to display your avatar or not. </li>\r\n<li>Assign a funky twitter icon to the first tweet in your stream.</li>\r\n<li>Select whether to display just your tweets or all tweets related to a  particular topic</li>\r\n<li>Select auto join phrases  according to the nature of your tweet eg  specific intro text for replies, verbs, replying to tweets and more.</li>\r\n<li>Set the text to appear while the tweets loads. </li>\r\n<li>Filter your own tweets via keywords. eg only display tweets that  contain the word \"joomla\". </li>\r\n<li>Control the follow me text at the bottom of the module.</li>\r\n</ul>\r\nSee more about <a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jtweet\">jTweets on our website</a>.',1,0,0,12,'2010-05-05 00:47:50',62,'','2010-05-06 05:10:00',62,0,'0000-00-00 00:00:00','2010-05-05 00:47:50','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,7,'','',1,13,'',0,'*',''),
	(42,49,'JB Library',X'6A622D6C696272617279',X'','<div class=\"extensionIntro\">\r\n<p><img original=\"/images/jblibrary/jblibrary.jpg\" src=\"images/democontent/jQuery.png\" class=\"border floatleft\" alt=\"jQuery\" height=\"216\" width=\"480\" /></p>\r\n<p>The <strong>JB  Library </strong>plugin is a system utility we use in our Joomla  templates to help ease the pain of javascript conflicts and the common  occurrence of</p>\r\n','\r\n<p>having multiple versions of a javascript library loaded  into your Joomla site.</p>\r\n<p>The <a href=\"http://www.jquery.com/\">jQuery</a> library plugin neatly loads the native version of mootools first and  then it loads the latest version of jQuery from the Google api, but only  when necessary. Many of our Joomla modules require this library, but  you can use it on any Joomla site.<strong> </strong></p>\r\n</div>\r\n<h3>Overview</h3>\r\n<p><strong>Why are we using this method for embedding jQuery?</strong></p>\r\n<p>By adding jQuery as a plugin we can add other jQuery plugins and  scripts in our modules on the fly. That means that there is no need to  add script references to the head of your template and it also means  that scripts only get loaded if the module is present.</p>\r\n<div class=\"featureLeft\"></div>\r\n<div class=\"featureRight\">\r\n<h3>Features</h3>\r\n<ul>\r\n<li>Easily add jQuery to your site</li>\r\n<li>Allows you to use a copy of the jQuery library from your site, or to  load it from Google</li>\r\n<li>Needed by many JB extensions</li>\r\n<li>Includes an option for Scroll to top button automatically created  when the user scrolls down the page.</li>\r\n<li>Includes an option to use the jQuery Lazyload script for images.</li>\r\n<li>Includes a browser warning for users using the outdated ie6 browser.</li>\r\n</ul>\r\nFind out more about <a href=\"http://www.joomlabamboo.com/joomla-extensions/free-joomla-extensions/jb-library-plugin-a-free-joomla-jquery-plugin\">JB Library and download it from our website</a>.</div>',1,0,0,12,'2010-05-05 00:50:39',62,'','2010-05-06 05:09:47',62,0,'0000-00-00 00:00:00','2010-05-05 00:50:39','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,8,'','',1,16,'',0,'*',''),
	(46,53,'Module Examples',X'6D6F64756C652D6578616D706C6573',X'','This page highlights most of the modules available for the Shop Front template. Please refer to the module position schematic on the <a href=\"http://www.joomlabamboo.com/documentation/2010-template-documentation/shopfront-documentation\">Shopfront documentation</a> for a more indepth analysis.','',1,0,0,9,'2010-05-08 01:49:26',62,'','2011-03-28 05:21:55',62,0,'0000-00-00 00:00:00','2010-05-08 01:49:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',2,0,1,'','',1,180,'',0,'*',''),
	(47,54,'Dignissim orci',X'6C696D697465642D65646974696F6E',X'','<p><img src=\"images/democontent/slideshow/handstand.jpg\" border=\"0\" alt=\"handstand\" width=\"675\" height=\"385\" /></p>\r\n','\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>',1,0,0,11,'2011-03-11 13:15:28',62,'','2011-11-21 05:32:33',62,0,'0000-00-00 00:00:00','2011-03-11 13:15:28','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',5,0,3,'','',1,27,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(48,55,'Sit amet ',X'7369742D616D65742D',X'','<p><img src=\"images/democontent/slideshow/slideshow.jpg\" width=\"675\" height=\"385\" alt=\"slideshow\" /></p>\r\n','\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>',1,0,0,11,'2011-03-11 13:15:28',62,'','2011-03-27 05:16:02',62,0,'0000-00-00 00:00:00','2011-03-11 13:15:28','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":0,\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,2,'','',1,10,'',0,'*',''),
	(49,56,'Rock Steady',X'726F636B2D737465616479',X'','<p><img class=\"floatleft\" src=\"images/democontent/microblog/rocksteady.jpg\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','',1,0,0,13,'2011-03-12 00:21:08',62,'','2011-03-12 00:23:28',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,5,'','',1,61,'',0,'*',''),
	(50,57,'iPhone Version coming soon',X'6970686F6E652D76657273696F6E2D636F6D696E672D736F6F6E',X'','<p><img alt=\"iphone\" height=\"127\" width=\"235\" src=\"images/democontent/microblog/iphone.jpg\" class=\"floatleft\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','',1,0,0,13,'2011-03-12 00:21:08',62,'','2011-03-12 00:24:51',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,4,'','',1,49,'',0,'*',''),
	(51,58,'National 98',X'6E6174696F6E616C2D3938',X'','<p><img alt=\"national98\" height=\"127\" width=\"235\" src=\"images/democontent/microblog/national98.jpg\" class=\"floatleft\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','',1,0,0,13,'2011-03-12 00:21:08',62,'','2011-03-12 00:24:29',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,3,'','',1,28,'',0,'*',''),
	(52,59,'Delivery Rates',X'64656C69766572792D7261746573',X'','<p><img alt=\"deliveryrates\" height=\"127\" width=\"235\" src=\"images/democontent/microblog/deliveryrates.gif\" class=\"floatleft\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','',1,0,0,13,'2011-03-12 00:21:08',62,'','2011-03-12 00:24:01',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,2,'','',1,51,'',1,'*',''),
	(53,60,'Newsletter Signup',X'6E6577736C65747465722D7369676E7570',X'','<p><img class=\"floatleft\" src=\"images/democontent/microblog/newsletter.jpg\" width=\"236\" height=\"126\" alt=\"newsletter\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','',1,0,0,14,'2011-03-12 00:21:08',62,'','2011-03-15 11:23:13',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,4,'','',1,1,'',0,'*',''),
	(54,61,'Meet the Players',X'707572706C652D6E6174696F6E',X'','<p><img alt=\"purplenation\" height=\"126\" width=\"236\" src=\"images/democontent/microblog/purplenation.jpg\" class=\"floatleft\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.&nbsp;</p>','',1,0,0,14,'2011-03-17 00:00:00',62,'','2011-03-19 05:51:43',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,3,'','',1,8,'',0,'*',''),
	(55,62,'Hero',X'6865726F',X'','<p><img alt=\"hero\" height=\"126\" width=\"236\" src=\"images/democontent/microblog/hero.jpg\" class=\"floatleft\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.&nbsp;</p>','',1,0,0,14,'2011-03-12 00:21:08',62,'','2011-03-15 11:24:02',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',2,0,2,'','',1,9,'',1,'*',''),
	(56,63,'Suscipit Donec eget nibh arcu, sit amet dignissim orci. ',X'646F6E65632D656765742D6E6962682D617263752D7369742D616D65742D6469676E697373696D2D6F7263692D',X'','<p><img src=\"images/democontent/slideshow/bendback.jpg\" width=\"675\" height=\"385\" alt=\"bendback\" /></p>\r\n','\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.&nbsp;</p>',1,0,0,11,'2011-03-11 13:15:28',62,'','2011-03-27 05:20:11',62,0,'0000-00-00 00:00:00','2011-03-11 13:15:28','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":0,\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,1,'','',1,16,'',0,'*',''),
	(57,64,'Maecenas neque augue.',X'6D616563656E61732D6E657175652D6175677565',X'','<p><img alt=\"statue\" height=\"126\" width=\"225\" src=\"images/democontent/microblog/statue.jpg\" class=\"floatleft\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.&nbsp;</p>','',1,0,0,14,'2011-03-12 00:21:08',62,'','2011-03-19 05:43:55',62,0,'0000-00-00 00:00:00','2011-03-12 00:21:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',2,0,1,'','',1,4,'',0,'*',''),
	(58,65,'Down in the hood',X'646F776E2D696E2D7468652D686F6F64',X'','<p><img class=\"floatleft\" src=\"images/democontent/microblog/womensshirts.jpg\" width=\"236\" height=\"250\" alt=\"womensshirts\" /></p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>','',1,0,0,13,'2011-03-20 00:00:00',62,'','2011-03-20 09:31:02',62,0,'0000-00-00 00:00:00','2011-03-20 00:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',3,0,6,'','',1,29,'',0,'*',''),
	(59,66,'Red Shop Template',X'7265642D73686F702D74656D706C617465',X'','Shop Ignition comes with a custom built Red Shop template that matches the content you can see on this&nbsp;','',0,0,0,13,'2011-03-28 09:12:25',62,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2011-03-28 09:12:25','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,1,'','',1,0,'',0,'*','');

/*!40000 ALTER TABLE `#__content` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__content_frontpage
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content_frontpage`;

CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__content_frontpage` WRITE;
/*!40000 ALTER TABLE `#__content_frontpage` DISABLE KEYS */;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`)
VALUES
	(32,3),
	(52,1),
	(55,2);

/*!40000 ALTER TABLE `#__content_frontpage` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__extensions
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__extensions`;

CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__extensions` WRITE;
/*!40000 ALTER TABLE `#__extensions` DISABLE KEYS */;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`)
VALUES
	(1,'com_mailto','component','com_mailto','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(3,'com_admin','component','com_admin','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(4,'com_banners','component','com_banners','',1,1,1,0,'','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(5,'com_cache','component','com_cache','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(6,'com_categories','component','com_categories','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(7,'com_checkin','component','com_checkin','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(8,'com_contact','component','com_contact','',1,1,1,0,'','{\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"sliders\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"allow_vcard_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_category_crumb\":\"0\",\"metakey\":\"\",\"metadesc\":\"\",\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(10,'com_installer','component','com_installer','',1,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(11,'com_languages','component','com_languages','',1,1,1,1,'','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),
	(12,'com_login','component','com_login','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(13,'com_media','component','com_media','',1,1,0,1,'','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(14,'com_menus','component','com_menus','',1,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(15,'com_messages','component','com_messages','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(16,'com_modules','component','com_modules','',1,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(18,'com_plugins','component','com_plugins','',1,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(19,'com_search','component','com_search','',1,1,1,1,'','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(20,'com_templates','component','com_templates','',1,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(22,'com_content','component','com_content','',1,1,0,1,'','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"1\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"filters\":{\"1\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),
	(23,'com_config','component','com_config','',1,1,0,1,'','{\"filters\":{\"1\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),
	(24,'com_redirect','component','com_redirect','',1,1,0,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(25,'com_users','component','com_users','',1,1,0,1,'','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"useractivation\":\"1\",\"frontend_userparams\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(100,'PHPMailer','library','phpmailer','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(101,'SimplePie','library','simplepie','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(102,'phputf8','library','phputf8','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(103,'Joomla! Web Application Framework','library','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"Joomla! Web Application Framework\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"1.6.0\",\"description\":\"The Joomla! Web Application Framework is the Core of the Joomla! Content Management System\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(203,'mod_banners','module','mod_banners','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(205,'mod_custom','module','mod_custom','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(206,'mod_feed','module','mod_feed','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(207,'mod_footer','module','mod_footer','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(208,'mod_login','module','mod_login','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(209,'mod_menu','module','mod_menu','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(213,'mod_search','module','mod_search','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(214,'mod_stats','module','mod_stats','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(216,'mod_users_latest','module','mod_users_latest','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(220,'mod_articles_category','module','mod_articles_category','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(222,'mod_languages','module','mod_languages','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(300,'mod_custom','module','mod_custom','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(301,'mod_feed','module','mod_feed','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(302,'mod_latest','module','mod_latest','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(303,'mod_logged','module','mod_logged','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(304,'mod_login','module','mod_login','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(305,'mod_menu','module','mod_menu','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(307,'mod_popular','module','mod_popular','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(309,'mod_status','module','mod_status','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(311,'mod_title','module','mod_title','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(313,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.1\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),
	(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),
	(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),
	(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'','{}','','',0,'0000-00-00 00:00:00',2,0),
	(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"xhtml\"}','','',0,'2011-09-18 15:22:50',0,0),
	(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,1,'','{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}','','',0,'0000-00-00 00:00:00',4,0),
	(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,1,1,1,'','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),
	(409,'plg_content_vote','plugin','vote','content',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',6,0),
	(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),
	(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',2,0),
	(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,1,'','{\"mode\":\"1\",\"skin\":\"0\",\"compressed\":\"0\",\"cleanup_startup\":\"0\",\"cleanup_save\":\"2\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"safari\":\"0\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),
	(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',1,0),
	(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',2,0),
	(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',3,0),
	(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',4,0),
	(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(419,'plg_search_content','plugin','content','search',0,1,1,0,'','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'','{}','','',0,'0000-00-00 00:00:00',1,0),
	(423,'plg_system_p3p','plugin','p3p','system',0,1,1,1,'','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0),
	(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',9,0),
	(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0),
	(426,'plg_system_log','plugin','log','system',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',5,0),
	(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',6,0),
	(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',7,0),
	(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',8,0),
	(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',3,0),
	(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,1,'','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),
	(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),
	(433,'plg_user_profile','plugin','profile','user',0,0,1,1,'','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'','{}','','',0,'0000-00-00 00:00:00',1,0),
	(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'','{}','','',0,'0000-00-00 00:00:00',0,0),
	(500,'atomic','template','atomic','',0,1,1,0,'{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"1.6.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(502,'bluestork','template','bluestork','',1,1,1,0,'{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"1.6.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(503,'beez_20','template','beez_20','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"1.6.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),
	(504,'hathor','template','hathor','',1,1,1,0,'{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"1.6.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(505,'beez5','template','beez5','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"1.6.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(700,'Joomla! CMS','file','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"September 2011\",\"author\":\"Joomla!\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.4\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(800,'joomla','package','pkg_joomla','',0,1,1,1,'','','','',0,'0000-00-00 00:00:00',0,0),
	(10000,'COM_K2','component','com_k2','',1,1,1,0,'','{\"enable_css\":1,\"jQueryHandling\":0,\"backendJQueryHandling\":\"remote\",\"userName\":1,\"userImage\":1,\"userDescription\":1,\"userURL\":1,\"userEmail\":1,\"userFeedLink\":1,\"userFeedIcon\":1,\"userItemCount\":10,\"userItemTitle\":1,\"userItemTitleLinked\":1,\"userItemDateCreated\":1,\"userItemImage\":1,\"userItemIntroText\":1,\"userItemCategory\":1,\"userItemTags\":1,\"userItemCommentsAnchor\":1,\"userItemReadMore\":1,\"userItemK2Plugins\":1,\"tagItemCount\":10,\"tagItemTitle\":1,\"tagItemTitleLinked\":1,\"tagItemDateCreated\":1,\"tagItemImage\":1,\"tagItemIntroText\":1,\"tagItemCategory\":1,\"tagItemReadMore\":1,\"tagItemExtraFields\":0,\"tagOrdering\":\"\",\"tagFeedLink\":1,\"tagFeedIcon\":1,\"genericItemCount\":10,\"genericItemTitle\":1,\"genericItemTitleLinked\":1,\"genericItemDateCreated\":1,\"genericItemImage\":1,\"genericItemIntroText\":1,\"genericItemCategory\":1,\"genericItemReadMore\":1,\"genericItemExtraFields\":0,\"genericFeedLink\":1,\"genericFeedIcon\":1,\"feedLimit\":10,\"feedItemImage\":1,\"feedImgSize\":\"S\",\"feedItemIntroText\":1,\"feedTextWordLimit\":\"\",\"feedItemFullText\":1,\"feedItemTags\":0,\"feedItemVideo\":0,\"feedItemGallery\":0,\"feedItemAttachments\":0,\"feedBogusEmail\":\"\",\"introTextCleanup\":0,\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":0,\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":0,\"linkPopupWidth\":900,\"linkPopupHeight\":600,\"imagesQuality\":100,\"itemImageXS\":100,\"itemImageS\":200,\"itemImageM\":400,\"itemImageL\":600,\"itemImageXL\":900,\"itemImageGeneric\":300,\"catImageWidth\":100,\"catImageDefault\":1,\"userImageWidth\":100,\"userImageDefault\":1,\"commenterImgWidth\":48,\"imageTimestamp\":0,\"imageMemoryLimit\":\"\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"facebookImage\":\"XSmall\",\"comments\":1,\"commentsOrdering\":\"DESC\",\"commentsLimit\":10,\"commentsFormPosition\":\"below\",\"commentsPublishing\":1,\"commentsReporting\":2,\"commentsReportRecipient\":\"\",\"inlineCommentsModeration\":0,\"gravatar\":1,\"recaptcha\":0,\"commentsFormNotes\":1,\"commentsFormNotesText\":\"\",\"frontendEditing\":1,\"showImageTab\":1,\"showImageGalleryTab\":1,\"showVideoTab\":1,\"showExtraFieldsTab\":1,\"showAttachmentsTab\":1,\"showK2Plugins\":1,\"sideBarDisplayFrontend\":0,\"mergeEditors\":1,\"sideBarDisplay\":1,\"attachmentsFolder\":\"\",\"hideImportButton\":0,\"taggingSystem\":1,\"lockTags\":0,\"showTagFilter\":0,\"googleSearch\":0,\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":1,\"K2UserGroup\":1,\"redirect\":\"\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"recaptcha_public_key\":\"\",\"recaptcha_private_key\":\"\",\"recaptcha_theme\":\"clean\",\"recaptchaOnRegistration\":0,\"showItemsCounterAdmin\":1,\"showChildCatItems\":1,\"disableCompactOrdering\":0,\"SEFReplacements\":\"\\u00c5\\u00a0\\\\|S, \\u00c5\\u2019\\\\|O, \\u00c5\\u00bd\\\\|Z, \\u00c5\\u00a1\\\\|s, \\u00c5\\u201c\\\\|oe, \\u00c5\\u00be\\\\|z, \\u00c5\\u00b8\\\\|Y, \\u00c2\\u00a5\\\\|Y, \\u00c2\\u00b5\\\\|u, \\u00c3\\u20ac\\\\|A, \\u00c3\\ufffd\\\\|A, \\u00c3\\u201a\\\\|A, \\u00c3\\u0192\\\\|A, \\u00c3\\u201e\\\\|A, \\u00c3\\u2026\\\\|A, \\u00c3\\u2020\\\\|A, \\u00c3\\u2021\\\\|C, \\u00c3\\u02c6\\\\|E, \\u00c3\\u2030\\\\|E, \\u00c3\\u0160\\\\|E, \\u00c3\\u2039\\\\|E, \\u00c3\\u0152\\\\|I, \\u00c3\\ufffd\\\\|I, \\u00c3\\u017d\\\\|I, \\u00c3\\ufffd\\\\|I, \\u00c3\\ufffd\\\\|D, \\u00c3\\u2018\\\\|N, \\u00c3\\u2019\\\\|O, \\u00c3\\u201c\\\\|O, \\u00c3\\u201d\\\\|O, \\u00c3\\u2022\\\\|O, \\u00c3\\u2013\\\\|O, \\u00c3\\u02dc\\\\|O, \\u00c3\\u2122\\\\|U, \\u00c3\\u0161\\\\|U, \\u00c3\\u203a\\\\|U, \\u00c3\\u0153\\\\|U, \\u00c3\\ufffd\\\\|Y, \\u00c3\\u0178\\\\|s, \\u00c3\\u00a0\\\\|a, \\u00c3\\u00a1\\\\|a, \\u00c3\\u00a2\\\\|a, \\u00c3\\u00a3\\\\|a, \\u00c3\\u00a4\\\\|a, \\u00c3\\u00a5\\\\|a, \\u00c3\\u00a6\\\\|a, \\u00c3\\u00a7\\\\|c, \\u00c3\\u00a8\\\\|e, \\u00c3\\u00a9\\\\|e, \\u00c3\\u00aa\\\\|e, \\u00c3\\u00ab\\\\|e, \\u00c3\\u00ac\\\\|i, \\u00c3\\u00ad\\\\|i, \\u00c3\\u00ae\\\\|i, \\u00c3\\u00af\\\\|i, \\u00c3\\u00b0\\\\|o, \\u00c3\\u00b1\\\\|n, \\u00c3\\u00b2\\\\|o, \\u00c3\\u00b3\\\\|o, \\u00c3\\u00b4\\\\|o, \\u00c3\\u00b5\\\\|o, \\u00c3\\u00b6\\\\|o, \\u00c3\\u00b8\\\\|o, \\u00c3\\u00b9\\\\|u, \\u00c3\\u00ba\\\\|u, \\u00c3\\u00bb\\\\|u, \\u00c3\\u00bc\\\\|u, \\u00c3\\u00bd\\\\|y, \\u00c3\\u00bf\\\\|y, \\u00c3\\u0178\\\\|ss\",\"metaDescLimit\":150,\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":2,\"sh404SefTitleAlias\":\"alias\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10006,'JB_Shopignition','template','jb_shopignition','',0,1,1,0,'{\"legacy\":true,\"name\":\"JB_Shopignition\",\"type\":\"template\",\"creationDate\":\"June, 2009\",\"author\":\"Anthony Olsen\",\"copyright\":\"Joomla Bamboo, 2010.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"2.0\",\"description\":\"\\n\\t\\t<p style=\\\"line-height:180%;font-size:1.2em\\\"><a href=\\\"http:\\/\\/www.joomlabamboo.com\\\"><img src=\\\"http:\\/\\/www.joomlabamboo.com\\/images\\/JB_logo.jpg\\\" alt=\\\"joomla Bamboo\\\" style=\\\"float:left;margin:0 20px 20px 0px\\\"\\/><\\/a><br style=\\\"clear:both\\\" \\/>Shop Ignition is a beautifully crafted ecommerce template for Joomla that comes with pre-built styling for both Tienda and Red Shop ecommerce Joomla extensions.<\\/p>\\n\\t\",\"group\":\"\"}','{\"debug\":\"0\",\"legacy\":\"0\",\"zenTranslate\":\"1\",\"removejblogo\":\"0\",\"customcopyright\":\"\",\"hilite\":\"hiliteBlue\",\"tiendaCSS\":\"1\",\"redshopCSS\":\"1\",\"overwriteCSS\":\"1\",\"firstcolorelement\":\"\",\"firstcolorAtt\":\"\",\"firstcolor\":\"\",\"secondcolorelement\":\"\",\"secondcolorAtt\":\"\",\"secondcolor\":\"\",\"thirdcolorelement\":\"\",\"thirdcolorAtt\":\"\",\"thirdcolor\":\"\",\"fourthcolorelement\":\"\",\"fourthcolorAtt\":\"\",\"fourthcolor\":\"\",\"fifthcolorelement\":\"\",\"fifthcolorAtt\":\"\",\"fifthecolor\":\"\",\"sixthcolourelement\":\"\",\"sixthcolorAtt\":\"\",\"sixthcolor\":\"\",\"extraCSS\":\"\",\"logoType\":\"text\",\"logoWidth\":\"twelve\",\"logoLink\":\"\",\"logoClass\":\"h1\",\"logoPosition\":\"logo\",\"logoAlign\":\"zencenter\",\"logoText\":\"Shop Ignition\",\"fontStackLogo\":\"Rochester\",\"logoFontSize\":\"2em\",\"logoColour\":\"\",\"logoFile\":\"\",\"logoAltTag\":\"\",\"enableTagline\":\"1\",\"tagline\":\"\",\"taglineTop\":\"0px\",\"taglineLeft\":\"0px\",\"taglineCSS\":\"\",\"fonts\":\"1\",\"fontSize\":\"80%\",\"fontStackBody\":\"helvetica\",\"fontStackHeading\":\"helvetica\",\"fontStackNav\":\"helvetica\",\"fontStackSelector1\":\"\",\"fontStackCustom1\":\"helvetica\",\"fontStackSelector2\":\"\",\"fontStackCustom2\":\"helvetica\",\"fontStackSelector3\":\"\",\"fontStackCustom3\":\"helvetica\",\"typekit\":\"1\",\"typekitId\":\"\",\"bodyclassOption\":\"1\",\"bodyclassView\":\"1\",\"bodyclassLayout\":\"1\",\"bodyclassTask\":\"1\",\"bodyclassItem\":\"1\",\"bodyclassMainWidth\":\"1\",\"containerPosition\":\"center\",\"layoutType\":\"fixed\",\"tWidth\":\"960\",\"containerMargin\":\"0\",\"allEqual\":\"0\",\"controlMainArea\":\"0\",\"topEqual\":\"1\",\"top1Width\":\"4\",\"top2Width\":\"4\",\"top3Width\":\"4\",\"top4Width\":\"4\",\"headerEqual\":\"1\",\"header1Width\":\"4\",\"header2Width\":\"4\",\"header3Width\":\"4\",\"header4Width\":\"4\",\"grid1Equal\":\"1\",\"grid1Width\":\"three\",\"grid2Width\":\"three\",\"grid3Width\":\"three\",\"grid4Width\":\"three\",\"grid4WidthPx\":\"\",\"grid4Height\":\"\",\"grid2Equal\":\"1\",\"grid5Width\":\"three\",\"grid6Width\":\"three\",\"grid7Width\":\"three\",\"grid8Width\":\"three\",\"grid3Equal\":\"1\",\"grid9Width\":\"three\",\"grid10Width\":\"three\",\"grid11Width\":\"three\",\"grid12Width\":\"three\",\"grid4Equal\":\"1\",\"grid13Width\":\"three\",\"grid14Width\":\"three\",\"grid15Width\":\"three\",\"grid16Width\":\"three\",\"grid5Equal\":\"1\",\"grid17Width\":\"three\",\"grid18Width\":\"three\",\"grid19Width\":\"three\",\"grid20Width\":\"three\",\"grid6Equal\":\"1\",\"grid21Width\":\"three\",\"grid22Width\":\"three\",\"grid23Width\":\"three\",\"grid24Width\":\"three\",\"bottomEqual\":\"1\",\"bottom1Width\":\"two\",\"bottom2Width\":\"two\",\"bottom3Width\":\"two\",\"bottom4Width\":\"two\",\"bottom5Width\":\"two\",\"bottom6Width\":\"two\",\"footerWidth\":\"twelve\",\"navposition\":\"below\",\"navWidth\":\"twelve\",\"mainLayout\":\"two\",\"leftCols2L\":\"three\",\"midCols2L\":\"nine\",\"midCols2R\":\"nine\",\"rightCols2R\":\"three\",\"leftCols3LR\":\"four\",\"midCols3LR\":\"four\",\"rightCols3LR\":\"four\",\"leftCols4LRC\":\"three\",\"midCols4LRC\":\"three\",\"centerCols4LRC\":\"three\",\"rightCols4LRC\":\"three\",\"leftCols3LC\":\"three\",\"centerCols3LC\":\"three\",\"midCols3LC\":\"six\",\"midCols3RC\":\"six\",\"centerCols3RC\":\"three\",\"rightCols3RC\":\"three\",\"banner\":\"1\",\"bottom\":\"1\",\"closeContainer\":\"1\",\"footer\":\"1\",\"frontpage\":\"1\",\"grid1\":\"1\",\"grid2\":\"1\",\"grid3\":\"1\",\"grid4\":\"1\",\"grid5\":\"1\",\"grid6\":\"1\",\"header\":\"1\",\"main\":\"1\",\"nav\":\"1\",\"zentabs\":\"1\",\"openContainer\":\"1\",\"panel\":\"1\",\"top\":\"1\",\"superfish\":\"yes\",\"sfEffect\":\"1\",\"sfSpeed\":\"normal\",\"sfhover\":\"yes\",\"sfDelay\":\"800\",\"sfMinWidth\":\"14\",\"sfMaxWidth\":\"17\",\"panelMenu\":\"yes\",\"splitMenu\":\"0\",\"splitMenuName\":\"mainmenu\",\"splitMenuNavPos\":\"top1\",\"splitMenuNavStart\":\"0\",\"splitMenuNavEnd\":\"1\",\"splitMenuNav\":\"0\",\"splitMenuSubNavStart\":\"0\",\"splitMenuSubNavEnd\":\"1\",\"splitMenuAbove\":\"0\",\"splitMenuAboveStart\":\"0\",\"splitMenuAboveEnd\":\"1\",\"splitMenuLeft\":\"0\",\"splitMenuLeftTitle\":\"In this section ...\",\"splitMenuLeftStart\":\"1\",\"splitMenuLeftEnd\":\"2\",\"splitMenuRight\":\"0\",\"splitMenuRightTitle\":\"In this section ...\",\"splitMenuRightStart\":\"2\",\"splitMenuRightEnd\":\"3\",\"csscompress\":\"0\",\"k2CSS\":\"0\",\"combinescripts\":\"0\",\"bottomScripts\":\"0\",\"removeMootools\":\"0\",\"removeModal\":\"0\",\"removeK2\":\"0\",\"moduleslide\":\"0\",\"jQueryVersion\":\"1.6\",\"source\":\"local\",\"noConflict\":\"1\",\"stripCustom\":\"0\",\"customScripts\":\"\",\"removeJgen\":\"0\",\"disableTP\":\"0\",\"analyticsPosition\":\"after\",\"analytics\":\"\",\"extraScripts\":\"\",\"pngfix\":\"0\",\"pngfixrules\":\".pathway img,#logo a img,.topInner,.jbLogo,#topShadow,.slideShowNav.indexNavButtons  a.activeSlide,#slideShowNav.indexNavButtons  a:hover,div.jbReadmore,.mbMoreFlat .readon,.itemRatingList,.itemRatingList a:hover,.itemRatingList .itemCurrentRating,.k2ReadMore\",\"ie6Warning\":\"0\",\"openPanel\":\"Open\",\"paneltype\":\"opacity\",\"panelHeight\":\"200\",\"panelWidth\":\"300\",\"tab1Title\":\"Tab1\",\"jbTab1Icon\":\"heart\",\"tab2Title\":\"Tab2\",\"jbTab2Icon\":\"heart\",\"tab3Title\":\"Tab3\",\"jbTab3Icon\":\"heart\",\"tab4Title\":\"Tab4\",\"jbTab4Icon\":\"heart\",\"socialicons\":\"1\",\"socialiconstitle\":\"\",\"socialiconsposition\":\"1\",\"socialalign\":\"below\",\"icon1Image\":\"-1\",\"icon1Link\":\"#\",\"icon2Image\":\"-1\",\"icon2Link\":\"#\",\"icon3Image\":\"-1\",\"icon3Link\":\"#\",\"icon4Image\":\"-1\",\"icon4Link\":\"#\",\"icon5Image\":\"-1\",\"icon5Link\":\"#\",\"icon6Image\":\"-1\",\"icon6Link\":\"#\",\"lazyLoad\":\"1\",\"lazyloadSelector\":\"\",\"scrolltop\":\"0\",\"mediaqueries\":\"0\",\"mobileMeta\":\"0\",\"mobilemenu\":\"0\",\"mobileDetect\":\"OPT1\",\"topMob\":\"0\",\"headerMob\":\"0\",\"logoMob\":\"0\",\"navMob\":\"0\",\"bannerMob\":\"0\",\"tabMob\":\"0\",\"grid1Mob\":\"0\",\"grid2Mob\":\"0\",\"grid3Mob\":\"0\",\"grid4Mob\":\"0\",\"grid5Mob\":\"0\",\"grid6Mob\":\"0\",\"bottomMob\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10007,'System - Zen Grid Framework','plugin','zengridframework','system',0,1,1,0,'{\"legacy\":true,\"name\":\"System - Zen Grid Framework\",\"type\":\"plugin\",\"creationDate\":\"October, 2011\",\"author\":\"Author\",\"copyright\":\"Copyright (C) 2011 Joomlabamboo. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"http:\\/\\/www.joomlabamboo.com\",\"version\":\"2.0.5\",\"description\":\"\\n\\t\\t<p style=\\\"line-height:180%;font-size:1.2em\\\"><a href=\\\"http:\\/\\/www.joomlabamboo.com\\\"><img src=\\\"http:\\/\\/www.joomlabamboo.com\\/images\\/zengrid2\\/zengridframework2.png\\\" alt=\\\"Zen Grid Framework\\\" style=\\\"float:left;margin:0 20px 20px 0px\\\"\\/><\\/a><br style=\\\"clear:both\\\" \\/>The Zen Grid Framework v2.0 is a feature rich, mobile friendly and easy to use Joomla template framework. <br \\/>Please visit the <a href=\\\"http:\\/\\/docs.joomlabamboo.com\\/zen-grid-framework\\\">Zen Grid Framework Knowledgebase<\\/a> for more details.<br \\/><br \\/> This plugin must be enabled for your Zen grid framework compatible template to operate. The plugin does not contain any configuration options as all plugin parameters are controlled via the template.<\\/p>\\n\\t\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10008,'jTweet','module','mod_jTweet','',0,1,0,0,'{\"legacy\":false,\"name\":\"jTweet\",\"type\":\"module\",\"creationDate\":\"October 2009\",\"author\":\"Joomla Bamboo\",\"copyright\":\"(C) 2005 Open Source Matters. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.7.0\",\"description\":\"MOD_JTWEET_XML_DESCRIPTION\",\"group\":\"\"}','{\"type\":\"0\",\"userName\":\"\",\"query\":\"\",\"count\":\"5\",\"scripts\":\"article\",\"twitterBird\":\"bird1\",\"avatar\":\"no\",\"avatarSize\":\"48\",\"twitterName\":\"yes\",\"tweetSource\":\"yes\",\"joinText\":\"auto\",\"noReplies\":\"no\",\"tweetTemplate\":\"1\",\"popup\":\"yes\",\"moreInfo\":\"more info...!\",\"popupIntro\":\"I am on Twitter!\",\"follow\":\"yes\",\"followText\":\"Follow me on Twitter\",\"followStyle\":\"auto\",\"followPosition\":\"right\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10009,'JB MicroBlog','module','mod_microblog','',0,1,0,0,'{\"legacy\":true,\"name\":\"JB MicroBlog\",\"type\":\"module\",\"creationDate\":\"13\\/05\\/2009\",\"author\":\"Joomla Bamboo\",\"copyright\":\"This extension in released under the GNU\\/GPL License - http:\\/\\/www.gnu.org\\/copyleft\\/gpl.html\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.10.0\",\"description\":\"The microblog module displays the latest news from selected sections and categories and controls whether the intro text is displayed, the time of the post, whether the title is a link and whether or not to display a read more button. For more information please check the documentation at http:\\/\\/www.joomlabamboo.com\",\"group\":\"\"}','{\"layout\":\"flat\",\"mbHeight\":\"\",\"scripts\":\"article\",\"count\":\"5\",\"category_filtering_type\":\"1\",\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"articleinfo\":\"The following options are useful for selecting or omitting individual articles. Select All Articles will result in the category filter being the only effective filter.\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"titlelink\":\"2\",\"linkTarget\":\"article\",\"titleClass\":\"h2\",\"titleLimit\":\"0\",\"titleSuffix\":\"\",\"showintro\":\"1\",\"wordCount\":\"\",\"introSuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"displayMore\":\"1\",\"readonText\":\"\",\"showdate\":\"1\",\"translateDate\":\"0\",\"dateString\":\"1\",\"dateFormat\":\"j M, y\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"displayImages\":\"1\",\"resizeImage\":\"1\",\"image_width\":\"245\",\"image_height\":\"100\",\"option\":\"1\",\"fadeEffect\":\"1\",\"cbTheme\":\"1\",\"popupGallery\":\"1\",\"justImage\":\"1\",\"overlayOpacity\":\"0.6\",\"frameWidth\":\"800\",\"frameHeight\":\"500\",\"colorboxScrolling\":\"false\",\"addMargin\":\"1\",\"rightMargin\":\"5\",\"bottomMargin\":\"5\",\"imagesPerRow\":\"3\",\"colClearDiv\":\"1\",\"trigger1\":\"\",\"trigger2\":\"\",\"trigger3\":\"\",\"trigger4\":\"\",\"trigger5\":\"\",\"trigger6\":\"\",\"trigger7\":\"\",\"trigger8\":\"\",\"trigger9\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10010,'prettyBox','module','mod_prettyBox','',0,1,0,0,'{\"legacy\":false,\"name\":\"prettyBox\",\"type\":\"module\",\"creationDate\":\"Jan 2009\",\"author\":\"Joomla Bamboo\",\"copyright\":\"Copyright (C) 2008 Joomla Bamboo. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.1.0\",\"description\":\"MOD_PRETTYBOX_XML_DESCRIPTION\",\"group\":\"\"}','{\"directory\":\"images\\/\",\"output\":\"random\",\"details\":\"0\",\"link\":\"0\",\"perRow\":\"4\",\"scripts\":\"article\",\"prettyPhoto\":\"true\",\"theme\":\"dark_rounded\",\"opacity\":\"0.6\",\"resize\":\"true\",\"prettyBoxTitle\":\"false\",\"prettyBoxSpeed\":\"tfast\",\"overlayGallery\":\"false\",\"img_width\":\"200\",\"img_height\":\"100\",\"option\":\"1\",\"height\":\"150\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10011,'JB Slideshow v3.0','module','mod_slideshow3','',0,1,0,0,'{\"legacy\":false,\"name\":\"JB Slideshow v3.0\",\"type\":\"module\",\"creationDate\":\"April 2011\",\"author\":\"Joomla Bamboo\",\"copyright\":\"This extension in released under the GNU\\/GPL License - http:\\/\\/www.gnu.org\\/copyleft\\/gpl.html\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"http:\\/\\/www.joomlabamboo.com\",\"version\":\"1.2.0\",\"description\":\"JB Slideshow scrolls and fades latest news and images of your choice in a module position.\",\"group\":\"\"}','{\"display_ticker\":\"1\",\"display_slideshow\":\"1\",\"contentSource\":\"article\",\"scripts\":\"article\",\"ssTheme\":\"None\",\"ticker_transition\":\"fade\",\"slideshow_height\":\"400\",\"slideshow_width\":\"100%\",\"sstime\":\"10000\",\"ssSpeed\":\"1500\",\"content_image\":\"1\",\"itemImageSize\":\"Original\",\"imageLink\":\"1\",\"image_top\":\"0\",\"image_left\":\"380\",\"imgBorder\":\"1\",\"info2\":\"The options below are only relevant if you have selected directory as the source for the image in the settings above.\",\"imagedirectory\":\"\",\"lowercase\":\"0\",\"fileType\":\"jpg\",\"imageResize\":\"1\",\"image_width\":\"555\",\"image_height\":\"347\",\"option\":\"1\",\"count\":\"5\",\"category_filtering_type\":\"1\",\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"articleinfo\":\"The following options are useful for selecting or omitting individual articles. Select All Articles will result in the category filter being the only effective filter.\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"k2count\":\"5\",\"k2catid\":\"\",\"getChildren\":\"0\",\"k2items\":\"\",\"k2Ordering\":\"\",\"k2FeaturedItems\":\"1\",\"popularityRange\":\"\",\"ticker_height\":\"260\",\"ticker_width\":\"360\",\"margin_top\":\"100\",\"margin_left\":\"0\",\"bgOverlay\":\"no\",\"item_title\":\"1\",\"title_class\":\"h2\",\"title_link\":\"1\",\"linkTarget\":\"article\",\"ticker_text\":\"1\",\"introtext_limit\":\"40\",\"striptags\":\"yes\",\"tags\":\"<a><ul><li><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"render\",\"createdDate\":\"1\",\"dateFormat\":\"j M, y\",\"readMoreText\":\"Read More ...\",\"readMoreLink\":\"1\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"display_nav\":\"thumbsNav\",\"navWidth\":\"400\",\"navHeight\":\"400\",\"navTop\":\"0\",\"navLeft\":\"0\",\"navButtons\":\"on\",\"navPrevText\":\"<<  Previous\",\"navNextText\":\"Next  >>\",\"scrollNav\":\"vertical\",\"numVis\":\"3\",\"navItemWidth\":\"40\",\"navItemHeight\":\"40\",\"titleLimit\":\"0\",\"titleSuffix\":\"...\",\"fadeEffect\":\"1\",\"hoverTransition\":\"no\",\"thumb_width\":\"60\",\"thumb_height\":\"40\",\"thumb_option\":\"1\",\"tickerIntro\":\" \",\"showDescriptionText\":\"none\",\"descriptionText\":\"\",\"descriptionMarginTop\":\"0\",\"descriptionMarginLeft\":\"0\",\"descriptionHeight\":\"50\",\"descriptionWidth\":\"100\",\"descriptionOverlay\":\"no\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10012,'JB Captify Content','module','mod_captifyContent','',0,1,0,0,'{\"legacy\":false,\"name\":\"JB Captify Content\",\"type\":\"module\",\"creationDate\":\"April 2011\",\"author\":\"Joomla Bamboo\",\"copyright\":\"This extension in released under the GNU\\/GPL License - http:\\/\\/www.gnu.org\\/copyleft\\/gpl.html\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"http:\\/\\/www.joomlabamboo.com\",\"version\":\"1.1.0\",\"description\":\"Captify Content displays the image assigned to your categories or articles and the title using the awesome captifyScript. If the section or category does not have an image assigned to it then it will not show. Please note that you need to have the JB Library plugin installed and published for this module to work as desired.\",\"group\":\"\"}','{\"type\":\"section\",\"count\":\"5\",\"imagesPerRow\":\"3\",\"titleBelow\":\"0\",\"scripts\":\"article\",\"category_filtering_type\":\"1\",\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"articleinfo\":\"The following options are particularly relevant to using articles as a source of Captify images. Picking a value of Select all Articles will not filter any articles except by the category selctions above. If you have chosen to display images from categories then the following settings can be ignored.\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"c_catid\":\"\",\"c_show_child_category_articles\":\"0\",\"c_levels\":\"1\",\"image_width\":\"245\",\"image_height\":\"100\",\"option\":\"1\",\"imageDimensions\":\"1\",\"rightMargin\":\"0\",\"bottomMargin\":\"0\",\"useCaptify\":\"1\",\"background\":\"1\",\"transition\":\"slide\",\"position\":\"bottom\",\"speed\":\"800\",\"speedOut\":\"800\",\"fadeEffect\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10013,'System - JB Type ','plugin','jbtype','system',0,1,1,0,'{\"legacy\":false,\"name\":\"System - JB Type \",\"type\":\"plugin\",\"creationDate\":\"Feb 2010\",\"author\":\"Joomla Bamboo\",\"copyright\":\"Copyright 2006 to 2011 - joomlabamboo.com\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com.com\",\"version\":\"1.4.2\",\"description\":\"<p style=\\\"line-height:180%;font-size:1.2em\\\"><a href=\\\"http:\\/\\/www.joomlabamboo.com\\/joomla-extensions\\/jb-type-joomla-typography-plugin\\\"><img src=\\\"http:\\/\\/d129tlhqmunv45.cloudfront.net\\/images\\/blog\\/icons\\/JBtype.png?1305337042\\\" alt=\\\"JB Type\\\" style=\\\"float:left;margin:0 20px 20px 0px\\\"\\/><\\/a><br style=\\\"clear:both\\\" \\/>JB Type is a Joomla style and typography plugin for your content. By using some simple Joomla syntax you can create some awesome typography for your site without knowing any html at all.<\\/p>\",\"group\":\"\"}','{\"iconStyle\":\"coquette\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10014,'K2 Comments','module','mod_k2_comments','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Comments\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_COMMENTS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"\",\"\":\"K2_TOP_COMMENTERS\",\"catfilter\":\"0\",\"category_id\":\"\",\"comments_limit\":\"5\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"1\",\"itemCategory\":\"1\",\"feed\":\"1\",\"commenters_limit\":\"5\",\"commenterNameOrUsername\":\"1\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10015,'K2 Content','module','mod_k2_content','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Content\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_MOD_K2_CONTENT_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"\":\"K2_OTHER_OPTIONS\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemCount\":\"5\",\"itemsOrdering\":\"\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"\",\"items\":\"\",\"itemTitle\":\"1\",\"itemAuthor\":\"1\",\"itemAuthorAvatar\":\"1\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"50\",\"userDescription\":\"1\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"\",\"itemImage\":\"1\",\"itemImgSize\":\"Small\",\"itemVideo\":\"1\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemAttachments\":\"1\",\"itemTags\":\"1\",\"itemCategory\":\"1\",\"itemDateCreated\":\"1\",\"itemHits\":\"1\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"1\",\"feed\":\"1\",\"itemPreText\":\"\",\"itemCustomLink\":\"0\",\"itemCustomLinkTitle\":\"\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkMenuItem\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10016,'K2 Login','module','mod_k2_login','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Login\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_LOGIN_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10017,'K2 Tools','module','mod_k2_tools','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Tools\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_TOOLS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"\":\"K2_CUSTOM_CODE_SETTINGS\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"\",\"authors_module_category\":\"\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":\"0\",\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10018,'K2 Users','module','mod_k2_users','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Users\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_MOD_K2_USERS_DESCRTIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"0\",\"\":\"K2_DISPLAY_OPTIONS\",\"filter\":\"1\",\"K2UserGroup\":\"\",\"ordering\":\"1\",\"limit\":\"4\",\"userIDs\":\"\",\"userName\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"userDescription\":\"1\",\"userDescriptionWordLimit\":\"\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"userItemCount\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10019,'K2 User','module','mod_k2_user','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 User\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_MOD_K2_USER_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10020,'K2 QuickIcons (admin)','module','mod_k2_quickicons','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 QuickIcons (admin)\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE\",\"group\":\"\"}','{\"modCSSStyling\":\"1\",\"modLogo\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10021,'K2 Stats (admin)','module','mod_k2_stats','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 Stats (admin)\",\"type\":\"module\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE\",\"group\":\"\"}','{\"latestItems\":\"1\",\"popularItems\":\"1\",\"mostCommentedItems\":\"1\",\"latestComments\":\"1\",\"statistics\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10022,'Search - K2','plugin','k2','search',0,1,1,0,'{\"legacy\":true,\"name\":\"Search - K2\",\"type\":\"plugin\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_tags\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10023,'System - K2','plugin','k2','system',0,1,1,0,'{\"legacy\":true,\"name\":\"System - K2\",\"type\":\"plugin\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10024,'User - K2','plugin','k2','user',0,1,1,0,'{\"legacy\":true,\"name\":\"User - K2\",\"type\":\"plugin\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10025,'k2','component','com_k2','',1,1,0,0,'{\"legacy\":true,\"name\":\"K2\",\"type\":\"component\",\"creationDate\":\"October 27th, 2011\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2011 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.gr\",\"authorUrl\":\"www.joomlaworks.gr\",\"version\":\"2.5.1\",\"description\":\"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!\",\"group\":\"\"}','{\"enable_css\":\"1\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"userItemCount\":\"10\",\"userItemTitle\":\"1\",\"userItemTitleLinked\":\"1\",\"userItemDateCreated\":\"1\",\"userItemImage\":\"1\",\"userItemIntroText\":\"1\",\"userItemCategory\":\"1\",\"userItemTags\":\"1\",\"userItemCommentsAnchor\":\"1\",\"userItemReadMore\":\"1\",\"userItemK2Plugins\":\"1\",\"tagItemCount\":\"10\",\"tagItemTitle\":\"1\",\"tagItemTitleLinked\":\"1\",\"tagItemDateCreated\":\"1\",\"tagItemImage\":\"1\",\"tagItemIntroText\":\"1\",\"tagItemCategory\":\"1\",\"tagItemReadMore\":\"1\",\"tagItemExtraFields\":\"0\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"genericItemCount\":\"10\",\"genericItemTitle\":\"1\",\"genericItemTitleLinked\":\"1\",\"genericItemDateCreated\":\"1\",\"genericItemImage\":\"1\",\"genericItemIntroText\":\"1\",\"genericItemCategory\":\"1\",\"genericItemReadMore\":\"1\",\"genericItemExtraFields\":\"0\",\"genericFeedLink\":\"1\",\"genericFeedIcon\":\"1\",\"feedLimit\":\"10\",\"feedItemImage\":\"1\",\"feedImgSize\":\"S\",\"feedItemIntroText\":\"1\",\"feedTextWordLimit\":\"\",\"feedItemFullText\":\"1\",\"feedItemTags\":\"0\",\"feedItemVideo\":\"0\",\"feedItemGallery\":\"0\",\"feedItemAttachments\":\"0\",\"feedBogusEmail\":\"\",\"introTextCleanup\":\"0\",\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":\"0\",\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":\"0\",\"linkPopupWidth\":\"900\",\"linkPopupHeight\":\"600\",\"imagesQuality\":\"100\",\"itemImageXS\":\"100\",\"itemImageS\":\"200\",\"itemImageM\":\"400\",\"itemImageL\":\"600\",\"itemImageXL\":\"900\",\"itemImageGeneric\":\"300\",\"catImageWidth\":\"100\",\"catImageDefault\":\"1\",\"userImageWidth\":\"100\",\"userImageDefault\":\"1\",\"commenterImgWidth\":\"48\",\"imageTimestamp\":\"0\",\"imageMemoryLimit\":\"\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"urlShortener\":\"1\",\"comments\":\"1\",\"commentsOrdering\":\"DESC\",\"commentsLimit\":\"10\",\"commentsFormPosition\":\"below\",\"commentsPublishing\":\"1\",\"gravatar\":\"1\",\"recaptcha\":\"0\",\"commentsFormNotes\":\"1\",\"commentsFormNotesText\":\"\",\"frontendEditing\":\"1\",\"showImageTab\":\"1\",\"showImageGalleryTab\":\"1\",\"showVideoTab\":\"1\",\"showExtraFieldsTab\":\"1\",\"showAttachmentsTab\":\"1\",\"showK2Plugins\":\"1\",\"sideBarDisplayFrontend\":\"0\",\"mergeEditors\":\"1\",\"sideBarDisplay\":\"1\",\"attachmentsFolder\":\"\",\"hideImportButton\":\"0\",\"taggingSystem\":\"1\",\"lockTags\":\"0\",\"showTagFilter\":\"0\",\"googleSearch\":\"0\",\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":\"1\",\"K2UserGroup\":\"\",\"redirect\":\"\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"recaptcha_public_key\":\"\",\"recaptcha_private_key\":\"\",\"recaptcha_theme\":\"clean\",\"recaptchaOnRegistration\":\"0\",\"showItemsCounterAdmin\":\"1\",\"showChildCatItems\":\"1\",\"disableCompactOrdering\":\"0\",\"SEFReplacements\":\"\",\"metaDescLimit\":\"150\",\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":\"2\",\"sh404SefTitleAlias\":\"alias\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10026,'redshop','component','com_redshop','',1,1,0,0,'{\"legacy\":true,\"name\":\"redSHOP\",\"type\":\"component\",\"creationDate\":\"10-10-2011\",\"author\":\"Redweb.dk\",\"copyright\":\"(c) Redweb.dk\",\"authorEmail\":\"email@redweb.dk\",\"authorUrl\":\"www.redweb.dk\",\"version\":\"1.1.9.4\",\"description\":\"redSHOP Joomla Webshop Component\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10027,'RedSHOP cart module','module','mod_redshop_cart','',0,1,0,0,'{\"legacy\":false,\"name\":\"RedSHOP cart module\",\"type\":\"module\",\"creationDate\":\"10-10-2010\",\"author\":\"redweb.dk\",\"copyright\":\"redCOMPONENT.com\",\"authorEmail\":\"email@redweb.dk\",\"authorUrl\":\"\",\"version\":\"1.1.8\",\"description\":\"Redshop Cart Module\",\"group\":\"\"}','{\"cart_output\":\"0\",\"moduleclass_sfx\":\"\",\"show_with_shipping\":\"0\",\"show_with_discount\":\"0\",\"show_with_vat\":\"0\",\"show_shipping_line\":\"0\",\"checkout_empty\":\"1\",\"button_text\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10028,'System - JB Library','plugin','jblibrary','system',0,1,1,0,'{\"legacy\":false,\"name\":\"System - JB Library\",\"type\":\"plugin\",\"creationDate\":\"Feb 2009\",\"author\":\"Joomla Bamboo\",\"copyright\":\"(C) 2007-2009 Joomla Bamboo\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.1.0\",\"description\":\"JB_LIBRARY_DESC\",\"group\":\"\"}','{\"jQueryVersion\":\"1.6\",\"source\":\"local\",\"noConflict\":\"1\",\"jqunique\":\"1\",\"jqregex\":\"([\\\\\\/a-zA-Z0-9_:\\\\.-]*)jquery([0-9\\\\.-]|min|pack)*?.js\",\"stripCustom\":\"0\",\"customScripts\":\"\",\"stripMootools\":\"0\",\"replaceMootools\":\"0\",\"mootoolsPath\":\"http:\\/\\/ajax.googleapis.com\\/ajax\\/libs\\/mootools\\/1.3.1\\/mootools-yui-compressed.js\",\"stripMootoolsMore\":\"0\",\"ie6Warning\":\"1\",\"scrollTop\":\"1\",\"scrollStyle\":\"dark\",\"scrollTextTranslate\":\"1\",\"scrollText\":\"BACK_TO_TOP\",\"lazyLoad\":\"0\",\"llSelector\":\"img\"}','','',62,'2011-11-18 06:04:55',0,0);

/*!40000 ALTER TABLE `#__extensions` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_attachments
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_attachments`;

CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__k2_categories
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_categories`;

CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_categories` WRITE;
/*!40000 ALTER TABLE `#__k2_categories` DISABLE KEYS */;

INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`)
VALUES
	(7,'Demo Content','demo-content','',0,0,1,1,1,'','{\"inheritFrom\":\"0\",\"theme\":\"ignition\",\"num_leading_items\":\"3\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"1\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),
	(8,'Blog','blog','',7,0,1,1,1,'','{\"inheritFrom\":\"0\",\"theme\":\"ignition\",\"num_leading_items\":\"3\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"1\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"1\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"1\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),
	(9,'About Us','about-us','',7,0,1,0,2,'','inheritFrom=7\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',1,'',''),
	(10,'Services','services','',7,0,1,0,3,'','inheritFrom=7\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',1,'',''),
	(11,'Slideshow','slideshow','',7,0,1,0,4,'','inheritFrom=7\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',1,'',''),
	(12,'Features','features','',7,0,1,0,2,'','inheritFrom=7\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nfeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',1,'',''),
	(13,'Setting Up','setting-up','',7,0,1,0,6,'','inheritFrom=7\ntheme=\nnum_leading_items=2\nnum_leading_columns=1\nleadingImgSize=Large\nnum_primary_items=4\nnum_primary_columns=2\nprimaryImgSize=Medium\nnum_secondary_items=4\nnum_secondary_columns=1\nsecondaryImgSize=Small\nnum_links=4\nnum_links_columns=1\nlinksImgSize=XSmall\ncatCatalogMode=0\ncatFeaturedItems=1\ncatOrdering=\ncatPagination=2\ncatPaginationResults=1\ncatTitle=1\ncatTitleItemCounter=1\ncatDescription=1\ncatImage=1\ncatFeedLink=1\nsubCategories=1\nsubCatColumns=2\nsubCatOrdering=\nsubCatTitle=1\nsubCatTitleItemCounter=1\nsubCatDescription=1\nsubCatImage=1\nitemImageXS=\nitemImageS=\nitemImageM=\nitemImageL=\nitemImageXL=\ncatItemTitle=1\ncatItemTitleLinked=1\ncatItemFeaturedNotice=0\ncatItemAuthor=1\ncatItemDateCreated=1\ncatItemRating=0\ncatItemImage=1\ncatItemIntroText=1\ncatItemIntroTextWordLimit=\ncatItemExtraFields=0\ncatItemHits=0\ncatItemCategory=1\ncatItemTags=1\ncatItemAttachments=0\ncatItemAttachmentsCounter=0\ncatItemVideo=0\ncatItemVideoWidth=\ncatItemVideoHeight=\ncatItemVideoAutoPlay=0\ncatItemImageGallery=0\ncatItemDateModified=0\ncatItemReadMore=1\ncatItemCommentsAnchor=1\ncatItemK2Plugins=1\nitemDateCreated=1\nitemTitle=1\nitemFeaturedNotice=1\nitemAuthor=1\nitemFontResizer=1\nitemPrintButton=1\nitemEmailButton=1\nitemSocialButton=1\nitemVideoAnchor=1\nitemImageGalleryAnchor=1\nitemCommentsAnchor=1\nitemRating=1\nitemImage=1\nitemImgSize=Large\nitemImageMainCaption=1\nitemImageMainCredits=1\nitemIntroText=1\nitemFullText=1\nitemExtraFields=1\nitemDateModified=1\nitemHits=1\nitemTwitterLink=1\nitemCategory=1\nitemTags=1\nitemShareLinks=1\nitemAttachments=1\nitemAttachmentsCounter=1\nitemRelated=1\nitemRelatedLimit=5\nitemVideo=1\nitemVideoWidth=\nitemVideoHeight=\nitemVideoAutoPlay=0\nitemVideoCaption=1\nitemVideoCredits=1\nitemImageGallery=1\nitemNavigation=1\nitemComments=1\nitemAuthorBlock=1\nitemAuthorImage=1\nitemAuthorDescription=1\nitemAuthorURL=1\nitemAuthorEmail=1\nitemAuthorLatest=1\nitemAuthorLatestLimit=5\nitemK2Plugins=1\n\n',1,'','');

/*!40000 ALTER TABLE `#__k2_categories` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_comments
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_comments`;

CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_comments` WRITE;
/*!40000 ALTER TABLE `#__k2_comments` DISABLE KEYS */;

INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`)
VALUES
	(1,4,0,'Tester','2010-01-26 03:03:41','Yeah this is such an awesome comment','designiac@joop.com','http://www.jooomlajaj.com',1),
	(2,4,0,'Whatsit','2010-03-02 04:05:32','Tell my about it - I think thats just handsdown the best thing Ive ever read.','test@joomlabamboo.com','http://www.joomlabamboo.com',1),
	(3,26,0,'K2Joom','2010-03-03 08:25:37','Just a test, got to make sure it works right?','simon@k2joom.com','',1),
	(4,69,0,'Magazine Freak','2010-03-22 07:24:31','This is one of the best comments Ive ever made.','test@mag.com','http://www.joomlbamboo.com',1),
	(5,69,0,'You are the best','2010-03-22 07:25:12','Integer molestie quam dictum justo adipiscing hendrerit in nec erat. Pellentesque convallis malesuada purus sit amet lacinia.','best@comments.com','http://www.commenter.com',1),
	(6,63,0,'dsf','2010-04-08 13:14:06','fgfdg','schiberis@gmail.com','',1),
	(7,36,0,'Austin Warren','2010-04-08 15:59:55','great item.','awarren@mnsi.com','',1),
	(8,32,0,'Опа-Допа','2010-04-12 14:21:50','Приём, Алтай 4','kedsmopeds@yandex.ru','',1),
	(9,36,0,'Darryl Jones','2010-04-13 14:50:29','this looks interesting. Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud e','splattered1@gmail.com','',1),
	(10,56,0,'Acomplia Tablets','2010-04-17 00:48:17','Buy Generic Acomplia\r\nAcomplia is manufactured by the pharmaceutical company Sanofi Aventis and its generic notability is rimonabant (lively ingredient). Acomplia helps overweight and pudgy people to admit defeat force cultivate they bring off a in good weight. Acomplia promotes protected value damage and does not subscribe to fixed power erosion which often people seeking picture-perfect work out hanker for.','serpolaska@gmail.com','',1),
	(11,56,0,'CHEAP Cialis','2010-04-18 01:33:54','buy cialis on line uk   Buy Cialis online buy cialis doctor online \r\n http://www1.chaffey.edu/tabs/ buy cialis online 32  http://www1.chaffey.edu/counseling/','serpolaska@gmail.com','',1),
	(12,69,0,'Steven','2010-04-22 07:34:59','Die Bilder sind wirklich sehr cool! Das Template ist sehr schön geworden','max@muster.de','',1),
	(13,69,0,'haris','2010-04-23 14:00:38','test comment','dfdfd@commentme.com','',1),
	(14,63,0,'dope','2010-04-23 19:16:56','dope','shfdjh@kjdfkfjdk.com','',1);

/*!40000 ALTER TABLE `#__k2_comments` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_extra_fields
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_extra_fields`;

CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__k2_extra_fields_groups
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_extra_fields_groups`;

CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__k2_items
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_items`;

CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext,
  `fulltext` mediumtext,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `language` (`language`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_items` WRITE;
/*!40000 ALTER TABLE `#__k2_items` DISABLE KEYS */;

INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`)
VALUES
	(32,'Nunc ligula velit','nunc-ligula-velit',8,1,'<p><img class=\"border floatleft\" src=\"images/democontent/stockimages/iStock_000003279378Small.jpg\" border=\"0\" alt=\"iStock_000003279378Small\" width=\"394\" height=\"218\" />Sed nec leo vitae nisi varius sodales. Nulla porta gravida cursus. Nunc ligula velit, fermentum in posuere eu, congue non odio. Sed blandit, ipsum in pharetra mollis, nisl nisl cursus nisi, ut condimentum metus nisl nec ipsum. Nam ultricies elit quis ligula placerat molestie. Nunc sit amet bibendum massa.</p>\r\n','\r\n<p> </p>\r\n<p>Sed in vestibulum turpis. Nulla sed pellentesque libero. Sed fringilla elementum metus, et scelerisque tortor sodales consectetur. Pellentesque volutpat interdum nisi, eu gravida magna dignissim quis. Nulla congue volutpat arcu, nec placerat velit bibendum et. Mauris varius nulla at felis pellentesque et mollis est semper.</p>\r\n<p>Cras dui lectus, convallis non pharetra vitae, dignissim in leo. Vivamus pellentesque elit non tellus tincidunt a fringilla metus varius. Nunc et urna eu erat convallis mattis vitae ac enim. Ut at est non turpis elementum tincidunt at sit amet arcu.</p>\r\n<p>Nulla fringilla tincidunt felis, sit amet eleifend odio interdum non. Nam nec imperdiet nunc. Etiam quis tortor nec nisl porta porttitor.</p>',NULL,NULL,'[]','','2009-11-22 01:49:41',62,'',62,'2011-11-15 10:02:13','2011-11-15 10:02:04',62,'2009-11-22 01:49:41','0000-00-00 00:00:00',0,1,6,0,0,'','','','',128,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(69,'A K2 Item','a-k2-item',8,1,'<p><img class=\"border floatleft\" src=\"images/democontent/stockimages/iStock_000002829958XSmall.jpg\" border=\"0\" alt=\"iStock_000002829958XSmall\" width=\"394\" height=\"254\" />This is an example of a K2 Item page.</p>\r\n<p>K2 Items allow additional features and functions to be used which are not available if you create content using the default Joomla Articles.</p>\r\n<p>K2 moves away from the restrictive Sections and Categories and instead uses Nested Categories which in turn allows for multilevel categories to be created.  More information on categories can be found under the K2 menu.</p>\r\n<p>Look around this page, see them?</p>\r\n','\r\n<p>Lets start at the top of the page and look at some of the features which have been styled.</p>\r\n<ul>\r\n<li>Font Resizing Top Left.</li>\r\n<li>Item Rating Top Right.</li>\r\n<li>Tagging, below the item text.</li>\r\n<li>Social Media Links, below tagging.</li>\r\n<li>Link to Author Bio.</li>\r\n<li>Latest, from author.</li>\r\n<li>Related items, by tag.</li>\r\n<li>Built in commenting, with reCaptcha support.</li>\r\n<li>Video, requires additional extension.</li>\r\n<li>Image Galleries, requires additional extension.</li>\r\n</ul>\r\n<p>All of these features can be enabled/disabled through K2.</p>\r\n<p>Sed in vestibulum turpis. Nulla sed pellentesque libero. Sed fringilla elementum metus, et scelerisque tortor sodales consectetur. Pellentesque volutpat interdum nisi, eu gravida magna dignissim quis. Nulla congue volutpat arcu, nec placerat velit bibendum et. Mauris varius nulla at felis pellentesque et mollis est semper.</p>\r\n<p>Cras dui lectus, convallis non pharetra vitae, dignissim in leo. Vivamus pellentesque elit non tellus tincidunt a fringilla metus varius. Nunc et urna eu erat convallis mattis vitae ac enim. Ut at est non turpis elementum tincidunt at sit amet arcu.</p>\r\n<p>Nulla fringilla tincidunt felis, sit amet eleifend odio interdum non. Nam nec imperdiet nunc. Etiam quis tortor nec nisl porta porttitor.</p>','','{gallery}69{/gallery}','[]','','2010-03-05 02:27:40',62,'',0,'0000-00-00 00:00:00','2011-11-15 10:42:01',62,'2009-11-22 01:49:41','0000-00-00 00:00:00',0,1,1,1,0,'','','','',3029,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(33,'Sed elementum','sed-elementum',8,1,'<p><img class=\"border floatleft\" src=\"images/democontent/stockimages/iStock_000003347135XSmall.jpg\" border=\"0\" alt=\"iStock_000003347135XSmall\" width=\"394\" height=\"261\" />Sed nec leo vitae nisi varius sodales. Nulla porta gravida cursus. Nunc ligula velit, fermentum in posuere eu, congue non odio. Sed blandit, ipsum in pharetra mollis, nisl nisl cursus nisi, ut condimentum metus nisl nec ipsum. Nam ultricies elit quis ligula placerat molestie. Nunc sit amet bibendum massa.</p>\r\n','\r\n<p> </p>\r\n<p>Sed in vestibulum turpis. Nulla sed pellentesque libero. Sed fringilla elementum metus, et scelerisque tortor sodales consectetur. Pellentesque volutpat interdum nisi, eu gravida magna dignissim quis. Nulla congue volutpat arcu, nec placerat velit bibendum et. Mauris varius nulla at felis pellentesque et mollis est semper.</p>\r\n<p>Cras dui lectus, convallis non pharetra vitae, dignissim in leo. Vivamus pellentesque elit non tellus tincidunt a fringilla metus varius. Nunc et urna eu erat convallis mattis vitae ac enim. Ut at est non turpis elementum tincidunt at sit amet arcu.</p>\r\n<p>Nulla fringilla tincidunt felis, sit amet eleifend odio interdum non. Nam nec imperdiet nunc. Etiam quis tortor nec nisl porta porttitor.</p>',NULL,NULL,'[]','','2009-11-22 01:49:41',62,'',0,'0000-00-00 00:00:00','2011-11-15 10:01:56',62,'2009-11-22 01:49:41','0000-00-00 00:00:00',0,1,5,0,0,'','','','',119,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(34,'Ipsum in pharetra','ipsum-in-pharetra',8,1,'<p><img class=\"border floatleft\" src=\"images/democontent/stockimages/iStock_000003242976XSmall.jpg\" border=\"0\" alt=\"iStock_000003242976XSmall\" width=\"283\" height=\"424\" />Sed nec leo vitae nisi varius sodales. Nulla porta gravida cursus. Nunc ligula velit, fermentum in posuere eu, congue non odio. Sed blandit, ipsum in pharetra mollis, nisl nisl cursus nisi, ut condimentum metus nisl nec ipsum. Nam ultricies elit quis ligula placerat molestie. Nunc sit amet bibendum massa.</p>\r\n','\r\n<p> </p>\r\n<p>Sed in vestibulum turpis. Nulla sed pellentesque libero. Sed fringilla elementum metus, et scelerisque tortor sodales consectetur. Pellentesque volutpat interdum nisi, eu gravida magna dignissim quis. Nulla congue volutpat arcu, nec placerat velit bibendum et. Mauris varius nulla at felis pellentesque et mollis est semper.</p>\r\n<p>Cras dui lectus, convallis non pharetra vitae, dignissim in leo. Vivamus pellentesque elit non tellus tincidunt a fringilla metus varius. Nunc et urna eu erat convallis mattis vitae ac enim. Ut at est non turpis elementum tincidunt at sit amet arcu.</p>\r\n<p>Nulla fringilla tincidunt felis, sit amet eleifend odio interdum non. Nam nec imperdiet nunc. Etiam quis tortor nec nisl porta porttitor.</p>',NULL,NULL,'[]','','2009-11-22 01:49:41',62,'',0,'0000-00-00 00:00:00','2011-11-15 10:02:26',62,'2009-11-22 01:49:41','0000-00-00 00:00:00',0,1,4,0,0,'','','','',118,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(35,'Sed blandit','sed-blandit',8,1,'<p><img class=\"border floatleft\" src=\"images/democontent/stockimages/iStock_000002434183XSmall.jpg\" border=\"0\" alt=\"iStock_000002434183XSmall\" width=\"394\" height=\"263\" />Sed nec leo vitae nisi varius sodales. Nulla porta gravida cursus. Nunc ligula velit, fermentum in posuere eu, congue non odio. Sed blandit, ipsum in pharetra mollis, nisl nisl cursus nisi, ut condimentum metus nisl nec ipsum. Nam ultricies elit quis ligula placerat molestie. Nunc sit amet bibendum massa.</p>\r\n','\r\n<p> </p>\r\n<p>Sed in vestibulum turpis. Nulla sed pellentesque libero. Sed fringilla elementum metus, et scelerisque tortor sodales consectetur. Pellentesque volutpat interdum nisi, eu gravida magna dignissim quis. Nulla congue volutpat arcu, nec placerat velit bibendum et. Mauris varius nulla at felis pellentesque et mollis est semper.</p>\r\n<p>Cras dui lectus, convallis non pharetra vitae, dignissim in leo. Vivamus pellentesque elit non tellus tincidunt a fringilla metus varius. Nunc et urna eu erat convallis mattis vitae ac enim. Ut at est non turpis elementum tincidunt at sit amet arcu.</p>\r\n<p>Nulla fringilla tincidunt felis, sit amet eleifend odio interdum non. Nam nec imperdiet nunc. Etiam quis tortor nec nisl porta porttitor.</p>',NULL,NULL,'[]','','2009-11-22 01:49:41',62,'',62,'2011-11-15 10:02:10','2011-11-15 10:01:50',62,'2009-11-22 01:49:41','0000-00-00 00:00:00',0,1,3,0,0,'','','','',209,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(36,'Nam ultricies elit','nam-ultricies-elit',8,1,'<p><img class=\"border floatleft\" src=\"images/democontent/stockimages/iStock_000001000643XSmall.jpg\" border=\"0\" alt=\"iStock_000001000643XSmall\" width=\"394\" height=\"261\" />Sed nec leo vitae nisi varius sodales. Nulla porta gravida cursus. Nunc ligula velit, fermentum in posuere eu, congue non odio. Sed blandit, ipsum in pharetra mollis, nisl nisl cursus nisi, ut condimentum metus nisl nec ipsum. Nam ultricies elit quis ligula placerat molestie. Nunc sit amet bibendum massa.</p>\r\n','\r\n<p> </p>\r\n<p>Sed in vestibulum turpis. Nulla sed pellentesque libero. Sed fringilla elementum metus, et scelerisque tortor sodales consectetur. Pellentesque volutpat interdum nisi, eu gravida magna dignissim quis. Nulla congue volutpat arcu, nec placerat velit bibendum et. Mauris varius nulla at felis pellentesque et mollis est semper.</p>\r\n<p>Cras dui lectus, convallis non pharetra vitae, dignissim in leo. Vivamus pellentesque elit non tellus tincidunt a fringilla metus varius. Nunc et urna eu erat convallis mattis vitae ac enim. Ut at est non turpis elementum tincidunt at sit amet arcu.</p>\r\n<p>Nulla fringilla tincidunt felis, sit amet eleifend odio interdum non. Nam nec imperdiet nunc. Etiam quis tortor nec nisl porta porttitor.</p>',NULL,NULL,'[]','','2009-11-22 01:49:41',62,'',62,'2011-11-15 10:02:09','2011-11-15 10:01:39',62,'2009-11-22 01:49:41','0000-00-00 00:00:00',0,1,2,0,0,'','','','',204,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*');

/*!40000 ALTER TABLE `#__k2_items` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_rating
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_rating`;

CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_rating` WRITE;
/*!40000 ALTER TABLE `#__k2_rating` DISABLE KEYS */;

INSERT INTO `#__k2_rating` (`itemID`, `rating_sum`, `rating_count`, `lastip`)
VALUES
	(69,4,1,'127.0.0.1'),
	(36,5,1,'127.0.0.1');

/*!40000 ALTER TABLE `#__k2_rating` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_tags
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_tags`;

CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_tags` WRITE;
/*!40000 ALTER TABLE `#__k2_tags` DISABLE KEYS */;

INSERT INTO `#__k2_tags` (`id`, `name`, `published`)
VALUES
	(1,'settingup',1),
	(2,'joomlabamboo',1),
	(3,'furniture',1),
	(4,'woman',1),
	(5,'music',1),
	(6,'man',1),
	(7,'dj',1),
	(8,' dj',1),
	(9,'item',1),
	(10,'Indoor Tools',1),
	(11,'Outdoor Tools',1),
	(12,'Garden Tools',1),
	(13,'Power Tools',1),
	(14,'Hand Tools',1);

/*!40000 ALTER TABLE `#__k2_tags` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_tags_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_tags_xref`;

CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_tags_xref` WRITE;
/*!40000 ALTER TABLE `#__k2_tags_xref` DISABLE KEYS */;

INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`)
VALUES
	(103,9,36),
	(106,7,35),
	(105,5,35),
	(104,4,35),
	(112,8,34),
	(111,4,34),
	(108,7,33),
	(107,6,33),
	(110,7,32),
	(109,4,32),
	(114,9,69),
	(113,2,69),
	(102,2,36);

/*!40000 ALTER TABLE `#__k2_tags_xref` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_user_groups
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_user_groups`;

CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_user_groups` WRITE;
/*!40000 ALTER TABLE `#__k2_user_groups` DISABLE KEYS */;

INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`)
VALUES
	(1,'Registered','frontEdit=0\nadd=0\neditOwn=0\neditAll=0\npublish=0\ncomment=1\ninheritance=0\ncategories=all\n\n'),
	(2,'Site Owner','frontEdit=1\nadd=1\neditOwn=1\neditAll=1\npublish=1\ncomment=1\ninheritance=1\ncategories=all\n\n');

/*!40000 ALTER TABLE `#__k2_user_groups` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_users
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_users`;

CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_users` WRITE;
/*!40000 ALTER TABLE `#__k2_users` DISABLE KEYS */;

INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`)
VALUES
	(1,64,'test','m','',NULL,'',1,'');

/*!40000 ALTER TABLE `#__k2_users` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__menu`;

CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(255)),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__menu` WRITE;
/*!40000 ALTER TABLE `#__menu` DISABLE KEYS */;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`)
VALUES
	(1,'','Menu_Item_Root',X'726F6F74','','','','',1,0,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,197,0,'*',0),
	(2,'menu','com_banners',X'42616E6E657273','','Banners','index.php?option=com_banners','component',0,1,1,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',135,144,0,'*',1),
	(3,'menu','com_banners',X'42616E6E657273','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',136,137,0,'*',1),
	(4,'menu','com_banners_categories',X'43617465676F72696573','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',138,139,0,'*',1),
	(5,'menu','com_banners_clients',X'436C69656E7473','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',140,141,0,'*',1),
	(6,'menu','com_banners_tracks',X'547261636B73','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',142,143,0,'*',1),
	(7,'menu','com_contact',X'436F6E7461637473','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',145,150,0,'*',1),
	(8,'menu','com_contact',X'436F6E7461637473','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',146,147,0,'*',1),
	(9,'menu','com_contact_categories',X'43617465676F72696573','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',148,149,0,'*',1),
	(10,'menu','com_messages',X'4D6573736167696E67','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',151,156,0,'*',1),
	(11,'menu','com_messages_add',X'4E65772050726976617465204D657373616765','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',152,153,0,'*',1),
	(12,'menu','com_messages_read',X'526561642050726976617465204D657373616765','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',154,155,0,'*',1),
	(13,'menu','com_newsfeeds',X'4E657773204665656473','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',157,162,0,'*',1),
	(14,'menu','com_newsfeeds_feeds',X'4665656473','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',158,159,0,'*',1),
	(15,'menu','com_newsfeeds_categories',X'43617465676F72696573','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',160,161,0,'*',1),
	(16,'menu','com_redirect',X'5265646972656374','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',171,172,0,'*',1),
	(17,'menu','com_search',X'536561726368','','Search','index.php?option=com_search','component',0,1,1,19,0,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',163,164,0,'*',1),
	(18,'menu','com_weblinks',X'5765626C696E6B73','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',165,170,0,'*',1),
	(19,'menu','com_weblinks_links',X'4C696E6B73','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',166,167,0,'*',1),
	(20,'menu','com_weblinks_categories',X'43617465676F72696573','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',168,169,0,'*',1),
	(21,'bottom-menu','Shop',X'73686F70','','shop','index.php?option=com_tienda&view=products&filter_category=1','component',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',133,134,0,'*',0),
	(23,'mainmenu','Features',X'6665617475726573','','features','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',3,24,0,'*',0),
	(24,'mainmenu','Zen Grid Framework',X'7A656E2D677269642D6672616D65776F726B','','features/zen-grid-framework','index.php?option=com_content&view=article&id=32','component',1,23,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',4,5,0,'*',0),
	(25,'mainmenu','Module Positions and Styles',X'6D6F64756C652D706F736974696F6E732D616E642D7374796C6573','','features/module-positions-and-styles','index.php?option=com_content&view=article&id=46','component',1,23,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\" simplemeta\",\"menu_image\":\"\",\"secure\":0}',6,7,0,'*',0),
	(26,'mainmenu','Themes',X'7468656D6573','','features/themes','index.php?option=com_content&view=article&id=33','component',1,23,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',8,9,0,'*',0),
	(30,'mainmenu','Typography',X'7479706F677261706879','','features/typography','index.php?option=com_content&view=article&id=36','component',1,23,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" simplemeta\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',22,23,0,'*',0),
	(33,'mainmenu','Joomla',X'6A6F6F6D6C61','','joomla','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',25,38,0,'*',0),
	(34,'mainmenu','Category Blog',X'73656374696F6E','','joomla/section','index.php?option=com_content&view=category&layout=blog&id=11','component',1,33,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"2\",\"num_columns\":\"1\",\"num_links\":\"20\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"use_article\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" simplemeta\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',26,27,0,'*',0),
	(35,'mainmenu','All Categories',X'63617465676F7279','','joomla/category','index.php?option=com_content&view=categories&id=0','component',1,33,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" simplemeta\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',28,29,0,'*',0),
	(36,'mainmenu','Article',X'61727469636C65','','joomla/article','index.php?option=com_content&view=article&id=32','component',1,33,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',30,31,0,'*',0),
	(38,'mainmenu','Home',X'73686F7066726F6E74','','shopfront','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"num_leading_articles\":1,\"num_intro_articles\":4,\"num_columns\":2,\"num_links\":4,\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"multi_column_order\":1,\"show_pagination\":2,\"show_pagination_results\":1,\"show_feed_link\":1,\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',1,2,1,'*',0),
	(47,'usermenu','Your Account',X'796F75722D6163636F756E74','','your-account','index.php?option=com_redshop&view=account_billto&Itemid=68','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',113,114,0,'*',0),
	(48,'usermenu','Account Dashboard',X'6163636F756E742D64617368626F617264','','account-dashboard','index.php?option=com_redshop&view=account&logout=38','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',111,112,0,'*',0),
	(49,'usermenu','Your Shopping Cart',X'796F75722D73686F7070696E672D63617274','','your-shopping-cart','index.php?option=com_redshop&view=cart','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',109,110,0,'*',0),
	(50,'usermenu','Order History',X'6F726465722D686973746F7279','','order-history','index.php?option=com_redshop&view=orders&template_id=0','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',107,108,0,'*',0),
	(51,'bottom-menu','Account',X'6163636F756E74','','account','index.php?option=com_tienda&view=dashboard','component',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',105,106,0,'*',0),
	(56,'mainmenu','K2 Template',X'6B3233','','features/k23','index.php?option=com_content&view=article&id=37','component',1,23,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',10,21,0,'*',0),
	(57,'mainmenu','K2 Item',X'6B322D6974656D34','','features/k23/k2-item4','index.php?option=com_k2&view=item&layout=item&id=69','component',1,56,3,10000,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',11,12,0,'*',0),
	(58,'mainmenu','K2 Categories',X'6B322D63617465676F7269657335','','features/k23/k2-categories5','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=7','component',1,56,3,10000,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"7\"],\"singleCatOrdering\":\"\",\"theme\":\"default\",\"catFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" simplemeta\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',13,14,0,'*',0),
	(59,'mainmenu','K2 Tag',X'6B322D74616736','','features/k23/k2-tag6','index.php?option=com_k2&view=itemlist&layout=tag&tag=item&task=tag','component',1,56,3,10000,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"ignition\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',15,16,0,'*',0),
	(60,'mainmenu','K2 User',X'6B322D7573657237','','features/k23/k2-user7','index.php?option=com_k2&view=itemlist&layout=user&id=62&task=user','component',1,56,3,10000,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"ignition\",\"userOrdering\":\"\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',17,18,0,'*',0),
	(61,'mainmenu','K2 Latest',X'6B322D6C617465737438','','features/k23/k2-latest8','index.php?option=com_k2&view=latest&layout=latest','component',1,56,3,10000,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"source\":\"1\",\"latestItemsCols\":\"1\",\"latestItemsLimit\":\"3\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"1\",\"userFeed\":\"1\",\"categoryIDs\":[\"7\"],\"categoryTitle\":\"1\",\"categoryDescription\":\"1\",\"categoryImage\":\"1\",\"categoryFeed\":\"1\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"1\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Medium\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"1\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',19,20,0,'*',0),
	(62,'Top-Login','Login',X'6C6F67696E','','login','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_login_title\":1,\"header_login\":\"\",\"login\":\"\",\"login_message\":0,\"description_login\":0,\"description_login_text\":\"\",\"image_login\":\"\",\"image_login_align\":\"right\",\"show_logout_title\":1,\"header_logout\":\"\",\"logout\":\"\",\"logout_message\":1,\"description_logout\":1,\"description_logout_text\":\"\",\"image_logout\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',115,116,0,'*',0),
	(63,'Top-Login','Sign up (it\'s free!)',X'7369676E2D75702D6974732D66726565','','sign-up-its-free','index.php?option=com_users&view=register','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',117,118,0,'*',0),
	(64,'above','{jb_img}images/icons/heart.png{/jb_img}All products',X'616C6C2D70726F6475637473','','all-products','index.php?option=com_redshop&view=category','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',119,120,0,'*',0),
	(65,'above','{jb_img}images/icons/sale.png{/jb_img}Shoes',X'73686F6573','','shoes','index.php?option=com_redshop&view=category&layout=detail&cid=4&order_by=p.product_name ASC&maxproduct=0','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',121,122,0,'*',0),
	(66,'above','{jb_img}images/icons/star.png{/jb_img}Shirts',X'736869727473','','shirts','index.php?option=com_redshop&view=category&layout=detail&cid=7&order_by=p.product_name ASC&maxproduct=5','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',123,124,0,'*',0),
	(67,'above','{jb_img}images/icons/cart.png{/jb_img}Checkout',X'626567696E2D636865636B6F7574','','begin-checkout','index.php?option=com_redshop&view=checkout','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',127,128,0,'*',0),
	(68,'above','{jb_img}images/icons/book.png{/jb_img}Your Account',X'796F75722D6163636F756E7439','','your-account9','index.php?option=com_redshop&view=account&logout=51','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',129,130,0,'*',0),
	(69,'above','{jb_img}images/icons/download.png{/jb_img}Downloads',X'646F776E6C6F616473','','downloads','index.php?option=com_redshop&view=product&layout=downloadproduct','component',0,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',131,132,0,'*',0),
	(70,'above','{jb_img}images/icons/cart.png{/jb_img}Your Cart',X'796F75722D63617274','','your-cart','index.php?option=com_redshop&view=cart','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',125,126,0,'*',0),
	(74,'mainmenu','Setup',X'7365747570','','setup','','separator',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1}',39,96,0,'*',0),
	(75,'mainmenu','ShopIgnition Documentation',X'73686F7069676E6974696F6E2D646F63756D656E746174696F6E','','setup/shopignition-documentation','index.php?option=com_content&view=article&id=32','component',1,74,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"feed_summary\":\"\",\"page_title\":\"\",\"show_page_title\":1,\"pageclass_sfx\":\"\",\"menu_image\":\"\",\"secure\":0}',40,63,0,'*',0),
	(76,'mainmenu','Installing a Fresh Version of Joomla',X'696E7374616C6C696E672D612D66726573682D76657273696F6E2D6F662D6A6F6F6D6C61','','setup/shopignition-documentation/installing-a-fresh-version-of-joomla','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#eight','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',41,42,0,'*',0),
	(77,'mainmenu','Getting Started with ShopIgnition',X'67657474696E672D737461727465642D776974682D73686F7069676E6974696F6E','','setup/shopignition-documentation/getting-started-with-shopignition','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#one','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',59,60,0,'*',0),
	(78,'mainmenu','Recreating the Front Page',X'72656372656174696E672D7468652D66726F6E7470616765','','setup/shopignition-documentation/recreating-the-frontpage','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#five','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',57,58,0,'*',0),
	(79,'mainmenu','A note about Compatibility and CSS3 Selectors',X'612D6E6F74652D61626F75742D636F6D7061746962696C6974792D616E642D637373332D73656C6563746F7273','','setup/shopignition-documentation/a-note-about-compatibility-and-css3-selectors','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#ten','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',55,56,0,'*',0),
	(80,'mainmenu','Troubleshooting Tips',X'74726F75626C6573686F6F74696E672D74697073','','setup/shopignition-documentation/troubleshooting-tips','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#ten','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',53,54,0,'*',0),
	(81,'mainmenu','Configuring K2',X'636F6E6669677572696E672D6B32','','setup/shopignition-documentation/configuring-k2','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#seven','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',51,52,0,'*',0),
	(82,'mainmenu','Setting Up Module Classes',X'73657474696E672D75702D6D6F64756C652D636C6173736573','','setup/shopignition-documentation/setting-up-module-classes','#','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',49,50,0,'*',0),
	(83,'mainmenu','Zen Grid Framework Documentation',X'7A656E2D677269642D6672616D65776F726B2D646F63756D656E746174696F6E','','setup/zen-grid-framework-documentation','','separator',1,74,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',64,87,0,'*',0),
	(84,'mainmenu','Working with Zen Grid Framework',X'776F726B696E672D776974682D7A656E2D677269642D6672616D65776F726B','','setup/zen-grid-framework-documentation/working-with-zen-grid-framework','http://docs.joomlabamboo.com/zen-grid-framework','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',65,66,0,'*',0),
	(85,'mainmenu','Adding analytics to your site',X'616464696E672D616E616C79746963732D746F2D796F75722D73697465','','setup/zen-grid-framework-documentation/adding-analytics-to-your-site','http://docs.joomlabamboo.com/item/547-analytics','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',83,84,0,'*',0),
	(86,'mainmenu','Controlling Module Layouts',X'636F6E74726F6C6C696E672D6D6F64756C652D6C61796F757473','','setup/zen-grid-framework-documentation/controlling-module-layouts','http://docs.joomlabamboo.com/item/550-controlling-module-layouts','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',81,82,0,'*',0),
	(87,'mainmenu','Controlling the logo',X'636F6E74726F6C6C696E672D7468652D6C6F676F','','setup/zen-grid-framework-documentation/controlling-the-logo','http://docs.joomlabamboo.com/item/562-zen-grid-2-logo-options','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',79,80,0,'*',0),
	(88,'mainmenu','Copyright Removal',X'636F707972696768742D72656D6F76616C','','setup/zen-grid-framework-documentation/copyright-removal','http://docs.joomlabamboo.com/item/700-copyright-removal-and-branding','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',77,78,0,'*',0),
	(89,'mainmenu','Hidden panel overview',X'68696464656E2D70616E656C2D6F76657276696577','','setup/zen-grid-framework-documentation/hidden-panel-overview','http://docs.joomlabamboo.com/item/565-hidden-panel','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',75,76,0,'*',0),
	(90,'mainmenu','IE6 PNG Fix',X'6965362D706E672D666978','','setup/zen-grid-framework-documentation/ie6-png-fix','http://docs.joomlabamboo.com/item/556-ie6-png-fix','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',73,74,0,'*',0),
	(91,'mainmenu','Language and Translation',X'6C616E67756167652D616E642D7472616E736C6174696F6E','','setup/zen-grid-framework-documentation/language-and-translation','http://docs.joomlabamboo.com/item/726-language-settings-for-zen-grid-framework-templates','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',71,72,0,'*',0),
	(92,'mainmenu','Superfish Menu',X'7375706572666973682D6D656E75','','setup/zen-grid-framework-documentation/superfish-menu','http://docs.joomlabamboo.com/item/552-setting-up-the-superfish-menu','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',69,70,0,'*',0),
	(93,'mainmenu','Tabbed Modules',X'7461626265642D6D6F64756C6573','','setup/zen-grid-framework-documentation/tabbed-modules','http://docs.joomlabamboo.com/item/701-tabbed-modules','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',67,68,0,'*',0),
	(94,'mainmenu','More framework documentation',X'6D6F72652D6672616D65776F726B2D646F63756D656E746174696F6E','','setup/zen-grid-framework-documentation/more-framework-documentation','http://docs.joomlabamboo.com/zen-grid-framework','url',1,83,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',85,86,0,'*',0),
	(95,'mainmenu','General Joomla Documentation',X'67656E6572616C2D6A6F6F6D6C612D646F63756D656E746174696F6E','','setup/general-joomla-documentation','','separator',1,74,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',88,95,0,'*',0),
	(96,'mainmenu','Installing a Joomla template',X'696E7374616C6C696E672D612D6A6F6F6D6C612D74656D706C617465','','setup/general-joomla-documentation/installing-a-joomla-template','http://docs.joomlabamboo.com/item/616-how-to-install-a-joomla-template','url',1,95,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',89,90,0,'*',0),
	(97,'mainmenu','Installing a Joomla Extension',X'696E7374616C6C696E672D612D6A6F6F6D6C612D657874656E73696F6E','','setup/general-joomla-documentation/installing-a-joomla-extension','http://docs.joomlabamboo.com/item/618-how-to-install-a-joomla-module','url',1,95,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',91,92,0,'*',0),
	(98,'mainmenu','Installing the Quickstart package',X'696E7374616C6C696E672D7468652D717569636B73746172742D7061636B616765','','setup/general-joomla-documentation/installing-the-quickstart-package','http://docs.joomlabamboo.com/item/614-how-to-install-the-quickstart-package','url',1,95,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',93,94,0,'*',0),
	(99,'mainmenu','Recreating the Icon Menu',X'72656372656174696E672D7468652D69636F6E2D6D656E75','','setup/shopignition-documentation/recreating-the-icon-menu','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#nine','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',47,48,0,'*',0),
	(100,'mainmenu','Red Shop and Tienda Setup',X'7265642D73686F702D616E642D7469656E64612D7365747570','','setup/shopignition-documentation/red-shop-and-tienda-setup','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#ten','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',45,46,0,'*',0),
	(101,'mainmenu','Module Classes',X'6D6F64756C652D636C6173736573','','setup/shopignition-documentation/module-classes','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#six','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',43,44,0,'*',0),
	(102,'mainmenu','Module Position Overview',X'6D6F64756C652D706F736974696F6E2D6F76657276696577','','setup/shopignition-documentation/module-position-overview','http://docs.joomlabamboo.com/item/745-shop-ignition-joomla-template-documentation#two','url',1,75,3,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\"}',61,62,0,'*',0),
	(104,'mainmenu','Red Shop',X'7265642D73686F70','','red-shop','index.php?option=com_redshop&view=category','component',1,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'',10,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',97,104,0,'*',0),
	(107,'main','COM_K2',X'636F6D6B32','','comk2','index.php?option=com_k2','component',0,1,1,10000,0,0,'0000-00-00 00:00:00',0,1,'../media/k2/assets/images/system/k2_16x16.png',0,'',173,194,0,'',1),
	(108,'main','K2_ITEMS',X'6B326974656D73','','comk2/k2items','index.php?option=com_k2&view=items','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',174,175,0,'',1),
	(109,'main','K2_CATEGORIES',X'6B3263617465676F72696573','','comk2/k2categories','index.php?option=com_k2&view=categories','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',176,177,0,'',1),
	(110,'main','K2_TAGS',X'6B3274616773','','comk2/k2tags','index.php?option=com_k2&view=tags','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',178,179,0,'',1),
	(111,'main','K2_COMMENTS',X'6B32636F6D6D656E7473','','comk2/k2comments','index.php?option=com_k2&view=comments','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',180,181,0,'',1),
	(112,'main','K2_USERS',X'6B327573657273','','comk2/k2users','index.php?option=com_k2&view=users','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',182,183,0,'',1),
	(113,'main','K2_USER_GROUPS',X'6B327573657267726F757073','','comk2/k2usergroups','index.php?option=com_k2&view=usergroups','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',184,185,0,'',1),
	(114,'main','K2_EXTRA_FIELDS',X'6B3265787472616669656C6473','','comk2/k2extrafields','index.php?option=com_k2&view=extrafields','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',186,187,0,'',1),
	(115,'main','K2_EXTRA_FIELD_GROUPS',X'6B3265787472616669656C6467726F757073','','comk2/k2extrafieldgroups','index.php?option=com_k2&view=extrafieldsgroups','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',188,189,0,'',1),
	(116,'main','K2_MEDIA_MANAGER',X'6B326D656469616D616E61676572','','comk2/k2mediamanager','index.php?option=com_k2&view=media','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',190,191,0,'',1),
	(117,'main','K2_INFORMATION',X'6B32696E666F726D6174696F6E','','comk2/k2information','index.php?option=com_k2&view=info','component',0,107,2,10000,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',192,193,0,'',1),
	(118,'main','redSHOP',X'72656473686F70','','redshop','index.php?option=com_redshop','component',0,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'components/com_redshop/assets/images/redshopcart16.png',0,'',195,196,0,'',1),
	(119,'mainmenu','Featured Articles',X'66656174757265642D61727469636C6573','','joomla/featured-articles','index.php?option=com_content&view=featured','component',1,33,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',32,33,0,'*',0),
	(121,'mainmenu','Redshop Category',X'7265642D73686F702D63617465676F7279','','red-shop/red-shop-category','index.php?option=com_redshop&view=category&layout=detail&cid=4&order_by=p.product_name ASC&maxproduct=0','component',1,104,2,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',98,99,0,'*',0),
	(122,'mainmenu','Redshop Product',X'72656473686F702D70726F64756374','','red-shop/redshop-product','index.php?option=com_redshop&view=product&pid=21','component',1,104,2,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',100,101,0,'*',0),
	(123,'mainmenu','Redshop Cart',X'72656473686F702D63617274','','red-shop/redshop-cart','index.php?option=com_redshop&view=cart','component',1,104,2,10026,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',102,103,0,'*',0),
	(124,'mainmenu','Microblog Content',X'6D6963726F626C6F672D636F6E74656E74','','joomla/microblog-content','index.php?option=com_content&view=category&layout=blog&id=13','component',1,33,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"\",\"num_columns\":\"\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',34,35,0,'*',0),
	(125,'mainmenu','Article using simplemeta',X'61727469636C652D7573696E672D73696D706C656D657461','','joomla/article-using-simplemeta','index.php?option=com_content&view=article&id=58','component',1,33,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" simplemeta\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',36,37,0,'*',0);

/*!40000 ALTER TABLE `#__menu` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__menu_types
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__menu_types`;

CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__menu_types` WRITE;
/*!40000 ALTER TABLE `#__menu_types` DISABLE KEYS */;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`)
VALUES
	(1,'mainmenu','Main Menu','The main menu for the site'),
	(2,'bottom-menu','Bottom Menu','Bottom Menu'),
	(5,'usermenu','User Menu',''),
	(6,'Top-Login','Top Login','Top Login'),
	(7,'above','Above Menu','above');

/*!40000 ALTER TABLE `#__menu_types` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__modules
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__modules`;

CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__modules` WRITE;
/*!40000 ALTER TABLE `#__modules` DISABLE KEYS */;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`)
VALUES
	(1,'Main Menu','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),
	(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),
	(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),
	(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),
	(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),
	(14,'User Status','','',2,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),
	(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),
	(16,'Login Form','','',7,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_login',1,1,'{\"greeting\":\"1\",\"name\":\"0\"}',0,'*'),
	(17,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(18,'Book Store','','',1,'position-10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_banners',1,0,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"3\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Books!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),
	(79,'Multilanguage status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_multilangstatus',3,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),
	(80,'Main Menu','','',1,'top1',62,'2011-11-18 11:00:49','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-superfish\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(81,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_breadcrumbs',1,0,'{\"showHome\":1,\"homeText\":\"Home\",\"showLast\":1,\"separator\":\" >\",\"moduleclass_sfx\":\"\",\"cache\":0}',0,'*'),
	(82,'Latest','','',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"3\",\"show_featured\":\"\",\"ordering\":\"m_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(83,'The best shoes around','','<p>\"I have to say these are the best shoes you can wear, at a price you can\'t beat. Shopfront is my store of choice.\" Jennifer, USA</p>',1,'bottom6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-dark\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(84,'Popular','','',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"3\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(85,'Featured','','',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"3\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(86,'Social Buttons','','<div><a href=\"http://twitter.com/joomlabamboo\"><img src=\"images/icons/twitter.png\" border=\"0\" alt=\"twitter\" width=\"40\" height=\"40\" /></a><a href=\"http://www.facebook.com\"><img src=\"images/icons/facebook.png\" border=\"0\" alt=\"facebook\" width=\"40\" height=\"40\" /></a><a href=\"http://flickr.com\"><img src=\"images/icons/flickr.png\" border=\"0\" alt=\"flickr\" width=\"40\" height=\"40\" /></a></div>',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(87,'Footer','','',1,'header2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,0,'{\"menutype\":\"bottom-menu\",\"menu_style\":\"list\",\"startLevel\":1,\"endLevel\":0,\"showAllChildren\":0,\"window_open\":\"\",\"show_whitespace\":0,\"cache\":1,\"tag_id\":\"\",\"class_sfx\":\"\",\"moduleclass_sfx\":\"\",\"maxdepth\":10,\"menu_images\":0,\"menu_images_align\":0,\"menu_images_link\":0,\"expand_menu\":0,\"activate_parent\":0,\"full_active_id\":0,\"indent_image\":0,\"indent_image1\":\"\",\"indent_image2\":\"\",\"indent_image3\":\"\",\"indent_image4\":\"\",\"indent_image5\":\"\",\"indent_image6\":\"\",\"spacer\":\"\",\"end_spacer\":\"\"}',0,'*'),
	(88,'Reviews from Industry Specialists','','<p>Phasellus sed laoreet risus. Morbi imperdiet, lacus et interdum luctus, arcu nisi pharetra velit, sit amet pharetra est velit in lorem. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>',1,'left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(89,'Ordering Information','','<p><img class=\"floatleft border\" src=\"images/democontent/microblog/national98.jpg\" border=\"0\" alt=\"national98\" width=\"225\" height=\"126\" />Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p> </p>\r\n<p>{jb_iconic_truck}Please note that this is not a real shop. Its a demo showcasing the Shop Ignition template by Joomlabamboo.{/jb_iconic_truck}</p>\r\n<p>{jb_iconic_tick}liquam placerat iaculis risus quis mollis..{/jb_iconic_tick}</p>\r\n<p>{jb_iconic_tick}Nam feugiat tortor at nisi rhoncus volutpat. Pellentesque tempus, ligula eu vehicula aliquet,.{/jb_iconic_tick}</p>\r\n<p>{jb_iconic_tick}Pellentesque tempus, ligula eu vehicula aliquet,.{/jb_iconic_tick}</p>',1,'tab3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-tag\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(90,'Grid 1','','<p>Module class \"-heart padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-heart padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(91,'Grid 10','','<p>Module Class \"-truck padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet.</p>',1,'grid10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-truck padding\"}',0,'*'),
	(92,'Grid 4','','<p>Module Class \"-tag padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'grid4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-tag padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(93,'Grid 8','','<p>Module Class -green. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'grid8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-green\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(94,'Grid 5','','<p>Module Class -red.&nbsp;Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Lorem ipsum.</p>',2,'grid5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-red\"}',0,'*'),
	(95,'Grid 6','','<p>Module Class -lightblue. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',2,'grid6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-lightblue\"}',0,'*'),
	(96,'Grid 9','','<p>Module Class \"-download padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'grid9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-download padding\"}',0,'*'),
	(97,'Grid 12','','<p>Module Class \"-info padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid12',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-info padding\"}',0,'*'),
	(98,'Above','','<p>Module Class \" -tag padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit. Aenean eu mauris nisi, sagittis faucibus mi. Morbi semper bibendum vestibulum. Nulla dictum orci ut nibh lobortis luctus.</p>',1,'above',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-tag padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(99,'Grid13','','<p>A custom module with the class -arrival. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid13',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-arrival\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(100,'Grid 16','','<p>A custom module with the module class -email. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid16',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-email\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(101,'Grid 17','','<p>A module with the \"-bolt padding\" class applied. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid17',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-bolt padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(102,'Grid 18','','<p>This is a custom module with the class \"-book padding\".Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid18',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-book padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(103,'Grid 20','','<p>A custom html module with the class \"-box padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid20',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-box padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(104,'Grid 21','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid21',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(105,'Grid 22','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(106,'Grid 23','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(107,'Grid24','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(108,'Below','','<p>A custom module with the module class -beaker. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit. Aenean eu mauris nisi, sagittis faucibus mi. Morbi semper bibendum vestibulum. Nulla dictum orci ut nibh lobortis luctus.</p>',1,'below',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-beaker\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(109,'Right','','<p>A custom module with the module class -cloud. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit. Aenean eu mauris nisi, sagittis faucibus mi. Morbi semper bibendum vestibulum. Nulla dictum orci ut nibh lobortis luctus.</p>',1,'right',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-cloud\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(110,'Center','','<p>A custom module with the module class -lightbulb. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit. Aenean eu mauris nisi, sagittis faucibus mi. Morbi semper bibendum vestibulum. Nulla dictum orci ut nibh lobortis luctus.</p>',1,'center',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-lightbulb\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(111,'Customer Menu','','',1,'left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',2,1,'{\"menutype\":\"usermenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(112,'Head','','<p>This is head</p>',1,'head',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"\"}',0,'*'),
	(113,'Top Login','','',1,'top3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,0,'{\"menutype\":\"Top-Login\",\"menu_style\":\"list\",\"startLevel\":1,\"endLevel\":0,\"showAllChildren\":0,\"window_open\":\"\",\"show_whitespace\":0,\"cache\":1,\"tag_id\":\"\",\"class_sfx\":\"\",\"moduleclass_sfx\":\"\",\"maxdepth\":10,\"menu_images\":0,\"menu_images_align\":0,\"menu_images_link\":0,\"expand_menu\":0,\"activate_parent\":0,\"full_active_id\":0,\"indent_image\":0,\"indent_image1\":\"\",\"indent_image2\":\"\",\"indent_image3\":\"\",\"indent_image4\":\"\",\"indent_image5\":\"\",\"indent_image6\":\"\",\"spacer\":\"\",\"end_spacer\":\"\"}',0,'*'),
	(114,'Tell us what you think','','<p>Lorem ipsum dolor sit amet, conser adipiscing elit.</p>\r\n<p> </p>\r\n<p> </p>',3,'grid4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-darkblue\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(115,'Ladies','','',1,'bottom4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"3\",\"show_featured\":\"\",\"ordering\":\"m_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(116,'Newsletter Signup','','<p><img class=\"floatleft border\" src=\"images/democontent/microblog/newsletter.jpg\" border=\"0\" alt=\"newsletter\" width=\"236\" height=\"126\" />Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>\r\n<p>Maecenas neque augue, suscipit vel eleifend sit amet, vehicula nec dolor. Aliquam placerat iaculis risus quis mollis. Morbi ipsum massa, congue sit amet mollis ut, fringilla et leo. Vivamus purus tortor, interdum at semper non, fringilla sed nisl. Maecenas neque est, molestie et euismod at, suscipit sit amet risus. Nam feugiat tortor at nisi rhoncus volutpat.</p>\r\n<p>{jb_cloud}Pellentesque tempus, ligula eu vehicula aliquet, magna risus ornare lacus, vel tincidunt sapien risus id dolor. Vestibulum eu neque sed nibh dapibus vestibulum. Donec nulla felis, adipiscing vel tristique posuere, posuere eu metus. Lorem ipsum dolor sit amet, consectetur adipiscing elit.{/jb_cloud}</p>',1,'tab4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(117,'Copy of Breadcrumbs','','',1,'bottombreadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"Y\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(118,'Our Stores','','In addition to our online shop we also have real live stores. Come in and see us.',2,'grid21',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"moduleclass_sfx\":\"\"}',0,'*'),
	(119,'Melbourne','','<ul>\r\n<li>300 Collins St, Melbourne</li>\r\n<li>(03) 9555 5555</li>\r\n<li>9am to 5pm</li>\r\n</ul>',2,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(120,'Brisbane','','<ul>\r\n<li>300 Collins St, Melbourne</li>\r\n<li>(03) 9555 5555</li>\r\n<li>9am to 5pm</li>\r\n</ul>',2,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(121,'New Zealand','','<ul>\r\n<li>300 Collins St, Melbourne</li>\r\n<li>(03) 9555 5555</li>\r\n<li>9am to 5pm</li>\r\n</ul>',2,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(122,'Perth','','<ul>\r\n<li>300 Collins St, Melbourne</li>\r\n<li>(03) 9555 5555</li>\r\n<li>9am to 5pm</li>\r\n</ul>',3,'grid23',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(123,'Hong Kong','','<ul>\r\n<li>300 Collins St, Melbourne</li>\r\n<li>(03) 9555 5555</li>\r\n<li>9am to 5pm</li>\r\n</ul>',3,'grid22',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(124,'New York','','<ul>\r\n<li>300 Collins St, Melbourne</li>\r\n<li>(03) 9555 5555</li>\r\n<li>9am to 5pm</li>\r\n</ul>',3,'grid24',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(125,'Free Shippoing','','<p class=\"shipping\">Free shipping for a limited time.</p>',1,'tabextra',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(126,'Payment Methods','','<p>We accept Paypal and credit cards</p>\r\n<p><img src=\"images/democontent/paymentMethods.png\" border=\"0\" alt=\"paymentMethods\" width=\"146\" height=\"21\" /></p>',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(127,'Tienda Menu','','',2,'above',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"above\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(128,'Banner','','<p>This is the banner position</p>',1,'banner',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(129,'Search','','',1,'header4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,0,'{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(130,'Grid 11','','<p>Module Class \"-document padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid11',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-document padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(131,'Grid 14','','<p>A custom module with the class -star. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid14',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-star\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(132,'Grid 15','','<p>A custom html module with the module class -arrow. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid15',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-arrow\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(133,'Grid 19','','<p>This is a custom module with the class \"-calendar padding\".Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',1,'grid19',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-calendar padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(134,'Left','','<p>A custom module with the module class -comment. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit. Aenean eu mauris nisi, sagittis faucibus mi. Morbi semper bibendum vestibulum. Nulla dictum orci ut nibh lobortis luctus.</p>',1,'Left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-comment\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(135,'Grid 10','','<p>Module Class \"-tick padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet.</p>',2,'grid10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-tick padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(136,'Grid 11','','<p>Module Class \"-image padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',2,'grid11',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-image padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(137,'Grid 12','','<p>Module Class \"-quote padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit.</p>',2,'grid12',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-quote padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(138,'Grid 9','','<p>Module Class \"-search padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Donec aliquet porttitor nulla non blandit. Lorem Ipsum.</p>',1,'grid9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-search padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(139,'Grid 10','','<p>Module Class \"-movie padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet.</p>',3,'grid10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-movie padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(140,'Grid 9','','<p>Module Class \"-dash padding\". Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',2,'grid9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-dash padding\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(141,'Header 2','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',2,'header2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" tag\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(142,'Header 3','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'header3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" quote\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(143,'Grid 7','','<p>Module Class -midgreen. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'grid7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-midgreen\"}',0,'*'),
	(144,'Grid 5','','<p>Module Class -lightgreen.&nbsp;Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',3,'grid5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"moduleclass_sfx\":\"-lightgreen\"}',0,'*'),
	(145,'Grid 6','','<p>Module Class -purple. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',3,'grid6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-purple\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(146,'Grid 7','','<p>Module Class -green. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',2,'grid7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-green\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(147,'Grid 8','','<p>Module Class -pink. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Lorem Ipsum.</p>',2,'grid8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-pink\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(148,'Grid 5','','<p>Module Class -orange. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'grid5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-orange\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(149,'Grid 6','','<p>Module Class -darkblue. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'grid6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-darkblue\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(150,'Grid 7','','<p>Module Class -dark. Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi. Lorem Ipsum.</p>',3,'grid7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-dark\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(152,'jTweet','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_jTweet',1,1,'',0,'*'),
	(153,'Top Microblog','','',1,'grid9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_microblog',1,0,'{\"contentSource\":\"article\",\"layout\":\"columns\",\"mbHeight\":\"\",\"scripts\":\"1\",\"count\":\"4\",\"category_filtering_type\":\"1\",\"catid\":[\"13\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"k2count\":\"5\",\"k2catid\":[\"7\"],\"getChildren\":\"0\",\"k2items\":[\"\"],\"k2Ordering\":\"\",\"k2FeaturedItems\":\"1\",\"popularityRange\":\"\",\"titlelink\":\"2\",\"linkTarget\":\"article\",\"titleClass\":\"h2\",\"titleLimit\":\"0\",\"titleSuffix\":\"\",\"showintro\":\"0\",\"wordCount\":\"\",\"introSuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"\",\"renderPlugin\":\"strip\",\"displayMore\":\"0\",\"readonText\":\"\",\"showdate\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"displayImages\":\"k2content\",\"resizeImage\":\"1\",\"image_width\":\"225\",\"image_height\":\"126\",\"option\":\"crop\",\"fadeEffect\":\"1\",\"cbTheme\":\"1\",\"popupGallery\":\"1\",\"justImage\":\"1\",\"overlayOpacity\":\"0.6\",\"frameWidth\":\"800\",\"frameHeight\":\"500\",\"colorboxScrolling\":\"false\",\"addMargin\":\"0\",\"rightMargin\":\"0\",\"bottomMargin\":\"0\",\"imagesPerRow\":\"4\",\"colClearDiv\":\"1\",\"trigger1\":\"\",\"trigger2\":\"\",\"trigger3\":\"\",\"trigger4\":\"\",\"trigger5\":\"\",\"trigger6\":\"\",\"trigger7\":\"\",\"trigger8\":\"\",\"trigger9\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"-microblog\"}',0,'*'),
	(154,'Shop Front Themes','','',1,'themes',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_prettyBox',1,1,'{\"directory\":\"\\/images\\/democontent\\/themes\",\"output\":\"2\",\"details\":\"1\",\"link\":\"1\",\"perRow\":\"1\",\"prettyPhoto\":\"true\",\"theme\":\"dark_rounded\",\"opacity\":\"0.6\",\"resize\":\"true\",\"prettyBoxTitle\":\"false\",\"prettyBoxSpeed\":\"fast\",\"overlayGallery\":\"false\",\"img_width\":\"200\",\"img_height\":\"100\",\"option\":\"crop\",\"height\":\"150\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(155,'JB Slideshow v3.0','','',1,'grid1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_slideshow3',1,0,'{\"display_ticker\":\"0\",\"display_slideshow\":\"1\",\"contentSource\":\"article\",\"ssTheme\":\"None\",\"ticker_transition\":\"fade\",\"slideshow_height\":\"385\",\"slideshow_width\":\"100%\",\"sstime\":\"10000\",\"ssSpeed\":\"1500\",\"content_image\":\"content\",\"itemImageSize\":\"Original\",\"imageLink\":\"1\",\"image_top\":\"0\",\"image_left\":\"0\",\"imgBorder\":\"0\",\"imagedirectory\":\"\",\"lowercase\":\"0\",\"fileType\":\"jpg\",\"imageResize\":\"0\",\"image_width\":\"555\",\"image_height\":\"347\",\"option\":\"crop\",\"count\":\"5\",\"category_filtering_type\":\"1\",\"catid\":[\"11\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"k2count\":\"5\",\"k2catid\":[\"\"],\"getChildren\":\"0\",\"k2items\":[\"\"],\"k2Ordering\":\"\",\"k2FeaturedItems\":\"1\",\"popularityRange\":\"\",\"ticker_height\":\"260\",\"ticker_width\":\"360\",\"margin_top\":\"100\",\"margin_left\":\"0\",\"bgOverlay\":\"no\",\"item_title\":\"1\",\"title_class\":\"h2\",\"title_link\":\"1\",\"linkTarget\":\"article\",\"ticker_text\":\"1\",\"introtext_limit\":\"40\",\"striptags\":\"1\",\"tags\":\"<a><ul><li><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"render\",\"createdDate\":\"1\",\"dateFormat\":\"j M, y\",\"readMoreText\":\"Read More ...\",\"readMoreLink\":\"1\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"display_nav\":\"indexNavButtons\",\"navWidth\":\"400\",\"navHeight\":\"400\",\"navTop\":\"320px\",\"navLeft\":\"30\",\"navButtons\":\"0\",\"navPrevText\":\"<<  Previous\",\"navNextText\":\"Next  >>\",\"scrollNav\":\"vertical\",\"numVis\":\"3\",\"navItemWidth\":\"40\",\"navItemHeight\":\"40\",\"titleLimit\":\"0\",\"titleSuffix\":\"...\",\"fadeEffect\":\"1\",\"hoverTransition\":\"1\",\"thumb_width\":\"60\",\"thumb_height\":\"40\",\"thumb_option\":\"crop\",\"tickerIntro\":\" \",\"showDescriptionText\":\"none\",\"descriptionText\":\"\",\"descriptionMarginTop\":\"0\",\"descriptionMarginLeft\":\"0\",\"descriptionHeight\":\"50\",\"descriptionWidth\":\"100\",\"descriptionOverlay\":\"no\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(156,'JB Captify Content','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_captifyContent',1,1,'',0,'*'),
	(157,'K2 Comments','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_comments',1,1,'',0,'*'),
	(158,'K2 Content','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_content',1,1,'',0,'*'),
	(159,'K2 Login','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_login',1,1,'',0,'*'),
	(160,'K2 Tools','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_tools',1,1,'',0,'*'),
	(161,'K2 Users','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_users',1,1,'',0,'*'),
	(162,'K2 User','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_user',1,1,'',0,'*'),
	(163,'K2 QuickIcons (admin)','','',99,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_quickicons',1,1,'',1,'*'),
	(164,'K2 Stats (admin)','','',0,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_stats',1,1,'',1,'*'),
	(165,'JB MicroBlog (2)','','',1,'grid4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_microblog',1,0,'{\"contentSource\":\"article\",\"layout\":\"columns\",\"mbHeight\":\"\",\"scripts\":\"1\",\"count\":\"1\",\"category_filtering_type\":\"1\",\"catid\":[\"\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"artid\":[\"58\"],\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"k2count\":\"5\",\"k2catid\":[\"7\"],\"getChildren\":\"0\",\"k2items\":[\"\"],\"k2Ordering\":\"\",\"k2FeaturedItems\":\"1\",\"popularityRange\":\"\",\"titlelink\":\"2\",\"linkTarget\":\"article\",\"titleClass\":\"h2\",\"titleLimit\":\"0\",\"titleSuffix\":\"\",\"showintro\":\"0\",\"wordCount\":\"\",\"introSuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"\",\"renderPlugin\":\"strip\",\"displayMore\":\"0\",\"readonText\":\"\",\"showdate\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"displayImages\":\"k2content\",\"resizeImage\":\"1\",\"image_width\":\"225\",\"image_height\":\"250\",\"option\":\"crop\",\"fadeEffect\":\"1\",\"cbTheme\":\"1\",\"popupGallery\":\"1\",\"justImage\":\"1\",\"overlayOpacity\":\"0.6\",\"frameWidth\":\"800\",\"frameHeight\":\"500\",\"colorboxScrolling\":\"false\",\"addMargin\":\"1\",\"rightMargin\":\"5\",\"bottomMargin\":\"5\",\"imagesPerRow\":\"1\",\"colClearDiv\":\"1\",\"trigger1\":\"\",\"trigger2\":\"\",\"trigger3\":\"\",\"trigger4\":\"\",\"trigger5\":\"\",\"trigger6\":\"\",\"trigger7\":\"\",\"trigger8\":\"\",\"trigger9\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"-microblog\"}',0,'*'),
	(166,'RedSHOP cart module','','',1,'top4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_redshop_cart',1,0,'{\"cart_output\":\"simple\",\"moduleclass_sfx\":\"\",\"show_with_shipping\":\"0\",\"show_with_discount\":\"0\",\"show_with_vat\":\"0\",\"show_shipping_line\":\"0\",\"checkout_empty\":\"0\",\"button_text\":\"\"}',0,'*'),
	(167,'Custom Login','','',1,'panel1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*'),
	(168,'Bottom Microblog','','',1,'grid17',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_microblog',1,0,'{\"contentSource\":\"article\",\"layout\":\"columns\",\"mbHeight\":\"\",\"scripts\":\"1\",\"count\":\"4\",\"category_filtering_type\":\"1\",\"catid\":[\"14\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"k2count\":\"5\",\"k2catid\":[\"7\"],\"getChildren\":\"0\",\"k2items\":[\"\"],\"k2Ordering\":\"\",\"k2FeaturedItems\":\"1\",\"popularityRange\":\"\",\"titlelink\":\"2\",\"linkTarget\":\"article\",\"titleClass\":\"h2\",\"titleLimit\":\"0\",\"titleSuffix\":\"\",\"showintro\":\"0\",\"wordCount\":\"\",\"introSuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"\",\"renderPlugin\":\"strip\",\"displayMore\":\"0\",\"readonText\":\"\",\"showdate\":\"0\",\"translateDate\":\"0\",\"dateString\":\"DATE_FORMAT_LC1\",\"dateFormat\":\"j M, y\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"displayImages\":\"k2content\",\"resizeImage\":\"1\",\"image_width\":\"225\",\"image_height\":\"126\",\"option\":\"crop\",\"fadeEffect\":\"1\",\"cbTheme\":\"1\",\"popupGallery\":\"1\",\"justImage\":\"1\",\"overlayOpacity\":\"0.6\",\"frameWidth\":\"800\",\"frameHeight\":\"500\",\"colorboxScrolling\":\"false\",\"addMargin\":\"0\",\"rightMargin\":\"0\",\"bottomMargin\":\"0\",\"imagesPerRow\":\"4\",\"colClearDiv\":\"1\",\"trigger1\":\"\",\"trigger2\":\"\",\"trigger3\":\"\",\"trigger4\":\"\",\"trigger5\":\"\",\"trigger6\":\"\",\"trigger7\":\"\",\"trigger8\":\"\",\"trigger9\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"-microblog\"}',0,'*'),
	(169,'Shop Front Themes (2)','','',1,'views',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_prettyBox',1,1,'{\"directory\":\"\\/images\\/democontent\\/views\",\"output\":\"2\",\"details\":\"1\",\"link\":\"1\",\"perRow\":\"1\",\"prettyPhoto\":\"true\",\"theme\":\"dark_rounded\",\"opacity\":\"0.6\",\"resize\":\"true\",\"prettyBoxTitle\":\"false\",\"prettyBoxSpeed\":\"fast\",\"overlayGallery\":\"false\",\"img_width\":\"200\",\"img_height\":\"100\",\"option\":\"crop\",\"height\":\"150\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(170,'Header 4','','<p>Curabitur sed eros nisl. Quisque arcu arcu, malesuada at lacinia non, lacinia sit amet mi.</p>',1,'header4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" quote\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');

/*!40000 ALTER TABLE `#__modules` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__modules_menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__modules_menu`;

CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__modules_menu` WRITE;
/*!40000 ALTER TABLE `#__modules_menu` DISABLE KEYS */;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`)
VALUES
	(1,0),
	(2,0),
	(3,0),
	(4,0),
	(6,0),
	(7,0),
	(8,0),
	(9,0),
	(10,0),
	(12,0),
	(13,0),
	(14,0),
	(15,0),
	(16,0),
	(17,0),
	(18,0),
	(52,0),
	(53,0),
	(54,0),
	(55,0),
	(56,0),
	(57,0),
	(58,0),
	(59,0),
	(62,0),
	(67,0),
	(69,0),
	(71,0),
	(72,0),
	(73,0),
	(75,0),
	(79,0),
	(80,0),
	(82,21),
	(82,23),
	(82,24),
	(82,26),
	(82,27),
	(82,30),
	(82,33),
	(82,34),
	(82,35),
	(82,36),
	(82,38),
	(82,47),
	(82,48),
	(82,49),
	(82,50),
	(82,51),
	(82,56),
	(82,57),
	(82,58),
	(82,59),
	(82,60),
	(82,61),
	(82,62),
	(82,63),
	(82,64),
	(82,65),
	(82,66),
	(82,67),
	(82,68),
	(82,69),
	(82,70),
	(82,74),
	(82,75),
	(82,76),
	(82,77),
	(82,78),
	(82,79),
	(82,80),
	(82,81),
	(82,82),
	(82,83),
	(82,84),
	(82,85),
	(82,86),
	(82,87),
	(82,88),
	(82,89),
	(82,90),
	(82,91),
	(82,92),
	(82,93),
	(82,94),
	(82,95),
	(82,96),
	(82,97),
	(82,98),
	(82,99),
	(82,100),
	(82,101),
	(82,102),
	(82,104),
	(82,119),
	(82,121),
	(82,122),
	(82,123),
	(82,124),
	(82,125),
	(83,21),
	(83,23),
	(83,24),
	(83,26),
	(83,27),
	(83,30),
	(83,33),
	(83,34),
	(83,35),
	(83,36),
	(83,38),
	(83,47),
	(83,48),
	(83,49),
	(83,50),
	(83,51),
	(83,56),
	(83,57),
	(83,58),
	(83,59),
	(83,60),
	(83,61),
	(83,62),
	(83,63),
	(83,64),
	(83,65),
	(83,66),
	(83,67),
	(83,68),
	(83,69),
	(83,70),
	(83,74),
	(83,75),
	(83,76),
	(83,77),
	(83,78),
	(83,79),
	(83,80),
	(83,81),
	(83,82),
	(83,83),
	(83,84),
	(83,85),
	(83,86),
	(83,87),
	(83,88),
	(83,89),
	(83,90),
	(83,91),
	(83,92),
	(83,93),
	(83,94),
	(83,95),
	(83,96),
	(83,97),
	(83,98),
	(83,99),
	(83,100),
	(83,101),
	(83,102),
	(83,104),
	(83,119),
	(83,121),
	(83,122),
	(83,123),
	(83,124),
	(83,125),
	(84,21),
	(84,23),
	(84,24),
	(84,26),
	(84,27),
	(84,30),
	(84,33),
	(84,34),
	(84,35),
	(84,36),
	(84,38),
	(84,47),
	(84,48),
	(84,49),
	(84,50),
	(84,51),
	(84,56),
	(84,57),
	(84,58),
	(84,59),
	(84,60),
	(84,61),
	(84,62),
	(84,63),
	(84,64),
	(84,65),
	(84,66),
	(84,67),
	(84,68),
	(84,69),
	(84,70),
	(84,74),
	(84,75),
	(84,76),
	(84,77),
	(84,78),
	(84,79),
	(84,80),
	(84,81),
	(84,82),
	(84,83),
	(84,84),
	(84,85),
	(84,86),
	(84,87),
	(84,88),
	(84,89),
	(84,90),
	(84,91),
	(84,92),
	(84,93),
	(84,94),
	(84,95),
	(84,96),
	(84,97),
	(84,98),
	(84,99),
	(84,100),
	(84,101),
	(84,102),
	(84,104),
	(84,119),
	(84,121),
	(84,122),
	(84,123),
	(84,124),
	(84,125),
	(85,21),
	(85,23),
	(85,24),
	(85,26),
	(85,27),
	(85,30),
	(85,33),
	(85,34),
	(85,35),
	(85,36),
	(85,38),
	(85,47),
	(85,48),
	(85,49),
	(85,50),
	(85,51),
	(85,56),
	(85,57),
	(85,58),
	(85,59),
	(85,60),
	(85,61),
	(85,62),
	(85,63),
	(85,64),
	(85,65),
	(85,66),
	(85,67),
	(85,68),
	(85,69),
	(85,70),
	(85,74),
	(85,75),
	(85,76),
	(85,77),
	(85,78),
	(85,79),
	(85,80),
	(85,81),
	(85,82),
	(85,83),
	(85,84),
	(85,85),
	(85,86),
	(85,87),
	(85,88),
	(85,89),
	(85,90),
	(85,91),
	(85,92),
	(85,93),
	(85,94),
	(85,95),
	(85,96),
	(85,97),
	(85,98),
	(85,99),
	(85,100),
	(85,101),
	(85,102),
	(85,104),
	(85,119),
	(85,121),
	(85,122),
	(85,123),
	(85,124),
	(85,125),
	(86,21),
	(86,23),
	(86,24),
	(86,26),
	(86,27),
	(86,30),
	(86,33),
	(86,34),
	(86,35),
	(86,36),
	(86,38),
	(86,47),
	(86,48),
	(86,49),
	(86,50),
	(86,51),
	(86,56),
	(86,57),
	(86,58),
	(86,59),
	(86,60),
	(86,61),
	(86,62),
	(86,63),
	(86,64),
	(86,65),
	(86,66),
	(86,67),
	(86,68),
	(86,69),
	(86,70),
	(86,74),
	(86,75),
	(86,76),
	(86,77),
	(86,78),
	(86,79),
	(86,80),
	(86,81),
	(86,82),
	(86,83),
	(86,84),
	(86,85),
	(86,86),
	(86,87),
	(86,88),
	(86,89),
	(86,90),
	(86,91),
	(86,92),
	(86,93),
	(86,94),
	(86,95),
	(86,96),
	(86,97),
	(86,98),
	(86,99),
	(86,100),
	(86,101),
	(86,102),
	(86,104),
	(86,119),
	(86,121),
	(86,122),
	(86,123),
	(86,124),
	(86,125),
	(88,21),
	(88,23),
	(88,24),
	(88,26),
	(88,27),
	(88,30),
	(88,33),
	(88,34),
	(88,35),
	(88,36),
	(88,47),
	(88,48),
	(88,49),
	(88,50),
	(88,51),
	(88,56),
	(88,57),
	(88,58),
	(88,59),
	(88,60),
	(88,61),
	(88,62),
	(88,63),
	(88,64),
	(88,65),
	(88,66),
	(88,67),
	(88,68),
	(88,69),
	(88,70),
	(88,74),
	(88,75),
	(88,76),
	(88,77),
	(88,78),
	(88,79),
	(88,80),
	(88,81),
	(88,82),
	(88,83),
	(88,84),
	(88,85),
	(88,86),
	(88,87),
	(88,88),
	(88,89),
	(88,90),
	(88,91),
	(88,92),
	(88,93),
	(88,94),
	(88,95),
	(88,96),
	(88,97),
	(88,98),
	(88,99),
	(88,100),
	(88,101),
	(88,102),
	(88,104),
	(88,121),
	(88,122),
	(88,123),
	(89,38),
	(90,25),
	(91,30),
	(92,25),
	(93,25),
	(94,30),
	(95,30),
	(96,30),
	(97,30),
	(98,25),
	(99,25),
	(100,25),
	(101,25),
	(102,25),
	(103,25),
	(104,25),
	(105,25),
	(106,25),
	(107,25),
	(108,25),
	(109,25),
	(110,25),
	(111,0),
	(114,38),
	(115,21),
	(115,23),
	(115,24),
	(115,26),
	(115,27),
	(115,30),
	(115,33),
	(115,34),
	(115,35),
	(115,36),
	(115,38),
	(115,47),
	(115,48),
	(115,49),
	(115,50),
	(115,51),
	(115,56),
	(115,57),
	(115,58),
	(115,59),
	(115,60),
	(115,61),
	(115,62),
	(115,63),
	(115,64),
	(115,65),
	(115,66),
	(115,67),
	(115,68),
	(115,69),
	(115,70),
	(115,74),
	(115,75),
	(115,76),
	(115,77),
	(115,78),
	(115,79),
	(115,80),
	(115,81),
	(115,82),
	(115,83),
	(115,84),
	(115,85),
	(115,86),
	(115,87),
	(115,88),
	(115,89),
	(115,90),
	(115,91),
	(115,92),
	(115,93),
	(115,94),
	(115,95),
	(115,96),
	(115,97),
	(115,98),
	(115,99),
	(115,100),
	(115,101),
	(115,102),
	(115,104),
	(115,119),
	(115,121),
	(115,122),
	(115,123),
	(115,124),
	(115,125),
	(116,38),
	(117,0),
	(118,0),
	(119,21),
	(119,23),
	(119,24),
	(119,26),
	(119,27),
	(119,30),
	(119,33),
	(119,34),
	(119,35),
	(119,36),
	(119,38),
	(119,47),
	(119,48),
	(119,49),
	(119,50),
	(119,51),
	(119,56),
	(119,57),
	(119,58),
	(119,59),
	(119,60),
	(119,61),
	(119,62),
	(119,63),
	(119,64),
	(119,65),
	(119,66),
	(119,67),
	(119,68),
	(119,69),
	(119,70),
	(119,74),
	(119,75),
	(119,76),
	(119,77),
	(119,78),
	(119,79),
	(119,80),
	(119,81),
	(119,82),
	(119,83),
	(119,84),
	(119,85),
	(119,86),
	(119,87),
	(119,88),
	(119,89),
	(119,90),
	(119,91),
	(119,92),
	(119,93),
	(119,94),
	(119,95),
	(119,96),
	(119,97),
	(119,98),
	(119,99),
	(119,100),
	(119,101),
	(119,102),
	(119,104),
	(119,119),
	(119,121),
	(119,122),
	(119,123),
	(119,124),
	(119,125),
	(120,21),
	(120,23),
	(120,24),
	(120,26),
	(120,27),
	(120,30),
	(120,33),
	(120,34),
	(120,35),
	(120,36),
	(120,38),
	(120,47),
	(120,48),
	(120,49),
	(120,50),
	(120,51),
	(120,56),
	(120,57),
	(120,58),
	(120,59),
	(120,60),
	(120,61),
	(120,62),
	(120,63),
	(120,64),
	(120,65),
	(120,66),
	(120,67),
	(120,68),
	(120,69),
	(120,70),
	(120,74),
	(120,75),
	(120,76),
	(120,77),
	(120,78),
	(120,79),
	(120,80),
	(120,81),
	(120,82),
	(120,83),
	(120,84),
	(120,85),
	(120,86),
	(120,87),
	(120,88),
	(120,89),
	(120,90),
	(120,91),
	(120,92),
	(120,93),
	(120,94),
	(120,95),
	(120,96),
	(120,97),
	(120,98),
	(120,99),
	(120,100),
	(120,101),
	(120,102),
	(120,104),
	(120,119),
	(120,121),
	(120,122),
	(120,123),
	(120,124),
	(120,125),
	(121,21),
	(121,23),
	(121,24),
	(121,26),
	(121,27),
	(121,30),
	(121,33),
	(121,34),
	(121,35),
	(121,36),
	(121,38),
	(121,47),
	(121,48),
	(121,49),
	(121,50),
	(121,51),
	(121,56),
	(121,57),
	(121,58),
	(121,59),
	(121,60),
	(121,61),
	(121,62),
	(121,63),
	(121,64),
	(121,65),
	(121,66),
	(121,67),
	(121,68),
	(121,69),
	(121,70),
	(121,74),
	(121,75),
	(121,76),
	(121,77),
	(121,78),
	(121,79),
	(121,80),
	(121,81),
	(121,82),
	(121,83),
	(121,84),
	(121,85),
	(121,86),
	(121,87),
	(121,88),
	(121,89),
	(121,90),
	(121,91),
	(121,92),
	(121,93),
	(121,94),
	(121,95),
	(121,96),
	(121,97),
	(121,98),
	(121,99),
	(121,100),
	(121,101),
	(121,102),
	(121,104),
	(121,119),
	(121,121),
	(121,122),
	(121,123),
	(121,124),
	(121,125),
	(122,-125),
	(122,-124),
	(122,-123),
	(122,-122),
	(122,-121),
	(122,-119),
	(122,-104),
	(122,-102),
	(122,-101),
	(122,-100),
	(122,-99),
	(122,-98),
	(122,-97),
	(122,-96),
	(122,-95),
	(122,-94),
	(122,-93),
	(122,-92),
	(122,-91),
	(122,-90),
	(122,-89),
	(122,-88),
	(122,-87),
	(122,-86),
	(122,-85),
	(122,-84),
	(122,-83),
	(122,-82),
	(122,-81),
	(122,-80),
	(122,-79),
	(122,-78),
	(122,-77),
	(122,-76),
	(122,-75),
	(122,-74),
	(122,-70),
	(122,-69),
	(122,-68),
	(122,-67),
	(122,-66),
	(122,-65),
	(122,-64),
	(122,-63),
	(122,-62),
	(122,-61),
	(122,-60),
	(122,-59),
	(122,-58),
	(122,-57),
	(122,-56),
	(122,-51),
	(122,-50),
	(122,-49),
	(122,-48),
	(122,-47),
	(122,-38),
	(122,-36),
	(122,-35),
	(122,-34),
	(122,-33),
	(122,-30),
	(122,-27),
	(122,-26),
	(122,-24),
	(122,-23),
	(122,-21),
	(123,21),
	(123,23),
	(123,24),
	(123,26),
	(123,27),
	(123,30),
	(123,33),
	(123,34),
	(123,35),
	(123,36),
	(123,38),
	(123,47),
	(123,48),
	(123,49),
	(123,50),
	(123,51),
	(123,56),
	(123,57),
	(123,58),
	(123,59),
	(123,60),
	(123,61),
	(123,62),
	(123,63),
	(123,64),
	(123,65),
	(123,66),
	(123,67),
	(123,68),
	(123,69),
	(123,70),
	(123,74),
	(123,75),
	(123,76),
	(123,77),
	(123,78),
	(123,79),
	(123,80),
	(123,81),
	(123,82),
	(123,83),
	(123,84),
	(123,85),
	(123,86),
	(123,87),
	(123,88),
	(123,89),
	(123,90),
	(123,91),
	(123,92),
	(123,93),
	(123,94),
	(123,95),
	(123,96),
	(123,97),
	(123,98),
	(123,99),
	(123,100),
	(123,101),
	(123,102),
	(123,104),
	(123,119),
	(123,121),
	(123,122),
	(123,123),
	(123,124),
	(123,125),
	(124,21),
	(124,23),
	(124,24),
	(124,26),
	(124,27),
	(124,30),
	(124,33),
	(124,34),
	(124,35),
	(124,36),
	(124,38),
	(124,47),
	(124,48),
	(124,49),
	(124,50),
	(124,51),
	(124,56),
	(124,57),
	(124,58),
	(124,59),
	(124,60),
	(124,61),
	(124,62),
	(124,63),
	(124,64),
	(124,65),
	(124,66),
	(124,67),
	(124,68),
	(124,69),
	(124,70),
	(124,74),
	(124,75),
	(124,76),
	(124,77),
	(124,78),
	(124,79),
	(124,80),
	(124,81),
	(124,82),
	(124,83),
	(124,84),
	(124,85),
	(124,86),
	(124,87),
	(124,88),
	(124,89),
	(124,90),
	(124,91),
	(124,92),
	(124,93),
	(124,94),
	(124,95),
	(124,96),
	(124,97),
	(124,98),
	(124,99),
	(124,100),
	(124,101),
	(124,102),
	(124,104),
	(124,119),
	(124,121),
	(124,122),
	(124,123),
	(124,124),
	(124,125),
	(125,38),
	(126,21),
	(126,23),
	(126,24),
	(126,25),
	(126,26),
	(126,27),
	(126,30),
	(126,33),
	(126,34),
	(126,35),
	(126,36),
	(126,38),
	(126,47),
	(126,48),
	(126,49),
	(126,50),
	(126,51),
	(126,56),
	(126,57),
	(126,58),
	(126,59),
	(126,60),
	(126,61),
	(126,62),
	(126,63),
	(126,64),
	(126,65),
	(126,66),
	(126,67),
	(126,68),
	(126,69),
	(126,70),
	(126,74),
	(126,75),
	(126,76),
	(126,77),
	(126,78),
	(126,79),
	(126,80),
	(126,81),
	(126,82),
	(126,83),
	(126,84),
	(126,85),
	(126,86),
	(126,87),
	(126,88),
	(126,89),
	(126,90),
	(126,91),
	(126,92),
	(126,93),
	(126,94),
	(126,95),
	(126,96),
	(126,97),
	(126,98),
	(126,99),
	(126,100),
	(126,101),
	(126,102),
	(126,104),
	(126,119),
	(126,121),
	(126,122),
	(126,123),
	(126,124),
	(126,125),
	(127,21),
	(127,23),
	(127,24),
	(127,26),
	(127,27),
	(127,30),
	(127,33),
	(127,34),
	(127,35),
	(127,36),
	(127,38),
	(127,47),
	(127,48),
	(127,49),
	(127,50),
	(127,51),
	(127,56),
	(127,57),
	(127,58),
	(127,59),
	(127,60),
	(127,61),
	(127,62),
	(127,63),
	(127,64),
	(127,65),
	(127,66),
	(127,67),
	(127,68),
	(127,69),
	(127,70),
	(127,74),
	(127,75),
	(127,76),
	(127,77),
	(127,78),
	(127,79),
	(127,80),
	(127,81),
	(127,82),
	(127,83),
	(127,84),
	(127,85),
	(127,86),
	(127,87),
	(127,88),
	(127,89),
	(127,90),
	(127,91),
	(127,92),
	(127,93),
	(127,94),
	(127,95),
	(127,96),
	(127,97),
	(127,98),
	(127,99),
	(127,100),
	(127,101),
	(127,102),
	(127,104),
	(127,119),
	(127,121),
	(127,122),
	(127,123),
	(127,124),
	(128,25),
	(129,21),
	(129,23),
	(129,24),
	(129,26),
	(129,27),
	(129,30),
	(129,33),
	(129,34),
	(129,35),
	(129,36),
	(129,38),
	(129,47),
	(129,48),
	(129,49),
	(129,50),
	(129,51),
	(129,56),
	(129,57),
	(129,58),
	(129,59),
	(129,60),
	(129,61),
	(129,62),
	(129,63),
	(129,64),
	(129,65),
	(129,66),
	(129,67),
	(129,68),
	(129,69),
	(129,70),
	(129,74),
	(129,75),
	(129,76),
	(129,77),
	(129,78),
	(129,79),
	(129,80),
	(129,81),
	(129,82),
	(129,83),
	(129,84),
	(129,85),
	(129,86),
	(129,87),
	(129,88),
	(129,89),
	(129,90),
	(129,91),
	(129,92),
	(129,93),
	(129,94),
	(129,95),
	(129,96),
	(129,97),
	(129,98),
	(129,99),
	(129,100),
	(129,101),
	(129,102),
	(129,104),
	(129,119),
	(129,121),
	(129,122),
	(129,123),
	(129,124),
	(130,25),
	(131,25),
	(132,25),
	(133,25),
	(134,25),
	(135,25),
	(136,25),
	(137,25),
	(138,25),
	(139,25),
	(140,25),
	(141,25),
	(142,25),
	(143,45),
	(144,45),
	(145,25),
	(146,25),
	(147,25),
	(148,25),
	(149,25),
	(150,25),
	(152,45),
	(153,38),
	(154,0),
	(155,38),
	(156,0),
	(159,45),
	(160,45),
	(162,0),
	(163,3),
	(163,24),
	(163,28),
	(163,29),
	(163,31),
	(163,32),
	(163,34),
	(163,35),
	(163,36),
	(163,37),
	(163,38),
	(163,39),
	(163,40),
	(163,41),
	(163,44),
	(163,45),
	(163,52),
	(163,53),
	(163,54),
	(163,55),
	(163,56),
	(163,57),
	(163,58),
	(163,59),
	(163,60),
	(163,62),
	(163,63),
	(163,70),
	(163,71),
	(163,72),
	(163,73),
	(163,74),
	(163,75),
	(163,76),
	(163,77),
	(163,78),
	(163,79),
	(163,80),
	(163,81),
	(163,82),
	(163,83),
	(163,86),
	(163,87),
	(163,88),
	(163,89),
	(163,90),
	(163,91),
	(163,92),
	(163,93),
	(163,94),
	(163,95),
	(163,96),
	(163,97),
	(163,98),
	(163,99),
	(163,100),
	(163,101),
	(163,102),
	(163,103),
	(163,104),
	(163,105),
	(163,106),
	(163,107),
	(163,108),
	(163,109),
	(163,110),
	(163,111),
	(163,112),
	(163,113),
	(163,114),
	(163,115),
	(163,116),
	(163,117),
	(163,118),
	(163,119),
	(164,3),
	(164,24),
	(164,28),
	(164,29),
	(164,31),
	(164,32),
	(164,34),
	(164,35),
	(164,36),
	(164,37),
	(164,38),
	(164,39),
	(164,40),
	(164,41),
	(164,44),
	(164,45),
	(164,52),
	(164,53),
	(164,54),
	(164,55),
	(164,56),
	(164,57),
	(164,58),
	(164,59),
	(164,60),
	(164,62),
	(164,63),
	(164,70),
	(164,71),
	(164,72),
	(164,73),
	(164,74),
	(164,75),
	(164,76),
	(164,77),
	(164,78),
	(164,79),
	(164,80),
	(164,81),
	(164,82),
	(164,83),
	(164,86),
	(164,87),
	(164,88),
	(164,89),
	(164,90),
	(164,91),
	(164,92),
	(164,93),
	(164,94),
	(164,95),
	(164,96),
	(164,97),
	(164,98),
	(164,99),
	(164,100),
	(164,101),
	(164,102),
	(164,103),
	(164,104),
	(164,105),
	(164,106),
	(164,107),
	(164,108),
	(164,109),
	(164,110),
	(164,111),
	(164,112),
	(164,113),
	(164,114),
	(164,115),
	(164,116),
	(164,117),
	(164,118),
	(164,119),
	(165,38),
	(166,0),
	(167,0),
	(168,38),
	(169,0),
	(170,25),
	(171,0),
	(172,0),
	(173,0),
	(174,0),
	(175,0),
	(180,45),
	(181,30),
	(182,119),
	(184,0),
	(185,30),
	(186,30),
	(187,30),
	(188,30),
	(189,30),
	(190,30),
	(191,30),
	(192,30),
	(193,30),
	(194,30),
	(195,30),
	(196,119),
	(197,30),
	(198,30),
	(199,30),
	(200,30),
	(201,30),
	(202,30),
	(203,30),
	(204,30),
	(205,30),
	(206,30),
	(207,0),
	(208,0),
	(209,0),
	(210,0),
	(211,0),
	(212,0),
	(213,0),
	(214,0),
	(215,0),
	(216,0),
	(217,0);

/*!40000 ALTER TABLE `#__modules_menu` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__newsfeeds
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__newsfeeds`;

CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__redirect_links
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redirect_links`;

CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__redirect_links` WRITE;
/*!40000 ALTER TABLE `#__redirect_links` DISABLE KEYS */;

INSERT INTO `#__redirect_links` (`id`, `old_url`, `new_url`, `referer`, `comment`, `published`, `created_date`, `modified_date`)
VALUES
	(1,'http://localhost/ShopIgnition_Development_Akeeba/index.php/features/index.php','','http://localhost/ShopIgnition_Development_Akeeba/index.php/features/themes','',0,'2011-11-15 06:46:19','0000-00-00 00:00:00'),
	(2,'http://localhost/ShopIgnition_Development_Akeeba/index.php/joomla/index.php','','http://localhost/ShopIgnition_Development_Akeeba/index.php/joomla/article','',0,'2011-11-15 08:41:28','0000-00-00 00:00:00'),
	(3,'http://localhost/ShopIgnition_Development_Akeeba/index.php?option=com_tienda&view=carts&Itemid=49','','http://localhost/ShopIgnition_Development_Akeeba/index.php?option=com_redshop&view=checkout&Itemid=67','',0,'2011-11-17 05:23:15','0000-00-00 00:00:00'),
	(4,'http://localhost/ShopIgnition_Development_Akeeba/index.php?option=com_user&view=register&Itemid=41','','','',0,'2011-11-18 10:28:45','0000-00-00 00:00:00'),
	(5,'http://localhost/ShopIgnition_Development_Akeeba/index.php?option=com_user&view=register','','','',0,'2011-11-18 10:28:51','0000-00-00 00:00:00'),
	(6,'http://localhost/ShopIgnition_Development_Akeeba/index.php?option=com_user','','','',0,'2011-11-18 10:28:56','0000-00-00 00:00:00'),
	(7,'http://localhost:8888/qs/unified/17/Shopignition/index.php/features/images/icons/star.png','','http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda','',0,'2011-11-22 01:32:30','0000-00-00 00:00:00'),
	(8,'http://localhost:8888/qs/unified/17/Shopignition/index.php/features/images/icons/book.png','','http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda','',0,'2011-11-22 01:32:30','0000-00-00 00:00:00'),
	(9,'http://localhost:8888/qs/unified/17/Shopignition/index.php/features/images/icons/heart.png','','http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda','',0,'2011-11-22 01:32:30','0000-00-00 00:00:00'),
	(10,'http://localhost:8888/qs/unified/17/Shopignition/index.php/features/images/icons/sale.png','','http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda','',0,'2011-11-22 01:32:30','0000-00-00 00:00:00'),
	(11,'http://localhost:8888/qs/unified/17/Shopignition/index.php/features/images/icons/cart.png','','http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda','',0,'2011-11-22 01:32:30','0000-00-00 00:00:00'),
	(13,'http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda/12-demo-content/index.php','','http://localhost:8888/qs/unified/17/Shopignition/index.php/features/tienda/12-demo-content/features','',0,'2011-11-22 01:48:15','0000-00-00 00:00:00');

/*!40000 ALTER TABLE `#__redirect_links` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_accessmanager
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_accessmanager`;

CREATE TABLE `#__redshop_accessmanager` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `section_name` varchar(256) NOT NULL,
  `gid` int(11) NOT NULL,
  `view` enum('1','0') DEFAULT NULL,
  `add` enum('1','0') DEFAULT NULL,
  `edit` enum('1','0') DEFAULT NULL,
  `delete` enum('1','0') DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Access Manager';



# Dump of table #__redshop_attribute_set
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_attribute_set`;

CREATE TABLE `#__redshop_attribute_set` (
  `attribute_set_id` int(11) NOT NULL AUTO_INCREMENT,
  `attribute_set_name` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`attribute_set_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Attribute set detail';



# Dump of table #__redshop_cart
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_cart`;

CREATE TABLE `#__redshop_cart` (
  `session_id` varchar(255) NOT NULL,
  `product_id` int(11) NOT NULL,
  `section` varchar(250) NOT NULL,
  `qty` int(11) NOT NULL,
  `time` double NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Cart';

LOCK TABLES `#__redshop_cart` WRITE;
/*!40000 ALTER TABLE `#__redshop_cart` DISABLE KEYS */;

INSERT INTO `#__redshop_cart` (`session_id`, `product_id`, `section`, `qty`, `time`)
VALUES
	('885ea1d48fd779c4e80027f509e47c8f',22,'product',1,1321854015);

/*!40000 ALTER TABLE `#__redshop_cart` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_catalog
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_catalog`;

CREATE TABLE `#__redshop_catalog` (
  `catalog_id` int(11) NOT NULL AUTO_INCREMENT,
  `catalog_name` varchar(250) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`catalog_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Catalog';



# Dump of table #__redshop_catalog_colour
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_catalog_colour`;

CREATE TABLE `#__redshop_catalog_colour` (
  `colour_id` int(11) NOT NULL AUTO_INCREMENT,
  `sample_id` int(11) NOT NULL,
  `code_image` varchar(250) NOT NULL,
  `is_image` tinyint(4) NOT NULL,
  PRIMARY KEY (`colour_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Catalog Colour';



# Dump of table #__redshop_catalog_request
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_catalog_request`;

CREATE TABLE `#__redshop_catalog_request` (
  `catalog_user_id` int(11) NOT NULL AUTO_INCREMENT,
  `catalog_id` int(11) NOT NULL,
  `name` varchar(250) NOT NULL,
  `email` varchar(250) NOT NULL,
  `registerDate` int(11) NOT NULL,
  `block` tinyint(4) NOT NULL,
  `reminder_1` tinyint(4) NOT NULL,
  `reminder_2` tinyint(4) NOT NULL,
  `reminder_3` tinyint(4) NOT NULL,
  PRIMARY KEY (`catalog_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Catalog Request';



# Dump of table #__redshop_catalog_sample
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_catalog_sample`;

CREATE TABLE `#__redshop_catalog_sample` (
  `sample_id` int(11) NOT NULL AUTO_INCREMENT,
  `sample_name` varchar(100) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`sample_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Catalog Sample';



# Dump of table #__redshop_category
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_category`;

CREATE TABLE `#__redshop_category` (
  `category_id` int(11) NOT NULL AUTO_INCREMENT,
  `category_name` varchar(250) NOT NULL,
  `category_short_description` longtext NOT NULL,
  `category_description` longtext NOT NULL,
  `category_template` int(11) NOT NULL,
  `category_more_template` varchar(255) NOT NULL,
  `products_per_page` int(11) NOT NULL,
  `category_thumb_image` varchar(250) NOT NULL,
  `category_full_image` varchar(250) NOT NULL,
  `metakey` varchar(250) NOT NULL,
  `metadesc` longtext NOT NULL,
  `metalanguage_setting` text NOT NULL,
  `metarobot_info` text NOT NULL,
  `pagetitle` text NOT NULL,
  `pageheading` longtext NOT NULL,
  `sef_url` text NOT NULL,
  `published` tinyint(4) NOT NULL,
  `category_pdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ordering` int(11) NOT NULL,
  `category_back_full_image` varchar(250) NOT NULL,
  `compare_template_id` varchar(255) NOT NULL,
  PRIMARY KEY (`category_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Category';

LOCK TABLES `#__redshop_category` WRITE;
/*!40000 ALTER TABLE `#__redshop_category` DISABLE KEYS */;

INSERT INTO `#__redshop_category` (`category_id`, `category_name`, `category_short_description`, `category_description`, `category_template`, `category_more_template`, `products_per_page`, `category_thumb_image`, `category_full_image`, `metakey`, `metadesc`, `metalanguage_setting`, `metarobot_info`, `pagetitle`, `pageheading`, `sef_url`, `published`, `category_pdate`, `ordering`, `category_back_full_image`, `compare_template_id`)
VALUES
	(1,'T-shirts','','',5,'0',5,'1300537643_greenwomens.jpg','1300537643_greenwomens.jpg','','','','','','','',1,'2011-03-19 12:51:05',0,'','0'),
	(2,'Womens T-shirts','Sed sagittis ante sit amet eros iaculis faucibus. Suspendisse sed magna a  nisi adipiscing tincidunt sit amet eu justo.&nbsp;Sed elementum aliquet  adipiscing. Vestibulum tincidunt varius eleifend.','',5,'0',5,'1300536343_1300536311_greenwomens.jpg','1300536343_1300536311_greenwomens.jpg','','','','','','','',1,'2011-03-19 12:51:22',0,'','0'),
	(3,'Mens T-shirts','Sed sagittis ante sit amet eros iaculis faucibus. Suspendisse sed magna a   nisi adipiscing tincidunt sit amet eu justo.&nbsp;Sed elementum aliquet   adipiscing. Vestibulum tincidunt varius eleifend.','',5,'0',5,'1300538410_1300536311_oliveshirt.jpg','1300538410_1300536311_oliveshirt.jpg','','','','','','','',1,'2011-03-19 12:51:41',0,'','0'),
	(4,'Shoes','','',5,'0',5,'1301366872_sportshoe.jpg','1301366872_sportshoe.jpg','','','','','','','',1,'2011-03-19 12:52:01',0,'','0'),
	(5,'Novelty Shoes','','',5,'0',5,'1301366090_shoe1.jpg','1301366090_shoe1.jpg','','','','','','','',1,'2011-03-19 12:52:16',0,'','0'),
	(6,'Sport shoes','','',5,'0',5,'1301366131_brownwhitesneakers.jpg','1301366131_brownwhitesneakers.jpg','','','','','','','',1,'2011-03-19 12:52:33',0,'','0'),
	(7,'T-shirts','','',5,'0',5,'1321433107_1300536343_1300536311_greenwomens.jpg','1321433107_1300536343_1300536311_greenwomens.jpg','','','','','','','',1,'2011-11-16 13:29:10',0,'','0'),
	(8,'Womens T-shirts','<p>Sed sagittis ante sit amet eros iaculis faucibus. Suspendisse sed magna a nisi adipiscing tincidunt sit amet eu justo. Sed elementum aliquet adipiscing. Vestibulum tincidunt varius eleifend.</p>','',5,'0',5,'1321433081_1300536343_1300536311_greenwomens.jpg','1321433081_1300536343_1300536311_greenwomens.jpg','','','','','','','',1,'2011-11-16 14:04:28',0,'','0'),
	(9,'Mens T-shirts','','',5,'0',5,'1321433185_1300538410_1300536311_oliveshirt.jpg','1321433185_1300538410_1300536311_oliveshirt.jpg','','','','','','','',1,'2011-11-16 14:16:25',0,'','0');

/*!40000 ALTER TABLE `#__redshop_category` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_category_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_category_xref`;

CREATE TABLE `#__redshop_category_xref` (
  `category_parent_id` int(11) NOT NULL DEFAULT '0',
  `category_child_id` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `category_parent_id` (`category_parent_id`,`category_child_id`),
  KEY `category_xref_category_parent_id` (`category_parent_id`),
  KEY `category_xref_category_child_id` (`category_child_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Category relation';

LOCK TABLES `#__redshop_category_xref` WRITE;
/*!40000 ALTER TABLE `#__redshop_category_xref` DISABLE KEYS */;

INSERT INTO `#__redshop_category_xref` (`category_parent_id`, `category_child_id`)
VALUES
	(0,4),
	(0,7),
	(1,5),
	(1,6),
	(4,5),
	(4,6),
	(7,8),
	(7,9);

/*!40000 ALTER TABLE `#__redshop_category_xref` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_container
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_container`;

CREATE TABLE `#__redshop_container` (
  `container_id` int(11) NOT NULL AUTO_INCREMENT,
  `container_name` varchar(250) NOT NULL,
  `manufacture_id` int(11) NOT NULL,
  `supplier_id` int(11) NOT NULL,
  `container_desc` longtext NOT NULL,
  `creation_date` double NOT NULL,
  `min_del_time` int(11) NOT NULL,
  `max_del_time` int(11) NOT NULL,
  `container_volume` double NOT NULL,
  `stockroom_id` int(11) NOT NULL,
  `published` int(11) NOT NULL,
  PRIMARY KEY (`container_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Container';



# Dump of table #__redshop_container_product_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_container_product_xref`;

CREATE TABLE `#__redshop_container_product_xref` (
  `container_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `quantity` int(11) NOT NULL,
  UNIQUE KEY `container_id` (`container_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Container Product Relation';



# Dump of table #__redshop_country
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_country`;

CREATE TABLE `#__redshop_country` (
  `country_id` int(11) NOT NULL AUTO_INCREMENT,
  `country_name` varchar(64) DEFAULT NULL,
  `country_3_code` char(3) DEFAULT NULL,
  `country_2_code` char(2) DEFAULT NULL,
  `country_jtext` varchar(255) NOT NULL,
  PRIMARY KEY (`country_id`),
  KEY `idx_country_name` (`country_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Country records';

LOCK TABLES `#__redshop_country` WRITE;
/*!40000 ALTER TABLE `#__redshop_country` DISABLE KEYS */;

INSERT INTO `#__redshop_country` (`country_id`, `country_name`, `country_3_code`, `country_2_code`, `country_jtext`)
VALUES
	(1,'Afghanistan','AFG','AF',''),
	(2,'Albania','ALB','AL',''),
	(3,'Algeria','DZA','DZ',''),
	(4,'American Samoa','ASM','AS',''),
	(5,'Andorra','AND','AD',''),
	(6,'Angola','AGO','AO',''),
	(7,'Anguilla','AIA','AI',''),
	(8,'Antarctica','ATA','AQ',''),
	(9,'Antigua and Barbuda','ATG','AG',''),
	(10,'Argentina','ARG','AR',''),
	(11,'Armenia','ARM','AM',''),
	(12,'Aruba','ABW','AW',''),
	(13,'Australia','AUS','AU',''),
	(14,'Austria','AUT','AT',''),
	(15,'Azerbaijan','AZE','AZ',''),
	(16,'Bahamas','BHS','BS',''),
	(17,'Bahrain','BHR','BH',''),
	(18,'Bangladesh','BGD','BD',''),
	(19,'Barbados','BRB','BB',''),
	(20,'Belarus','BLR','BY',''),
	(21,'Belgium','BEL','BE',''),
	(22,'Belize','BLZ','BZ',''),
	(23,'Benin','BEN','BJ',''),
	(24,'Bermuda','BMU','BM',''),
	(25,'Bhutan','BTN','BT',''),
	(26,'Bolivia','BOL','BO',''),
	(27,'Bosnia and Herzegowina','BIH','BA',''),
	(28,'Botswana','BWA','BW',''),
	(29,'Bouvet Island','BVT','BV',''),
	(30,'Brazil','BRA','BR',''),
	(31,'British Indian Ocean Territory','IOT','IO',''),
	(32,'Brunei Darussalam','BRN','BN',''),
	(33,'Bulgaria','BGR','BG',''),
	(34,'Burkina Faso','BFA','BF',''),
	(35,'Burundi','BDI','BI',''),
	(36,'Cambodia','KHM','KH',''),
	(37,'Cameroon','CMR','CM',''),
	(38,'Canada','CAN','CA',''),
	(39,'Cape Verde','CPV','CV',''),
	(40,'Cayman Islands','CYM','KY',''),
	(41,'Central African Republic','CAF','CF',''),
	(42,'Chad','TCD','TD',''),
	(43,'Chile','CHL','CL',''),
	(44,'China','CHN','CN',''),
	(45,'Christmas Island','CXR','CX',''),
	(46,'Cocos (Keeling) Islands','CCK','CC',''),
	(47,'Colombia','COL','CO',''),
	(48,'Comoros','COM','KM',''),
	(49,'Congo','COG','CG',''),
	(50,'Cook Islands','COK','CK',''),
	(51,'Costa Rica','CRI','CR',''),
	(52,'Cote D\'Ivoire','CIV','CI',''),
	(53,'Croatia','HRV','HR',''),
	(54,'Cuba','CUB','CU',''),
	(55,'Cyprus','CYP','CY',''),
	(56,'Czech Republic','CZE','CZ',''),
	(57,'Denmark','DNK','DK',''),
	(58,'Djibouti','DJI','DJ',''),
	(59,'Dominica','DMA','DM',''),
	(60,'Dominican Republic','DOM','DO',''),
	(62,'Ecuador','ECU','EC',''),
	(63,'Egypt','EGY','EG',''),
	(64,'El Salvador','SLV','SV',''),
	(65,'Equatorial Guinea','GNQ','GQ',''),
	(66,'Eritrea','ERI','ER',''),
	(67,'Estonia','EST','EE',''),
	(68,'Ethiopia','ETH','ET',''),
	(69,'Falkland Islands (Malvinas)','FLK','FK',''),
	(70,'Faroe Islands','FRO','FO',''),
	(71,'Fiji','FJI','FJ',''),
	(72,'Finland','FIN','FI',''),
	(73,'France','FRA','FR',''),
	(75,'French Guiana','GUF','GF',''),
	(76,'French Polynesia','PYF','PF',''),
	(77,'French Southern Territories','ATF','TF',''),
	(78,'Gabon','GAB','GA',''),
	(79,'Gambia','GMB','GM',''),
	(80,'Georgia','GEO','GE',''),
	(81,'Germany','DEU','DE',''),
	(82,'Ghana','GHA','GH',''),
	(83,'Gibraltar','GIB','GI',''),
	(84,'Greece','GRC','GR',''),
	(85,'Greenland','GRL','GL',''),
	(86,'Grenada','GRD','GD',''),
	(87,'Guadeloupe','GLP','GP',''),
	(88,'Guam','GUM','GU',''),
	(89,'Guatemala','GTM','GT',''),
	(90,'Guinea','GIN','GN',''),
	(91,'Guinea-bissau','GNB','GW',''),
	(92,'Guyana','GUY','GY',''),
	(93,'Haiti','HTI','HT',''),
	(94,'Heard and Mc Donald Islands','HMD','HM',''),
	(95,'Honduras','HND','HN',''),
	(96,'Hong Kong','HKG','HK',''),
	(97,'Hungary','HUN','HU',''),
	(98,'Iceland','ISL','IS',''),
	(99,'India','IND','IN',''),
	(100,'Indonesia','IDN','ID',''),
	(101,'Iran (Islamic Republic of)','IRN','IR',''),
	(102,'Iraq','IRQ','IQ',''),
	(103,'Ireland','IRL','IE',''),
	(104,'Israel','ISR','IL',''),
	(105,'Italy','ITA','IT',''),
	(106,'Jamaica','JAM','JM',''),
	(107,'Japan','JPN','JP',''),
	(108,'Jordan','JOR','JO',''),
	(109,'Kazakhstan','KAZ','KZ',''),
	(110,'Kenya','KEN','KE',''),
	(111,'Kiribati','KIR','KI',''),
	(112,'Korea, Democratic People\'s Republic of','PRK','KP',''),
	(113,'Korea, Republic of','KOR','KR',''),
	(114,'Kuwait','KWT','KW',''),
	(115,'Kyrgyzstan','KGZ','KG',''),
	(116,'Lao People\'s Democratic Republic','LAO','LA',''),
	(117,'Latvia','LVA','LV',''),
	(118,'Lebanon','LBN','LB',''),
	(119,'Lesotho','LSO','LS',''),
	(120,'Liberia','LBR','LR',''),
	(121,'Libyan Arab Jamahiriya','LBY','LY',''),
	(122,'Liechtenstein','LIE','LI',''),
	(123,'Lithuania','LTU','LT',''),
	(124,'Luxembourg','LUX','LU',''),
	(125,'Macau','MAC','MO',''),
	(126,'Macedonia, The Former Yugoslav Republic of','MKD','MK',''),
	(127,'Madagascar','MDG','MG',''),
	(128,'Malawi','MWI','MW',''),
	(129,'Malaysia','MYS','MY',''),
	(130,'Maldives','MDV','MV',''),
	(131,'Mali','MLI','ML',''),
	(132,'Malta','MLT','MT',''),
	(133,'Marshall Islands','MHL','MH',''),
	(134,'Martinique','MTQ','MQ',''),
	(135,'Mauritania','MRT','MR',''),
	(136,'Mauritius','MUS','MU',''),
	(137,'Mayotte','MYT','YT',''),
	(138,'Mexico','MEX','MX',''),
	(139,'Micronesia, Federated States of','FSM','FM',''),
	(140,'Moldova, Republic of','MDA','MD',''),
	(141,'Monaco','MCO','MC',''),
	(142,'Mongolia','MNG','MN',''),
	(143,'Montserrat','MSR','MS',''),
	(144,'Morocco','MAR','MA',''),
	(145,'Mozambique','MOZ','MZ',''),
	(146,'Myanmar','MMR','MM',''),
	(147,'Namibia','NAM','NA',''),
	(148,'Nauru','NRU','NR',''),
	(149,'Nepal','NPL','NP',''),
	(150,'Netherlands','NLD','NL',''),
	(151,'Netherlands Antilles','ANT','AN',''),
	(152,'New Caledonia','NCL','NC',''),
	(153,'New Zealand','NZL','NZ',''),
	(154,'Nicaragua','NIC','NI',''),
	(155,'Niger','NER','NE',''),
	(156,'Nigeria','NGA','NG',''),
	(157,'Niue','NIU','NU',''),
	(158,'Norfolk Island','NFK','NF',''),
	(159,'Northern Mariana Islands','MNP','MP',''),
	(160,'Norway','NOR','NO',''),
	(161,'Oman','OMN','OM',''),
	(162,'Pakistan','PAK','PK',''),
	(163,'Palau','PLW','PW',''),
	(164,'Panama','PAN','PA',''),
	(165,'Papua New Guinea','PNG','PG',''),
	(166,'Paraguay','PRY','PY',''),
	(167,'Peru','PER','PE',''),
	(168,'Philippines','PHL','PH',''),
	(169,'Pitcairn','PCN','PN',''),
	(170,'Poland','POL','PL',''),
	(171,'Portugal','PRT','PT',''),
	(172,'Puerto Rico','PRI','PR',''),
	(173,'Qatar','QAT','QA',''),
	(174,'Reunion','REU','RE',''),
	(175,'Romania','ROM','RO',''),
	(176,'Russian Federation','RUS','RU',''),
	(177,'Rwanda','RWA','RW',''),
	(178,'Saint Kitts and Nevis','KNA','KN',''),
	(179,'Saint Lucia','LCA','LC',''),
	(180,'Saint Vincent and the Grenadines','VCT','VC',''),
	(181,'Samoa','WSM','WS',''),
	(182,'San Marino','SMR','SM',''),
	(183,'Sao Tome and Principe','STP','ST',''),
	(184,'Saudi Arabia','SAU','SA',''),
	(185,'Senegal','SEN','SN',''),
	(186,'Seychelles','SYC','SC',''),
	(187,'Sierra Leone','SLE','SL',''),
	(188,'Singapore','SGP','SG',''),
	(189,'Slovakia (Slovak Republic)','SVK','SK',''),
	(190,'Slovenia','SVN','SI',''),
	(191,'Solomon Islands','SLB','SB',''),
	(192,'Somalia','SOM','SO',''),
	(193,'South Africa','ZAF','ZA',''),
	(194,'South Georgia and the South Sandwich Islands','SGS','GS',''),
	(195,'Spain','ESP','ES',''),
	(196,'Sri Lanka','LKA','LK',''),
	(197,'St. Helena','SHN','SH',''),
	(198,'St. Pierre and Miquelon','SPM','PM',''),
	(199,'Sudan','SDN','SD',''),
	(200,'Suriname','SUR','SR',''),
	(201,'Svalbard and Jan Mayen Islands','SJM','SJ',''),
	(202,'Swaziland','SWZ','SZ',''),
	(203,'Sweden','SWE','SE',''),
	(204,'Switzerland','CHE','CH',''),
	(205,'Syrian Arab Republic','SYR','SY',''),
	(206,'Taiwan','TWN','TW',''),
	(207,'Tajikistan','TJK','TJ',''),
	(208,'Tanzania, United Republic of','TZA','TZ',''),
	(209,'Thailand','THA','TH',''),
	(210,'Togo','TGO','TG',''),
	(211,'Tokelau','TKL','TK',''),
	(212,'Tonga','TON','TO',''),
	(213,'Trinidad and Tobago','TTO','TT',''),
	(214,'Tunisia','TUN','TN',''),
	(215,'Turkey','TUR','TR',''),
	(216,'Turkmenistan','TKM','TM',''),
	(217,'Turks and Caicos Islands','TCA','TC',''),
	(218,'Tuvalu','TUV','TV',''),
	(219,'Uganda','UGA','UG',''),
	(220,'Ukraine','UKR','UA',''),
	(221,'United Arab Emirates','ARE','AE',''),
	(222,'United Kingdom','GBR','GB',''),
	(223,'United States','USA','US',''),
	(224,'United States Minor Outlying Islands','UMI','UM',''),
	(225,'Uruguay','URY','UY',''),
	(226,'Uzbekistan','UZB','UZ',''),
	(227,'Vanuatu','VUT','VU',''),
	(228,'Vatican City State (Holy See)','VAT','VA',''),
	(229,'Venezuela','VEN','VE',''),
	(230,'Viet Nam','VNM','VN',''),
	(231,'Virgin Islands (British)','VGB','VG',''),
	(232,'Virgin Islands (U.S.)','VIR','VI',''),
	(233,'Wallis and Futuna Islands','WLF','WF',''),
	(234,'Western Sahara','ESH','EH',''),
	(235,'Yemen','YEM','YE',''),
	(237,'The Democratic Republic of Congo','DRC','DC',''),
	(238,'Zambia','ZMB','ZM',''),
	(239,'Zimbabwe','ZWE','ZW',''),
	(241,'Jersey','XJE','XJ',''),
	(242,'St. Barthelemy','XSB','XB',''),
	(245,'Aland Islands','ALA','AX',''),
	(246,'Guernsey','GGY','GG',''),
	(247,'Saint Martin (French part)','MAF','MF',''),
	(248,'Timor-Leste','TLS','TL',''),
	(249,'Serbia','SRB','RS',''),
	(250,'Isle of Man','IMN','IM',''),
	(251,'Montenegro','MNE','ME',''),
	(252,'Palestinian Territory, Occupied','PSE','PS','');

/*!40000 ALTER TABLE `#__redshop_country` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_coupons
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_coupons`;

CREATE TABLE `#__redshop_coupons` (
  `coupon_id` int(16) NOT NULL AUTO_INCREMENT,
  `coupon_code` varchar(32) NOT NULL DEFAULT '',
  `percent_or_total` tinyint(4) NOT NULL,
  `coupon_value` decimal(12,2) NOT NULL DEFAULT '0.00',
  `start_date` double NOT NULL,
  `end_date` double NOT NULL,
  `coupon_type` tinyint(4) NOT NULL COMMENT '0 - Global, 1 - User Specific',
  `userid` int(11) NOT NULL,
  `coupon_left` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `free_shipping` tinyint(4) NOT NULL,
  PRIMARY KEY (`coupon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Coupons';



# Dump of table #__redshop_coupons_transaction
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_coupons_transaction`;

CREATE TABLE `#__redshop_coupons_transaction` (
  `transaction_coupon_id` int(11) NOT NULL AUTO_INCREMENT,
  `coupon_id` int(11) NOT NULL,
  `coupon_code` varchar(255) NOT NULL,
  `coupon_value` decimal(10,3) NOT NULL,
  `userid` int(11) NOT NULL,
  `trancation_date` int(11) NOT NULL,
  `published` int(11) NOT NULL,
  PRIMARY KEY (`transaction_coupon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Coupons Transaction';



# Dump of table #__redshop_cron
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_cron`;

CREATE TABLE `#__redshop_cron` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Cron Job';

LOCK TABLES `#__redshop_cron` WRITE;
/*!40000 ALTER TABLE `#__redshop_cron` DISABLE KEYS */;

INSERT INTO `#__redshop_cron` (`id`, `date`, `published`)
VALUES
	(1,'2011-11-21',1);

/*!40000 ALTER TABLE `#__redshop_cron` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_currency
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_currency`;

CREATE TABLE `#__redshop_currency` (
  `currency_id` int(11) NOT NULL AUTO_INCREMENT,
  `currency_name` varchar(64) DEFAULT NULL,
  `currency_code` char(3) DEFAULT NULL,
  PRIMARY KEY (`currency_id`),
  KEY `idx_currency_name` (`currency_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Currency Detail';

LOCK TABLES `#__redshop_currency` WRITE;
/*!40000 ALTER TABLE `#__redshop_currency` DISABLE KEYS */;

INSERT INTO `#__redshop_currency` (`currency_id`, `currency_name`, `currency_code`)
VALUES
	(1,'Andorran Peseta','ADP'),
	(2,'United Arab Emirates Dirham','AED'),
	(3,'Afghanistan Afghani','AFA'),
	(4,'Albanian Lek','ALL'),
	(5,'Netherlands Antillian Guilder','ANG'),
	(6,'Angolan Kwanza','AOK'),
	(7,'Argentine Peso','ARS'),
	(9,'Australian Dollar','AUD'),
	(10,'Aruban Florin','AWG'),
	(11,'Barbados Dollar','BBD'),
	(12,'Bangladeshi Taka','BDT'),
	(14,'Bulgarian Lev','BGL'),
	(15,'Bahraini Dinar','BHD'),
	(16,'Burundi Franc','BIF'),
	(17,'Bermudian Dollar','BMD'),
	(18,'Brunei Dollar','BND'),
	(19,'Bolivian Boliviano','BOB'),
	(20,'Brazilian Real','BRL'),
	(21,'Bahamian Dollar','BSD'),
	(22,'Bhutan Ngultrum','BTN'),
	(23,'Burma Kyat','BUK'),
	(24,'Botswanian Pula','BWP'),
	(25,'Belize Dollar','BZD'),
	(26,'Canadian Dollar','CAD'),
	(27,'Swiss Franc','CHF'),
	(28,'Chilean Unidades de Fomento','CLF'),
	(29,'Chilean Peso','CLP'),
	(30,'Yuan (Chinese) Renminbi','CNY'),
	(31,'Colombian Peso','COP'),
	(32,'Costa Rican Colon','CRC'),
	(33,'Czech Koruna','CZK'),
	(34,'Cuban Peso','CUP'),
	(35,'Cape Verde Escudo','CVE'),
	(36,'Cyprus Pound','CYP'),
	(40,'Danish Krone','DKK'),
	(41,'Dominican Peso','DOP'),
	(42,'Algerian Dinar','DZD'),
	(43,'Ecuador Sucre','ECS'),
	(44,'Egyptian Pound','EGP'),
	(46,'Ethiopian Birr','ETB'),
	(47,'Euro','EUR'),
	(49,'Fiji Dollar','FJD'),
	(50,'Falkland Islands Pound','FKP'),
	(52,'British Pound','GBP'),
	(53,'Ghanaian Cedi','GHC'),
	(54,'Gibraltar Pound','GIP'),
	(55,'Gambian Dalasi','GMD'),
	(56,'Guinea Franc','GNF'),
	(58,'Guatemalan Quetzal','GTQ'),
	(59,'Guinea-Bissau Peso','GWP'),
	(60,'Guyanan Dollar','GYD'),
	(61,'Hong Kong Dollar','HKD'),
	(62,'Honduran Lempira','HNL'),
	(63,'Haitian Gourde','HTG'),
	(64,'Hungarian Forint','HUF'),
	(65,'Indonesian Rupiah','IDR'),
	(66,'Irish Punt','IEP'),
	(67,'Israeli Shekel','ILS'),
	(68,'Indian Rupee','INR'),
	(69,'Iraqi Dinar','IQD'),
	(70,'Iranian Rial','IRR'),
	(73,'Jamaican Dollar','JMD'),
	(74,'Jordanian Dinar','JOD'),
	(75,'Japanese Yen','JPY'),
	(76,'Kenyan Schilling','KES'),
	(77,'Kampuchean (Cambodian) Riel','KHR'),
	(78,'Comoros Franc','KMF'),
	(79,'North Korean Won','KPW'),
	(80,'(South) Korean Won','KRW'),
	(81,'Kuwaiti Dinar','KWD'),
	(82,'Cayman Islands Dollar','KYD'),
	(83,'Lao Kip','LAK'),
	(84,'Lebanese Pound','LBP'),
	(85,'Sri Lanka Rupee','LKR'),
	(86,'Liberian Dollar','LRD'),
	(87,'Lesotho Loti','LSL'),
	(89,'Libyan Dinar','LYD'),
	(90,'Moroccan Dirham','MAD'),
	(91,'Malagasy Franc','MGF'),
	(92,'Mongolian Tugrik','MNT'),
	(93,'Macau Pataca','MOP'),
	(94,'Mauritanian Ouguiya','MRO'),
	(95,'Maltese Lira','MTL'),
	(96,'Mauritius Rupee','MUR'),
	(97,'Maldive Rufiyaa','MVR'),
	(98,'Malawi Kwacha','MWK'),
	(99,'Mexican Peso','MXP'),
	(100,'Malaysian Ringgit','MYR'),
	(101,'Mozambique Metical','MZM'),
	(102,'Nigerian Naira','NGN'),
	(103,'Nicaraguan Cordoba','NIC'),
	(105,'Norwegian Kroner','NOK'),
	(106,'Nepalese Rupee','NPR'),
	(107,'New Zealand Dollar','NZD'),
	(108,'Omani Rial','OMR'),
	(109,'Panamanian Balboa','PAB'),
	(110,'Peruvian Nuevo Sol','PEN'),
	(111,'Papua New Guinea Kina','PGK'),
	(112,'Philippine Peso','PHP'),
	(113,'Pakistan Rupee','PKR'),
	(114,'Polish Złoty','PLN'),
	(116,'Paraguay Guarani','PYG'),
	(117,'Qatari Rial','QAR'),
	(118,'Romanian Leu','RON'),
	(119,'Rwanda Franc','RWF'),
	(120,'Saudi Arabian Riyal','SAR'),
	(121,'Solomon Islands Dollar','SBD'),
	(122,'Seychelles Rupee','SCR'),
	(123,'Sudanese Pound','SDP'),
	(124,'Swedish Krona','SEK'),
	(125,'Singapore Dollar','SGD'),
	(126,'St. Helena Pound','SHP'),
	(127,'Sierra Leone Leone','SLL'),
	(128,'Somali Schilling','SOS'),
	(129,'Suriname Guilder','SRG'),
	(130,'Sao Tome and Principe Dobra','STD'),
	(131,'Russian Ruble','RUB'),
	(132,'El Salvador Colon','SVC'),
	(133,'Syrian Potmd','SYP'),
	(134,'Swaziland Lilangeni','SZL'),
	(135,'Thai Bath','THB'),
	(136,'Tunisian Dinar','TND'),
	(137,'Tongan Pa\'anga','TOP'),
	(138,'East Timor Escudo','TPE'),
	(139,'Turkish Lira','TRY'),
	(140,'Trinidad and Tobago Dollar','TTD'),
	(141,'Taiwan Dollar','TWD'),
	(142,'Tanzanian Schilling','TZS'),
	(143,'Uganda Shilling','UGS'),
	(144,'US Dollar','USD'),
	(145,'Uruguayan Peso','UYP'),
	(146,'Venezualan Bolivar','VEB'),
	(147,'Vietnamese Dong','VND'),
	(148,'Vanuatu Vatu','VUV'),
	(149,'Samoan Tala','WST'),
	(150,'Democratic Yemeni Dinar','YDD'),
	(151,'Yemeni Rial','YER'),
	(152,'New Yugoslavia Dinar','YUD'),
	(153,'South African Rand','ZAR'),
	(154,'Zambian Kwacha','ZMK'),
	(155,'Zaire Zaire','ZRZ'),
	(156,'Zimbabwe Dollar','ZWD'),
	(157,'Slovak Koruna','SKK'),
	(158,'Armenian Dram','AMD');

/*!40000 ALTER TABLE `#__redshop_currency` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_customer_question
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_customer_question`;

CREATE TABLE `#__redshop_customer_question` (
  `question_id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `question` longtext NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_name` varchar(255) NOT NULL,
  `user_email` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `question_date` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`question_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Customer Question';



# Dump of table #__redshop_discount
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_discount`;

CREATE TABLE `#__redshop_discount` (
  `discount_id` int(11) NOT NULL AUTO_INCREMENT,
  `amount` int(11) NOT NULL,
  `condition` tinyint(1) NOT NULL DEFAULT '1',
  `discount_amount` decimal(10,4) NOT NULL,
  `discount_type` tinyint(4) NOT NULL,
  `start_date` double NOT NULL,
  `end_date` double NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`discount_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Discount';



# Dump of table #__redshop_discount_product
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_discount_product`;

CREATE TABLE `#__redshop_discount_product` (
  `discount_product_id` int(11) NOT NULL AUTO_INCREMENT,
  `amount` int(11) NOT NULL,
  `condition` tinyint(1) NOT NULL DEFAULT '1',
  `discount_amount` decimal(10,2) NOT NULL,
  `discount_type` tinyint(4) NOT NULL,
  `start_date` double NOT NULL,
  `end_date` double NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`discount_product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__redshop_discount_product_shoppers
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_discount_product_shoppers`;

CREATE TABLE `#__redshop_discount_product_shoppers` (
  `discount_product_id` int(11) NOT NULL,
  `shopper_group_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__redshop_discount_shoppers
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_discount_shoppers`;

CREATE TABLE `#__redshop_discount_shoppers` (
  `discount_id` int(11) NOT NULL,
  `shopper_group_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



# Dump of table #__redshop_economic_accountgroup
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_economic_accountgroup`;

CREATE TABLE `#__redshop_economic_accountgroup` (
  `accountgroup_id` int(11) NOT NULL AUTO_INCREMENT,
  `accountgroup_name` varchar(255) NOT NULL,
  `economic_vat_account` varchar(255) NOT NULL,
  `economic_nonvat_account` varchar(255) NOT NULL,
  `economic_discount_nonvat_account` varchar(255) NOT NULL,
  `economic_shipping_vat_account` varchar(255) NOT NULL,
  `economic_shipping_nonvat_account` varchar(255) NOT NULL,
  `economic_discount_product_number` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `economic_service_nonvat_account` varchar(255) NOT NULL,
  PRIMARY KEY (`accountgroup_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Economic Account Group';

LOCK TABLES `#__redshop_economic_accountgroup` WRITE;
/*!40000 ALTER TABLE `#__redshop_economic_accountgroup` DISABLE KEYS */;

INSERT INTO `#__redshop_economic_accountgroup` (`accountgroup_id`, `accountgroup_name`, `economic_vat_account`, `economic_nonvat_account`, `economic_discount_nonvat_account`, `economic_shipping_vat_account`, `economic_shipping_nonvat_account`, `economic_discount_product_number`, `published`, `economic_service_nonvat_account`)
VALUES
	(1,'default account group','4001','4000','4000','4001','4000','191919',1,'');

/*!40000 ALTER TABLE `#__redshop_economic_accountgroup` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_fields
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_fields`;

CREATE TABLE `#__redshop_fields` (
  `field_id` int(11) NOT NULL AUTO_INCREMENT,
  `field_title` varchar(250) NOT NULL,
  `field_name` varchar(20) NOT NULL,
  `field_type` varchar(20) NOT NULL,
  `field_desc` longtext NOT NULL,
  `field_class` varchar(20) NOT NULL,
  `field_section` varchar(20) NOT NULL,
  `field_maxlength` int(11) NOT NULL,
  `field_cols` int(11) NOT NULL,
  `field_rows` int(11) NOT NULL,
  `field_size` tinyint(4) NOT NULL,
  `field_show_in_front` tinyint(4) NOT NULL,
  `required` tinyint(4) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  `display_in_product` tinyint(4) NOT NULL,
  PRIMARY KEY (`field_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Fields';

LOCK TABLES `#__redshop_fields` WRITE;
/*!40000 ALTER TABLE `#__redshop_fields` DISABLE KEYS */;

INSERT INTO `#__redshop_fields` (`field_id`, `field_title`, `field_name`, `field_type`, `field_desc`, `field_class`, `field_section`, `field_maxlength`, `field_cols`, `field_rows`, `field_size`, `field_show_in_front`, `required`, `published`, `ordering`, `display_in_product`)
VALUES
	(1,'Model','rs_model','5','','','1',0,0,0,0,1,0,1,0,0);

/*!40000 ALTER TABLE `#__redshop_fields` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_fields_data
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_fields_data`;

CREATE TABLE `#__redshop_fields_data` (
  `data_id` int(11) NOT NULL AUTO_INCREMENT,
  `fieldid` int(11) DEFAULT NULL,
  `data_txt` longtext,
  `itemid` int(11) DEFAULT NULL,
  `section` varchar(20) DEFAULT NULL,
  `alt_text` varchar(255) NOT NULL,
  `image_link` varchar(255) NOT NULL,
  `user_email` varchar(255) NOT NULL,
  PRIMARY KEY (`data_id`),
  KEY `itemid` (`itemid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Fields Data';

LOCK TABLES `#__redshop_fields_data` WRITE;
/*!40000 ALTER TABLE `#__redshop_fields_data` DISABLE KEYS */;

INSERT INTO `#__redshop_fields_data` (`data_id`, `fieldid`, `data_txt`, `itemid`, `section`, `alt_text`, `image_link`, `user_email`)
VALUES
	(1,1,'model1',20,'1','','',''),
	(2,1,'model2',21,'1','','',''),
	(3,1,'model3',22,'1','','',''),
	(4,1,'model2',23,'1','','',''),
	(5,1,'model2',24,'1','','','');

/*!40000 ALTER TABLE `#__redshop_fields_data` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_fields_value
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_fields_value`;

CREATE TABLE `#__redshop_fields_value` (
  `value_id` int(11) NOT NULL AUTO_INCREMENT,
  `field_id` int(11) NOT NULL,
  `field_value` varchar(250) NOT NULL,
  `field_name` varchar(250) NOT NULL,
  `alt_text` varchar(255) NOT NULL,
  `image_link` varchar(255) NOT NULL,
  PRIMARY KEY (`value_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Fields Value';

LOCK TABLES `#__redshop_fields_value` WRITE;
/*!40000 ALTER TABLE `#__redshop_fields_value` DISABLE KEYS */;

INSERT INTO `#__redshop_fields_value` (`value_id`, `field_id`, `field_value`, `field_name`, `alt_text`, `image_link`)
VALUES
	(1,1,'model1','Model 1','',''),
	(2,1,'model2','Model 2','',''),
	(3,1,'model3','Model 1','','');

/*!40000 ALTER TABLE `#__redshop_fields_value` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_giftcard
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_giftcard`;

CREATE TABLE `#__redshop_giftcard` (
  `giftcard_id` int(11) NOT NULL AUTO_INCREMENT,
  `giftcard_name` varchar(255) NOT NULL,
  `giftcard_price` decimal(10,3) NOT NULL,
  `giftcard_value` decimal(10,3) NOT NULL,
  `giftcard_validity` int(11) NOT NULL,
  `giftcard_date` int(11) NOT NULL,
  `giftcard_bgimage` varchar(255) NOT NULL,
  `giftcard_image` varchar(255) NOT NULL,
  `published` int(11) NOT NULL,
  `giftcard_desc` longtext NOT NULL,
  `customer_amount` int(11) NOT NULL,
  PRIMARY KEY (`giftcard_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Giftcard';



# Dump of table #__redshop_mail
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_mail`;

CREATE TABLE `#__redshop_mail` (
  `mail_id` int(11) NOT NULL AUTO_INCREMENT,
  `mail_name` varchar(255) NOT NULL,
  `mail_subject` varchar(255) NOT NULL,
  `mail_section` varchar(255) NOT NULL,
  `mail_order_status` varchar(11) NOT NULL,
  `mail_body` longtext NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`mail_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Mail Center';

LOCK TABLES `#__redshop_mail` WRITE;
/*!40000 ALTER TABLE `#__redshop_mail` DISABLE KEYS */;

INSERT INTO `#__redshop_mail` (`mail_id`, `mail_name`, `mail_subject`, `mail_section`, `mail_order_status`, `mail_body`, `published`)
VALUES
	(1,'Ask Question','Ask Question About Product','ask_question_mail','0','<p>To Admin,</p>\r\n<p>Product  : {product_name}</p>\r\n<p>Please check this link : {product_link}</p>\r\n<p> </p>\r\n<p>{user_question}</p>\r\n<p>{answer}</p>\r\n<p> </p>',1),
	(10,'Reset Password Mail','Reset Password','status_of_password_reset','0','<p>Hello, request has been made to reset your {username} account password. To reset your password, you will need to submit this token in order to verify that the request was legitimate.</p>\r\n<p>The token is {reset_token}.</p>\r\n<p>Click on the URL below to enter the token and proceed with resetting your password.</p>\r\n<p><a href=\"{password_complete_url}\">Reset Password</a></p>\r\n<p> </p>\r\n<p>Thank you.</p>',1),
	(11,'Send to friend','Send to friend','product','0','<p>Hi {friend_name} ,</p>\r\n<p>New Product  : {product_name}</p>\r\n<p>{product_desc} Please check this link : {product_url}</p>\r\n<p> </p>\r\n<p> </p>',1),
	(12,'Tax exempt approval mail','Tax exempt approval mail subject','tax_exempt_approval_mail','0','<p>Hello,</p>\r\n<p>Tax exempt has been approved</p>',1),
	(13,'Tax exempt disapproval mail','Tax exempt disapproval mail subject','tax_exempt_disapproval_mail','0','<p>Hello,</p>\r\n<p>Tax exempt  has been disapproved.</p>',1),
	(14,'Tax exempt waiting approval mail','Tax exempt waiting approval mail subject','tax_exempt_waiting_approval_mail','0','<p>Tax exempt waiting approval mail contents...</p>\r\n<p>Thanks.</p>',1),
	(15,'Registration mail','Registration mail','register','0','<p>Hi,</p>\r\n<p>Thanks for your registration with our site.</p>\r\n<p>Thanks,</p>',1),
	(16,'Catlog First Reminder','Catlog First Reminder','catalog_first_reminder','0','<!-- 		@page { margin: 0.79in } 		P { margin-bottom: 0.08in } 	-->\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in; text-align: left;\"><strong><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\">Dear {name}. <br /></span></span></strong></p>\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in; text-align: left;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span> My name is xyz, in charge of customer support here at abc. We sent you our catalogue the other day, and I would just like to know if you had a chance to look at it...? In any case, I am ready by the phone / e-mail if you need any assistance whatsoever. </span></span></span></p>\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in; text-align: left;\"><strong><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Kind regards,</span></span></span></strong></p>\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in; text-align: left;\"><strong><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Name<br /></span></span></span></strong></p>\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in;\"> </p>',1),
	(17,'Catlog Second Reminder','Catlog Second Reminder','catalog_second_reminder','0','<p style=\"background: #ffffff none repeat scroll 0% 0%; margin-left: 0.5in; margin-bottom: 0in; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; text-align: left;\"><strong><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Dear {name}, </span></span></span></strong></p>\r\n<p style=\"background: #ffffff none repeat scroll 0% 0%; margin-left: 0.5in; margin-bottom: 0in; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; text-align: left;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span> I just wish to inform you that we are currently running a campaign for all the clients who received our catalogue earlier. This means that in the next 4 days, you get </span></span></span><span style=\"color: #ff0000;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>5% </span></span></span></span><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>off everything you buy, and since our products are already competitively priced, it is a really good offer. You can use the code: XXX when you order to get the discount, but remember you have 4 days from now to decide!</span></span></span></p>\r\n<p style=\"background: #ffffff none repeat scroll 0% 0%; margin-left: 0.5in; margin-bottom: 0in; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; text-align: left;\"> </p>\r\n<p style=\"background: #ffffff none repeat scroll 0% 0%; margin-left: 0.5in; margin-bottom: 0in; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; text-align: left;\"><strong>Regards,</strong></p>\r\n<p style=\"background: #ffffff none repeat scroll 0% 0%; margin-left: 0.5in; margin-bottom: 0in; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; text-align: left;\"><strong>xyz. </strong></p>',1),
	(18,'Catlog Sample First Reminder','Catlog Sample First Reminder','colour_sample_first_reminder','0','<!-- 		@page { margin: 0.79in } 		P { margin-bottom: 0.08in } 	-->\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Dear {name}. My name is xyz, in charge of customer support here at xyz. You have requested some colour samples, and I will send them to you as soon as possible. If you have any questions, please do not hesitate to contact me. </span></span></span><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\">Kind regards, xyz</span></span></p>',1),
	(19,'Catlog Sample Second Reminder','Catlog Sample Second Reminder','colour_sample_second_reminder','0','<!-- 		@page { margin: 0.79in } 		P { margin-bottom: 0.08in } 	-->\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Dear {name}. I sent you some sample colour material the other day, and I would just like to know if you had a chance to look at it...? In any case, I am ready by the phone / e-mail if you need any assistance whatsoever. Kind regards, xyz</span></span></span></p>',1),
	(20,'Catlog Sample Third Reminder','Catlog Sample Third Reminder','colour_sample_third_reminder','0','<!-- 		@page { margin: 0.79in } 		P { margin-bottom: 0.08in } 	-->\r\n<p style=\"margin-left: 0.5in; margin-bottom: 0in;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Dear {name}. I just wish to inform you that we are currently running a campaign for all the clients who received sample colour material from us earlier. This means that in the next 4 days, you get 5% off everything you buy, and since our products are already competitively priced, it is a really good offer. You can use the code: XXX when you order to get the discount, but remember you have 4 days from now to decide!</span></span></span></p>',1),
	(21,'Order Mail','Order Mail for {order_id}','order','0','<table style=\"width: 100%;\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\r\n<tbody>\r\n<tr>\r\n<td><img style=\"margin: 0px;\" alt=\"globus\" src=\"images/globus.gif\" width=\"77\" height=\"80\" /><br /></td>\r\n<td>\r\n<table style=\"width: 100%;\" align=\"right\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr>\r\n<td align=\"right\">ABC Company -- abc.com</td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">abccompany.com</td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">Street Address</td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">Address line 2</td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">County</td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">Country</td>\r\n</tr>\r\n<tr>\r\n<td></td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">Telephone Number : 11325-3251</td>\r\n</tr>\r\n<tr>\r\n<td></td>\r\n</tr>\r\n<tr>\r\n<td align=\"right\">E-mail : abccompany@abc.om</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\" style=\"font-weight: bold;\">Some Title</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">Some Intro text...Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries...</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{order_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{order_id_lbl} : {order_id}</td>\r\n</tr>\r\n<tr>\r\n<td>{order_number_lbl} : {order_number}</td>\r\n</tr>\r\n<tr>\r\n<td>{order_date_lbl} : {order_date}</td>\r\n</tr>\r\n<tr>\r\n<td>{order_status_lbl} : {order_status}</td>\r\n</tr>\r\n<tr>\r\n<td>{customer_note_lbl} :</td>\r\n</tr>\r\n<tr>\r\n<td>{customer_note}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{billing_address_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{billing_address}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{shipping_address_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{shipping_address}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{order_detail_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\">\r\n<tbody>\r\n<tr>\r\n<td>{product_name_lbl}</td>\r\n<td>{note_lbl}</td>\r\n<td>{price_lbl}</td>\r\n<td>{quantity_lbl}</td>\r\n<td align=\"right\">{total_price_lbl}</td>\r\n</tr>\r\n{product_loop_start}   \r\n<tr>\r\n<td>{product_name}<br />{product_s_desc}<br/>{product_attribute}<br />{product_accessory}{product_userfields}</td>\r\n<td>{product_wrapper}</td>\r\n<td>{product_price}</td>\r\n<td>{product_quantity}</td>\r\n<td align=\"right\">{product_total_price}</td>\r\n</tr>\r\n{product_loop_end}\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td></td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\">\r\n<tbody>\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{order_subtotal_lbl} : </strong></td>\r\n<td align=\"right\">{product_subtotal}</td>\r\n</tr>\r\n{if vat}  \r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{vat_lbl}</strong></td>\r\n<td align=\"right\">{order_tax}</td>\r\n</tr>\r\n{vat end if} {if discount}  \r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{discount_lbl}</strong></td>\r\n<td align=\"right\">{order_discount}</td>\r\n</tr>\r\n{discount end if}   \r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{shipping_lbl}</strong></td>\r\n<td align=\"right\">{shipping_excl_vat}</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td colspan=\"2\" align=\"left\">\r\n<hr />\r\n</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{total_lbl} :</strong></td>\r\n<td align=\"right\">{order_total}</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td colspan=\"2\" align=\"left\">\r\n<hr />\r\n<br /> \r\n<hr />\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{payment_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{order_payment_status}</td>\r\n</tr>\r\n<tr>\r\n<td>{payment_extrainfo}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{shipping_method_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{shipping_method}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc;\">\r\n<th align=\"left\">{order_detail_link_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{order_detail_link}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>',1),
	(22,'Order Status Change Shipped','Order Status Change Shipped','order_status','S','<p style=\"text-align: left;\">Hi {fullname},</p>\r\n<p style=\"text-align: left;\">Shipped order status mail...</p>\r\n<p style=\"text-align: left;\">Order details are as follows :</p>\r\n<p style=\"text-align: left;\">Order ID : {order_id}</p>\r\n<p style=\"text-align: left;\">Order Number : {order_number}</p>\r\n<p style=\"text-align: left;\">Order Date : {order_date}</p>\r\n<p style=\"text-align: left;\">{order_comment}</p>',1),
	(23,'Order Status Change Refunded','Order Status Change Refunded','order_status','R','<p style=\"text-align: left;\">Hi {fullname},</p>\r\n<p style=\"text-align: left;\">Refunded order status mail...</p>\r\n<p style=\"text-align: left;\">Order details are as follows :</p>\r\n<p style=\"text-align: left;\">Order ID : {order_id}</p>\r\n<p style=\"text-align: left;\">Order Number : {order_number}</p>\r\n<p style=\"text-align: left;\">Order Date : {order_date}</p>\r\n<p style=\"text-align: left;\">{order_comment}</p>',1),
	(24,'Order Status Change Pending','Order Status Change Pending','order_status','P','<p style=\"text-align: left;\">Hi {fullname},</p>\r\n<p style=\"text-align: left;\">Pending order status mail...</p>\r\n<p style=\"text-align: left;\">Order details are as follows :</p>\r\n<p style=\"text-align: left;\">Order ID : {order_id}</p>\r\n<p style=\"text-align: left;\">Order Number : {order_number}</p>\r\n<p style=\"text-align: left;\">Order Date : {order_date}</p>\r\n<p style=\"text-align: left;\">{order_comment}</p>',1),
	(25,'Order Status Change Confirmed','Order Status Change Confirmed','order_status','C','<p style=\"text-align: left;\">Hi {fullname},</p>\r\n<p style=\"text-align: left;\">Confirmed order status mail...</p>\r\n<p style=\"text-align: left;\">Order details are as follows :</p>\r\n<p style=\"text-align: left;\">Order ID : {order_id}</p>\r\n<p style=\"text-align: left;\">Order Number : {order_number}</p>\r\n<p style=\"text-align: left;\">Order Date : {order_date}</p>\r\n<p style=\"text-align: left;\">{order_comment}</p>',1),
	(26,'Order Status Change Cancelled','Order Status Change Cancelled','order_status','X','<p style=\"text-align: left;\">Hi {fullname},</p>\r\n<p style=\"text-align: left;\">Cancelled order status mail...</p>\r\n<p style=\"text-align: left;\">Order details are as follows :</p>\r\n<p style=\"text-align: left;\">Order ID : {order_id}</p>\r\n<p style=\"text-align: left;\">Order Number : {order_number}</p>\r\n<p style=\"text-align: left;\">Order Date : {order_date}</p>\r\n<p style=\"text-align: left;\">{order_comment}</p>',1),
	(27,'catalog coupon reminder','catalog coupon reminder','catalog_coupon_reminder','0','<!-- 		@page { margin: 0.79in } 		P { margin-bottom: 0.08in } 	-->\r\n<p style=\"background: #ffffff none repeat scroll 0% 0%; margin-left: 0.5in; margin-bottom: 0in; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>Dear {name}. I just wish to inform you that we are currently running a campaign for all the clients who received our catalogue earlier. This means that in the next 4 days, you get </span></span></span><span style=\"color: #ff0000;\"><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>{discount} </span></span></span></span><span style=\"font-family: Verdana,sans-serif;\"><span style=\"font-size: x-small;\"><span>off everything you buy, and since our products are already competitively priced, it is a really good offer. You can use the code: {coupon_code} when you order to get the discount, but remember you have 4 days from now to decide!</span></span></span></p>',1),
	(28,'Order mail Imglobal','Order mail Imglobal Subject','order_imglobal','0','<p>Hi,</p>\r\n<p>Your order will be confirmed after payment received.</p>\r\n<p style=\"text-align: left;\">Order Payment Status : {order_payment_status}</p>\r\n<p style=\"text-align: left;\"> </p>\r\n<p style=\"text-align: left;\">Thanks You.</p>\r\n<p style=\"text-align: left;\"> </p>\r\n<p style=\"text-align: left;\">Order Payment Status : {order_payment_status}</p>',1),
	(29,'Order mail Bank transfer','Order mail Bank transfer subject','order_bank','0','<p>Thanks for choosing bank transfer. your order will be confirmed after payment received.</p>\r\n<p style=\"text-align: left;\">Order Payment Status : {order_payment_status}</p>\r\n<p style=\"text-align: left;\"> </p>\r\n<p style=\"text-align: left;\">Thanks You.</p>',1),
	(30,'First Mail After Order Purchased','Mail After Order Purchased','first_mail_after_order_purchased','0','<p>Hi {name}, <br />You made an order with us 7 days ago and to show our appreciation of you as a customer we send you discount code to use the next time you visit our store</p>\r\n<p>{url}</p>\r\n<p>discount amount : {coupon_amount}</p>\r\n<p>discount coupon code : {coupon_code}</p>\r\n<p>valid upto : {coupon_duration}</p>\r\n<p>Thank you.</p>',1),
	(32,'Second Mail After Order Purchased','Second Mail After Order Purchased','second_mail_after_order_purchased','0','<p>Hi {name}, <br />You made an order with us 10 days ago and to show our appreciation of you as a customer we send you discount code to use the next time you visit our store</p>\r\n<p>{url}</p>\r\n<p>discount amount : {coupon_amount}</p>\r\n<p>discount coupon code : {coupon_code}</p>\r\n<p>valid upto : {coupon_duration}</p>\r\n<p>Thank you.</p>',1),
	(33,'Third Mail After Order Purchased','Third Mail After Order Purchased','third_mail_after_order_purchased','0','<p>Hi {name}, <br />You made an order with us 21 days ago and to show our appreciation of you as a customer we send you discount code to use the next time you visit our store</p>\r\n<p>{url}</p>\r\n<p>discount amount : {coupon_amount}</p>\r\n<p>discount coupon code : {coupon_code}</p>\r\n<p>valid upto : {coupon_duration}</p>\r\n<p>Thank you.</p>',1),
	(34,'Catalog Send Mail','Catalog Request','catalog','0','<p>Dear, <strong>{name}</strong></p>\r\n<p>We get your request for catalog. Here, you can found attached catalogs.</p>\r\n<p> </p>\r\n<p>Thank you.</p>',1),
	(50,'Economic Invoice','Invoice','economic_inoice','0','Hi {name},<br><br>Attached is your invoice.<br><br>Thanks<br>',1),
	(54,'My wishlist mail','My wishlist','mywishlist_mail','0','hi,{name}{product_loop_start}<table style=\"width: 100%;\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"><tbody><tr valign=\"top\"><td width=\"40%\"><div style=\"float: left; width: 195px; height: 230px; text-align: center;\">{product_thumb_image}<div>{product_name}</div><div>{product_price}</div></div></td></tr></tbody></table>{product_loop_end}Regards,{from_name}',1),
	(64,'Order Special Discount Mail','Admin applied discount (special offer)','order_special_discount','0','You got {special_discount} that is {special_discount_amount}.<table style=\"width: 100%;\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"><tbody><tr><td><br /></td><td><table style=\"width: 100%;\" align=\"right\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr><td align=\"right\">ABC Company -- abc.com</td></tr><tr><td align=\"right\">abccompany.com</td></tr><tr><td align=\"right\">Street Address</td></tr><tr><td align=\"right\">Address line 2</td></tr><tr><td align=\"right\">County</td></tr><tr><td align=\"right\">Country</td></tr><tr><td></td></tr><tr><td align=\"right\">Telephone Number : 11325-3251</td></tr><tr><td></td></tr><tr><td align=\"right\">E-mail : abccompany@abc.om</td></tr></tbody></table></td></tr><tr><td style=\"font-weight: bold\" colspan=\"2\">Some Title</td></tr><tr><td colspan=\"2\">Some Intro text...Lorem Ipsum is simply dummy 			text of the printing and typesetting industry. Lorem Ipsum has been 			the industrys standard dummy text ever since the 1500s, when an 			unknown printer took a galley of type and scrambled it to make a type 			specimen book. It has survived not only five centuries...</td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">Order Information</th></tr><tr></tr><tr><td>Order id : {order_id}</td></tr><tr><td>Order Number : {order_number}</td></tr><tr><td>Order Date : {order_date}</td></tr><tr><td>Order Status : {order_status}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">Billing Address Information</th></tr><tr></tr><tr><td>{billing_address}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">Shipping Address Information</th></tr><tr></tr><tr><td>{shipping_address}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">Order Details</th></tr><tr></tr><tr><td><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\"><tbody><tr><td>Product Name</td><td>Note</td><td>Price</td><td>Quantity</td><td align=\"right\">Total Price</td></tr>{product_loop_start}<tr><td>{product_name}        {product_sku}</td><td>{product_wrapper}</td><td>{product_price}</td><td>{product_quantity}</td><td align=\"right\">{product_total_price}</td></tr>{product_loop_end}</tbody></table></td></tr><tr><td></td></tr><tr><td><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\"><tbody><tr align=\"left\"><td align=\"left\"><strong>Order Subtotal : </strong></td><td align=\"right\">{product_subtotal}</td></tr><tr align=\"left\"><td align=\"left\"><strong>TAX : </strong></td><td align=\"right\">{order_tax}</td></tr><tr align=\"left\"><td align=\"left\"><strong>Discount : </strong></td><td align=\"right\">{order_discount}</td></tr><tr align=\"left\"><td align=\"left\"><strong>{special_discount_lbl} </strong></td><td align=\"right\">{special_discount_amount}</td></tr><tr align=\"left\"><td align=\"left\"><strong>Shipping : </strong></td><td align=\"right\">{order_shipping}</td></tr><tr align=\"left\"><td colspan=\"2\" align=\"left\"><hr /></td></tr><tr align=\"left\"><td align=\"left\"><strong>Total :</strong></td><td align=\"right\">{order_total}</td></tr><tr align=\"left\"><td colspan=\"2\" align=\"left\"><hr /></td></tr></tbody></table></td></tr></tbody></table></td></tr></tbody></table>',1),
	(74,'News letter ','News Letter confirmation','newsletter_confirmation','0','<p>hi {name},</p>\r\n<p>Confirm your News letter {link}.</p>',1),
	(84,'NewsLetter cancellation ','NewsLetter cancellation ','newsletter_cancellation','0','NewsLetter cancellationNewsLetter cancellation NewsLetter cancellation NewsLetter cancellationNewsLetter cancellation NewsLetter cancellation',1),
	(85,'Invoice Mail','Invoice Mail','invoice_mail','0','<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{order_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{order_id_lbl} : {order_id}</td>\r\n</tr>\r\n<tr>\r\n<td>{order_number_lbl} : {order_number}</td>\r\n</tr>\r\n<tr>\r\n<td>{order_date_lbl} : {order_date}</td>\r\n</tr>\r\n<tr>\r\n<td>{order_status_lbl} : {order_status}</td>\r\n</tr>\r\n<tr>\r\n<td>{customer_note_lbl} : {customer_note}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{billing_address_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{billing_address}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{shipping_address_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{shipping_address}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{order_detail_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>{product_name_lbl}</td>\r\n<td>{note_lbl}</td>\r\n<td>{price_lbl}</td>\r\n<td>{quantity_lbl}</td>\r\n<td align=\"right\">{total_price_lbl}</td>\r\n</tr>\r\n{product_loop_start}\r\n<tr>\r\n<td>{product_name}({product_number})<br />{product_userfields}<br />{product_attribute}<br />{product_accessory}</td>\r\n<td>{product_wrapper}</td>\r\n<td>{product_price}</td>\r\n<td>{product_quantity}</td>\r\n<td align=\"right\">{product_total_price}</td>\r\n</tr>\r\n{product_loop_end}\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td></td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{order_subtotal_lbl} : </strong></td>\r\n<td align=\"right\">{product_subtotal}</td>\r\n</tr>\r\n{if vat}\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{vat_lbl} : </strong></td>\r\n<td align=\"right\">{order_tax}</td>\r\n</tr>\r\n{vat end if} {if discount}\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{discount_lbl} : </strong></td>\r\n<td align=\"right\">{order_discount}</td>\r\n</tr>\r\n{discount end if}\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{shipping_lbl} : </strong></td>\r\n<td align=\"right\">{shipping_excl_vat}</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td colspan=\"2\" align=\"left\">\r\n<hr />\r\n</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{total_lbl} :</strong></td>\r\n<td align=\"right\">{order_total}</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td colspan=\"2\" align=\"left\">\r\n<hr />\r\n<br /> \r\n<hr />\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">Payment Status</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{order_payment_status}<br />{shipping_method_lbl}: {shipping_method}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td colspan=\"2\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{order_detail_link_lbl}</th>\r\n</tr>\r\n<tr>\r\n</tr>\r\n<tr>\r\n<td>{order_detail_link}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>',1),
	(86,'Product Subscription Mail','Mail for product Subscription ','subscription_renewal_mail','0','<h1>Product Subscription Renew</h1>\r\n<h3>Dear,</h3>\r\n<p><span>{firstname} {lastname}</span></p>\r\n<p>Your Subscription for <strong>{product_name}</strong> is going to expired on <span>{subsciption_enddate}</span></p>\r\n<h2>Your Subscription Detail is as below</h2>\r\n<table border=\"0\">\r\n<tbody>\r\n<tr>\r\n<td>Subscribe Product :</td>\r\n<td>{product_name}</td>\r\n</tr>\r\n<tr>\r\n<td>Subscription Period :</td>\r\n<td>{subscription_period}</td>\r\n</tr>\r\n<tr>\r\n<td>Subscription Price : </td>\r\n<td>{subscription_price}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<p>Click here <em>{product_link}</em> and renew it</p>',1),
	(94,'Giftcard Mail','Giftcard Mail','giftcard_mail','0','<table><tr><td ><span>{giftcard_price_lbl}</span></td><td>{giftcard_price}</td></tr><tr><td ><span>{giftcard_reciver_name_lbl}</span></td><td>{giftcard_reciver_name}</td></tr><tr><td>{giftcard_reciver_email_lbl}</td><td>{giftcard_reciver_email}</td></tr><tr><td></td><td>{giftcard_desc}</td></tr><tr><td></td><td>{giftcard_price}</td></tr><tr><td>{giftcard_validity_from}{giftcard_validity_to}</td></tr><tr><td>{giftcard_image}</td></tr><tr><td>{giftcard_validity}</td></tr></table>',1),
	(105,'Quotation Mail','Quotation Mail for {quotation_id} - {quotation_status} - {quotation_total}','quotation_mail','0','<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{quotation_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n<td>{quotation_id_lbl} : {quotation_id}</td>\r\n</tr>\r\n<tr>\r\n<td>{quotation_number_lbl} : {quotation_number}</td>\r\n</tr>\r\n<tr>\r\n<td>{quotation_date_lbl} : {quotation_date}</td>\r\n</tr>\r\n<tr>\r\n<td>{quotation_status_lbl} : {quotation_status}</td>\r\n</tr>\r\n<tr>\r\n<td>{quotation_note_lbl} : {quotation_note}</td>\r\n</tr>\r\n<tr>\r\n<td>{quotation_detail_link}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{billing_address_information_lbl}</th>\r\n</tr>\r\n<tr>\r\n<td>{billing_address}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr style=\"background-color: #cccccc\">\r\n<th align=\"left\">{quotation_detail_lbl}</th>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr>\r\n<td>{product_name_lbl}</td>\r\n<td>{note_lbl}</td>\r\n<td>{price_lbl}</td>\r\n<td>{quantity_lbl}</td>\r\n<td align=\"right\">{total_price_lbl}</td>\r\n</tr>\r\n{product_loop_start}\r\n<tr>\r\n<td>{product_name}{product_s_desc}({product_number})<br />{product_userfields}<br />{product_attribute}<br />{product_accessory}</td>\r\n<td>{product_wrapper}<br />{product_thumb_image}</td>\r\n<td>{product_price}</td>\r\n<td>{product_quantity}</td>\r\n<td align=\"right\">{product_total_price}</td>\r\n</tr>\r\n{product_loop_end}\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n<tr>\r\n<td></td>\r\n</tr>\r\n<tr>\r\n<td>\r\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\r\n<tbody>\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{quotation_subtotal_lbl} : </strong></td>\r\n<td align=\"right\">{quotation_subtotal}</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td colspan=\"2\" align=\"left\">\r\n<hr />\r\n</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td align=\"left\"><strong>{total_lbl} :</strong></td>\r\n<td align=\"right\">{quotation_total}</td>\r\n</tr>\r\n<tr align=\"left\">\r\n<td colspan=\"2\" align=\"left\">\r\n<hr />\r\n<br /> \r\n<hr />\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</td>\r\n</tr>\r\n</tbody>\r\n</table>',1),
	(150,'Catalogue Order Mail','Catalogue Order Mail:','catalogue_order','0','<table style=\"width: 100%;\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"><tbody><tr><td><br /></td><td><table style=\"width: 100%;\" align=\"right\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr><td align=\"right\">ABC Company -- abc.com</td></tr><tr><td align=\"right\">abccompany.com</td></tr><tr><td align=\"right\">Street Address</td></tr><tr><td align=\"right\">Address line 2</td></tr><tr><td align=\"right\">County</td></tr><tr><td align=\"right\">Country</td></tr><tr><td></td></tr><tr><td align=\"right\">Telephone Number : 11325-3251</td></tr><tr><td></td></tr><tr><td align=\"right\">E-mail : abccompany@abc.om</td></tr></tbody></table></td></tr><tr><td style=\"font-weight: bold\" colspan=\"2\">Some Title</td></tr><tr><td colspan=\"2\">Some Intro text...Lorem Ipsum is simply dummy    text of the printing and typesetting industry. Lorem Ipsum has been    the industry\'s standard dummy text ever since the 1500s, when an    unknown printer took a galley of type and scrambled it to make a type    specimen book. It has survived not only five centuries...</td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">{order_information_lbl}</th></tr><tr></tr><tr><td>{order_id_lbl} : {order_id}</td></tr><tr><td>{order_number_lbl} : {order_number}</td></tr><tr><td>{order_date_lbl} : {order_date}</td></tr><tr><td>{order_status_lbl} : {order_status}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">{billing_address_information_lbl}</th></tr><tr></tr><tr><td>{billing_address}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">{shipping_address_information_lbl}</th></tr><tr></tr><tr><td>{shipping_address}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">{order_detail_lbl}</th></tr><tr></tr><tr><td><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\"><tbody><tr><td>{product_name_lbl}</td><td>{note_lbl}</td><td>{quantity_lbl}</td></tr>{product_loop_start}<tr><td>{pro_name}<br /> {product_userfields}</td><td>{pro_note}</td><td>{pro_quantity}</td></tr>{product_loop_end}</tbody></table></td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">Payment Status</th></tr><tr></tr><tr><td>{order_payment_status}{shipping_method_lbl}{shipping_method}</td></tr></tbody></table></td></tr><tr><td colspan=\"2\"><table style=\"width: 100%;\" border=\"0\" cellpadding=\"2\" cellspacing=\"0\"><tbody><tr style=\"background-color: #cccccc\"><th align=\"left\">Order url</th></tr><tr></tr><tr><td>{order_detail_link}</td></tr></tbody></table></td></tr></tbody></table>',1),
	(160,'Quotation User Register Mail','Quotation User Register Mail:','quotation_user_register','0','<table><tr><td>Username</td><td> : </td><td>{username}</td></tr><tr><td>Password</td><td> : </td><td>{password}</td></tr><tr><td>Click here</td><td> : </td><td>{link}</td></tr></table>',1),
	(175,'RequestTaxExemptMail','RequestTaxExemptMail:','request_tax_exempt_mail','0','<table style=\"width: 100%;\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"><tbody><tr><td>Vat Number</td><td>{vat_number}</td></tr><tr><td>User Name</td><td>{username}</td></tr><tr><td>Company Name</td><td>{company_name}</td></tr><tr><td>Country</td><td>{country}</td></tr><tr><td>State</td><td>{state}</td></tr><tr><td>Phone</td><td>{phone}</td></tr><tr><td>Zipcode</td><td>{zipcode}</td></tr><tr><td>Address</td><td>{address}</td></tr><tr><td>City</td><td>{city}</td></tr></tbody></table>',1);

/*!40000 ALTER TABLE `#__redshop_mail` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_manufacturer
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_manufacturer`;

CREATE TABLE `#__redshop_manufacturer` (
  `manufacturer_id` int(11) NOT NULL AUTO_INCREMENT,
  `manufacturer_name` varchar(250) NOT NULL,
  `manufacturer_desc` longtext NOT NULL,
  `manufacturer_email` varchar(250) NOT NULL,
  `product_per_page` int(11) NOT NULL,
  `template_id` int(11) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metalanguage_setting` text NOT NULL,
  `metarobot_info` text NOT NULL,
  `pagetitle` text NOT NULL,
  `pageheading` text NOT NULL,
  `sef_url` text NOT NULL,
  `published` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `manufacturer_url` varchar(255) NOT NULL,
  PRIMARY KEY (`manufacturer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Manufacturer';

LOCK TABLES `#__redshop_manufacturer` WRITE;
/*!40000 ALTER TABLE `#__redshop_manufacturer` DISABLE KEYS */;

INSERT INTO `#__redshop_manufacturer` (`manufacturer_id`, `manufacturer_name`, `manufacturer_desc`, `manufacturer_email`, `product_per_page`, `template_id`, `metakey`, `metadesc`, `metalanguage_setting`, `metarobot_info`, `pagetitle`, `pageheading`, `sef_url`, `published`, `ordering`, `manufacturer_url`)
VALUES
	(1,'redweb.dk','<p>http://redweb.dk</p>','',0,14,'','','','','','','',1,1,''),
	(2,'redhost.dk','<p>http://redhost.dk</p>','',0,14,'','','','','','','',1,2,''),
	(3,'redcomponent.com','<p>http://redcomponent.com</p>','',0,14,'','','','','','','',1,3,'');

/*!40000 ALTER TABLE `#__redshop_manufacturer` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_mass_discount
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_mass_discount`;

CREATE TABLE `#__redshop_mass_discount` (
  `mass_discount_id` int(11) NOT NULL AUTO_INCREMENT,
  `discount_product` longtext NOT NULL,
  `category_id` longtext NOT NULL,
  `manufacturer_id` longtext NOT NULL,
  `discount_type` tinyint(4) NOT NULL,
  `discount_amount` double(10,2) NOT NULL,
  `discount_startdate` int(11) NOT NULL,
  `discount_enddate` int(11) NOT NULL,
  `discount_name` longtext NOT NULL,
  PRIMARY KEY (`mass_discount_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Page Viewer';



# Dump of table #__redshop_media
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_media`;

CREATE TABLE `#__redshop_media` (
  `media_id` int(11) NOT NULL AUTO_INCREMENT,
  `media_name` varchar(250) NOT NULL,
  `media_alternate_text` varchar(255) NOT NULL,
  `media_section` varchar(20) NOT NULL,
  `section_id` int(11) NOT NULL,
  `media_type` varchar(250) NOT NULL,
  `media_mimetype` varchar(20) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`media_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Media';

LOCK TABLES `#__redshop_media` WRITE;
/*!40000 ALTER TABLE `#__redshop_media` DISABLE KEYS */;

INSERT INTO `#__redshop_media` (`media_id`, `media_name`, `media_alternate_text`, `media_section`, `section_id`, `media_type`, `media_mimetype`, `published`, `ordering`)
VALUES
	(5,'1262693813_11872.jpg','','product',0,'images','jpg',1,0),
	(6,'1262693813_11873.jpg','','product',0,'images','jpg',1,0),
	(7,'1262693813_11879.jpg','','product',0,'images','jpg',1,0),
	(8,'1262693813_11887.jpg','','product',0,'images','jpg',1,0),
	(9,'1262693813_11920.jpg','','product',0,'images','jpg',1,0),
	(10,'1262693813_11928.jpg','','product',0,'images','jpg',1,0),
	(11,'1262693813_11935.jpg','','product',0,'images','jpg',1,0),
	(12,'1262693813_11936.jpg','','product',0,'images','jpg',1,0),
	(33,'1274444752_redweb-logo.jpg','redweb.dk','manufacturer',1,'images','',1,0),
	(34,'1274444735_redhost-logo.jpg','redhost.dk','manufacturer',2,'images','',1,0),
	(35,'1274444723_redcomponent-logo.jpg','redcomponent.com','manufacturer',3,'images','',1,0),
	(46,'0','','product',20,'images','',1,0),
	(48,'0','','product',21,'images','',1,0),
	(49,'1301366289_twittershoe1.jpg','','product',22,'images','',1,0),
	(50,'1301366393_brownwhitesneakers.jpg','','product',23,'images','',1,0),
	(51,'0','','product',23,'images','',1,0),
	(52,'rename_rename_1300544368_greenshirt.jpg','','product',24,'images','',1,0),
	(53,'0','','product',24,'images','',1,0),
	(54,'1321433334_1321433334and1300538410and1300536311andoliveshirt.jpg','','product',20,'images','image/jpeg',1,0),
	(55,'1321433426_1321433425and1301367062anddarkgrey.jpg','','product',20,'images','image/jpeg',1,0),
	(56,'1321433494_1321433493and1300538410and1300536311andoliveshirt.jpg','','product',21,'images','image/jpeg',1,0);

/*!40000 ALTER TABLE `#__redshop_media` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_media_download
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_media_download`;

CREATE TABLE `#__redshop_media_download` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `media_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Media Additional Downloadable Files';



# Dump of table #__redshop_newsletter
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_newsletter`;

CREATE TABLE `#__redshop_newsletter` (
  `newsletter_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `body` longtext NOT NULL,
  `template_id` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`newsletter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Newsletter';

LOCK TABLES `#__redshop_newsletter` WRITE;
/*!40000 ALTER TABLE `#__redshop_newsletter` DISABLE KEYS */;

INSERT INTO `#__redshop_newsletter` (`newsletter_id`, `name`, `subject`, `body`, `template_id`, `published`)
VALUES
	(1,'News Letter Demo','News Letter Demo','User Name : {username} Email : {email}',29,1);

/*!40000 ALTER TABLE `#__redshop_newsletter` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_newsletter_subscription
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_newsletter_subscription`;

CREATE TABLE `#__redshop_newsletter_subscription` (
  `subscription_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `date` int(11) NOT NULL,
  `newsletter_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `checkout` tinyint(4) NOT NULL,
  `published` int(11) NOT NULL,
  PRIMARY KEY (`subscription_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Newsletter subscribers';



# Dump of table #__redshop_newsletter_tracker
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_newsletter_tracker`;

CREATE TABLE `#__redshop_newsletter_tracker` (
  `tracker_id` int(11) NOT NULL AUTO_INCREMENT,
  `newsletter_id` int(11) NOT NULL,
  `subscription_id` int(11) NOT NULL,
  `subscriber_name` varchar(255) NOT NULL,
  `user_id` int(11) NOT NULL,
  `read` tinyint(4) NOT NULL,
  `date` double NOT NULL,
  PRIMARY KEY (`tracker_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Newsletter Tracker';



# Dump of table #__redshop_order_acc_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_acc_item`;

CREATE TABLE `#__redshop_order_acc_item` (
  `order_item_acc_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_item_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `order_acc_item_sku` varchar(255) NOT NULL,
  `order_acc_item_name` varchar(255) NOT NULL,
  `order_acc_price` decimal(15,4) NOT NULL,
  `order_acc_vat` decimal(15,4) NOT NULL,
  `product_quantity` int(11) NOT NULL,
  `product_acc_item_price` decimal(15,2) NOT NULL,
  `product_acc_final_price` decimal(15,2) NOT NULL,
  `product_attribute` text NOT NULL,
  PRIMARY KEY (`order_item_acc_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Order Accessory Item Detail';



# Dump of table #__redshop_order_attribute_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_attribute_item`;

CREATE TABLE `#__redshop_order_attribute_item` (
  `order_att_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_item_id` int(11) NOT NULL,
  `section_id` int(11) NOT NULL,
  `section` varchar(250) NOT NULL,
  `parent_section_id` int(11) NOT NULL,
  `section_name` varchar(250) NOT NULL,
  `section_price` decimal(15,4) NOT NULL,
  `section_vat` decimal(15,4) NOT NULL,
  `section_oprand` char(1) NOT NULL,
  `is_accessory_att` tinyint(4) NOT NULL,
  PRIMARY KEY (`order_att_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP order Attribute item';



# Dump of table #__redshop_order_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_item`;

CREATE TABLE `#__redshop_order_item` (
  `order_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) DEFAULT NULL,
  `user_info_id` varchar(32) DEFAULT NULL,
  `supplier_id` int(11) DEFAULT NULL,
  `product_id` int(11) DEFAULT NULL,
  `order_item_sku` varchar(64) NOT NULL DEFAULT '',
  `order_item_name` varchar(255) NOT NULL,
  `product_quantity` int(11) DEFAULT NULL,
  `product_item_price` decimal(15,2) DEFAULT NULL,
  `product_item_price_excl_vat` decimal(15,2) DEFAULT NULL,
  `product_final_price` decimal(12,2) NOT NULL DEFAULT '0.00',
  `order_item_currency` varchar(16) DEFAULT NULL,
  `order_status` varchar(250) DEFAULT NULL,
  `customer_note` text NOT NULL,
  `cdate` int(11) DEFAULT NULL,
  `mdate` int(11) DEFAULT NULL,
  `product_attribute` text,
  `product_accessory` text NOT NULL,
  `delivery_time` int(11) NOT NULL,
  `container_id` int(11) NOT NULL,
  `stockroom_id` varchar(255) NOT NULL,
  `is_split` tinyint(1) NOT NULL,
  `attribute_image` text NOT NULL,
  `wrapper_id` int(11) NOT NULL,
  `wrapper_price` decimal(10,2) NOT NULL,
  `is_giftcard` tinyint(4) NOT NULL,
  `product_item_old_price` decimal(10,4) NOT NULL,
  `product_purchase_price` decimal(10,2) NOT NULL,
  `discount_calc_data` text NOT NULL,
  PRIMARY KEY (`order_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Order Item Detail';



# Dump of table #__redshop_order_payment
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_payment`;

CREATE TABLE `#__redshop_order_payment` (
  `payment_order_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL DEFAULT '0',
  `payment_method_id` int(11) DEFAULT NULL,
  `order_payment_code` varchar(30) NOT NULL DEFAULT '',
  `order_payment_cardname` blob NOT NULL,
  `order_payment_number` blob,
  `order_payment_ccv` blob NOT NULL,
  `order_payment_amount` double(10,2) NOT NULL,
  `order_payment_expire` int(11) DEFAULT NULL,
  `order_payment_name` varchar(255) DEFAULT NULL,
  `payment_method_class` varchar(256) DEFAULT NULL,
  `order_payment_trans_id` text NOT NULL,
  `authorize_status` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`payment_order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Order Payment Detail';



# Dump of table #__redshop_order_status
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_status`;

CREATE TABLE `#__redshop_order_status` (
  `order_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_status_code` varchar(64) NOT NULL,
  `order_status_name` varchar(64) DEFAULT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`order_status_id`),
  UNIQUE KEY `order_status_code` (`order_status_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Orders Status';

LOCK TABLES `#__redshop_order_status` WRITE;
/*!40000 ALTER TABLE `#__redshop_order_status` DISABLE KEYS */;

INSERT INTO `#__redshop_order_status` (`order_status_id`, `order_status_code`, `order_status_name`, `published`)
VALUES
	(1,'P','Pending',1),
	(2,'C','Confirmed',1),
	(3,'X','Cancelled',1),
	(4,'R','Refunded',1),
	(5,'S','Shipped',1),
	(6,'RD','Ready for delivery',1),
	(7,'RD1','Ready for 1st delivery',1),
	(8,'RD2','Ready for 2nd delivery',1),
	(9,'ACCP','Awaiting credit card payment',1),
	(10,'APP','Awaiting paypal payment',1),
	(11,'ABT','Awaiting bank transfer',1),
	(12,'PR','Payment received',1),
	(13,'RC','Reclamation',1),
	(14,'PS','Partially shipped',1),
	(15,'RT','Returned',1),
	(16,'PRT','Partially Returned',1),
	(17,'PRC','Partially Reclamation',1);

/*!40000 ALTER TABLE `#__redshop_order_status` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_order_status_log
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_status_log`;

CREATE TABLE `#__redshop_order_status_log` (
  `order_status_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `order_status` varchar(5) NOT NULL,
  `order_payment_status` varchar(25) NOT NULL,
  `date_changed` int(11) NOT NULL,
  `customer_note` text NOT NULL,
  PRIMARY KEY (`order_status_log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Orders Status history';



# Dump of table #__redshop_order_users_info
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_order_users_info`;

CREATE TABLE `#__redshop_order_users_info` (
  `order_info_id` int(11) NOT NULL AUTO_INCREMENT,
  `users_info_id` int(11) NOT NULL,
  `order_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `firstname` varchar(250) NOT NULL,
  `lastname` varchar(250) NOT NULL,
  `address_type` varchar(255) NOT NULL,
  `vat_number` varchar(250) NOT NULL,
  `tax_exempt` tinyint(4) NOT NULL,
  `shopper_group_id` int(11) NOT NULL,
  `address` varchar(255) NOT NULL,
  `city` varchar(255) NOT NULL,
  `country_code` varchar(11) NOT NULL,
  `state_code` varchar(11) NOT NULL,
  `zipcode` varchar(255) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `tax_exempt_approved` tinyint(1) NOT NULL,
  `approved` tinyint(1) NOT NULL,
  `is_company` tinyint(4) NOT NULL,
  `user_email` varchar(255) NOT NULL,
  `company_name` varchar(255) NOT NULL,
  `ean_number` varchar(250) NOT NULL,
  `requesting_tax_exempt` tinyint(4) NOT NULL,
  `thirdparty_email` varchar(255) NOT NULL,
  PRIMARY KEY (`order_info_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Order User Information';



# Dump of table #__redshop_orderbarcode_log
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_orderbarcode_log`;

CREATE TABLE `#__redshop_orderbarcode_log` (
  `log_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `barcode` varchar(255) NOT NULL,
  `user_id` int(11) NOT NULL,
  `search_date` datetime NOT NULL,
  PRIMARY KEY (`log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__redshop_ordernumber_track
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_ordernumber_track`;

CREATE TABLE `#__redshop_ordernumber_track` (
  `trackdatetime` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='redSHOP Order number track';



# Dump of table #__redshop_orders
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_orders`;

CREATE TABLE `#__redshop_orders` (
  `order_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `order_number` varchar(32) DEFAULT NULL,
  `barcode` varchar(13) NOT NULL,
  `user_info_id` varchar(32) DEFAULT NULL,
  `order_total` decimal(15,2) NOT NULL DEFAULT '0.00',
  `order_subtotal` decimal(15,5) DEFAULT NULL,
  `order_tax` decimal(10,2) DEFAULT NULL,
  `order_tax_details` text NOT NULL,
  `order_shipping` decimal(10,2) DEFAULT NULL,
  `order_shipping_tax` decimal(10,2) DEFAULT NULL,
  `coupon_discount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `order_discount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `special_discount_amount` decimal(12,2) NOT NULL,
  `payment_dicount` decimal(12,2) NOT NULL,
  `order_status` varchar(5) DEFAULT NULL,
  `order_payment_status` varchar(25) NOT NULL,
  `cdate` int(11) DEFAULT NULL,
  `mdate` int(11) DEFAULT NULL,
  `ship_method_id` varchar(255) DEFAULT NULL,
  `customer_note` text NOT NULL,
  `ip_address` varchar(15) NOT NULL DEFAULT '',
  `encr_key` varchar(255) NOT NULL,
  `split_payment` int(11) NOT NULL,
  `invoice_no` varchar(255) NOT NULL,
  `mail1_status` tinyint(1) NOT NULL,
  `mail2_status` tinyint(1) NOT NULL,
  `mail3_status` tinyint(1) NOT NULL,
  `special_discount` decimal(10,2) NOT NULL,
  `payment_discount` decimal(10,2) NOT NULL,
  `is_booked` tinyint(1) NOT NULL,
  `order_label_create` tinyint(1) NOT NULL,
  `vm_order_number` varchar(32) NOT NULL,
  `requisition_number` varchar(255) NOT NULL,
  `bookinvoice_number` int(11) NOT NULL,
  `order_discount_vat` decimal(10,3) NOT NULL,
  `payment_oprand` varchar(50) NOT NULL,
  `discount_type` varchar(255) NOT NULL,
  `analytics_status` int(1) NOT NULL,
  `tax_after_discount` decimal(10,3) NOT NULL,
  PRIMARY KEY (`order_id`),
  KEY `idx_orders_user_id` (`user_id`),
  KEY `idx_orders_order_number` (`order_number`),
  KEY `idx_orders_user_info_id` (`user_info_id`),
  KEY `idx_orders_ship_method_id` (`ship_method_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Order Detail';



# Dump of table #__redshop_pageviewer
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_pageviewer`;

CREATE TABLE `#__redshop_pageviewer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `session_id` varchar(250) NOT NULL,
  `section` varchar(250) NOT NULL,
  `section_id` int(11) NOT NULL,
  `hit` int(11) NOT NULL,
  `created_date` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Page Viewer';

LOCK TABLES `#__redshop_pageviewer` WRITE;
/*!40000 ALTER TABLE `#__redshop_pageviewer` DISABLE KEYS */;

INSERT INTO `#__redshop_pageviewer` (`id`, `user_id`, `session_id`, `section`, `section_id`, `hit`, `created_date`)
VALUES
	(1,0,'197775d65f13464abebca56ba77e47ba','category',0,0,1321246509),
	(2,0,'197775d65f13464abebca56ba77e47ba','category',1,0,1321246512),
	(3,0,'uk1ocah7rb4n5pt8b03jm9kvs2','category',0,0,1321337440),
	(4,0,'uk1ocah7rb4n5pt8b03jm9kvs2','category',1,0,1321358938),
	(5,0,'uk1ocah7rb4n5pt8b03jm9kvs2','category',2,0,1321360152),
	(6,0,'uk1ocah7rb4n5pt8b03jm9kvs2','category',4,0,1321361586),
	(7,0,'uk1ocah7rb4n5pt8b03jm9kvs2','product',22,0,1321363852),
	(8,0,'uk1ocah7rb4n5pt8b03jm9kvs2','product',21,0,1321365125),
	(9,0,'uk1ocah7rb4n5pt8b03jm9kvs2','category',5,0,1321366419),
	(10,0,'uk1ocah7rb4n5pt8b03jm9kvs2','category',6,0,1321366472),
	(11,0,'k8ge7ds1j3e3gnfrk6l5av7572','category',4,0,1321421467),
	(12,0,'k8ge7ds1j3e3gnfrk6l5av7572','product',21,0,1321421519),
	(13,0,'k8ge7ds1j3e3gnfrk6l5av7572','category',0,0,1321427861),
	(14,0,'k8ge7ds1j3e3gnfrk6l5av7572','category',7,0,1321432328),
	(15,0,'k8ge7ds1j3e3gnfrk6l5av7572','product',22,0,1321437493),
	(16,0,'3iaglhdikeaiarj9180s9p59u0','product',22,0,1321437610),
	(17,0,'k8ge7ds1j3e3gnfrk6l5av7572','category',5,0,1321438131),
	(18,0,'k8ge7ds1j3e3gnfrk6l5av7572','product',20,0,1321438155),
	(19,0,'k8ge7ds1j3e3gnfrk6l5av7572','category',8,0,1321438683),
	(20,0,'k8ge7ds1j3e3gnfrk6l5av7572','category',1,0,1321443087),
	(21,0,'a43rmstk0cfut3qg58d5muc905','product',21,0,1321447388),
	(22,0,'a43rmstk0cfut3qg58d5muc905','category',4,0,1321451315),
	(23,0,'0607218ebb8954527ee7b04f11d76c23','category',4,0,1321504830),
	(24,0,'0607218ebb8954527ee7b04f11d76c23','product',21,0,1321506239),
	(25,0,'mv3uc53ui36tsmt6h4lmo2ga47','category',4,0,1321622219),
	(26,0,'df0794cce131526d9de7c7fa09abcc1b','category',4,0,1321694906),
	(27,62,'df0794cce131526d9de7c7fa09abcc1b','category',0,0,1321694959),
	(28,0,'52807196048e116bd25cf11028d90023','category',7,0,1321696201),
	(29,0,'52807196048e116bd25cf11028d90023','category',4,0,1321696405),
	(30,0,'04ae4aaa8d3a11bfde1cf17cb1c61735','category',0,0,1321697303),
	(31,0,'04ae4aaa8d3a11bfde1cf17cb1c61735','category',4,0,1321697305),
	(32,0,'885ea1d48fd779c4e80027f509e47c8f','category',4,0,1321854013),
	(33,0,'885ea1d48fd779c4e80027f509e47c8f','category',7,0,1321854019),
	(34,0,'885ea1d48fd779c4e80027f509e47c8f','category',0,0,1321869219);

/*!40000 ALTER TABLE `#__redshop_pageviewer` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_payment_method
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_payment_method`;

CREATE TABLE `#__redshop_payment_method` (
  `payment_method_id` int(11) NOT NULL AUTO_INCREMENT,
  `plugin` varchar(100) NOT NULL,
  `payment_method_name` varchar(255) DEFAULT NULL,
  `payment_class` varchar(50) NOT NULL DEFAULT '',
  `payment_method_code` varchar(8) DEFAULT NULL,
  `published` tinyint(1) DEFAULT NULL,
  `is_creditcard` tinyint(1) NOT NULL DEFAULT '0',
  `payment_discount_is_percent` tinyint(4) NOT NULL,
  `payment_price` float(10,2) NOT NULL,
  `payment_extrainfo` text NOT NULL,
  `payment_passkey` blob NOT NULL,
  `params` text NOT NULL,
  `ordering` int(11) NOT NULL,
  `shopper_group` varchar(250) NOT NULL,
  `accepted_credict_card` varchar(255) NOT NULL,
  `payment_oprand` varchar(50) NOT NULL,
  PRIMARY KEY (`payment_method_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Payment Method';



# Dump of table #__redshop_product
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product`;

CREATE TABLE `#__redshop_product` (
  `product_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_parent_id` int(11) NOT NULL,
  `manufacturer_id` int(11) NOT NULL,
  `supplier_id` int(11) NOT NULL,
  `product_on_sale` tinyint(4) NOT NULL,
  `product_special` tinyint(4) NOT NULL,
  `product_download` tinyint(4) NOT NULL,
  `product_template` int(11) NOT NULL,
  `product_name` varchar(250) NOT NULL,
  `product_price` double NOT NULL,
  `discount_price` double NOT NULL,
  `discount_stratdate` int(11) NOT NULL,
  `discount_enddate` int(11) NOT NULL,
  `product_number` varchar(250) NOT NULL,
  `product_type` varchar(20) NOT NULL,
  `product_s_desc` longtext NOT NULL,
  `product_desc` longtext NOT NULL,
  `product_volume` double NOT NULL,
  `product_tax_id` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `product_thumb_image` varchar(250) NOT NULL,
  `product_full_image` varchar(250) NOT NULL,
  `publish_date` datetime NOT NULL,
  `update_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  `visited` int(11) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metalanguage_setting` text NOT NULL,
  `metarobot_info` text NOT NULL,
  `pagetitle` text NOT NULL,
  `pageheading` text NOT NULL,
  `sef_url` text NOT NULL,
  `cat_in_sefurl` int(11) NOT NULL,
  `weight` float(10,3) NOT NULL,
  `expired` tinyint(4) NOT NULL,
  `not_for_sale` tinyint(4) NOT NULL,
  `use_discount_calc` tinyint(4) NOT NULL,
  `discount_calc_method` varchar(255) NOT NULL,
  `min_order_product_quantity` int(11) NOT NULL,
  `attribute_set_id` int(11) NOT NULL,
  `product_length` decimal(10,2) NOT NULL,
  `product_height` decimal(10,2) NOT NULL,
  `product_width` decimal(10,2) NOT NULL,
  `product_diameter` decimal(10,2) NOT NULL,
  `product_availability_date` int(11) NOT NULL,
  `use_range` tinyint(4) NOT NULL,
  `product_tax_group_id` int(11) NOT NULL,
  `product_download_days` int(11) NOT NULL,
  `product_download_limit` int(11) NOT NULL,
  `product_download_clock` int(11) NOT NULL,
  `product_download_clock_min` int(11) NOT NULL,
  `accountgroup_id` int(11) NOT NULL,
  `quantity_selectbox_value` varchar(255) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `max_order_product_quantity` int(11) NOT NULL,
  `product_download_infinite` tinyint(4) NOT NULL,
  `product_back_full_image` varchar(250) NOT NULL,
  `product_back_thumb_image` varchar(250) NOT NULL,
  `product_preview_image` varchar(250) NOT NULL,
  `product_preview_back_image` varchar(250) NOT NULL,
  `preorder` varchar(255) NOT NULL,
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Products';

LOCK TABLES `#__redshop_product` WRITE;
/*!40000 ALTER TABLE `#__redshop_product` DISABLE KEYS */;

INSERT INTO `#__redshop_product` (`product_id`, `product_parent_id`, `manufacturer_id`, `supplier_id`, `product_on_sale`, `product_special`, `product_download`, `product_template`, `product_name`, `product_price`, `discount_price`, `discount_stratdate`, `discount_enddate`, `product_number`, `product_type`, `product_s_desc`, `product_desc`, `product_volume`, `product_tax_id`, `published`, `product_thumb_image`, `product_full_image`, `publish_date`, `update_date`, `visited`, `metakey`, `metadesc`, `metalanguage_setting`, `metarobot_info`, `pagetitle`, `pageheading`, `sef_url`, `cat_in_sefurl`, `weight`, `expired`, `not_for_sale`, `use_discount_calc`, `discount_calc_method`, `min_order_product_quantity`, `attribute_set_id`, `product_length`, `product_height`, `product_width`, `product_diameter`, `product_availability_date`, `use_range`, `product_tax_group_id`, `product_download_days`, `product_download_limit`, `product_download_clock`, `product_download_clock_min`, `accountgroup_id`, `quantity_selectbox_value`, `checked_out`, `checked_out_time`, `max_order_product_quantity`, `product_download_infinite`, `product_back_full_image`, `product_back_thumb_image`, `product_preview_image`, `product_preview_back_image`, `preorder`)
VALUES
	(20,0,0,0,1,0,0,9,'Dark Grey T Shirt ',1999,299,1300406400,1301696063,'shirt008','product','<p>Praesent ac magna massa, nec egestas libero. Vestibulum sed arcu at magna pulvinar tempus. Nullam in quam non nunc congue molestie a vitae augue.</p>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec tortor felis, venenatis luctus sollicitudin posuere, vestibulum in neque. Aliquam semper lacus et libero blandit tincidunt. Nam mollis leo a enim facilisis id gravida tellus laoreet. Vivamus mollis arcu vitae odio commodo tincidunt. Sed accumsan interdum metus non porta. Phasellus quis est lorem. Etiam vel enim felis. Nulla sit amet diam a purus mollis lobortis. Aliquam erat volutpat. In pretium, erat eu posuere tempus, magna tellus venenatis nisl, vitae rhoncus risus tortor at metus. Fusce rutrum fringilla ultrices. Phasellus venenatis ligula sem, ut egestas elit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam id sem nulla, gravida ultricies neque. In varius lacus at mauris rhoncus faucibus. Nunc pulvinar venenatis nulla eget vestibulum. Nullam lectus diam, ornare in pulvinar condimentum, posuere et tortor. Quisque dignissim massa eget augue egestas faucibus. Morbi sapien arcu, adipiscing a cursus et, varius iaculis ligula. Duis eleifend rutrum tellus, id tempus diam elementum convallis.</p>\r\n<p>Aenean vehicula orci vel justo iaculis malesuada. Ut accumsan mi ut ante convallis vel pellentesque nulla lobortis. Sed ultrices, tortor a semper porttitor, magna nibh lacinia eros, eget mollis arcu lorem non ante. Pellentesque consectetur, turpis vel viverra interdum, urna dui pretium nisi, vitae varius diam lectus vel dui. Vestibulum scelerisque odio pellentesque sapien pulvinar lacinia. Maecenas erat urna, vehicula id porttitor sed, placerat nec lacus. Aenean mattis, orci in viverra mattis, sapien massa sodales velit, sed auctor augue diam blandit velit. Vestibulum eget leo eget arcu pretium euismod ac non leo. Etiam quis tellus magna, et placerat leo. Ut sit amet turpis erat, et pharetra lorem. Donec cursus lacinia pellentesque.</p>',0,0,1,'','1321433425_1301367062anddarkgrey.jpg','2011-03-19 13:47:21','2011-11-16 16:51:38',258,'','','','','','','',7,0.000,0,0,0,'0',0,0,0.00,0.00,0.00,0.00,0,0,1,0,0,0,0,0,'',0,'0000-00-00 00:00:00',0,0,'','','','','global'),
	(21,0,0,0,0,0,0,9,'Green Shirt ',280,0,1300406400,1300572863,'shirt010','product','<p>Praesent ac magna massa, nec egestas libero. Vestibulum sed arcu at magna pulvinar tempus. Nullam in quam non nunc congue molestie a vitae augue.</p>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec tortor felis, venenatis luctus sollicitudin posuere, vestibulum in neque. Aliquam semper lacus et libero blandit tincidunt. Nam mollis leo a enim facilisis id gravida tellus laoreet. Vivamus mollis arcu vitae odio commodo tincidunt. Sed accumsan interdum metus non porta. Phasellus quis est lorem. Etiam vel enim felis. Nulla sit amet diam a purus mollis lobortis. Aliquam erat volutpat. In pretium, erat eu posuere tempus, magna tellus venenatis nisl, vitae rhoncus risus tortor at metus. Fusce rutrum fringilla ultrices. Phasellus venenatis ligula sem, ut egestas elit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam id sem nulla, gravida ultricies neque. In varius lacus at mauris rhoncus faucibus. Nunc pulvinar venenatis nulla eget vestibulum. Nullam lectus diam, ornare in pulvinar condimentum, posuere et tortor. Quisque dignissim massa eget augue egestas faucibus. Morbi sapien arcu, adipiscing a cursus et, varius iaculis ligula. Duis eleifend rutrum tellus, id tempus diam elementum convallis.</p>\r\n<p>Aenean vehicula orci vel justo iaculis malesuada. Ut accumsan mi ut ante convallis vel pellentesque nulla lobortis. Sed ultrices, tortor a semper porttitor, magna nibh lacinia eros, eget mollis arcu lorem non ante. Pellentesque consectetur, turpis vel viverra interdum, urna dui pretium nisi, vitae varius diam lectus vel dui. Vestibulum scelerisque odio pellentesque sapien pulvinar lacinia. Maecenas erat urna, vehicula id porttitor sed, placerat nec lacus. Aenean mattis, orci in viverra mattis, sapien massa sodales velit, sed auctor augue diam blandit velit. Vestibulum eget leo eget arcu pretium euismod ac non leo. Etiam quis tellus magna, et placerat leo. Ut sit amet turpis erat, et pharetra lorem. Donec cursus lacinia pellentesque.</p>',0,0,1,'','1321433493_1300538410and1300536311andoliveshirt.jpg','2011-03-19 14:57:10','2011-11-17 10:34:01',885,'','','','','','','',7,0.000,0,0,0,'0',0,0,0.00,0.00,0.00,0.00,0,0,0,0,0,0,0,0,'',0,'0000-00-00 00:00:00',0,0,'','','','','global'),
	(22,0,0,0,1,0,0,9,'Twitter Shoes',1999,299,0,0,'0029','product','<p>Praesent ac magna massa, nec egestas libero. Vestibulum sed arcu at magna pulvinar tempus. Nullam in quam non nunc congue molestie a vitae augue.</p>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec tortor felis, venenatis luctus sollicitudin posuere, vestibulum in neque. Aliquam semper lacus et libero blandit tincidunt. Nam mollis leo a enim facilisis id gravida tellus laoreet. Vivamus mollis arcu vitae odio commodo tincidunt. Sed accumsan interdum metus non porta. Phasellus quis est lorem. Etiam vel enim felis. Nulla sit amet diam a purus mollis lobortis. Aliquam erat volutpat. In pretium, erat eu posuere tempus, magna tellus venenatis nisl, vitae rhoncus risus tortor at metus. Fusce rutrum fringilla ultrices. Phasellus venenatis ligula sem, ut egestas elit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam id sem nulla, gravida ultricies neque. In varius lacus at mauris rhoncus faucibus. Nunc pulvinar venenatis nulla eget vestibulum. Nullam lectus diam, ornare in pulvinar condimentum, posuere et tortor. Quisque dignissim massa eget augue egestas faucibus. Morbi sapien arcu, adipiscing a cursus et, varius iaculis ligula. Duis eleifend rutrum tellus, id tempus diam elementum convallis.</p>\r\n<p>Aenean vehicula orci vel justo iaculis malesuada. Ut accumsan mi ut ante convallis vel pellentesque nulla lobortis. Sed ultrices, tortor a semper porttitor, magna nibh lacinia eros, eget mollis arcu lorem non ante. Pellentesque consectetur, turpis vel viverra interdum, urna dui pretium nisi, vitae varius diam lectus vel dui. Vestibulum scelerisque odio pellentesque sapien pulvinar lacinia. Maecenas erat urna, vehicula id porttitor sed, placerat nec lacus. Aenean mattis, orci in viverra mattis, sapien massa sodales velit, sed auctor augue diam blandit velit. Vestibulum eget leo eget arcu pretium euismod ac non leo. Etiam quis tellus magna, et placerat leo. Ut sit amet turpis erat, et pharetra lorem. Donec cursus lacinia pellentesque.</p>',0,0,1,'','1301366289_twittershoe1.jpg','2011-03-19 13:47:21','2011-11-16 16:51:55',271,'','','','','','','',4,0.000,0,0,0,'0',0,0,0.00,0.00,0.00,0.00,0,0,1,0,0,0,0,0,'',0,'0000-00-00 00:00:00',0,0,'','','','','global'),
	(23,0,0,0,0,0,0,9,'Sneakers',280,0,0,0,'Sneakers','product','<p>Praesent ac magna massa, nec egestas libero. Vestibulum sed arcu at magna pulvinar tempus. Nullam in quam non nunc congue molestie a vitae augue.</p>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec tortor felis, venenatis luctus sollicitudin posuere, vestibulum in neque. Aliquam semper lacus et libero blandit tincidunt. Nam mollis leo a enim facilisis id gravida tellus laoreet. Vivamus mollis arcu vitae odio commodo tincidunt. Sed accumsan interdum metus non porta. Phasellus quis est lorem. Etiam vel enim felis. Nulla sit amet diam a purus mollis lobortis. Aliquam erat volutpat. In pretium, erat eu posuere tempus, magna tellus venenatis nisl, vitae rhoncus risus tortor at metus. Fusce rutrum fringilla ultrices. Phasellus venenatis ligula sem, ut egestas elit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam id sem nulla, gravida ultricies neque. In varius lacus at mauris rhoncus faucibus. Nunc pulvinar venenatis nulla eget vestibulum. Nullam lectus diam, ornare in pulvinar condimentum, posuere et tortor. Quisque dignissim massa eget augue egestas faucibus. Morbi sapien arcu, adipiscing a cursus et, varius iaculis ligula. Duis eleifend rutrum tellus, id tempus diam elementum convallis.</p>\r\n<p>Aenean vehicula orci vel justo iaculis malesuada. Ut accumsan mi ut ante convallis vel pellentesque nulla lobortis. Sed ultrices, tortor a semper porttitor, magna nibh lacinia eros, eget mollis arcu lorem non ante. Pellentesque consectetur, turpis vel viverra interdum, urna dui pretium nisi, vitae varius diam lectus vel dui. Vestibulum scelerisque odio pellentesque sapien pulvinar lacinia. Maecenas erat urna, vehicula id porttitor sed, placerat nec lacus. Aenean mattis, orci in viverra mattis, sapien massa sodales velit, sed auctor augue diam blandit velit. Vestibulum eget leo eget arcu pretium euismod ac non leo. Etiam quis tellus magna, et placerat leo. Ut sit amet turpis erat, et pharetra lorem. Donec cursus lacinia pellentesque.</p>',0,0,1,'','1301366393_brownwhitesneakers.jpg','2011-03-19 14:57:10','2011-11-16 16:55:25',315,'','','','','','','',1,0.000,0,0,0,'0',0,0,0.00,0.00,0.00,0.00,0,0,1,0,0,0,0,0,'',0,'0000-00-00 00:00:00',0,0,'','','','','global'),
	(24,0,0,0,0,0,0,9,'T Shirts',280,0,0,0,'T Shirts','product','<p>Praesent ac magna massa, nec egestas libero. Vestibulum sed arcu at magna pulvinar tempus. Nullam in quam non nunc congue molestie a vitae augue.</p>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec tortor felis, venenatis luctus sollicitudin posuere, vestibulum in neque. Aliquam semper lacus et libero blandit tincidunt. Nam mollis leo a enim facilisis id gravida tellus laoreet. Vivamus mollis arcu vitae odio commodo tincidunt. Sed accumsan interdum metus non porta. Phasellus quis est lorem. Etiam vel enim felis. Nulla sit amet diam a purus mollis lobortis. Aliquam erat volutpat. In pretium, erat eu posuere tempus, magna tellus venenatis nisl, vitae rhoncus risus tortor at metus. Fusce rutrum fringilla ultrices. Phasellus venenatis ligula sem, ut egestas elit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam id sem nulla, gravida ultricies neque. In varius lacus at mauris rhoncus faucibus. Nunc pulvinar venenatis nulla eget vestibulum. Nullam lectus diam, ornare in pulvinar condimentum, posuere et tortor. Quisque dignissim massa eget augue egestas faucibus. Morbi sapien arcu, adipiscing a cursus et, varius iaculis ligula. Duis eleifend rutrum tellus, id tempus diam elementum convallis.</p>\r\n<p>Aenean vehicula orci vel justo iaculis malesuada. Ut accumsan mi ut ante convallis vel pellentesque nulla lobortis. Sed ultrices, tortor a semper porttitor, magna nibh lacinia eros, eget mollis arcu lorem non ante. Pellentesque consectetur, turpis vel viverra interdum, urna dui pretium nisi, vitae varius diam lectus vel dui. Vestibulum scelerisque odio pellentesque sapien pulvinar lacinia. Maecenas erat urna, vehicula id porttitor sed, placerat nec lacus. Aenean mattis, orci in viverra mattis, sapien massa sodales velit, sed auctor augue diam blandit velit. Vestibulum eget leo eget arcu pretium euismod ac non leo. Etiam quis tellus magna, et placerat leo. Ut sit amet turpis erat, et pharetra lorem. Donec cursus lacinia pellentesque.</p>',0,0,1,'','rename_rename_1300544368_greenshirt.jpg','2011-03-19 14:57:10','2011-11-16 16:58:59',327,'','','','','','','',7,0.000,0,0,0,'0',0,0,0.00,0.00,0.00,0.00,0,0,1,0,0,0,0,0,'',0,'0000-00-00 00:00:00',0,0,'1301366580_browntshirt.jpg','1301366580_browntshirt.jpg','','','global');

/*!40000 ALTER TABLE `#__redshop_product` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_product_accessory
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_accessory`;

CREATE TABLE `#__redshop_product_accessory` (
  `accessory_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `child_product_id` int(11) NOT NULL,
  `accessory_price` double NOT NULL,
  `oprand` char(1) NOT NULL,
  `setdefault_selected` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  PRIMARY KEY (`accessory_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Products Accessory';



# Dump of table #__redshop_product_attribute
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_attribute`;

CREATE TABLE `#__redshop_product_attribute` (
  `attribute_id` int(11) NOT NULL AUTO_INCREMENT,
  `attribute_name` varchar(250) NOT NULL,
  `attribute_required` tinyint(4) NOT NULL,
  `allow_multiple_selection` tinyint(1) NOT NULL,
  `hide_attribute_price` tinyint(1) NOT NULL,
  `product_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `attribute_set_id` int(11) NOT NULL,
  `display_type` varchar(255) NOT NULL,
  `attribute_published` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`attribute_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Products Attribute';



# Dump of table #__redshop_product_attribute_price
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_attribute_price`;

CREATE TABLE `#__redshop_product_attribute_price` (
  `price_id` int(11) NOT NULL AUTO_INCREMENT,
  `section_id` int(11) NOT NULL,
  `section` varchar(255) NOT NULL,
  `product_price` decimal(12,2) NOT NULL,
  `product_currency` varchar(10) NOT NULL,
  `cdate` int(11) NOT NULL,
  `shopper_group_id` int(11) NOT NULL,
  `price_quantity_start` int(11) NOT NULL,
  `price_quantity_end` bigint(20) NOT NULL,
  `discount_price` decimal(12,4) NOT NULL,
  `discount_start_date` int(11) NOT NULL,
  `discount_end_date` int(11) NOT NULL,
  PRIMARY KEY (`price_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Attribute Price';



# Dump of table #__redshop_product_attribute_property
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_attribute_property`;

CREATE TABLE `#__redshop_product_attribute_property` (
  `property_id` int(11) NOT NULL AUTO_INCREMENT,
  `attribute_id` int(11) NOT NULL,
  `property_name` varchar(255) NOT NULL,
  `property_price` double NOT NULL,
  `oprand` char(1) NOT NULL DEFAULT '+',
  `property_image` varchar(255) NOT NULL,
  `property_main_image` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL,
  `setdefault_selected` tinyint(4) NOT NULL,
  `setrequire_selected` tinyint(3) NOT NULL,
  `setmulti_selected` tinyint(4) NOT NULL,
  `setdisplay_type` varchar(255) NOT NULL,
  `property_number` varchar(255) NOT NULL,
  PRIMARY KEY (`property_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Products Attribute Property';



# Dump of table #__redshop_product_attribute_stockroom_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_attribute_stockroom_xref`;

CREATE TABLE `#__redshop_product_attribute_stockroom_xref` (
  `section_id` int(11) NOT NULL,
  `section` varchar(255) NOT NULL,
  `stockroom_id` int(11) NOT NULL,
  `quantity` int(11) NOT NULL,
  `preorder_stock` int(11) NOT NULL,
  `ordered_preorder` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Attribute Stockroom relation';



# Dump of table #__redshop_product_category_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_category_xref`;

CREATE TABLE `#__redshop_product_category_xref` (
  `category_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  UNIQUE KEY `category_id` (`category_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Category Relation';

LOCK TABLES `#__redshop_product_category_xref` WRITE;
/*!40000 ALTER TABLE `#__redshop_product_category_xref` DISABLE KEYS */;

INSERT INTO `#__redshop_product_category_xref` (`category_id`, `product_id`, `ordering`)
VALUES
	(4,22,0),
	(5,22,0),
	(6,22,0),
	(7,20,1),
	(7,21,2),
	(7,24,3),
	(9,20,1),
	(9,21,2),
	(9,24,3);

/*!40000 ALTER TABLE `#__redshop_product_category_xref` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_product_compare
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_compare`;

CREATE TABLE `#__redshop_product_compare` (
  `compare_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  PRIMARY KEY (`compare_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Comparision';



# Dump of table #__redshop_product_discount_calc
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_discount_calc`;

CREATE TABLE `#__redshop_product_discount_calc` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `area_start` float(10,2) NOT NULL,
  `area_end` float(10,2) NOT NULL,
  `area_price` double NOT NULL,
  `discount_calc_unit` varchar(255) NOT NULL,
  `area_start_converted` float(20,8) NOT NULL,
  `area_end_converted` float(20,8) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Discount Calculator';



# Dump of table #__redshop_product_discount_calc_extra
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_discount_calc_extra`;

CREATE TABLE `#__redshop_product_discount_calc_extra` (
  `pdcextra_id` int(11) NOT NULL AUTO_INCREMENT,
  `option_name` varchar(255) NOT NULL,
  `oprand` char(1) NOT NULL,
  `price` float(10,2) NOT NULL,
  `product_id` int(11) NOT NULL,
  PRIMARY KEY (`pdcextra_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Discount Calculator Extra Value';



# Dump of table #__redshop_product_download
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_download`;

CREATE TABLE `#__redshop_product_download` (
  `product_id` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `order_id` int(11) NOT NULL DEFAULT '0',
  `end_date` int(11) NOT NULL DEFAULT '0',
  `download_max` int(11) NOT NULL DEFAULT '0',
  `download_id` varchar(32) NOT NULL DEFAULT '',
  `file_name` varchar(255) NOT NULL DEFAULT '',
  `product_serial_number` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`download_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Downloadable Products';



# Dump of table #__redshop_product_download_log
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_download_log`;

CREATE TABLE `#__redshop_product_download_log` (
  `user_id` int(11) NOT NULL,
  `download_id` varchar(32) NOT NULL,
  `download_time` int(11) NOT NULL,
  `ip` varchar(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Downloadable Products Logs';



# Dump of table #__redshop_product_price
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_price`;

CREATE TABLE `#__redshop_product_price` (
  `price_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `product_price` decimal(12,2) NOT NULL,
  `product_currency` varchar(10) NOT NULL,
  `cdate` date NOT NULL,
  `shopper_group_id` int(11) NOT NULL,
  `price_quantity_start` int(11) NOT NULL,
  `price_quantity_end` bigint(20) NOT NULL,
  `discount_price` decimal(12,4) NOT NULL,
  `discount_start_date` int(11) NOT NULL,
  `discount_end_date` int(11) NOT NULL,
  PRIMARY KEY (`price_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='redSHOP Product Price';



# Dump of table #__redshop_product_rating
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_rating`;

CREATE TABLE `#__redshop_product_rating` (
  `rating_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `comment` text NOT NULL,
  `userid` int(11) NOT NULL DEFAULT '0',
  `time` int(11) NOT NULL DEFAULT '0',
  `user_rating` tinyint(1) NOT NULL DEFAULT '0',
  `favoured` tinyint(4) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`rating_id`),
  UNIQUE KEY `product_id` (`product_id`,`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__redshop_product_rating` WRITE;
/*!40000 ALTER TABLE `#__redshop_product_rating` DISABLE KEYS */;

INSERT INTO `#__redshop_product_rating` (`rating_id`, `product_id`, `title`, `comment`, `userid`, `time`, `user_rating`, `favoured`, `published`)
VALUES
	(1,1,'super','Flot flot flot...',64,1262695786,4,1,1);

/*!40000 ALTER TABLE `#__redshop_product_rating` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_product_related
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_related`;

CREATE TABLE `#__redshop_product_related` (
  `related_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  UNIQUE KEY `related_id` (`related_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Related Products';



# Dump of table #__redshop_product_serial_number
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_serial_number`;

CREATE TABLE `#__redshop_product_serial_number` (
  `serial_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `serial_number` varchar(255) NOT NULL,
  `is_used` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`serial_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP downloadable product serial numbers';



# Dump of table #__redshop_product_stockroom_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_stockroom_xref`;

CREATE TABLE `#__redshop_product_stockroom_xref` (
  `product_id` int(11) NOT NULL,
  `stockroom_id` int(11) NOT NULL,
  `quantity` int(11) NOT NULL,
  `preorder_stock` int(11) NOT NULL,
  `ordered_preorder` int(11) NOT NULL,
  UNIQUE KEY `product_id` (`product_id`,`stockroom_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Products Stockroom Relation';

LOCK TABLES `#__redshop_product_stockroom_xref` WRITE;
/*!40000 ALTER TABLE `#__redshop_product_stockroom_xref` DISABLE KEYS */;

INSERT INTO `#__redshop_product_stockroom_xref` (`product_id`, `stockroom_id`, `quantity`, `preorder_stock`, `ordered_preorder`)
VALUES
	(2,1,100,0,0),
	(15,1,1301367062,0,0),
	(16,1,1300544368,0,0),
	(18,1,1300544368,0,0),
	(19,1,0,0,0),
	(20,1,1301367062,0,0),
	(21,1,1300544368,0,0),
	(23,1,1300544368,0,0),
	(24,1,0,0,0);

/*!40000 ALTER TABLE `#__redshop_product_stockroom_xref` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_product_subattribute_color
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_subattribute_color`;

CREATE TABLE `#__redshop_product_subattribute_color` (
  `subattribute_color_id` int(11) NOT NULL AUTO_INCREMENT,
  `subattribute_color_name` varchar(255) NOT NULL,
  `subattribute_color_price` decimal(12,2) NOT NULL,
  `oprand` char(1) NOT NULL,
  `subattribute_color_image` varchar(255) NOT NULL,
  `subattribute_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `setdefault_selected` tinyint(4) NOT NULL,
  `subattribute_color_number` varchar(255) NOT NULL,
  `subattribute_color_title` varchar(255) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`subattribute_color_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Product Subattribute Color';



# Dump of table #__redshop_product_subscribe_detail
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_subscribe_detail`;

CREATE TABLE `#__redshop_product_subscribe_detail` (
  `product_subscribe_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `subscription_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `start_date` int(11) NOT NULL,
  `end_date` int(11) NOT NULL,
  `order_item_id` int(11) NOT NULL,
  `renewal_reminder` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`product_subscribe_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP User product Subscribe detail';



# Dump of table #__redshop_product_subscription
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_subscription`;

CREATE TABLE `#__redshop_product_subscription` (
  `subscription_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `subscription_period` int(11) NOT NULL,
  `period_type` varchar(10) NOT NULL,
  `subscription_price` double NOT NULL,
  PRIMARY KEY (`subscription_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Subscription';



# Dump of table #__redshop_product_tags
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_tags`;

CREATE TABLE `#__redshop_product_tags` (
  `tags_id` int(11) NOT NULL AUTO_INCREMENT,
  `tags_name` varchar(255) NOT NULL,
  `tags_counter` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`tags_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Product Tags';



# Dump of table #__redshop_product_tags_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_tags_xref`;

CREATE TABLE `#__redshop_product_tags_xref` (
  `tags_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `users_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Product Tags Relation With product and user';



# Dump of table #__redshop_product_voucher
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_voucher`;

CREATE TABLE `#__redshop_product_voucher` (
  `voucher_id` int(11) NOT NULL AUTO_INCREMENT,
  `voucher_code` varchar(255) NOT NULL,
  `amount` decimal(12,2) NOT NULL DEFAULT '0.00',
  `voucher_type` varchar(250) CHARACTER SET latin1 NOT NULL,
  `start_date` double NOT NULL,
  `end_date` double NOT NULL,
  `free_shipping` tinyint(4) NOT NULL,
  `voucher_left` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`voucher_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Voucher';



# Dump of table #__redshop_product_voucher_transaction
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_voucher_transaction`;

CREATE TABLE `#__redshop_product_voucher_transaction` (
  `transaction_voucher_id` int(11) NOT NULL AUTO_INCREMENT,
  `voucher_id` int(11) NOT NULL,
  `voucher_code` varchar(255) NOT NULL,
  `amount` decimal(10,3) NOT NULL,
  `user_id` int(11) NOT NULL,
  `order_id` int(11) NOT NULL,
  `trancation_date` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `product_id` varchar(50) NOT NULL,
  PRIMARY KEY (`transaction_voucher_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Product Voucher Transaction';



# Dump of table #__redshop_product_voucher_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_product_voucher_xref`;

CREATE TABLE `#__redshop_product_voucher_xref` (
  `voucher_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Products Voucher Relation';



# Dump of table #__redshop_quotation
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_quotation`;

CREATE TABLE `#__redshop_quotation` (
  `quotation_id` int(11) NOT NULL AUTO_INCREMENT,
  `quotation_number` varchar(50) NOT NULL,
  `user_id` int(11) NOT NULL,
  `user_info_id` int(11) NOT NULL,
  `order_id` int(11) NOT NULL,
  `quotation_total` decimal(15,2) NOT NULL,
  `quotation_subtotal` decimal(15,2) NOT NULL,
  `quotation_tax` decimal(15,2) NOT NULL,
  `quotation_discount` decimal(15,4) NOT NULL,
  `quotation_status` int(11) NOT NULL,
  `quotation_cdate` int(11) NOT NULL,
  `quotation_mdate` int(11) NOT NULL,
  `quotation_note` text NOT NULL,
  `quotation_ipaddress` varchar(20) NOT NULL,
  `quotation_encrkey` varchar(255) NOT NULL,
  `user_email` varchar(255) NOT NULL,
  PRIMARY KEY (`quotation_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Quotation';



# Dump of table #__redshop_quotation_accessory_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_quotation_accessory_item`;

CREATE TABLE `#__redshop_quotation_accessory_item` (
  `quotation_item_acc_id` int(11) NOT NULL AUTO_INCREMENT,
  `quotation_item_id` int(11) NOT NULL,
  `accessory_id` int(11) NOT NULL,
  `accessory_item_sku` varchar(255) NOT NULL,
  `accessory_item_name` varchar(255) NOT NULL,
  `accessory_price` decimal(15,4) NOT NULL,
  `accessory_vat` decimal(15,4) NOT NULL,
  `accessory_quantity` int(11) NOT NULL,
  `accessory_item_price` decimal(15,2) NOT NULL,
  `accessory_final_price` decimal(15,2) NOT NULL,
  `accessory_attribute` text NOT NULL,
  PRIMARY KEY (`quotation_item_acc_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Quotation Accessory item';



# Dump of table #__redshop_quotation_attribute_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_quotation_attribute_item`;

CREATE TABLE `#__redshop_quotation_attribute_item` (
  `quotation_att_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `quotation_item_id` int(11) NOT NULL,
  `section_id` int(11) NOT NULL,
  `section` varchar(250) NOT NULL,
  `parent_section_id` int(11) NOT NULL,
  `section_name` varchar(250) NOT NULL,
  `section_price` decimal(15,4) NOT NULL,
  `section_vat` decimal(15,4) NOT NULL,
  `section_oprand` char(1) NOT NULL,
  `is_accessory_att` tinyint(4) NOT NULL,
  PRIMARY KEY (`quotation_att_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Quotation Attribute item';



# Dump of table #__redshop_quotation_fields_data
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_quotation_fields_data`;

CREATE TABLE `#__redshop_quotation_fields_data` (
  `data_id` int(11) NOT NULL AUTO_INCREMENT,
  `fieldid` int(11) DEFAULT NULL,
  `data_txt` longtext,
  `quotation_item_id` int(11) DEFAULT NULL,
  `section` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`data_id`),
  KEY `quotation_item_id` (`quotation_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Quotation USer field';



# Dump of table #__redshop_quotation_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_quotation_item`;

CREATE TABLE `#__redshop_quotation_item` (
  `quotation_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `quotation_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `product_name` varchar(255) NOT NULL,
  `product_price` decimal(15,2) NOT NULL,
  `product_excl_price` decimal(15,2) NOT NULL,
  `product_final_price` decimal(15,2) NOT NULL,
  `actualitem_price` decimal(15,4) NOT NULL,
  `product_quantity` int(11) NOT NULL,
  `product_attribute` text NOT NULL,
  `product_accessory` text NOT NULL,
  `mycart_accessory` text NOT NULL,
  `product_wrapperid` int(11) NOT NULL,
  `wrapper_price` decimal(15,2) NOT NULL,
  `is_giftcard` tinyint(4) NOT NULL,
  PRIMARY KEY (`quotation_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Quotation Item';



# Dump of table #__redshop_sample_request
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_sample_request`;

CREATE TABLE `#__redshop_sample_request` (
  `request_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `email` varchar(250) NOT NULL,
  `colour_id` varchar(250) NOT NULL,
  `block` tinyint(4) NOT NULL,
  `reminder_1` tinyint(1) NOT NULL,
  `reminder_2` tinyint(1) NOT NULL,
  `reminder_3` tinyint(1) NOT NULL,
  `reminder_coupon` tinyint(1) NOT NULL,
  `registerdate` int(11) NOT NULL,
  PRIMARY KEY (`request_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Sample Request';



# Dump of table #__redshop_shipping_boxes
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_shipping_boxes`;

CREATE TABLE `#__redshop_shipping_boxes` (
  `shipping_box_id` int(11) NOT NULL AUTO_INCREMENT,
  `shipping_box_name` varchar(255) NOT NULL,
  `shipping_box_length` decimal(10,2) NOT NULL,
  `shipping_box_width` decimal(10,2) NOT NULL,
  `shipping_box_height` decimal(10,2) NOT NULL,
  `shipping_box_priority` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`shipping_box_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Shipping Boxes';

LOCK TABLES `#__redshop_shipping_boxes` WRITE;
/*!40000 ALTER TABLE `#__redshop_shipping_boxes` DISABLE KEYS */;

INSERT INTO `#__redshop_shipping_boxes` (`shipping_box_id`, `shipping_box_name`, `shipping_box_length`, `shipping_box_width`, `shipping_box_height`, `shipping_box_priority`, `published`)
VALUES
	(1,'Box1',1.00,1.00,1.00,1,1);

/*!40000 ALTER TABLE `#__redshop_shipping_boxes` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_shipping_rate
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_shipping_rate`;

CREATE TABLE `#__redshop_shipping_rate` (
  `shipping_rate_id` int(11) NOT NULL AUTO_INCREMENT,
  `shipping_rate_name` varchar(255) NOT NULL DEFAULT '',
  `shipping_class` varchar(255) NOT NULL DEFAULT '',
  `shipping_rate_country` longtext NOT NULL,
  `shipping_rate_zip_start` varchar(20) NOT NULL,
  `shipping_rate_zip_end` varchar(20) NOT NULL,
  `shipping_rate_weight_start` decimal(10,2) NOT NULL,
  `company_only` tinyint(4) NOT NULL,
  `apply_vat` tinyint(4) NOT NULL,
  `shipping_rate_weight_end` decimal(10,2) NOT NULL,
  `shipping_rate_volume_start` decimal(10,2) NOT NULL,
  `shipping_rate_volume_end` decimal(10,2) NOT NULL,
  `shipping_rate_ordertotal_start` decimal(10,3) NOT NULL DEFAULT '0.000',
  `shipping_rate_ordertotal_end` decimal(10,3) NOT NULL,
  `shipping_rate_priority` tinyint(4) NOT NULL DEFAULT '0',
  `shipping_rate_value` decimal(10,2) NOT NULL DEFAULT '0.00',
  `shipping_rate_package_fee` decimal(10,2) NOT NULL DEFAULT '0.00',
  `shipping_location_info` longtext NOT NULL,
  `shipping_rate_length_start` decimal(10,2) NOT NULL,
  `shipping_rate_length_end` decimal(10,2) NOT NULL,
  `shipping_rate_width_start` decimal(10,2) NOT NULL,
  `shipping_rate_width_end` decimal(10,2) NOT NULL,
  `shipping_rate_height_start` decimal(10,2) NOT NULL,
  `shipping_rate_height_end` decimal(10,2) NOT NULL,
  `shipping_rate_on_shopper_group` longtext NOT NULL,
  `shipping_rate_on_product` longtext NOT NULL,
  `shipping_rate_on_category` longtext NOT NULL,
  `shipping_tax_group_id` int(11) NOT NULL,
  `shipping_rate_state` longtext NOT NULL,
  PRIMARY KEY (`shipping_rate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Shipping Rates';

LOCK TABLES `#__redshop_shipping_rate` WRITE;
/*!40000 ALTER TABLE `#__redshop_shipping_rate` DISABLE KEYS */;

INSERT INTO `#__redshop_shipping_rate` (`shipping_rate_id`, `shipping_rate_name`, `shipping_class`, `shipping_rate_country`, `shipping_rate_zip_start`, `shipping_rate_zip_end`, `shipping_rate_weight_start`, `company_only`, `apply_vat`, `shipping_rate_weight_end`, `shipping_rate_volume_start`, `shipping_rate_volume_end`, `shipping_rate_ordertotal_start`, `shipping_rate_ordertotal_end`, `shipping_rate_priority`, `shipping_rate_value`, `shipping_rate_package_fee`, `shipping_location_info`, `shipping_rate_length_start`, `shipping_rate_length_end`, `shipping_rate_width_start`, `shipping_rate_width_end`, `shipping_rate_height_start`, `shipping_rate_height_end`, `shipping_rate_on_shopper_group`, `shipping_rate_on_product`, `shipping_rate_on_category`, `shipping_tax_group_id`, `shipping_rate_state`)
VALUES
	(1,'Demo Rate','default_shipping','','','',0.00,0,0,0.00,0.00,0.00,0.000,0.000,0,0.00,0.00,'',0.00,0.00,0.00,0.00,0.00,0.00,'','','',0,'');

/*!40000 ALTER TABLE `#__redshop_shipping_rate` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_shopper_group
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_shopper_group`;

CREATE TABLE `#__redshop_shopper_group` (
  `shopper_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `shopper_group_name` varchar(32) DEFAULT NULL,
  `shopper_group_customer_type` tinyint(4) NOT NULL,
  `shopper_group_portal` tinyint(4) NOT NULL,
  `shopper_group_categories` longtext NOT NULL,
  `shopper_group_url` varchar(255) NOT NULL,
  `shopper_group_logo` varchar(255) NOT NULL,
  `shopper_group_introtext` longtext NOT NULL,
  `shopper_group_desc` text,
  `parent_id` int(11) NOT NULL,
  `default_shipping` tinyint(4) NOT NULL,
  `default_shipping_rate` float(10,2) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `shopper_group_cart_checkout_itemid` int(11) NOT NULL,
  `shopper_group_cart_itemid` int(11) NOT NULL,
  `shopper_group_quotation_mode` tinyint(4) NOT NULL,
  `show_price_without_vat` tinyint(4) NOT NULL,
  `tax_group_id` int(11) NOT NULL,
  `apply_product_price_vat` int(11) NOT NULL,
  `show_price` varchar(255) NOT NULL DEFAULT 'global',
  `use_as_catalog` varchar(255) NOT NULL DEFAULT 'global',
  `is_logged_in` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`shopper_group_id`),
  KEY `idx_shopper_group_name` (`shopper_group_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Shopper Groups that users can be assigned to';

LOCK TABLES `#__redshop_shopper_group` WRITE;
/*!40000 ALTER TABLE `#__redshop_shopper_group` DISABLE KEYS */;

INSERT INTO `#__redshop_shopper_group` (`shopper_group_id`, `shopper_group_name`, `shopper_group_customer_type`, `shopper_group_portal`, `shopper_group_categories`, `shopper_group_url`, `shopper_group_logo`, `shopper_group_introtext`, `shopper_group_desc`, `parent_id`, `default_shipping`, `default_shipping_rate`, `published`, `shopper_group_cart_checkout_itemid`, `shopper_group_cart_itemid`, `shopper_group_quotation_mode`, `show_price_without_vat`, `tax_group_id`, `apply_product_price_vat`, `show_price`, `use_as_catalog`, `is_logged_in`)
VALUES
	(1,'Default Private',1,0,'','','','This is the default private shopper group.','This is the default private shopper group.',0,0,0.00,1,0,0,0,0,0,0,'global','global',1),
	(2,'Default Company',0,0,'','','','This is the default Company shopper group.','This is the default Company shopper group.',0,0,0.00,1,0,0,0,0,0,0,'global','global',1),
	(3,'Default Tax Exempt',0,0,'','','','This is the Default Tax Exempt shopper group.','This is the Default Tax Exempt shopper group.',0,0,0.00,1,0,0,0,0,0,0,'global','global',1);

/*!40000 ALTER TABLE `#__redshop_shopper_group` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_siteviewer
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_siteviewer`;

CREATE TABLE `#__redshop_siteviewer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `session_id` varchar(250) NOT NULL,
  `created_date` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Site Viewer';

LOCK TABLES `#__redshop_siteviewer` WRITE;
/*!40000 ALTER TABLE `#__redshop_siteviewer` DISABLE KEYS */;

INSERT INTO `#__redshop_siteviewer` (`id`, `user_id`, `session_id`, `created_date`)
VALUES
	(1,0,'197775d65f13464abebca56ba77e47ba',1321246509),
	(2,0,'uk1ocah7rb4n5pt8b03jm9kvs2',1321337440),
	(3,0,'k8ge7ds1j3e3gnfrk6l5av7572',1321421467),
	(4,0,'3iaglhdikeaiarj9180s9p59u0',1321437609),
	(5,0,'a43rmstk0cfut3qg58d5muc905',1321445482),
	(6,0,'0607218ebb8954527ee7b04f11d76c23',1321504816),
	(7,0,'mv3uc53ui36tsmt6h4lmo2ga47',1321622219),
	(8,0,'df0794cce131526d9de7c7fa09abcc1b',1321694906),
	(9,0,'52807196048e116bd25cf11028d90023',1321696201),
	(10,0,'04ae4aaa8d3a11bfde1cf17cb1c61735',1321697303),
	(11,0,'885ea1d48fd779c4e80027f509e47c8f',1321854012);

/*!40000 ALTER TABLE `#__redshop_siteviewer` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_state
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_state`;

CREATE TABLE `#__redshop_state` (
  `state_id` int(11) NOT NULL AUTO_INCREMENT,
  `country_id` int(11) NOT NULL DEFAULT '1',
  `state_name` varchar(64) DEFAULT NULL,
  `state_3_code` char(3) DEFAULT NULL,
  `state_2_code` char(2) DEFAULT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `show_state` int(11) NOT NULL DEFAULT '2',
  PRIMARY KEY (`state_id`),
  UNIQUE KEY `state_3_code` (`country_id`,`state_3_code`),
  UNIQUE KEY `state_2_code` (`country_id`,`state_2_code`),
  KEY `idx_country_id` (`country_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='States that are assigned to a country';

LOCK TABLES `#__redshop_state` WRITE;
/*!40000 ALTER TABLE `#__redshop_state` DISABLE KEYS */;

INSERT INTO `#__redshop_state` (`state_id`, `country_id`, `state_name`, `state_3_code`, `state_2_code`, `checked_out`, `checked_out_time`, `show_state`)
VALUES
	(1,223,'Alabama','ALA','AL',0,'0000-00-00 00:00:00',2),
	(2,223,'Alaska','ALK','AK',0,'0000-00-00 00:00:00',2),
	(3,223,'Arizona','ARZ','AZ',0,'0000-00-00 00:00:00',2),
	(4,223,'Arkansas','ARK','AR',0,'0000-00-00 00:00:00',2),
	(5,223,'California','CAL','CA',0,'0000-00-00 00:00:00',2),
	(6,223,'Colorado','COL','CO',0,'0000-00-00 00:00:00',2),
	(7,223,'Connecticut','CCT','CT',0,'0000-00-00 00:00:00',2),
	(8,223,'Delaware','DEL','DE',0,'0000-00-00 00:00:00',2),
	(9,223,'District Of Columbia','DOC','DC',0,'0000-00-00 00:00:00',2),
	(10,223,'Florida','FLO','FL',0,'0000-00-00 00:00:00',2),
	(11,223,'Georgia','GEA','GA',0,'0000-00-00 00:00:00',2),
	(12,223,'Hawaii','HWI','HI',0,'0000-00-00 00:00:00',2),
	(13,223,'Idaho','IDA','ID',0,'0000-00-00 00:00:00',2),
	(14,223,'Illinois','ILL','IL',0,'0000-00-00 00:00:00',2),
	(15,223,'Indiana','IND','IN',0,'0000-00-00 00:00:00',2),
	(16,223,'Iowa','IOA','IA',0,'0000-00-00 00:00:00',2),
	(17,223,'Kansas','KAS','KS',0,'0000-00-00 00:00:00',2),
	(18,223,'Kentucky','KTY','KY',0,'0000-00-00 00:00:00',2),
	(19,223,'Louisiana','LOA','LA',0,'0000-00-00 00:00:00',2),
	(20,223,'Maine','MAI','ME',0,'0000-00-00 00:00:00',2),
	(21,223,'Maryland','MLD','MD',0,'0000-00-00 00:00:00',2),
	(22,223,'Massachusetts','MSA','MA',0,'0000-00-00 00:00:00',2),
	(23,223,'Michigan','MIC','MI',0,'0000-00-00 00:00:00',2),
	(24,223,'Minnesota','MIN','MN',0,'0000-00-00 00:00:00',2),
	(25,223,'Mississippi','MIS','MS',0,'0000-00-00 00:00:00',2),
	(26,223,'Missouri','MIO','MO',0,'0000-00-00 00:00:00',2),
	(27,223,'Montana','MOT','MT',0,'0000-00-00 00:00:00',2),
	(28,223,'Nebraska','NEB','NE',0,'0000-00-00 00:00:00',2),
	(29,223,'Nevada','NEV','NV',0,'0000-00-00 00:00:00',2),
	(30,223,'New Hampshire','NEH','NH',0,'0000-00-00 00:00:00',2),
	(31,223,'New Jersey','NEJ','NJ',0,'0000-00-00 00:00:00',2),
	(32,223,'New Mexico','NEM','NM',0,'0000-00-00 00:00:00',2),
	(33,223,'New York','NEY','NY',0,'0000-00-00 00:00:00',2),
	(34,223,'North Carolina','NOC','NC',0,'0000-00-00 00:00:00',2),
	(35,223,'North Dakota','NOD','ND',0,'0000-00-00 00:00:00',2),
	(36,223,'Ohio','OHI','OH',0,'0000-00-00 00:00:00',2),
	(37,223,'Oklahoma','OKL','OK',0,'0000-00-00 00:00:00',2),
	(38,223,'Oregon','ORN','OR',0,'0000-00-00 00:00:00',2),
	(39,223,'Pennsylvania','PEA','PA',0,'0000-00-00 00:00:00',2),
	(40,223,'Rhode Island','RHI','RI',0,'0000-00-00 00:00:00',2),
	(41,223,'South Carolina','SOC','SC',0,'0000-00-00 00:00:00',2),
	(42,223,'South Dakota','SOD','SD',0,'0000-00-00 00:00:00',2),
	(43,223,'Tennessee','TEN','TN',0,'0000-00-00 00:00:00',2),
	(44,223,'Texas','TXS','TX',0,'0000-00-00 00:00:00',2),
	(45,223,'Utah','UTA','UT',0,'0000-00-00 00:00:00',2),
	(46,223,'Vermont','VMT','VT',0,'0000-00-00 00:00:00',2),
	(47,223,'Virginia','VIA','VA',0,'0000-00-00 00:00:00',2),
	(48,223,'Washington','WAS','WA',0,'0000-00-00 00:00:00',2),
	(49,223,'West Virginia','WEV','WV',0,'0000-00-00 00:00:00',2),
	(50,223,'Wisconsin','WIS','WI',0,'0000-00-00 00:00:00',2),
	(51,223,'Wyoming','WYO','WY',0,'0000-00-00 00:00:00',2),
	(52,38,'Alberta','ALB','AB',0,'0000-00-00 00:00:00',2),
	(53,38,'British Columbia','BRC','BC',0,'0000-00-00 00:00:00',2),
	(54,38,'Manitoba','MAB','MB',0,'0000-00-00 00:00:00',2),
	(55,38,'New Brunswick','NEB','NB',0,'0000-00-00 00:00:00',2),
	(56,38,'Newfoundland and Labrador','NFL','NL',0,'0000-00-00 00:00:00',2),
	(57,38,'Northwest Territories','NWT','NT',0,'0000-00-00 00:00:00',2),
	(58,38,'Nova Scotia','NOS','NS',0,'0000-00-00 00:00:00',2),
	(59,38,'Nunavut','NUT','NU',0,'0000-00-00 00:00:00',2),
	(60,38,'Ontario','ONT','ON',0,'0000-00-00 00:00:00',2),
	(61,38,'Prince Edward Island','PEI','PE',0,'0000-00-00 00:00:00',2),
	(62,38,'Quebec','QEC','QC',0,'0000-00-00 00:00:00',2),
	(63,38,'Saskatchewan','SAK','SK',0,'0000-00-00 00:00:00',2),
	(64,38,'Yukon','YUT','YT',0,'0000-00-00 00:00:00',2),
	(65,222,'England','ENG','EN',0,'0000-00-00 00:00:00',2),
	(66,222,'Northern Ireland','NOI','NI',0,'0000-00-00 00:00:00',2),
	(67,222,'Scotland','SCO','SD',0,'0000-00-00 00:00:00',2),
	(68,222,'Wales','WLS','WS',0,'0000-00-00 00:00:00',2),
	(69,13,'Australian Capital Territory','ACT','AT',0,'0000-00-00 00:00:00',2),
	(70,13,'New South Wales','NSW','NW',0,'0000-00-00 00:00:00',2),
	(71,13,'Northern Territory','NOT','NT',0,'0000-00-00 00:00:00',2),
	(72,13,'Queensland','QLD','QL',0,'0000-00-00 00:00:00',2),
	(73,13,'South Australia','SOA','SA',0,'0000-00-00 00:00:00',2),
	(74,13,'Tasmania','TAS','TA',0,'0000-00-00 00:00:00',2),
	(75,13,'Victoria','VIC','VI',0,'0000-00-00 00:00:00',2),
	(76,13,'Western Australia','WEA','WA',0,'0000-00-00 00:00:00',2),
	(77,138,'Aguascalientes','AGS','AG',0,'0000-00-00 00:00:00',2),
	(78,138,'Baja California Norte','BCN','BN',0,'0000-00-00 00:00:00',2),
	(79,138,'Baja California Sur','BCS','BS',0,'0000-00-00 00:00:00',2),
	(80,138,'Campeche','CAM','CA',0,'0000-00-00 00:00:00',2),
	(81,138,'Chiapas','CHI','CS',0,'0000-00-00 00:00:00',2),
	(82,138,'Chihuahua','CHA','CH',0,'0000-00-00 00:00:00',2),
	(83,138,'Coahuila','COA','CO',0,'0000-00-00 00:00:00',2),
	(84,138,'Colima','COL','CM',0,'0000-00-00 00:00:00',2),
	(85,138,'Distrito Federal','DFM','DF',0,'0000-00-00 00:00:00',2),
	(86,138,'Durango','DGO','DO',0,'0000-00-00 00:00:00',2),
	(87,138,'Guanajuato','GTO','GO',0,'0000-00-00 00:00:00',2),
	(88,138,'Guerrero','GRO','GU',0,'0000-00-00 00:00:00',2),
	(89,138,'Hidalgo','HGO','HI',0,'0000-00-00 00:00:00',2),
	(90,138,'Jalisco','JAL','JA',0,'0000-00-00 00:00:00',2),
	(91,138,'México (Estado de)','EDM','EM',0,'0000-00-00 00:00:00',2),
	(92,138,'Michoacán','MCN','MI',0,'0000-00-00 00:00:00',2),
	(93,138,'Morelos','MOR','MO',0,'0000-00-00 00:00:00',2),
	(94,138,'Nayarit','NAY','NY',0,'0000-00-00 00:00:00',2),
	(95,138,'Nuevo León','NUL','NL',0,'0000-00-00 00:00:00',2),
	(96,138,'Oaxaca','OAX','OA',0,'0000-00-00 00:00:00',2),
	(97,138,'Puebla','PUE','PU',0,'0000-00-00 00:00:00',2),
	(98,138,'Querétaro','QRO','QU',0,'0000-00-00 00:00:00',2),
	(99,138,'Quintana Roo','QUR','QR',0,'0000-00-00 00:00:00',2),
	(100,138,'San Luis Potosí','SLP','SP',0,'0000-00-00 00:00:00',2),
	(101,138,'Sinaloa','SIN','SI',0,'0000-00-00 00:00:00',2),
	(102,138,'Sonora','SON','SO',0,'0000-00-00 00:00:00',2),
	(103,138,'Tabasco','TAB','TA',0,'0000-00-00 00:00:00',2),
	(104,138,'Tamaulipas','TAM','TM',0,'0000-00-00 00:00:00',2),
	(105,138,'Tlaxcala','TLX','TX',0,'0000-00-00 00:00:00',2),
	(106,138,'Veracruz','VER','VZ',0,'0000-00-00 00:00:00',2),
	(107,138,'Yucatán','YUC','YU',0,'0000-00-00 00:00:00',2),
	(108,138,'Zacatecas','ZAC','ZA',0,'0000-00-00 00:00:00',2),
	(109,30,'Acre','ACR','AC',0,'0000-00-00 00:00:00',2),
	(110,30,'Alagoas','ALG','AL',0,'0000-00-00 00:00:00',2),
	(111,30,'Amapá','AMP','AP',0,'0000-00-00 00:00:00',2),
	(112,30,'Amazonas','AMZ','AM',0,'0000-00-00 00:00:00',2),
	(113,30,'Bahía','BAH','BA',0,'0000-00-00 00:00:00',2),
	(114,30,'Ceará','CEA','CE',0,'0000-00-00 00:00:00',2),
	(115,30,'Distrito Federal','DFB','DF',0,'0000-00-00 00:00:00',2),
	(116,30,'Espirito Santo','ESS','ES',0,'0000-00-00 00:00:00',2),
	(117,30,'Goiás','GOI','GO',0,'0000-00-00 00:00:00',2),
	(118,30,'Maranhão','MAR','MA',0,'0000-00-00 00:00:00',2),
	(119,30,'Mato Grosso','MAT','MT',0,'0000-00-00 00:00:00',2),
	(120,30,'Mato Grosso do Sul','MGS','MS',0,'0000-00-00 00:00:00',2),
	(121,30,'Minas Geraís','MIG','MG',0,'0000-00-00 00:00:00',2),
	(122,30,'Paraná','PAR','PR',0,'0000-00-00 00:00:00',2),
	(123,30,'Paraíba','PRB','PB',0,'0000-00-00 00:00:00',2),
	(124,30,'Pará','PAB','PA',0,'0000-00-00 00:00:00',2),
	(125,30,'Pernambuco','PER','PE',0,'0000-00-00 00:00:00',2),
	(126,30,'Piauí','PIA','PI',0,'0000-00-00 00:00:00',2),
	(127,30,'Rio Grande do Norte','RGN','RN',0,'0000-00-00 00:00:00',2),
	(128,30,'Rio Grande do Sul','RGS','RS',0,'0000-00-00 00:00:00',2),
	(129,30,'Rio de Janeiro','RDJ','RJ',0,'0000-00-00 00:00:00',2),
	(130,30,'Rondônia','RON','RO',0,'0000-00-00 00:00:00',2),
	(131,30,'Roraima','ROR','RR',0,'0000-00-00 00:00:00',2),
	(132,30,'Santa Catarina','SAC','SC',0,'0000-00-00 00:00:00',2),
	(133,30,'Sergipe','SER','SE',0,'0000-00-00 00:00:00',2),
	(134,30,'São Paulo','SAP','SP',0,'0000-00-00 00:00:00',2),
	(135,30,'Tocantins','TOC','TO',0,'0000-00-00 00:00:00',2),
	(136,44,'Anhui','ANH','34',0,'0000-00-00 00:00:00',2),
	(137,44,'Beijing','BEI','11',0,'0000-00-00 00:00:00',2),
	(138,44,'Chongqing','CHO','50',0,'0000-00-00 00:00:00',2),
	(139,44,'Fujian','FUJ','35',0,'0000-00-00 00:00:00',2),
	(140,44,'Gansu','GAN','62',0,'0000-00-00 00:00:00',2),
	(141,44,'Guangdong','GUA','44',0,'0000-00-00 00:00:00',2),
	(142,44,'Guangxi Zhuang','GUZ','45',0,'0000-00-00 00:00:00',2),
	(143,44,'Guizhou','GUI','52',0,'0000-00-00 00:00:00',2),
	(144,44,'Hainan','HAI','46',0,'0000-00-00 00:00:00',2),
	(145,44,'Hebei','HEB','13',0,'0000-00-00 00:00:00',2),
	(146,44,'Heilongjiang','HEI','23',0,'0000-00-00 00:00:00',2),
	(147,44,'Henan','HEN','41',0,'0000-00-00 00:00:00',2),
	(148,44,'Hubei','HUB','42',0,'0000-00-00 00:00:00',2),
	(149,44,'Hunan','HUN','43',0,'0000-00-00 00:00:00',2),
	(150,44,'Jiangsu','JIA','32',0,'0000-00-00 00:00:00',2),
	(151,44,'Jiangxi','JIX','36',0,'0000-00-00 00:00:00',2),
	(152,44,'Jilin','JIL','22',0,'0000-00-00 00:00:00',2),
	(153,44,'Liaoning','LIA','21',0,'0000-00-00 00:00:00',2),
	(154,44,'Nei Mongol','NML','15',0,'0000-00-00 00:00:00',2),
	(155,44,'Ningxia Hui','NIH','64',0,'0000-00-00 00:00:00',2),
	(156,44,'Qinghai','QIN','63',0,'0000-00-00 00:00:00',2),
	(157,44,'Shandong','SNG','37',0,'0000-00-00 00:00:00',2),
	(158,44,'Shanghai','SHH','31',0,'0000-00-00 00:00:00',2),
	(159,44,'Shaanxi','SHX','61',0,'0000-00-00 00:00:00',2),
	(160,44,'Sichuan','SIC','51',0,'0000-00-00 00:00:00',2),
	(161,44,'Tianjin','TIA','12',0,'0000-00-00 00:00:00',2),
	(162,44,'Xinjiang Uygur','XIU','65',0,'0000-00-00 00:00:00',2),
	(163,44,'Xizang','XIZ','54',0,'0000-00-00 00:00:00',2),
	(164,44,'Yunnan','YUN','53',0,'0000-00-00 00:00:00',2),
	(165,44,'Zhejiang','ZHE','33',0,'0000-00-00 00:00:00',2),
	(166,104,'Gaza Strip','GZS','GZ',0,'0000-00-00 00:00:00',2),
	(167,104,'West Bank','WBK','WB',0,'0000-00-00 00:00:00',2),
	(168,104,'Other','OTH','OT',0,'0000-00-00 00:00:00',2),
	(169,151,'St. Maarten','STM','SM',0,'0000-00-00 00:00:00',2),
	(170,151,'Bonaire','BNR','BN',0,'0000-00-00 00:00:00',2),
	(171,151,'Curacao','CUR','CR',0,'0000-00-00 00:00:00',2),
	(172,175,'Alba','ABA','AB',0,'0000-00-00 00:00:00',2),
	(173,175,'Arad','ARD','AR',0,'0000-00-00 00:00:00',2),
	(174,175,'Arges','ARG','AG',0,'0000-00-00 00:00:00',2),
	(175,175,'Bacau','BAC','BC',0,'0000-00-00 00:00:00',2),
	(176,175,'Bihor','BIH','BH',0,'0000-00-00 00:00:00',2),
	(177,175,'Bistrita-Nasaud','BIS','BN',0,'0000-00-00 00:00:00',2),
	(178,175,'Botosani','BOT','BT',0,'0000-00-00 00:00:00',2),
	(179,175,'Braila','BRL','BR',0,'0000-00-00 00:00:00',2),
	(180,175,'Brasov','BRA','BV',0,'0000-00-00 00:00:00',2),
	(181,175,'Bucuresti','BUC','B',0,'0000-00-00 00:00:00',2),
	(182,175,'Buzau','BUZ','BZ',0,'0000-00-00 00:00:00',2),
	(183,175,'Calarasi','CAL','CL',0,'0000-00-00 00:00:00',2),
	(184,175,'Caras Severin','CRS','CS',0,'0000-00-00 00:00:00',2),
	(185,175,'Cluj','CLJ','CJ',0,'0000-00-00 00:00:00',2),
	(186,175,'Constanta','CST','CT',0,'0000-00-00 00:00:00',2),
	(187,175,'Covasna','COV','CV',0,'0000-00-00 00:00:00',2),
	(188,175,'Dambovita','DAM','DB',0,'0000-00-00 00:00:00',2),
	(189,175,'Dolj','DLJ','DJ',0,'0000-00-00 00:00:00',2),
	(190,175,'Galati','GAL','GL',0,'0000-00-00 00:00:00',2),
	(191,175,'Giurgiu','GIU','GR',0,'0000-00-00 00:00:00',2),
	(192,175,'Gorj','GOR','GJ',0,'0000-00-00 00:00:00',2),
	(193,175,'Hargita','HRG','HR',0,'0000-00-00 00:00:00',2),
	(194,175,'Hunedoara','HUN','HD',0,'0000-00-00 00:00:00',2),
	(195,175,'Ialomita','IAL','IL',0,'0000-00-00 00:00:00',2),
	(196,175,'Iasi','IAS','IS',0,'0000-00-00 00:00:00',2),
	(197,175,'Ilfov','ILF','IF',0,'0000-00-00 00:00:00',2),
	(198,175,'Maramures','MAR','MM',0,'0000-00-00 00:00:00',2),
	(199,175,'Mehedinti','MEH','MH',0,'0000-00-00 00:00:00',2),
	(200,175,'Mures','MUR','MS',0,'0000-00-00 00:00:00',2),
	(201,175,'Neamt','NEM','NT',0,'0000-00-00 00:00:00',2),
	(202,175,'Olt','OLT','OT',0,'0000-00-00 00:00:00',2),
	(203,175,'Prahova','PRA','PH',0,'0000-00-00 00:00:00',2),
	(204,175,'Salaj','SAL','SJ',0,'0000-00-00 00:00:00',2),
	(205,175,'Satu Mare','SAT','SM',0,'0000-00-00 00:00:00',2),
	(206,175,'Sibiu','SIB','SB',0,'0000-00-00 00:00:00',2),
	(207,175,'Suceava','SUC','SV',0,'0000-00-00 00:00:00',2),
	(208,175,'Teleorman','TEL','TR',0,'0000-00-00 00:00:00',2),
	(209,175,'Timis','TIM','TM',0,'0000-00-00 00:00:00',2),
	(210,175,'Tulcea','TUL','TL',0,'0000-00-00 00:00:00',2),
	(211,175,'Valcea','VAL','VL',0,'0000-00-00 00:00:00',2),
	(212,175,'Vaslui','VAS','VS',0,'0000-00-00 00:00:00',2),
	(213,175,'Vrancea','VRA','VN',0,'0000-00-00 00:00:00',2),
	(214,105,'Agrigento','AGR','AG',0,'0000-00-00 00:00:00',2),
	(215,105,'Alessandria','ALE','AL',0,'0000-00-00 00:00:00',2),
	(216,105,'Ancona','ANC','AN',0,'0000-00-00 00:00:00',2),
	(217,105,'Aosta','AOS','AO',0,'0000-00-00 00:00:00',2),
	(218,105,'Arezzo','ARE','AR',0,'0000-00-00 00:00:00',2),
	(219,105,'Ascoli Piceno','API','AP',0,'0000-00-00 00:00:00',2),
	(220,105,'Asti','AST','AT',0,'0000-00-00 00:00:00',2),
	(221,105,'Avellino','AVE','AV',0,'0000-00-00 00:00:00',2),
	(222,105,'Bari','BAR','BA',0,'0000-00-00 00:00:00',2),
	(223,105,'Belluno','BEL','BL',0,'0000-00-00 00:00:00',2),
	(224,105,'Benevento','BEN','BN',0,'0000-00-00 00:00:00',2),
	(225,105,'Bergamo','BEG','BG',0,'0000-00-00 00:00:00',2),
	(226,105,'Biella','BIE','BI',0,'0000-00-00 00:00:00',2),
	(227,105,'Bologna','BOL','BO',0,'0000-00-00 00:00:00',2),
	(228,105,'Bolzano','BOZ','BZ',0,'0000-00-00 00:00:00',2),
	(229,105,'Brescia','BRE','BS',0,'0000-00-00 00:00:00',2),
	(230,105,'Brindisi','BRI','BR',0,'0000-00-00 00:00:00',2),
	(231,105,'Cagliari','CAG','CA',0,'0000-00-00 00:00:00',2),
	(232,105,'Caltanissetta','CAL','CL',0,'0000-00-00 00:00:00',2),
	(233,105,'Campobasso','CBO','CB',0,'0000-00-00 00:00:00',2),
	(234,105,'Carbonia-Iglesias','CAR','CI',0,'0000-00-00 00:00:00',2),
	(235,105,'Caserta','CAS','CE',0,'0000-00-00 00:00:00',2),
	(236,105,'Catania','CAT','CT',0,'0000-00-00 00:00:00',2),
	(237,105,'Catanzaro','CTZ','CZ',0,'0000-00-00 00:00:00',2),
	(238,105,'Chieti','CHI','CH',0,'0000-00-00 00:00:00',2),
	(239,105,'Como','COM','CO',0,'0000-00-00 00:00:00',2),
	(240,105,'Cosenza','COS','CS',0,'0000-00-00 00:00:00',2),
	(241,105,'Cremona','CRE','CR',0,'0000-00-00 00:00:00',2),
	(242,105,'Crotone','CRO','KR',0,'0000-00-00 00:00:00',2),
	(243,105,'Cuneo','CUN','CN',0,'0000-00-00 00:00:00',2),
	(244,105,'Enna','ENN','EN',0,'0000-00-00 00:00:00',2),
	(245,105,'Ferrara','FER','FE',0,'0000-00-00 00:00:00',2),
	(246,105,'Firenze','FIR','FI',0,'0000-00-00 00:00:00',2),
	(247,105,'Foggia','FOG','FG',0,'0000-00-00 00:00:00',2),
	(248,105,'Forli-Cesena','FOC','FC',0,'0000-00-00 00:00:00',2),
	(249,105,'Frosinone','FRO','FR',0,'0000-00-00 00:00:00',2),
	(250,105,'Genova','GEN','GE',0,'0000-00-00 00:00:00',2),
	(251,105,'Gorizia','GOR','GO',0,'0000-00-00 00:00:00',2),
	(252,105,'Grosseto','GRO','GR',0,'0000-00-00 00:00:00',2),
	(253,105,'Imperia','IMP','IM',0,'0000-00-00 00:00:00',2),
	(254,105,'Isernia','ISE','IS',0,'0000-00-00 00:00:00',2),
	(255,105,'L\'Aquila','AQU','AQ',0,'0000-00-00 00:00:00',2),
	(256,105,'La Spezia','LAS','SP',0,'0000-00-00 00:00:00',2),
	(257,105,'Latina','LAT','LT',0,'0000-00-00 00:00:00',2),
	(258,105,'Lecce','LEC','LE',0,'0000-00-00 00:00:00',2),
	(259,105,'Lecco','LCC','LC',0,'0000-00-00 00:00:00',2),
	(260,105,'Livorno','LIV','LI',0,'0000-00-00 00:00:00',2),
	(261,105,'Lodi','LOD','LO',0,'0000-00-00 00:00:00',2),
	(262,105,'Lucca','LUC','LU',0,'0000-00-00 00:00:00',2),
	(263,105,'Macerata','MAC','MC',0,'0000-00-00 00:00:00',2),
	(264,105,'Mantova','MAN','MN',0,'0000-00-00 00:00:00',2),
	(265,105,'Massa-Carrara','MAS','MS',0,'0000-00-00 00:00:00',2),
	(266,105,'Matera','MAA','MT',0,'0000-00-00 00:00:00',2),
	(267,105,'Medio Campidano','MED','VS',0,'0000-00-00 00:00:00',2),
	(268,105,'Messina','MES','ME',0,'0000-00-00 00:00:00',2),
	(269,105,'Milano','MIL','MI',0,'0000-00-00 00:00:00',2),
	(270,105,'Modena','MOD','MO',0,'0000-00-00 00:00:00',2),
	(271,105,'Napoli','NAP','NA',0,'0000-00-00 00:00:00',2),
	(272,105,'Novara','NOV','NO',0,'0000-00-00 00:00:00',2),
	(273,105,'Nuoro','NUR','NU',0,'0000-00-00 00:00:00',2),
	(274,105,'Ogliastra','OGL','OG',0,'0000-00-00 00:00:00',2),
	(275,105,'Olbia-Tempio','OLB','OT',0,'0000-00-00 00:00:00',2),
	(276,105,'Oristano','ORI','OR',0,'0000-00-00 00:00:00',2),
	(277,105,'Padova','PDA','PD',0,'0000-00-00 00:00:00',2),
	(278,105,'Palermo','PAL','PA',0,'0000-00-00 00:00:00',2),
	(279,105,'Parma','PAA','PR',0,'0000-00-00 00:00:00',2),
	(280,105,'Pavia','PAV','PV',0,'0000-00-00 00:00:00',2),
	(281,105,'Perugia','PER','PG',0,'0000-00-00 00:00:00',2),
	(282,105,'Pesaro e Urbino','PES','PU',0,'0000-00-00 00:00:00',2),
	(283,105,'Pescara','PSC','PE',0,'0000-00-00 00:00:00',2),
	(284,105,'Piacenza','PIA','PC',0,'0000-00-00 00:00:00',2),
	(285,105,'Pisa','PIS','PI',0,'0000-00-00 00:00:00',2),
	(286,105,'Pistoia','PIT','PT',0,'0000-00-00 00:00:00',2),
	(287,105,'Pordenone','POR','PN',0,'0000-00-00 00:00:00',2),
	(288,105,'Potenza','PTZ','PZ',0,'0000-00-00 00:00:00',2),
	(289,105,'Prato','PRA','PO',0,'0000-00-00 00:00:00',2),
	(290,105,'Ragusa','RAG','RG',0,'0000-00-00 00:00:00',2),
	(291,105,'Ravenna','RAV','RA',0,'0000-00-00 00:00:00',2),
	(292,105,'Reggio Calabria','REG','RC',0,'0000-00-00 00:00:00',2),
	(293,105,'Reggio Emilia','REE','RE',0,'0000-00-00 00:00:00',2),
	(294,105,'Rieti','RIE','RI',0,'0000-00-00 00:00:00',2),
	(295,105,'Rimini','RIM','RN',0,'0000-00-00 00:00:00',2),
	(296,105,'Roma','ROM','RM',0,'0000-00-00 00:00:00',2),
	(297,105,'Rovigo','ROV','RO',0,'0000-00-00 00:00:00',2),
	(298,105,'Salerno','SAL','SA',0,'0000-00-00 00:00:00',2),
	(299,105,'Sassari','SAS','SS',0,'0000-00-00 00:00:00',2),
	(300,105,'Savona','SAV','SV',0,'0000-00-00 00:00:00',2),
	(301,105,'Siena','SIE','SI',0,'0000-00-00 00:00:00',2),
	(302,105,'Siracusa','SIR','SR',0,'0000-00-00 00:00:00',2),
	(303,105,'Sondrio','SOO','SO',0,'0000-00-00 00:00:00',2),
	(304,105,'Taranto','TAR','TA',0,'0000-00-00 00:00:00',2),
	(305,105,'Teramo','TER','TE',0,'0000-00-00 00:00:00',2),
	(306,105,'Terni','TRN','TR',0,'0000-00-00 00:00:00',2),
	(307,105,'Torino','TOR','TO',0,'0000-00-00 00:00:00',2),
	(308,105,'Trapani','TRA','TP',0,'0000-00-00 00:00:00',2),
	(309,105,'Trento','TRE','TN',0,'0000-00-00 00:00:00',2),
	(310,105,'Treviso','TRV','TV',0,'0000-00-00 00:00:00',2),
	(311,105,'Trieste','TRI','TS',0,'0000-00-00 00:00:00',2),
	(312,105,'Udine','UDI','UD',0,'0000-00-00 00:00:00',2),
	(313,105,'Varese','VAR','VA',0,'0000-00-00 00:00:00',2),
	(314,105,'Venezia','VEN','VE',0,'0000-00-00 00:00:00',2),
	(315,105,'Verbano Cusio Ossola','VCO','VB',0,'0000-00-00 00:00:00',2),
	(316,105,'Vercelli','VER','VC',0,'0000-00-00 00:00:00',2),
	(317,105,'Verona','VRN','VR',0,'0000-00-00 00:00:00',2),
	(318,105,'Vibo Valenzia','VIV','VV',0,'0000-00-00 00:00:00',2),
	(319,105,'Vicenza','VII','VI',0,'0000-00-00 00:00:00',2),
	(320,105,'Viterbo','VIT','VT',0,'0000-00-00 00:00:00',2),
	(321,195,'A Coruña','ACO','15',0,'0000-00-00 00:00:00',2),
	(322,195,'Alava','ALA','01',0,'0000-00-00 00:00:00',2),
	(323,195,'Albacete','ALB','02',0,'0000-00-00 00:00:00',2),
	(324,195,'Alicante','ALI','03',0,'0000-00-00 00:00:00',2),
	(325,195,'Almeria','ALM','04',0,'0000-00-00 00:00:00',2),
	(326,195,'Asturias','AST','33',0,'0000-00-00 00:00:00',2),
	(327,195,'Avila','AVI','05',0,'0000-00-00 00:00:00',2),
	(328,195,'Badajoz','BAD','06',0,'0000-00-00 00:00:00',2),
	(329,195,'Baleares','BAL','07',0,'0000-00-00 00:00:00',2),
	(330,195,'Barcelona','BAR','08',0,'0000-00-00 00:00:00',2),
	(331,195,'Burgos','BUR','09',0,'0000-00-00 00:00:00',2),
	(332,195,'Caceres','CAC','10',0,'0000-00-00 00:00:00',2),
	(333,195,'Cadiz','CAD','11',0,'0000-00-00 00:00:00',2),
	(334,195,'Cantabria','CAN','39',0,'0000-00-00 00:00:00',2),
	(335,195,'Castellon','CAS','12',0,'0000-00-00 00:00:00',2),
	(336,195,'Ceuta','CEU','51',0,'0000-00-00 00:00:00',2),
	(337,195,'Ciudad Real','CIU','13',0,'0000-00-00 00:00:00',2),
	(338,195,'Cordoba','COR','14',0,'0000-00-00 00:00:00',2),
	(339,195,'Cuenca','CUE','16',0,'0000-00-00 00:00:00',2),
	(340,195,'Girona','GIR','17',0,'0000-00-00 00:00:00',2),
	(341,195,'Granada','GRA','18',0,'0000-00-00 00:00:00',2),
	(342,195,'Guadalajara','GUA','19',0,'0000-00-00 00:00:00',2),
	(343,195,'Guipuzcoa','GUI','20',0,'0000-00-00 00:00:00',2),
	(344,195,'Huelva','HUL','21',0,'0000-00-00 00:00:00',2),
	(345,195,'Huesca','HUS','22',0,'0000-00-00 00:00:00',2),
	(346,195,'Jaen','JAE','23',0,'0000-00-00 00:00:00',2),
	(347,195,'La Rioja','LRI','26',0,'0000-00-00 00:00:00',2),
	(348,195,'Las Palmas','LPA','35',0,'0000-00-00 00:00:00',2),
	(349,195,'Leon','LEO','24',0,'0000-00-00 00:00:00',2),
	(350,195,'Lleida','LLE','25',0,'0000-00-00 00:00:00',2),
	(351,195,'Lugo','LUG','27',0,'0000-00-00 00:00:00',2),
	(352,195,'Madrid','MAD','28',0,'0000-00-00 00:00:00',2),
	(353,195,'Malaga','MAL','29',0,'0000-00-00 00:00:00',2),
	(354,195,'Melilla','MEL','52',0,'0000-00-00 00:00:00',2),
	(355,195,'Murcia','MUR','30',0,'0000-00-00 00:00:00',2),
	(356,195,'Navarra','NAV','31',0,'0000-00-00 00:00:00',2),
	(357,195,'Ourense','OUR','32',0,'0000-00-00 00:00:00',2),
	(358,195,'Palencia','PAL','34',0,'0000-00-00 00:00:00',2),
	(359,195,'Pontevedra','PON','36',0,'0000-00-00 00:00:00',2),
	(360,195,'Salamanca','SAL','37',0,'0000-00-00 00:00:00',2),
	(361,195,'Santa Cruz de Tenerife','SCT','38',0,'0000-00-00 00:00:00',2),
	(362,195,'Segovia','SEG','40',0,'0000-00-00 00:00:00',2),
	(363,195,'Sevilla','SEV','41',0,'0000-00-00 00:00:00',2),
	(364,195,'Soria','SOR','42',0,'0000-00-00 00:00:00',2),
	(365,195,'Tarragona','TAR','43',0,'0000-00-00 00:00:00',2),
	(366,195,'Teruel','TER','44',0,'0000-00-00 00:00:00',2),
	(367,195,'Toledo','TOL','45',0,'0000-00-00 00:00:00',2),
	(368,195,'Valencia','VAL','46',0,'0000-00-00 00:00:00',2),
	(369,195,'Valladolid','VLL','47',0,'0000-00-00 00:00:00',2),
	(370,195,'Vizcaya','VIZ','48',0,'0000-00-00 00:00:00',2),
	(371,195,'Zamora','ZAM','49',0,'0000-00-00 00:00:00',2),
	(372,195,'Zaragoza','ZAR','50',0,'0000-00-00 00:00:00',2),
	(373,11,'Aragatsotn','ARG','AG',0,'0000-00-00 00:00:00',2),
	(374,11,'Ararat','ARR','AR',0,'0000-00-00 00:00:00',2),
	(375,11,'Armavir','ARM','AV',0,'0000-00-00 00:00:00',2),
	(376,11,'Gegharkunik','GEG','GR',0,'0000-00-00 00:00:00',2),
	(377,11,'Kotayk','KOT','KT',0,'0000-00-00 00:00:00',2),
	(378,11,'Lori','LOR','LO',0,'0000-00-00 00:00:00',2),
	(379,11,'Shirak','SHI','SH',0,'0000-00-00 00:00:00',2),
	(380,11,'Syunik','SYU','SU',0,'0000-00-00 00:00:00',2),
	(381,11,'Tavush','TAV','TV',0,'0000-00-00 00:00:00',2),
	(382,11,'Vayots-Dzor','VAD','VD',0,'0000-00-00 00:00:00',2),
	(383,11,'Yerevan','YER','ER',0,'0000-00-00 00:00:00',2),
	(384,99,'Andaman & Nicobar Islands','ANI','AI',0,'0000-00-00 00:00:00',2),
	(385,99,'Andhra Pradesh','AND','AN',0,'0000-00-00 00:00:00',2),
	(386,99,'Arunachal Pradesh','ARU','AR',0,'0000-00-00 00:00:00',2),
	(387,99,'Assam','ASS','AS',0,'0000-00-00 00:00:00',2),
	(388,99,'Bihar','BIH','BI',0,'0000-00-00 00:00:00',2),
	(389,99,'Chandigarh','CHA','CA',0,'0000-00-00 00:00:00',2),
	(390,99,'Chhatisgarh','CHH','CH',0,'0000-00-00 00:00:00',2),
	(391,99,'Dadra & Nagar Haveli','DAD','DD',0,'0000-00-00 00:00:00',2),
	(392,99,'Daman & Diu','DAM','DA',0,'0000-00-00 00:00:00',2),
	(393,99,'Delhi','DEL','DE',0,'0000-00-00 00:00:00',2),
	(394,99,'Goa','GOA','GO',0,'0000-00-00 00:00:00',2),
	(395,99,'Gujarat','GUJ','GU',0,'0000-00-00 00:00:00',2),
	(396,99,'Haryana','HAR','HA',0,'0000-00-00 00:00:00',2),
	(397,99,'Himachal Pradesh','HIM','HI',0,'0000-00-00 00:00:00',2),
	(398,99,'Jammu & Kashmir','JAM','JA',0,'0000-00-00 00:00:00',2),
	(399,99,'Jharkhand','JHA','JH',0,'0000-00-00 00:00:00',2),
	(400,99,'Karnataka','KAR','KA',0,'0000-00-00 00:00:00',2),
	(401,99,'Kerala','KER','KE',0,'0000-00-00 00:00:00',2),
	(402,99,'Lakshadweep','LAK','LA',0,'0000-00-00 00:00:00',2),
	(403,99,'Madhya Pradesh','MAD','MD',0,'0000-00-00 00:00:00',2),
	(404,99,'Maharashtra','MAH','MH',0,'0000-00-00 00:00:00',2),
	(405,99,'Manipur','MAN','MN',0,'0000-00-00 00:00:00',2),
	(406,99,'Meghalaya','MEG','ME',0,'0000-00-00 00:00:00',2),
	(407,99,'Mizoram','MIZ','MI',0,'0000-00-00 00:00:00',2),
	(408,99,'Nagaland','NAG','NA',0,'0000-00-00 00:00:00',2),
	(409,99,'Orissa','ORI','OR',0,'0000-00-00 00:00:00',2),
	(410,99,'Pondicherry','PON','PO',0,'0000-00-00 00:00:00',2),
	(411,99,'Punjab','PUN','PU',0,'0000-00-00 00:00:00',2),
	(412,99,'Rajasthan','RAJ','RA',0,'0000-00-00 00:00:00',2),
	(413,99,'Sikkim','SIK','SI',0,'0000-00-00 00:00:00',2),
	(414,99,'Tamil Nadu','TAM','TA',0,'0000-00-00 00:00:00',2),
	(415,99,'Tripura','TRI','TR',0,'0000-00-00 00:00:00',2),
	(416,99,'Uttaranchal','UAR','UA',0,'0000-00-00 00:00:00',2),
	(417,99,'Uttar Pradesh','UTT','UT',0,'0000-00-00 00:00:00',2),
	(418,99,'West Bengal','WES','WE',0,'0000-00-00 00:00:00',2),
	(419,101,'Ahmadi va Kohkiluyeh','BOK','BO',0,'0000-00-00 00:00:00',2),
	(420,101,'Ardabil','ARD','AR',0,'0000-00-00 00:00:00',2),
	(421,101,'Azarbayjan-e Gharbi','AZG','AG',0,'0000-00-00 00:00:00',2),
	(422,101,'Azarbayjan-e Sharqi','AZS','AS',0,'0000-00-00 00:00:00',2),
	(423,101,'Bushehr','BUS','BU',0,'0000-00-00 00:00:00',2),
	(424,101,'Chaharmahal va Bakhtiari','CMB','CM',0,'0000-00-00 00:00:00',2),
	(425,101,'Esfahan','ESF','ES',0,'0000-00-00 00:00:00',2),
	(426,101,'Fars','FAR','FA',0,'0000-00-00 00:00:00',2),
	(427,101,'Gilan','GIL','GI',0,'0000-00-00 00:00:00',2),
	(428,101,'Gorgan','GOR','GO',0,'0000-00-00 00:00:00',2),
	(429,101,'Hamadan','HAM','HA',0,'0000-00-00 00:00:00',2),
	(430,101,'Hormozgan','HOR','HO',0,'0000-00-00 00:00:00',2),
	(431,101,'Ilam','ILA','IL',0,'0000-00-00 00:00:00',2),
	(432,101,'Kerman','KER','KE',0,'0000-00-00 00:00:00',2),
	(433,101,'Kermanshah','BAK','BA',0,'0000-00-00 00:00:00',2),
	(434,101,'Khorasan-e Junoubi','KHJ','KJ',0,'0000-00-00 00:00:00',2),
	(435,101,'Khorasan-e Razavi','KHR','KR',0,'0000-00-00 00:00:00',2),
	(436,101,'Khorasan-e Shomali','KHS','KS',0,'0000-00-00 00:00:00',2),
	(437,101,'Khuzestan','KHU','KH',0,'0000-00-00 00:00:00',2),
	(438,101,'Kordestan','KOR','KO',0,'0000-00-00 00:00:00',2),
	(439,101,'Lorestan','LOR','LO',0,'0000-00-00 00:00:00',2),
	(440,101,'Markazi','MAR','MR',0,'0000-00-00 00:00:00',2),
	(441,101,'Mazandaran','MAZ','MZ',0,'0000-00-00 00:00:00',2),
	(442,101,'Qazvin','QAS','QA',0,'0000-00-00 00:00:00',2),
	(443,101,'Qom','QOM','QO',0,'0000-00-00 00:00:00',2),
	(444,101,'Semnan','SEM','SE',0,'0000-00-00 00:00:00',2),
	(445,101,'Sistan va Baluchestan','SBA','SB',0,'0000-00-00 00:00:00',2),
	(446,101,'Tehran','TEH','TE',0,'0000-00-00 00:00:00',2),
	(447,101,'Yazd','YAZ','YA',0,'0000-00-00 00:00:00',2),
	(448,101,'Zanjan','ZAN','ZA',0,'0000-00-00 00:00:00',2),
	(449,170,'Dolnośląskie','DOL','DO',0,'0000-00-00 00:00:00',2),
	(450,170,'Kujawsko-Pomorskie','KUJ','KU',0,'0000-00-00 00:00:00',2),
	(451,170,'Lubelskie','LUB','LU',0,'0000-00-00 00:00:00',2),
	(452,170,'Lubuskie','LBU','LB',0,'0000-00-00 00:00:00',2),
	(453,170,'Łódzkie','LOD','LO',0,'0000-00-00 00:00:00',2),
	(454,170,'Małopolskie','MAL','MP',0,'0000-00-00 00:00:00',2),
	(455,170,'Mazowieckie','MAZ','MZ',0,'0000-00-00 00:00:00',2),
	(456,170,'Opolskie','OPO','OP',0,'0000-00-00 00:00:00',2),
	(457,170,'Podkarpackie','PDK','PK',0,'0000-00-00 00:00:00',2),
	(458,170,'Podlaskie','PDL','PL',0,'0000-00-00 00:00:00',2),
	(459,170,'Pomorskie','POM','PO',0,'0000-00-00 00:00:00',2),
	(460,170,'Śląskie','SLA','SL',0,'0000-00-00 00:00:00',2),
	(461,170,'Świętokrzyskie','SWI','SW',0,'0000-00-00 00:00:00',2),
	(462,170,'Warmińsko-Mazurskie','WAR','WA',0,'0000-00-00 00:00:00',2),
	(463,170,'Wielkopolskie','WIE','WI',0,'0000-00-00 00:00:00',2),
	(464,170,'Zachodniopomorskie','ZAC','ZA',0,'0000-00-00 00:00:00',2);

/*!40000 ALTER TABLE `#__redshop_state` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_stockroom
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_stockroom`;

CREATE TABLE `#__redshop_stockroom` (
  `stockroom_id` int(11) NOT NULL AUTO_INCREMENT,
  `stockroom_name` varchar(250) NOT NULL,
  `stockroom_desc` longtext CHARACTER SET latin1 NOT NULL,
  `creation_date` double NOT NULL,
  `min_del_time` int(11) NOT NULL,
  `max_del_time` int(11) NOT NULL,
  `show_in_front` tinyint(1) NOT NULL,
  `delivery_time` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`stockroom_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Stockroom';

LOCK TABLES `#__redshop_stockroom` WRITE;
/*!40000 ALTER TABLE `#__redshop_stockroom` DISABLE KEYS */;

INSERT INTO `#__redshop_stockroom` (`stockroom_id`, `stockroom_name`, `stockroom_desc`, `creation_date`, `min_del_time`, `max_del_time`, `show_in_front`, `delivery_time`, `published`)
VALUES
	(1,'default','This is redshop default stockroom',0,0,0,0,'',1);

/*!40000 ALTER TABLE `#__redshop_stockroom` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_stockroom_amount_image
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_stockroom_amount_image`;

CREATE TABLE `#__redshop_stockroom_amount_image` (
  `stock_amount_id` int(11) NOT NULL AUTO_INCREMENT,
  `stockroom_id` int(11) NOT NULL,
  `stock_option` tinyint(4) NOT NULL,
  `stock_quantity` int(11) NOT NULL,
  `stock_amount_image` varchar(255) NOT NULL,
  `stock_amount_image_tooltip` text NOT NULL,
  PRIMARY KEY (`stock_amount_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP stockroom amount image';



# Dump of table #__redshop_stockroom_container_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_stockroom_container_xref`;

CREATE TABLE `#__redshop_stockroom_container_xref` (
  `stockroom_id` int(11) NOT NULL,
  `container_id` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Stockroom Container Relation';



# Dump of table #__redshop_subscription_renewal
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_subscription_renewal`;

CREATE TABLE `#__redshop_subscription_renewal` (
  `renewal_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `before_no_days` int(11) NOT NULL,
  PRIMARY KEY (`renewal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Subscription Renewal';

LOCK TABLES `#__redshop_subscription_renewal` WRITE;
/*!40000 ALTER TABLE `#__redshop_subscription_renewal` DISABLE KEYS */;

INSERT INTO `#__redshop_subscription_renewal` (`renewal_id`, `product_id`, `before_no_days`)
VALUES
	(1,20,1),
	(2,21,1),
	(3,22,1),
	(4,23,1),
	(5,24,1);

/*!40000 ALTER TABLE `#__redshop_subscription_renewal` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_supplier
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_supplier`;

CREATE TABLE `#__redshop_supplier` (
  `supplier_id` int(11) NOT NULL AUTO_INCREMENT,
  `supplier_name` varchar(250) NOT NULL,
  `supplier_desc` longtext NOT NULL,
  `supplier_email` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`supplier_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Supplier';



# Dump of table #__redshop_tax_group
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_tax_group`;

CREATE TABLE `#__redshop_tax_group` (
  `tax_group_id` int(11) NOT NULL AUTO_INCREMENT,
  `tax_group_name` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`tax_group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Tax Group';

LOCK TABLES `#__redshop_tax_group` WRITE;
/*!40000 ALTER TABLE `#__redshop_tax_group` DISABLE KEYS */;

INSERT INTO `#__redshop_tax_group` (`tax_group_id`, `tax_group_name`, `published`)
VALUES
	(1,'Default',1);

/*!40000 ALTER TABLE `#__redshop_tax_group` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_tax_rate
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_tax_rate`;

CREATE TABLE `#__redshop_tax_rate` (
  `tax_rate_id` int(11) NOT NULL AUTO_INCREMENT,
  `tax_state` varchar(64) DEFAULT NULL,
  `tax_country` varchar(64) DEFAULT NULL,
  `mdate` int(11) DEFAULT NULL,
  `tax_rate` decimal(10,4) DEFAULT NULL,
  `tax_group_id` int(11) NOT NULL,
  `is_eu_country` tinyint(4) NOT NULL,
  PRIMARY KEY (`tax_rate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Tax Rates';



# Dump of table #__redshop_template
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_template`;

CREATE TABLE `#__redshop_template` (
  `template_id` int(11) NOT NULL AUTO_INCREMENT,
  `template_name` varchar(250) NOT NULL,
  `template_section` varchar(250) NOT NULL,
  `template_desc` longtext NOT NULL,
  `order_status` varchar(250) NOT NULL,
  `payment_methods` varchar(250) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `shipping_methods` varchar(255) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  PRIMARY KEY (`template_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Templates Detail';

LOCK TABLES `#__redshop_template` WRITE;
/*!40000 ALTER TABLE `#__redshop_template` DISABLE KEYS */;

INSERT INTO `#__redshop_template` (`template_id`, `template_name`, `template_section`, `template_desc`, `order_status`, `payment_methods`, `published`, `shipping_methods`, `checked_out`, `checked_out_time`)
VALUES
	(5,'category_template','category','<div>{print}</div>\n<div>{filter_by_lbl}{filter_by}</div>\n<div>{redproductfinderfilter_formstart} {redproductfinderfilter:rp_myfilter} {redproductfinderfilter_formend}</div>\n<div>{order_by_lbl}{order_by}</div>\n<div>{template_selector_category_lbl}{template_selector_category}</div>\n<div>{product_price_slider}</div>\n<p> </p>\n<div class=\"category_main_description\">{category_main_name}</div>\n<div class=\"category_main_description\">{category_main_thumb_image}</div>\n<div class=\"category_main_description\">{category_main_description}</div>\n<div>{if subcats}\n<div>{category_loop_start}\n<div id=\"categories\">\n<div style=\"float: left; width: 200px;\">\n<div class=\"category_image\">{category_thumb_image}</div>\n<div class=\"category_description\">\n<h2 class=\"category_title\">{category_name}</h2>\n</div>\n<div class=\"category_description\">{category_readmore}</div>\n<div class=\"category_description\">{category_description}</div>\n</div>\n</div>\n{category_loop_end}</div>\n{subcats end if}</div>\n<div class=\"category_box_wrapper\">{product_loop_start}\n<div class=\"category_box_outside\">\n<div class=\"category_box_inside\">\n<table border=\"0\">\n<tbody>\n<tr>\n<td>\n<div class=\"category_product_image\">{product_thumb_image}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_title\">\n<h3>{product_name}</h3>\n</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_price\">{product_price}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_readmore\">{read_more}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_addtocart\">{attribute_template:attributes}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_addtocart\">{form_addtocart:add_to_cart1}</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</div>\n{product_loop_end}</div>\n<div class=\"category_pagination\">{pagination}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(8,'category_template2','category','<div class=\"category_box_wrapper\">{product_loop_start}<div class=\"category_box_outside\"><div class=\"category_box_inside\"><table border=\"0\"><tbody><tr><td><div class=\"category_product_image\">{product_thumb_image}</div></td></tr><tr><td><div class=\"category_product_title\"><h3>{product_name}</h3></div></td></tr><tr><td><div class=\"category_product_price\">{product_price}</div></td></tr><tr><td><div class=\"category_product_readmore\">{read_more}</div></td></tr><tr><td><div class=\"category_product_addtocart\">{attribute_template:attributes}</div></td></tr><tr><td><div class=\"category_product_addtocart\">{form_addtocart:add_to_cart1}</div></td></tr></tbody></table></div></div>{product_loop_end}</div><div class=\"category_pagination\" style=\"clear: both;\">{pagination}{perpagelimit:6}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(9,'product','product','<p>{rs_model}</p>\r\n<div class=\"product\">\r\n<div class=\"next-prev\">\r\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n<tbody>\r\n<tr>\r\n<td style=\"width: 33%; height: 20px;\" align=\"left\" valign=\"middle\">{navigation_link_left}</td>\r\n<td style=\"width: 33%; height: 20px;\" align=\"center\" valign=\"middle\">{returntocategory}</td>\r\n<td style=\"width: 33%; height: 20px;\" align=\"right\" valign=\"middle\">{navigation_link_right}</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</div>\r\n<div class=\"product_rating_summary\">{product_rating_summary}</div>\r\n<div class=\"product_writereview\">{form_rating}</div>\r\n<div class=\"product_box\">\r\n<div class=\"product_box_inside\">\r\n<div class=\"product_box_left\">\r\n<div class=\"product_image\">{product_thumb_image}<br />View Full-Size Image</div>\r\n<div class=\"product_more_images\">{more_images}</div>\r\n</div>\r\n<div class=\"product_box_right\">\r\n<div id=\"product_price\" class=\"product_price\">{product_price}</div>\r\n<div class=\"product_attributter\">{attribute_template:attributes}</div>\r\n{if product_userfield}\r\n<div class=\"product_userfield\">{userfield-test_lbl}: {userfield-test}</div>\r\n{product_userfield end if}\r\n<div class=\"product_accessory\">{accessory_template:accessory}</div>\r\n<div class=\"product_addtocart\">{form_addtocart:add_to_cart2}</div>\r\n<div class=\"product_manufacturer_link\">{manufacturer_link}</div>\r\n<div class=\"product_question_link\">{ask_question_about_product}</div>\r\n</div>\r\n</div>\r\n<div class=\"product_desc_wrapper\">\r\n<div class=\"product_title\">\r\n<h2>{product_name}</h2>\r\n</div>\r\n<div class=\"product_desc_short\">{product_s_desc}</div>\r\n<div class=\"product_desc_full\">{product_desc}</div>\r\n</div>\r\n<div class=\"product_related_products\">{related_product:related_products}</div>\r\n</div>\r\n</div>\r\n<p>{question_loop_start}{question} - {question_owner} - {question_date}{answer_loop_start}{answer} - {answer_owner} - {answer_date}{answer_loop_end}{question_loop_end}</p>','','',1,'',0,'0000-00-00 00:00:00'),
	(10,'cart','cart','<h1>{cart_lbl}</h1>\n<div class=\"category_print\">{print}</div>\n<table class=\"tdborder\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<thead>\n<tr>\n<th>{product_name_lbl}</th> <th> <br /></th><th>{price_lbl} </th><th>{product_price_excl_lbl}</th><th>{quantity_lbl}</th><th>{total_price_lbl}</th><th>Total Price excl price</th>\n</tr>\n</thead>\n<tbody>\n{product_loop_start}\n<div class=\"category_print\">{attribute_price_with_vat}</div>\n<tr class=\"tdborder\">\n<td>\n<div class=\"cartproducttitle\">{product_name}</div>\n<div class=\"cartproducttitle\">{product_old_price}</div>\n<div class=\"cartattribut\">{product_attribute}</div>\n<div class=\"cartaccessory\">{product_accessory}</div>\n<div class=\"cartwrapper\">{product_wrapper}</div>\n<div class=\"cartuserfields\">{product_userfields}</div>\n<div>{attribute_change}</div>\n</td>\n<td>{product_thumb_image}</td>\n<td>{product_price}<div>{vat_info}</div></td>\n<td>{product_price_excl_vat}</td>\n<td>\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{update_cart}</td>\n<td>{remove_product}</td>\n</tr>\n</tbody>\n</table>\n</td>\n<td>{product_total_price}</td>\n<td>{product_total_price_excl_vat}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n<p><strong class=\"discount_text\"><br /></strong></p>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tbody>\n<tr>\n<td width=\"50%\" valign=\"top\">\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{update}</td>\n<td>{empty_cart}</td>\n</tr>\n<tr>\n<td class=\"cart_discount_form\" colspan=\"2\">{discount_form_lbl}{coupon_code_lbl}<br />{discount_form}</td>\n</tr>\n</tbody>\n</table>\n<br /></td>\n<td width=\"50%\" align=\"right\" valign=\"top\"><br /><br />\n<table class=\"cart_calculations\" border=\"0\" width=\"100%\">\n<tbody>\n<tr class=\"tdborder\">\n<td><b>{product_subtotal_lbl}:</b></td>\n<td width=\"100\">{product_subtotal}</td>\n<td><b>{product_subtotal_excl_vat_lbl}:</b></td>\n<td width=\"100\">{product_subtotal_excl_vat}</td>\n</tr>\n<tr >\n<td><b>{shipping_with_vat_lbl}:</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>{shipping_excl_vat_lbl}:</b></td>\n<td width=\"100\">{shipping_excl_vat}{shipping_denotation}</td>\n</tr>\n{if discount}\n<tr class=\"tdborder\">\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount}</td>\n\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount_excl_vat}{discount_denotation}</td>\n</tr>\n\n{discount end if}\n<tr class=\"tdborder\">\n<td><b>{totalpurchase_lbl}:</b></td>\n<td width=\"100\">{subtotal}</td>\n<td><b>{subtotal_excl_vat_lbl} :</b></td>\n<td width=\"100\">{subtotal_excl_vat}</td>\n</tr>\n\n{if vat}\n<tr>\n<td>{vat_lbl}</td>\n<td width=\"100\">{tax}</td>\n<td>{vat_lbl}</td>\n<td width=\"100\">{sub_total_vat}</td>\n</tr>\n{vat end if}   {if payment_discount}\n<tr>\n<td>{payment_discount_lbl}</td>\n<td width=\"100\">{payment_order_discount}</td>\n</tr>\n{payment_discount end if}\n<tr>\n<td>\n<div class=\"singleline\"><strong>{total_lbl}:</strong></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{total}</div>\n</td>\n<td>\n<div class=\"singleline\"><b>{total_lbl}:</b></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{total_excl_vat}</div>\n</td>\n</tr>\n<tr>\n<td colspan=\"4\">\n<strong>{denotation_label}</strong></div>\n</td>\n</tr>\n</tbody>\n</table>\n\n{checkout}<br /><br /> {shop_more}</td>\n</tr>\n</tbody>\n</table>','','',1,'',0,'0000-00-00 00:00:00'),
	(11,'review','review','<div>{product_loop_start}\n<p><strong>{product_title}</strong></p>\n<div>{review_loop_start}\n<div id=\"reviews_wrapper\">\n<div id=\"reviews_rightside\">\n<div id=\"reviews_fullname\">{fullname}</div>\n<div id=\"reviews_title\">{title}</div>\n<div id=\"reviews_comment\">{comment}</div>\n</div>\n<div id=\"reviews_leftside\">\n<div id=\"reviews_stars\">{stars}</div>\n</div>\n</div>\n{review_loop_end}\n<div>{product_loop_end}</div>\n</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(13,'manufacturer_listings','manufacturer','<div class=\"category_print\">{print}</div>\n<div id=\"category_header\">\n<div class=\"category_order_by\">{order_by}</div>\n</div>\n<div class=\"manufacturer_box_wrapper\">{manufacturer_loop_start}\n<div class=\"manufacturer_box_outside\">\n<div class=\"manufacturer_box_inside\">\n<div class=\"manufacturer_image\">{manufacturer_image}</div>\n<div class=\"manufacturer_title\">\n<h3>{manufacturer_name}</h3>\n</div>\n<div class=\"manufacturer_desc\">{manufacturer_description}</div>\n<div class=\"manufacturer_link\"><a href=\"{manufacturer_link}\">Read more about the designer</a></div>\n<div class=\"manufacturer_product_link\"><a href=\"{manufacturer_allproductslink}\">See all the designers products</a></div>\n</div>\n</div>\n{manufacturer_loop_end}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(14,'manufacturer_products','manufacturer_products','<div class=\"category_print\">{print}</div>\n<div class=\"manufacturer_name\">{manufacturer_name}</div>\n<div class=\"manufacturer_image\">{manufacturer_image}</div>\n<div class=\"manufacturer_description\">{manufacturer_description}</div>\n<div id=\"category_header\">\n<div class=\"category_order_by\">{order_by}</div>\n</div>\n<div class=\"category_box_wrapper\">{product_loop_start}\n<div class=\"category_box_outside\">\n<div class=\"category_box_inside\">{category_heading_start} {category_name}{category_heading_end}\n<div class=\"category_product_image\">{product_thumb_image_1}</div>\n<div class=\"category_product_title\">\n<h3>{product_name}</h3>\n</div>\n<div class=\"category_product_price\">{product_price}</div>\n<div class=\"category_product_readmore\">{read_more}</div>\n</div>\n</div>\n{product_loop_end}</div>\n<div class=\"category_pagination\">{pagination}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(15,'order_list','order_list','<table border=\"0\" cellspacing=\"5\" cellpadding=\"5\" width=\"100%\">\n<tbody>\n<tr>\n<th>{order_id_lbl}</th> <th>{product_name_lbl}</th> <th>{total_price_lbl}</th> <th>{order_date_lbl}</th> <th>{order_status_lbl}</th> <th>{order_detail_lbl}</th>\n</tr>\n{product_loop_start}     \n<tr>\n<td style=\"background-color: #d7d7d4\">{order_id}</td>\n<td style=\"background-color: #d7d7d4\">{order_products}</td>\n<td style=\"background-color: #d7d7d4\">{order_total}</td>\n<td style=\"background-color: #d7d7d4\">{order_date}</td>\n<td style=\"background-color: #d7d7d4\">{order_status}</td>\n<td style=\"background-color: #d7d7d4\">{order_detail_link}{reorder_link}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n{pagination}\n','','',1,'',0,'0000-00-00 00:00:00'),
	(16,'order_detail','order_detail','<div class=\"product_print\">{print}</div>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tbody>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{discount_type_lbl}</th>\n</tr>\n<tr>\n<td>{discount_type}</td>\n</tr>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{order_information_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{order_id_lbl} : {order_id}</td>\n</tr>\n<tr>\n<td>{order_number_lbl} : {order_number}</td>\n</tr>\n<tr>\n<td>{order_date_lbl} : {order_date}</td>\n</tr>\n<tr>\n<td>{order_status_lbl} : {order_status}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{billing_address_information_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{billing_address}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{shipping_address_information_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{shipping_address}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{order_detail_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\">\n<tbody>\n<tr>\n<td>{copy_orderitem_lbl}</td>\n<td>{product_name_lbl}</td>\n<td>{note_lbl}</td>\n<td>{price_lbl}</td>\n<td>{quantity_lbl}</td>\n<td align=\"right\">{total_price_lbl}</td>\n</tr>\n{product_loop_start}\n<tr>\n<td>{copy_orderitem}</td>\n<td>{product_name}<br />{product_attribute}{product_accessory}{product_userfields}</td>\n<td>{product_wrapper}</td>\n<td>{product_price}</td>\n<td>{product_quantity}</td>\n<td align=\"right\">{product_total_price}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td>{customer_note_lbl}: {customer_note}</td>\n</tr>\n<tr>\n<td>{requisition_number_lbl}: {requisition_number}</td>\n</tr>\n<tr>\n<td>\n<table class=\"cart_calculations\" border=\"1\">\n<tbody>\n<tr class=\"tdborder\">\n<td><b>Product Subtotal:</b></td>\n<td width=\"100\">{product_subtotal}</td>\n<td><b>Product Subtotal excl vat:</b></td>\n<td width=\"100\">{product_subtotal_excl_vat}</td>\n</tr>\n<tr>\n<td><b>Shipping with vat:</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>Shipping excl vat:</b></td>\n<td width=\"100\">{shipping_excl_vat}</td>\n</tr>\n{if discount}\n<tr class=\"tdborder\">\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount}</td>\n\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount_excl_vat}</td>\n</tr>\n\n{discount end if}\n<tr>\n<td><b>{totalpurchase_lbl}:</b></td>\n<td width=\"100\">{order_subtotal}</td>\n<td><b>{subtotal_excl_vat_lbl} :</b></td>\n<td width=\"100\">{order_subtotal_excl_vat}</td>\n</tr>\n\n{if vat}\n<tr class=\"tdborder\">\n<td>{vat_lbl}</td>\n<td width=\"100\">{tax}</td>\n<td>{vat_lbl}</td>\n<td width=\"100\">{sub_total_vat}</td>\n</tr>\n{vat end if}   {if payment_discount}\n<tr>\n<td>{payment_discount_lbl}</td>\n<td width=\"100\">{payment_order_discount}</td>\n</tr>\n{payment_discount end if}\n<tr class=\"tdborder\">\n<td><b>{tax_with_shipping_lbl}</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>{shipping_lbl}</b></td>\n<td width=\"100\">{shipping_excl_vat}</td>\n</tr>\n\n<tr>\n<td>\n<div class=\"singleline\"><strong>{total_lbl}:</strong></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{order_total}</div>\n</td>\n<td>\n<div class=\"singleline\"><b>{total_lbl}:</b></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{total_excl_vat}</div>\n</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td align=\"left\">{reorder_button}\n</td></tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>','','',1,'',0,'0000-00-00 00:00:00'),
	(17,'order_receipt','order_receipt','<div class=\"product_print\">{print}</div>\n<table class=\"tdborder\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tbody>\n<tr>\n<th>{product_name_lbl}</th> <th> </th> <th>{price_lbl}</th> <th>{quantity_lbl}</th> <th>{total_price_lbl}</th>\n</tr>\n{product_loop_start}\n<tr>\n<td>{product_name}<br />{product_attribute}{product_accessory}{product_userfields}{product_wrapper}</td>\n<td>{product_thumb_image}</td>\n<td>{product_price}</td>\n<td>{product_quantity}</td>\n<td>{product_total_price}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n<p><br /><br /></p>\n<table class=\"cart_calculations\" border=\"1\">\n<tbody>\n<tr class=\"tdborder\">\n<td><b>Product Subtotal:</b></td>\n<td width=\"100\">{product_subtotal}</td>\n<td><b>Product Subtotal excl vat:</b></td>\n<td width=\"100\">{product_subtotal_excl_vat}</td>\n</tr>\n<tr>\n<td><b>Shipping with vat:</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>Shipping excl vat:</b></td>\n<td width=\"100\">{shipping_excl_vat}</td>\n</tr>\n{if discount}\n<tr class=\"tdborder\">\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount}</td>\n\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount_excl_vat}</td>\n</tr>\n\n{discount end if}\n<tr>\n<td><b>{totalpurchase_lbl}:</b></td>\n<td width=\"100\">{order_subtotal}</td>\n<td><b>{subtotal_excl_vat_lbl} :</b></td>\n<td width=\"100\">{order_subtotal_excl_vat}</td>\n</tr>\n\n{if vat}\n<tr class=\"tdborder\">\n<td>{vat_lbl}</td>\n<td width=\"100\">{tax}</td>\n<td>{vat_lbl}</td>\n<td width=\"100\">{sub_total_vat}</td>\n</tr>\n{vat end if}   {if payment_discount}\n<tr>\n<td>{payment_discount_lbl}</td>\n<td width=\"100\">{payment_order_discount}</td>\n</tr>\n{payment_discount end if}\n<tr class=\"tdborder\">\n<td><b>{shipping_lbl}</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>{shipping_lbl}</b></td>\n<td width=\"100\">{shipping_excl_vat}</td>\n</tr>\n\n<tr>\n<td>\n<div class=\"singleline\"><strong>{total_lbl}:</strong></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{order_total}</div>\n</td>\n<td>\n<div class=\"singleline\"><b>{total_lbl}:</b></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{total_excl_vat}</div>\n</td>\n</tr>\n<tr>\n<td colspan=\"4\">\n<p>{shipping_method_lbl} <strong>{shipping_method}</strong></p>\n<p>{payment_status}</p>\n</td>\n</tr>\n<tr>\n<td colspan=\"4\">{billing_address}</td>\n</tr>\n<tr>\n<td colspan=\"4\">{shipping_address}</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(18,'manufacturer_detail','manufacturer_detail','<div class=\"manufacturer_name\">{manufacturer_name}</div>\n<div class=\"manufacturer_image\">{manufacturer_image}</div>\n<div class=\"manufacturer_description\">{manufacturer_description}</div>\n<div class=\"manufacturer_product_link\"><a href=\"{manufacturer_allproductslink}\">See all the designers products</a></div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(22,'frontpage_category','frontpage_category','<div class=\"category_front_introtext\">\n<p>{category_frontpage_introtext}</p>\n</div>\n<p>{category_frontpage_loop_start}</p>\n<div class=\"category_front\">\n<div class=\"category_front_image\">{category_thumb_image}</div>\n<div class=\"category_front_title\">\n<h3>{category_name}</h3>\n</div>\n</div>\n<p>{category_frontpage_loop_end}</p>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(23,'related_products','related_product','<div class=\"related_product_wrapper\">\n<h2>Related Products</h2>\n{related_product_start}\n<div class=\"related_product_inside\">\n<div class=\"related_product_left\">\n<div class=\"related_product_image\">\n<div class=\"related_product_image_inside\">{relproduct_image}</div>\n</div>\n</div>\n<div class=\"related_product_right\">\n<div class=\"related_product_name\">{relproduct_name}</div>\n<div class=\"related_product_price\">{relproduct_price}</div>\n<div class=\"related_product_desc\">{relproduct_s_desc}</div>\n<div class=\"related_product_readmore\">{read_more}</div>\n</div>\n<div class=\"related_product_bottom\">\n<div class=\"related_product_attr\">{attribute_template:attributes}</div>\n<div class=\"related_product_addtocart\">{form_addtocart:add_to_cart2}</div>\n</div>\n</div>\n{related_product_end}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(24,'add_to_cart1','add_to_cart','<div>\n<div class=\"cart-link\">{addtocart_image_aslink}\n</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(25,'add_to_cart2','add_to_cart','<div style=\"clear: left;\"></div>\n<div class=\"cart-wrapper\">\n<div class=\"cart-quantity\">Quantity: {addtocart_quantity}</div>\n<div class=\"cart-link\">{addtocart_image_aslink}</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(26,'product2','product','<div class=\"product\">\n<div class=\"next-prev\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tbody>\n<tr>\n<td style=\"width: 33%; height: 20px;\" align=\"left\" valign=\"middle\">{navigation_link_left}</td>\n<td style=\"width: 33%; height: 20px;\" align=\"center\" valign=\"middle\">{returntocategory}</td>\n<td style=\"width: 33%; height: 20px;\" align=\"right\" valign=\"middle\">{navigation_link_right}</td>\n</tr>\n</tbody>\n</table>\n</div>\n<div class=\"product_rating_summary\">{product_rating_summary}</div>\n<div class=\"product_writereview\">{form_rating}</div>\n<div class=\"product_box\">\n<div class=\"product_box_inside\">\n<div class=\"product_box_left\">\n<div class=\"product_image\">{product_thumb_image}<br />View Full-Size Image</div>\n<div class=\"product_more_images\">{more_images}</div>\n</div>\n<div class=\"product_box_right\">\n<div id=\"product_price\" class=\"product_price\">{product_price}</div>\n<div class=\"product_attributter\">{attribute_template:attributes}</div>\n{if product_userfield}\n<div class=\"product_userfield\">{userfield-test}</div>\n{product_userfield end if}\n<div class=\"product_accessory\">{accessory_template:accessory}</div>\n<div class=\"product_addtocart\">{form_addtocart:add_to_cart2}</div>\n<div class=\"product_manufacturer_link\">{manufacturer_link}</div>\n<div class=\"product_question_link\">{ask_question_about_product}</div>\n</div>\n</div>\n<div class=\"product_desc_wrapper\">\n<div class=\"product_title\">\n<h2>{product_name}</h2>\n</div>\n<div class=\"product_desc_short\">{product_s_desc}</div>\n<div class=\"product_desc_full\">{product_desc}</div>\n</div>\n<div class=\"product_related_products\">{related_product:related_products}</div>\n</div>\n</div>\n<p>{question_loop_start}{question} - {question_owner} - {question_date}{answer_loop_start}{answer} - {answer_owner} - {answer_date}{answer_loop_end}{question_loop_end}</p>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(27,'accessory','accessory_template','<div class=\"accessory\">\n<div class=\"accessory_info\">\n<h2>Accessories</h2>\nAdd accessories by clicking in the box.</div>\n{accessory_product_start}\n<div class=\"accessory_box\">\n<div class=\"accessory_left\">\n<div class=\"accessory_image\">{accessory_image}</div>\n</div>\n<div class=\"accessory_right\">\n<div class=\"accessory_title\">\n<h3>{accessory_title}</h3>\n</div>\n<div class=\"accessory_desc\">{accessory_short_desc}</div>\n<div class=\"accessory_readmore\">{accessory_readmore}</div>\n<div class=\"accessory_add\">{accessory_price} {accessory_add_chkbox}</div>\n<div class=\"accessory_qua\">{accessory_quantity_lbl} {accessory_quantity}</div>\n</div>\n<div style=\"clear: left\">&nbsp;&nbsp;</div>\n</div>\n{accessory_product_end}</div>\n<div style=\"clear: left\">&nbsp;&nbsp;</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(28,'attributes','attribute_template','<div class=\"attribute_wrapper\">\n<p>{attribute_title}<br />{property_dropdown}<br />{subproperty_start}{property_title} <br />{subproperty_dropdown}{subproperty_end}</p>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(29,'newsletter1','newsletter','<p>Newsletter redSHOPdemo2</p>\n<p>{data}</p>\n<p>{username}</p>\n<p>{email}</p>\n<p>{unsubscribe_link}</p>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(100,'my_account_template','account_template','<table border=\"0\">\n<tbody>\n<tr>\n<td>{welcome_introtext}</td>\n</tr>\n<tr>\n<td class=\"account_billinginfo\">\n<table border=\"0\" cellspacing=\"10\" cellpadding=\"10\" width=\"100%\">\n<tbody>\n<tr valign=\"top\">\n<td width=\"40%\">{account_image}<strong>{account_title}</strong><br /><br /> \n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr>\n<td class=\"account_label\">{fullname_lbl}</td>\n<td class=\"account_field\">{fullname}</td>\n</tr>\n<tr>\n<td class=\"account_label\">{state_lbl}</td>\n<td class=\"account_field\">{state}</td>\n</tr>\n<tr>\n<td class=\"account_label\">{country_lbl}</td>\n<td class=\"account_field\">{country}</td>\n</tr>\n<tr>\n<td class=\"account_label\">{vatnumber_lbl}</td>\n<td class=\"account_field\">{vatnumber}</td>\n</tr>\n<tr>\n<td class=\"account_label\">{ean_number_lbl}</td>\n<td class=\"account_field\">{ean_number}</td>\n</tr>\n<tr>\n<td class=\"account_label\">{email_lbl}</td>\n<td class=\"account_field\">{email}</td>\n</tr>\n<tr>\n<td class=\"account_label\">{company_name_lbl}</td>\n<td class=\"account_field\">{company_name}</td>\n</tr>\n<tr>\n<td colspan=\"2\">{edit_account_link}</td>\n</tr>\n</tbody>\n</table>\n</td>\n<td>\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{order_image}<strong>{order_title}</strong></td>\n</tr>\n{order_loop_start}           \n<tr>\n<td>{order_index} {order_id} {order_detail_link}</td>\n</tr>\n{order_loop_end}           \n<tr>\n<td>{more_orders}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td class=\"account_shippinginfo\">{shipping_image}<strong>{shipping_title}</strong> <br /><br /> \n<table border=\"0\">\n<tbody>\n<tr>\n<td>{edit_shipping_link}</td>\n</tr>\n</tbody>\n</table>\n</td>\n<td>\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{quotation_image}<strong>{quotation_title}</strong></td>\n</tr>\n{quotation_loop_start}           \n<tr>\n<td>{quotation_index} {quotation_id} {quotation_detail_link}</td>\n</tr>\n{quotation_loop_end}\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td>{product_serial_image}<strong>{product_serial_title}</strong><br /><br /> \n<table border=\"0\">\n<tbody>\n{product_serial_loop_start}             \n<tr>\n<td>{product_name} {product_serial_number}</td>\n</tr>\n{product_serial_loop_end}\n</tbody>\n</table>\n</td>\n<td>\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{coupon_image}<strong>{coupon_title}</strong></td>\n</tr>\n{coupon_loop_start}          \n<tr>\n<td>{coupon_code_lbl} {coupon_code}</td>\n</tr>\n<tr>\n<td>{coupon_value_lbl} {coupon_value}</td>\n</tr>\n{coupon_loop_end}\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td>{wishlist_image}<strong>{wishlist_title}</strong><br /><br /> \n<table border=\"0\">\n<tbody>\n<tr>\n<td>{edit_wishlist_link}</td>\n</tr>\n</tbody>\n</table>\n</td>\n<td>{compare_image}<strong>{compare_title}</strong> <br /><br /> \n<table border=\"0\">\n<tbody>\n<tr>\n<td>{edit_compare_link}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td>{logout_link}</td>\n<td>{tag_image}<strong>{tag_title}</strong><br /><br /> \n<table border=\"0\">\n<tbody>\n<tr>\n<td>{edit_tag_link}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(101,'catalog','catalog','<div id=\"katalog_wrapper\">\n<div id=\"bestil_katalog_wrapper\">\n<div id=\"katalog_overskrift\">\n<h1>Order Catalog</h1>\n</div>\n<div id=\"katalog_venstre_wrapper\">\n<div id=\"katalog_tekst\">\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget nisi orci, vel vehicula massa. Phasellus ipsum est, egestas a consequat eget, placerat vitae ipsum. Proin ac purus risus. Quisque nec nisi lacus, vitae iaculis eros. Donec ipsum diam, dictum ac euismod molestie, ultrices eget arcu. Vestibulum lacinia nisl et odio sagittis fermentum. Aliquam tristique volutpat faucibus. Sed id orci ut metus condimentum bibendum. Ut gravida scelerisque magna et pharetra. Ut vel turpis in orci molestie scelerisque. Proin nisl elit, ullamcorper id blandit nec, congue eget augue. Nullam gravida ligula nisi.</p>\n</div>\n<div>Catalog:{catalog_select}</div>\n<div id=\"katalog_navn_email\">NAME  {name} <br /><br />EMAIL {email_address} <br /><br />{submit_button_catalog}</div>\n</div>\n<div id=\"katalog_hojre_wrapper\"></div>\n</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(102,'catalog_sample','product_sample','<div id=\"katalog_wrapper\">\n<div id=\"bestil_katalog_wrapper\">\n<div id=\"katalog_hojre_wrapper\"></div>\n</div>\n<div id=\"bestil_farveproeve_wrapper\">\n<div id=\"farveproeve_overskrift\">\n<h2>Bestil Farvepr�ver</h2>\n</div>\n<div id=\"farveproeve_venstre\">\n<div id=\"farveproever_tekst\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris eget nisi orci, vel vehicula massa. Phasellus ipsum est, egestas a consequat eget, placerat vitae ipsum. Proin ac purus risus. Quisque nec nisi lacus, vitae iaculis eros. Donec ipsum diam, dictum ac euismod molestie, ultrices eget arcu. Vestibulum lacinia nisl et odio sagittis fermentum. Aliquam tristique volutpat faucibus. Sed id orci ut metus condimentum bibendum. Ut gravida scelerisque magna et pharetra. Ut vel turpis in orci molestie scelerisque. Proin nisl elit, ullamcorper id blandit nec, congue eget augue. Nullam gravida ligula nisi.</div>\n<div id=\"farveproever\">\n<p style=\"text-align: left;\">{product_samples}</p>\n</div>\n</div>\n<div id=\"farveproeve_hojre_wrapper\">\n<div id=\"farveproeve_addressefelt\">\n<p style=\"text-align: left;\">{address_fields}</p>\n</div>\n<div id=\"farveproeve_sendknap\">\n<p style=\"text-align: left;\">{submit_button_sample}</p>\n</div>\n</div>\n</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(103,'wishlist_list','wishlist_template','<div style=\"float: right;\">{mail_link}</div>\n<p>{product_loop_start}</p>\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">\n<tbody>\n<tr valign=\"top\">\n<td width=\"40%\">\n<div style=\"float: left; width: 195px; height: 230px; text-align: center;\">{product_thumb_image}\n<div>{product_name}</div>\n<div>{product_price}</div>\n<div>{form_addtocart:add_to_cart1}</div>\n<div></div>\n<div>{remove_product_link}</div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<div></div>\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n<tbody>\n<tr>\n<td></td>\n<td align=\"center\" valign=\"top\"><br /><br /></td>\n</tr>\n</tbody>\n</table>\n<p>{product_loop_end}</p>\n<div style=\"float: right;\">{back_link}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(105,'wishlist_mail','wishlist_mail_template','<table border=\"0\" cellspacing=\"10\" cellpadding=\"10\">\n<tbody>\n<tr>\n<th colspan=\"2\">{email_to_friend}</th>\n</tr>\n<tr>\n<td>{emailto_lbl}</td>\n<td>{emailto}</td>\n</tr>\n<tr>\n<td>{sender_lbl}</td>\n<td>{sender}</td>\n</tr>\n<tr>\n<td>{mail_lbl}</td>\n<td>{mail}</td>\n</tr>\n<tr>\n<td>{subject_lbl}</td>\n<td>{subject}</td>\n</tr>\n<tr>\n<td>{cancel_button}</td>\n<td>{send_button}</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(110,'ask_question','ask_question_template','<table border=\"0\">\n<tbody>\n<tr>\n<td>{user_name_lbl}</td>\n<td>{user_name}</td>\n</tr>\n<tr>\n<td>{user_email_lbl}</td>\n<td>{user_email}</td>\n</tr>\n<tr>\n<td>{user_question_lbl}</td>\n<td>{user_question}</td>\n</tr>\n<tr>\n<td></td>\n<td>{send_button}</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(111,'ajax_cart_box','ajax_cart_box','<div id=\"ajax_cart_wrapper\">\n<div id=\"ajax_cart_text\">{ajax_cart_box_title}<br /><br /></div>\n<div id=\"ajax_cart_button_wrapper\">\n<div id=\"ajax_cart_button_inside\">\n<div id=\"ajax_cart_continue_button\">{continue_shopping_button}</div>\n<div id=\"ajax_cart_show_button\">{show_cart_button}</div>\n</div>\n</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(112,'ajax_cart_detail_box','ajax_cart_detail_box','<div id=\"ajax-cart\">\n<div id=\"ajax-cart-label\">\n<h3>Add to Cart</h3>\n</div>\n<div id=\"ajax-cart-attr\">{attribute_template:attributes}</div>\n<div id=\"ajax-cart-access\">{accessory_template:accessory}</div>\n{if product_userfield}\n<div id=\"ajax-cart-user\">{userfield-test}</div>\n{product_userfield end if}\n<div id=\"ajax-cart-label\">{form_addtocart:add_to_cart2}</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(115,'wrapper','wrapper_template','<div class=\"accessory\">\n<div class=\"accessory_info\">\n<h2>Product Wrapper</h2>\nSelect Wrapper by clicking in the box.</div>\n<div class=\"wrapper_box\">\n<div class=\"wrapper_left\">\n<div class=\"wrapper_image\">{wrapper_dropdown}</div>\n</div>\n<div class=\"wrapper_left\">\n<div class=\"wrapper_image\">{wrapper_image}</div>\n<div class=\"wrapper_price\">{wrapper_price}</div>\n</div>\n<div class=\"wrapper_left\">\n<div class=\"wrapper_image\">{wrapper_add_checkbox}</div>\n</div>\n</div>\n</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(125,'giftcard_listing','giftcard_list','<div>{giftcard_loop_start}\n<div><h3>{giftcard_name}</h3></div>\n<div>{giftcard_desc}</div>\n<div>{giftcard_validity}</div>{giftcard_loop_end}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(135,'giftcard','giftcard','<div>{giftcard_image}</div>\n<div>{giftcard_name}</div>\n<div>{giftcard_desc}</div>\n<div>{giftcard_price_lbl}{giftcard_price}</div>\n<div>{giftcard_validity}</div>\n<div>{giftcard_reciver_name_lbl}{giftcard_reciver_name}</div>\n<div>{giftcard_reciver_email_lbl}{giftcard_reciver_email}</div>\n<div>{form_addtocart:add_to_cart2}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(200,'shipping_pdf','shipping_pdf','<div style=\"background-color:#CCCCCC;color:white;\">{order_information_lbl}</div>\n<table border=\"0\">\n<tbody>\n<tr>\n<td class=\"caption\">{order_id_lbl}</td>\n<td>{order_id}</td>\n</tr>\n<tr>\n<td>{order_number_lbl}</td>\n<td>{order_number}</td>\n</tr>\n<tr>\n<td>{order_date_lbl}</td>\n<td>{order_date}</td>\n</tr>\n<tr>\n<td>{order_status_lbl}</td>\n<td>{order_status}</td>\n</tr>\n</tbody>\n</table>\n<div style=\"background-color:#CCCCCC;color:white;\">{shipping_address_info_lbl}</div>\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr>\n<td>{shipping_firstname_lbl} : {shipping_firstname}</td>\n</tr>\n<tr>\n<td>{shipping_lastname_lbl} : {shipping_lastname}</td>\n</tr>\n<tr>\n<td>{shipping_address_lbl}: {shipping_address}</td>\n</tr>\n<tr>\n<td>{shipping_zip_lbl}  : {shipping_zip}</td>\n</tr>\n<tr>\n<td>{shipping_city_lbl} :{shipping_city}</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(251,'order_print','order_print','<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tbody>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{order_information_lbl}{print}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{order_id_lbl} : {order_id}</td>\n</tr>\n<tr>\n<td>{order_number_lbl} : {order_number}</td>\n</tr>\n<tr>\n<td>{order_date_lbl} : {order_date}</td>\n</tr>\n<tr>\n<td>{order_status_lbl} : {order_status}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{billing_address_information_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{billing_address}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{shipping_address_information_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{shipping_address}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc;\">\n<th align=\"left\">{order_detail_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\">\n<tbody>\n<tr>\n<td>{product_name_lbl}</td>\n<td>{note_lbl}</td>\n<td>{price_lbl}</td>\n<td>{quantity_lbl}</td>\n<td align=\"right\">{total_price_lbl}</td>\n</tr>\n{product_loop_start}\n<tr>\n<td>\n<p>{product_name}<br />{product_attribute}{product_accessory}{product_userfields}</p>\n</td>\n<td>{product_wrapper}{product_thumb_image}</td>\n<td>{product_price}</td>\n<td>{product_quantity}</td>\n<td align=\"right\">{product_total_price}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td></td>\n</tr>\n<tr>\n<td>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\">\n<tbody>\n<tr align=\"left\">\n<td align=\"left\"><strong>{order_subtotal_lbl} : </strong></td>\n<td align=\"right\">{order_subtotal}</td>\n</tr>\n{if vat}\n<tr align=\"left\">\n<td align=\"left\"><strong>{vat_lbl} : </strong></td>\n<td align=\"right\">{order_tax}</td>\n</tr>\n{vat end if} {if discount}\n<tr align=\"left\">\n<td align=\"left\"><strong>{discount_lbl} : </strong></td>\n<td align=\"right\">{order_discount}</td>\n</tr>\n{discount end if}\n<tr align=\"left\">\n<td align=\"left\"><strong>{shipping_lbl} : </strong></td>\n<td align=\"right\">{order_shipping}</td>\n</tr>\n<tr align=\"left\">\n<td colspan=\"2\" align=\"left\">\n<hr />\n</td>\n</tr>\n<tr align=\"left\">\n<td align=\"left\"><strong>{total_lbl} :</strong></td>\n<td align=\"right\">{order_total}</td>\n</tr>\n<tr align=\"left\">\n<td colspan=\"2\" align=\"left\">\n<hr />\n<br />\n<hr />\n</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(252,'clicktell_sms_message','clicktell_sms_message','<p>{order_id}{order_status}<br />{customer_name}<br />{payment_status}</p>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(260,'redproductfinder','redproductfinder','<div class=\"redproductfinder_result_header\">\n{product_loop_start}<br />\n{product_id_lbl} :: {product_id} <br />\n{product_name}<br />{product_price}<br />\n{product_thumb_image}<br />\n{product_s_desc}<br />\n{product_number_lbl} :: {product_number} <br />\n{manufacturer_link}<br />{manufacturer_name}<br />\n{read_more}<br />{form_addtocart:add_to_cart1}<br />\n{product_loop_end}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(265,'quotation_detail','quotation_detail','<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">\n<tbody>\n<tr>\n<td colspan=\"2\">\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{quotation_information_lbl}{print}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>{quotation_id_lbl} : {quotation_id}</td>\n</tr>\n<tr>\n<td>{quotation_number_lbl} : {quotation_number}</td>\n</tr>\n<tr>\n<td>{quotation_date_lbl} : {quotation_date}</td>\n</tr>\n<tr>\n<td>{quotation_status_lbl} : {quotation_status}</td>\n</tr>\n<tr>\n<td>{quotation_note_lbl} : {quotation_note}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{account_information_lbl}</th>\n</tr>\n<tr>\n<td>{account_information}{quotation_custom_field_list}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{quotation_detail_lbl}</th>\n</tr>\n<tr>\n</tr>\n<tr>\n<td>\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr>\n<td>{product_name_lbl}</td>\n<td>{note_lbl}</td>\n<td>{price_lbl}</td>\n<td>{quantity_lbl}</td>\n<td align=\"right\">{total_price_lbl}</td>\n</tr>\n{product_loop_start} \n<tr>\n<td>{product_name}({product_number_lbl} - {product_number})<br />{product_accessory}{product_attribute}{product_userfields}</td>\n<td>{product_wrapper}</td>\n<td>{product_price}</td>\n<td>{product_quantity}</td>\n<td align=\"right\">{product_total_price}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td></td>\n</tr>\n<tr>\n<td>\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr align=\"left\">\n<td align=\"left\"><strong>{quotation_subtotal_lbl} : </strong></td>\n<td align=\"right\">{quotation_subtotal}</td>\n</tr>\n<tr align=\"left\">\n<td align=\"left\"><strong>{quotation_tax_lbl} : </strong></td>\n<td align=\"right\">{quotation_tax}</td>\n</tr>\n<tr align=\"left\">\n<td align=\"left\"><strong>{quotation_discount_lbl} : </strong></td>\n<td align=\"right\">{quotation_discount}</td>\n</tr>\n<tr align=\"left\">\n<td colspan=\"2\" align=\"left\">\n<hr />\n</td>\n</tr>\n<tr align=\"left\">\n<td align=\"left\"><strong>{total_lbl} :</strong></td>\n<td align=\"right\">{quotation_total}</td>\n</tr>\n<tr align=\"left\">\n<td colspan=\"2\" align=\"left\">\n<hr />\n<br /> \n<hr />\n</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(280,'catalogue_cart','catalogue_cart','<h1>Indkøbskurv</h1>\n<table class=\"tdborder\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<thead>\n<tr>\n<th>{product_name_lbl}</th> <th> <br /></th><th>{quantity_lbl}</th>\n</tr>\n</thead>\n<tbody>\n{print} {product_loop_start}\n<tr class=\"tdborder\">\n<td>\n<p>{product_name}  <span class=\"attribut\">{product_attribute} {product_accessory}</span> {product_wrapper}{product_userfields}</p>\n<p> </p>\n</td>\n<td>{product_thumb_image}</td>\n<td>\n<table style=\"width: 172px; height: 46px;\" border=\"0\">\n<tbody>\n<tr>\n<td>{update_cart}{remove_product}</td>\n<td><br /></td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tbody>\n<tr>\n<td width=\"50%\" valign=\"top\">\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{update}</td>\n<td>{empty_cart}</td>\n</tr>\n</tbody>\n</table>\n<br /><br /> {coupon_code_lbl}   {discount_form}</td>\n<td width=\"50%\" align=\"right\" valign=\"top\"><br /><br />\n<table class=\"cart_regnestykke\" border=\"0\">\n<tbody>\n</tbody>\n</table>\n<table class=\"regnestykke_sidste\" border=\"0\">\n<tbody>\n<tr>\n<td>{newsletter_signup_lbl}</td>\n<td>{newsletter_signup_chk}</td>\n</tr>\n</tbody>\n</table>\n<p>{terms_and_conditions}{checkout_button}<br /><br /> {shop_more}</p>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(281,'catalogue_order_detail','catalogue_order_detail','<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tbody>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{discount_type_lbl}</th>\n</tr>\n<tr>\n<td>{discount_type}</td>\n</tr>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{order_information_lbl}{print}</th>\n</tr>\n<tr>\n<td>{order_id_lbl} : {order_id}</td>\n</tr>\n<tr>\n<td>{order_number_lbl} : {order_number}</td>\n</tr>\n<tr>\n<td>{order_date_lbl} : {order_date}</td>\n</tr>\n<tr>\n<td>{order_status_lbl} : {order_status}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{billing_address_information_lbl}</th>\n</tr>\n<tr>\n<td>{billing_address}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{shipping_address_info_lbl}</th>\n</tr>\n<tr>\n<td>{shipping_address}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\">\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">\n<tbody>\n<tr style=\"background-color: #cccccc\">\n<th align=\"left\">{order_detail_lbl}</th>\n</tr>\n<tr>\n<td>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\">\n<tbody>\n<tr>\n<td>{product_name_lbl}</td>\n<td>{note_lbl}</td>\n<td>{quantity_lbl}</td>\n</tr>\n{product_loop_start}\n<tr>\n<td>{product_name}{product_userfields}</td>\n<td>{product_note}</td>\n<td>{product_quantity}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td></td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(282,'catalogue_order_receipt','catalogue_order_receipt','<table class=\"tdborder\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tbody>\n<tr>\n<th>{product_name_lbl} {print}</th> <th> </th> <th>{quantity_lbl}</th>\n</tr>\n{product_loop_start}\n<tr>\n<td>{product_name}<br />{product_userfields}</td>\n<td>{product_thumb_image}</td>\n<td>{product_quantity}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n<table class=\"order_details\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tbody>\n<tr>\n<td width=\"50%\" align=\"left\" valign=\"top\">\n<p>{order_number_lbl}{order_number}<strong>{delivery_time_lbl} {delivery_time}</strong></p>\n<p>{order_id}{order_id_lbl}</p>\n<p>{print} Print denne side</p>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(289,'empty_cart','empty_cart','<p>The Cart is empty.</p>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(320,'compare_product','compare_product','<div><span>{compare_product_heading}</span></div>\n<div><a href=\"{returntocategory_link}\">{returntocategory_name}</a></div>\n<table border=\"1\">\n<tbody>\n<tr>\n<th> </th>\n<td align=\"center\">{expand_collapse}</td>\n</tr>\n<tr>\n<th>Product Name</th>\n<td>{product_name}</td>\n</tr>\n<tr>\n<th>Image</th>\n<td>{product_image}</td>\n</tr>\n<tr>\n<th>Manufacturer</th>\n<td>{manufacturer_name}</td>\n</tr>\n<tr>\n<th>Discount Start <br /></th>\n<td>{discount_start_date}</td>\n</tr>\n<tr>\n<th>Discount End<br /></th>\n<td>{discount_end_date}</td>\n</tr>\n<tr>\n<th>Price</th>\n<td>{product_price}</td>\n</tr>\n<tr>\n<th>Short Desc<br /></th>\n<td>{product_s_desc}</td>\n</tr>\n<tr>\n<th>Desc</th>\n<td>{product_desc}</td>\n</tr>\n<tr>\n<th>Rating</th>\n<td>{product_rating_summary}</td>\n</tr>\n<tr>\n<th>Delivery Time</th>\n<td>{product_delivery_time}</td>\n</tr>\n<tr>\n<th>Product Number<br /></th>\n<td>{product_number}</td>\n</tr>\n<tr>\n<th>Stock<br /></th>\n<td>{products_in_stock}</td>\n</tr>\n<tr>\n<th>Stock<br /></th>\n<td>{product_stock_amount_image}</td>\n</tr>\n<tr>\n<th>Weight<br /></th>\n<td>{product_weight}</td>\n</tr>\n<tr>\n<th>Length<br /></th>\n<td>{product_length}</td>\n</tr>\n<tr>\n<th>Height<br /></th>\n<td>{product_height}</td>\n</tr>\n<tr>\n<th>Width<br /></th>\n<td>{product_width}</td>\n</tr>\n<tr>\n<th>Availability Date<br /></th>\n<td>{product_availability_date}</td>\n</tr>\n<tr>\n<th>Volume<br /></th>\n<td>{product_volume}</td>\n</tr>\n<tr>\n<th>Category<br /></th>\n<td>{product_category}</td>\n</tr>\n<tr>\n<th> </th>\n<td>{remove}</td>\n</tr>\n<tr>\n<th> </th>\n<td>{add_to_cart}</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(334,'newsletter_products','newsletter_product','	<p>{product_name}</p>\n<p>{product_price}</p>\n<p>{product_thumb_image}</p>\n<p>{product_s_desc}</p>\n<p>{product_desc}</p>\n<p>{unsubscribe_link}</p>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(353,'payment_method','redshop_payment','<fieldset class=\"adminform\"><legend><strong>{payment_heading}</strong></legend>\n<div>{split_payment}</div>\n<div>{payment_loop_start}\n<div>{payment_method_name}</div>\n<div>{creditcard_information}</div>\n{payment_loop_end}</div>\n</fieldset>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(354,'shipping_method','redshop_shipping','<fieldset><legend><strong>{shipping_heading}</strong></legend>\n<div>{shipping_method_loop_start}\n<h3>{shipping_method_title}</h3>\n<div>{shipping_rate_loop_start}\n<div>{shipping_rate_name}{shipping_rate}</div>\n{shipping_rate_loop_end}</div>\n{shipping_method_loop_end}</div>\n</fieldset>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(355,'shipping_box','shippingbox','<fieldset class=\"adminform\"> <legend><strong>{shipping_box_heading}</strong></legend>\n<div>{shipping_box_list}</div>\n</fieldset>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(356,'category_product_template','categoryproduct','<div>{print}</div>\n<div>{filter_by_lbl}{filter_by}</div>\n<div>{order_by_lbl}{order_by}</div>\n<p> </p>\n<div>{category_loop_start}\n<div id=\"categories\">\n<div style=\"float: left; width: 200px;\">\n<div class=\"category_image\">{category_thumb_image}</div>\n<div class=\"category_description\">\n<h2 class=\"category_title\">{category_name}</h2>\n{category_description}</div>\n</div>\n</div>\n<div class=\"category_box_wrapper\">{product_loop_start}\n<div class=\"category_box_outside\">\n<div class=\"category_box_inside\">\n<table border=\"0\">\n<tbody>\n<tr>\n<td>\n<div class=\"category_product_image\">{product_thumb_image}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_title\">\n<h3>{product_name}</h3>\n</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_price\">{product_price}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_readmore\">{read_more}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_addtocart\">{attribute_template:attributes}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"category_product_addtocart\">{form_addtocart:add_to_cart1}</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</div>\n{product_loop_end}</div>\n{category_loop_end}</div>\n<div class=\"category_pagination\">{pagination}</div>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(357,'change_cart_attribute_template','change_cart_attribute','<table border=\"0\">\n<tbody>\n<tr>\n<th>Change Attribute</th>\n</tr>\n<tr>\n<td>{attribute_template:attributes}</td>\n</tr>\n<tr>\n<td>{apply_button} {cancel_button}</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(358,'onestep_checkout','onestep_checkout','<table border=\"0\" cellspacing=\"2\" cellpadding=\"2\" width=\"100%\">\n<tbody>\n<tr>\n<td><fieldset class=\"adminform\"><legend>{billing_address_information_lbl}</legend> {edit_billing_address} <br />{billing_address} </fieldset></td>\n</tr>\n<tr>\n<td><fieldset class=\"adminform\"><legend>{shipping_address_information_lbl}</legend> {shipping_address} </fieldset></td>\n</tr>\n<tr>\n<td>\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{shippingbox_template:shipping_box}</td>\n</tr>\n<tr>\n<td>{shipping_template:shipping_method}</td>\n</tr>\n<tr>\n<td>{payment_template:payment_method}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n<tr>\n<td>\n<table border=\"0\">\n<tbody>\n<tr>\n<td>{checkout_template:checkout}</td>\n</tr>\n</tbody>\n</table>\n</td>\n</tr>\n</tbody>\n</table>\n','','',1,'',0,'0000-00-00 00:00:00'),
	(359,'attributes_listing1','attributewithcart_template','','','',1,'',0,'0000-00-00 00:00:00'),
	(360,'checkout','checkout','<h1>{cart_lbl}</h1>\n<div class=\"category_print\">{print}</div>\n<table class=\"tdborder\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<thead>\n<tr>\n<th>{product_name_lbl}</th> <th> </th><th>{price_lbl} </th><th>Product Price excl.</th><th>{quantity_lbl}</th><th>{total_price_lbl}</th><th>Total Price excl price</th>\n</tr>\n</thead>\n<tbody>\n{product_loop_start}\n<div class=\"category_print\">{attribute_price_without_vat}</div>\n<tr class=\"tdborder\">\n<td>\n<div class=\"cartproducttitle\">{product_name}</div>\n<div class=\"cartproducttitle\">{product_old_price}</div>\n<div class=\"cartattribut\">{product_attribute}</div>\n<div class=\"cartaccessory\">{product_accessory}</div>\n<div class=\"cartwrapper\">{product_wrapper}</div>\n<div class=\"cartuserfields\">{product_userfields}</div>\n</td>\n<td>{product_thumb_image}</td>\n<td>{product_price}<br />{vat_info}</td>\n<td>{product_price_excl_vat}</td>\n<td>{update_cart}</td>\n<td>{product_total_price}</td>\n<td>{product_total_price_excl_vat}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n<table style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<tbody>\n<tr>\n<td width=\"50%\" valign=\"top\">\n<table border=\"0\">\n<tbody>\n<tr>\n<td class=\"cart_customer_note\" colspan=\"2\">{customer_note_lbl}<br />{customer_note}</td></tr>\n<tr><td class=\"cart_requisition_number\" colspan=\"2\">{requisition_number_lbl}<br />{requisition_number}</td>\n</tr>\n</tbody>\n</table>\n<br /></td>\n<td width=\"50%\" align=\"right\" valign=\"top\"><br /><br />\n<table class=\"cart_calculations\" border=\"0\" width=\"100%\">\n<tbody>\n<tr class=\"tdborder\">\n<td><b>Product Subtotal:</b></td>\n<td width=\"100\">{product_subtotal}</td>\n<td><b>Product Subtotal excl vat:</b></td>\n<td width=\"100\">{product_subtotal_excl_vat}</td>\n</tr>\n<tr >\n<td><b>Shipping with vat:</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>Shipping excl vat:</b></td>\n<td width=\"100\">{shipping_excl_vat}{shipping_denotation}</td>\n</tr>\n{if discount}\n<tr class=\"tdborder\">\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount}</td>\n\n<td>{discount_lbl}</td>\n<td width=\"100\">{discount_excl_vat}{discount_denotation}</td>\n</tr>\n\n{discount end if}\n<tr class=\"tdborder\">\n<td><b>{totalpurchase_lbl}:</b></td>\n<td width=\"100\">{subtotal}</td>\n<td><b>{subtotal_excl_vat_lbl} :</b></td>\n<td width=\"100\">{subtotal_excl_vat}</td>\n</tr>\n\n{if vat}\n<tr>\n<td>{vat_lbl}</td>\n<td width=\"100\">{tax}</td>\n<td>{vat_lbl}</td>\n<td width=\"100\">{sub_total_vat}</td>\n</tr>\n{vat end if}   {if payment_discount}\n<tr>\n<td>{payment_discount_lbl}</td>\n<td width=\"100\">{payment_order_discount}</td>\n</tr>\n{payment_discount end if}\n<tr class=\"tdborder\">\n<td><b>{tax_with_shipping_lbl}</b></td>\n<td width=\"100\">{shipping}</td>\n<td><b>{shipping_lbl}</b></td>\n<td width=\"100\">{shipping_excl_vat}</td>\n</tr>\n\n<tr>\n<td>\n<div class=\"singleline\"><strong>{total_lbl}:</strong></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{total}</div>\n</td>\n<td>\n<div class=\"singleline\"><b>{total_lbl}:</b></div>\n</td>\n<td width=\"100\">\n<div class=\"singleline\">{total_excl_vat}</div>\n</td>\n</tr>\n<tr>\n<td colspan=\"4\">\n<strong>{denotation_label}</strong></div>\n</td>\n</tr>\n</tbody>\n</table>\n<div>{newsletter_signup_lbl} {newsletter_signup_chk}</div>\n<div>{terms_and_conditions}</div>\n<div>{checkout_button}{shop_more}</div></td>\n</tr>\n</tbody>\n</table>','','',1,'',0,'0000-00-00 00:00:00'),
	(370,'quotation_request_template','quotation_request','<fieldset class=\"adminform\"><legend>{order_detail_lbl}</legend> \n<table class=\"admintable\" style=\"width: 100%;\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n<thead> \n<tr>\n<th width=\"40%\" align=\"left\">{product_name_lbl}</th> <th width=\"35%\"> </th><th width=\"25%\">{quantity_lbl}</th>\n</tr>\n</thead> \n<tbody>\n{product_loop_start}  \n<tr>\n<td>\n<div class=\"cartproducttitle\">{product_name}</div>\n<div class=\"cartattribut\">{product_attribute}</div>\n<div class=\"cartaccessory\">{product_accessory}</div>\n<div class=\"cartwrapper\">{product_wrapper}</div>\n<div class=\"cartuserfields\">{product_userfields}</div>\n</td>\n<td align=\"center\">{product_thumb_image}</td>\n<td align=\"center\">{update_cart}</td>\n</tr>\n{product_loop_end}\n</tbody>\n</table>\n</fieldset>\n<p>{customer_note_lbl}:{customer_note}</p>\n<fieldset class=\"adminform\"><legend>{billing_address_information_lbl}</legend> {billing_address} {quotation_custom_field_list}</fieldset> \n<table border=\"0\">\n<tbody>\n<tr>\n<td align=\"center\">{cancel_btn}</td>\n<td align=\"center\">{request_quotation_btn}</td>\n</tr>\n</tbody>\n</table>','','',1,'',0,'0000-00-00 00:00:00'),
	(371,'product_content','product_content_template','<div class=\"mod_redshop_products\">\n<table border=\"0\">\n<tbody>\n<tr>\n<td>\n<div class=\"mod_redshop_products_image\">{product_thumb_image}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"mod_redshop_products_title\">\n{product_name}\n</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"mod_redshop_products_price\">{product_price}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"mod_redshop_products_readmore\">{read_more}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div>{attribute_template:attributes}</div>\n</td>\n</tr>\n<tr>\n<td>\n<div class=\"mod_redshop_product_addtocart\">{form_addtocart:add_to_cart1}</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>','','',1,'',0,'0000-00-00 00:00:00'),
	(372,'quotation_cart_template','quotation_cart','','','',1,'',0,'0000-00-00 00:00:00');

/*!40000 ALTER TABLE `#__redshop_template` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_textlibrary
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_textlibrary`;

CREATE TABLE `#__redshop_textlibrary` (
  `textlibrary_id` int(11) NOT NULL AUTO_INCREMENT,
  `text_name` varchar(255) DEFAULT NULL,
  `text_desc` varchar(255) DEFAULT NULL,
  `text_field` text,
  `section` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`textlibrary_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP TextLibrary';



# Dump of table #__redshop_usercart
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_usercart`;

CREATE TABLE `#__redshop_usercart` (
  `cart_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `cdate` int(11) NOT NULL,
  `mdate` int(11) NOT NULL,
  PRIMARY KEY (`cart_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP User Cart Item';

LOCK TABLES `#__redshop_usercart` WRITE;
/*!40000 ALTER TABLE `#__redshop_usercart` DISABLE KEYS */;

INSERT INTO `#__redshop_usercart` (`cart_id`, `user_id`, `cdate`, `mdate`)
VALUES
	(1,62,1321507187,1321507187);

/*!40000 ALTER TABLE `#__redshop_usercart` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_usercart_accessory_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_usercart_accessory_item`;

CREATE TABLE `#__redshop_usercart_accessory_item` (
  `cart_acc_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `cart_item_id` int(11) NOT NULL,
  `accessory_id` int(11) NOT NULL,
  `accessory_quantity` int(11) NOT NULL,
  PRIMARY KEY (`cart_acc_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP User Cart Accessory Item';



# Dump of table #__redshop_usercart_attribute_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_usercart_attribute_item`;

CREATE TABLE `#__redshop_usercart_attribute_item` (
  `cart_att_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `cart_item_id` int(11) NOT NULL,
  `section_id` int(11) NOT NULL,
  `section` varchar(25) NOT NULL,
  `parent_section_id` int(11) NOT NULL,
  `is_accessory_att` tinyint(4) NOT NULL,
  PRIMARY KEY (`cart_att_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP User cart Attribute Item';



# Dump of table #__redshop_usercart_item
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_usercart_item`;

CREATE TABLE `#__redshop_usercart_item` (
  `cart_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `cart_idx` int(11) NOT NULL,
  `cart_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `product_quantity` int(11) NOT NULL,
  `product_wrapper_id` int(11) NOT NULL,
  `product_subscription_id` int(11) NOT NULL,
  `giftcard_id` int(11) NOT NULL,
  PRIMARY KEY (`cart_item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP User Cart Item';

LOCK TABLES `#__redshop_usercart_item` WRITE;
/*!40000 ALTER TABLE `#__redshop_usercart_item` DISABLE KEYS */;

INSERT INTO `#__redshop_usercart_item` (`cart_item_id`, `cart_idx`, `cart_id`, `product_id`, `product_quantity`, `product_wrapper_id`, `product_subscription_id`, `giftcard_id`)
VALUES
	(4,0,1,22,1,0,0,0);

/*!40000 ALTER TABLE `#__redshop_usercart_item` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_users_info
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_users_info`;

CREATE TABLE `#__redshop_users_info` (
  `users_info_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `user_email` varchar(255) NOT NULL,
  `address_type` varchar(11) NOT NULL,
  `firstname` varchar(250) NOT NULL,
  `lastname` varchar(250) NOT NULL,
  `vat_number` varchar(250) NOT NULL,
  `tax_exempt` tinyint(4) NOT NULL,
  `shopper_group_id` int(11) NOT NULL,
  `country_code` varchar(11) NOT NULL,
  `address` varchar(255) NOT NULL,
  `city` varchar(50) NOT NULL,
  `state_code` varchar(11) NOT NULL,
  `zipcode` varchar(255) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `tax_exempt_approved` tinyint(1) NOT NULL,
  `approved` tinyint(1) NOT NULL,
  `is_company` tinyint(4) NOT NULL,
  `ean_number` varchar(250) NOT NULL,
  `company_name` varchar(255) NOT NULL,
  `requesting_tax_exempt` tinyint(4) NOT NULL,
  PRIMARY KEY (`users_info_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Users Information';

LOCK TABLES `#__redshop_users_info` WRITE;
/*!40000 ALTER TABLE `#__redshop_users_info` DISABLE KEYS */;

INSERT INTO `#__redshop_users_info` (`users_info_id`, `user_id`, `user_email`, `address_type`, `firstname`, `lastname`, `vat_number`, `tax_exempt`, `shopper_group_id`, `country_code`, `address`, `city`, `state_code`, `zipcode`, `phone`, `tax_exempt_approved`, `approved`, `is_company`, `ean_number`, `company_name`, `requesting_tax_exempt`)
VALUES
	(1,62,'design@joomlabamboo.com','BT','Administrator','','',0,1,'','0','0','','0','0',0,0,0,'','',0);

/*!40000 ALTER TABLE `#__redshop_users_info` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__redshop_wishlist
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_wishlist`;

CREATE TABLE `#__redshop_wishlist` (
  `wishlist_id` int(11) NOT NULL AUTO_INCREMENT,
  `wishlist_name` varchar(100) NOT NULL,
  `user_id` int(11) NOT NULL,
  `comment` mediumtext NOT NULL,
  `cdate` double NOT NULL,
  PRIMARY KEY (`wishlist_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP wishlist';



# Dump of table #__redshop_wishlist_product
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_wishlist_product`;

CREATE TABLE `#__redshop_wishlist_product` (
  `wishlist_product_id` int(11) NOT NULL AUTO_INCREMENT,
  `wishlist_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `cdate` int(11) NOT NULL,
  PRIMARY KEY (`wishlist_product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Wishlist Product';



# Dump of table #__redshop_wishlist_userfielddata
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_wishlist_userfielddata`;

CREATE TABLE `#__redshop_wishlist_userfielddata` (
  `fieldid` int(11) NOT NULL AUTO_INCREMENT,
  `wishlist_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `userfielddata` text NOT NULL,
  PRIMARY KEY (`fieldid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Wishlist Product userfielddata';



# Dump of table #__redshop_wrapper
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_wrapper`;

CREATE TABLE `#__redshop_wrapper` (
  `wrapper_id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` varchar(255) NOT NULL,
  `category_id` varchar(250) NOT NULL,
  `wrapper_name` varchar(255) NOT NULL,
  `wrapper_price` double NOT NULL,
  `wrapper_image` varchar(255) NOT NULL,
  `createdate` int(11) NOT NULL,
  `wrapper_use_to_all` tinyint(4) NOT NULL,
  `published` tinyint(4) NOT NULL,
  PRIMARY KEY (`wrapper_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP Wrapper';



# Dump of table #__redshop_xml_export
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_xml_export`;

CREATE TABLE `#__redshop_xml_export` (
  `xmlexport_id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) NOT NULL,
  `display_filename` varchar(255) NOT NULL,
  `parent_name` varchar(255) NOT NULL,
  `section_type` varchar(255) NOT NULL,
  `auto_sync` tinyint(4) NOT NULL,
  `sync_on_request` tinyint(4) NOT NULL,
  `auto_sync_interval` int(11) NOT NULL,
  `xmlexport_date` int(11) NOT NULL,
  `xmlexport_filetag` text NOT NULL,
  `element_name` varchar(255) DEFAULT NULL,
  `published` tinyint(4) NOT NULL,
  `use_to_all_users` tinyint(4) NOT NULL,
  `xmlexport_billingtag` text NOT NULL,
  `billing_element_name` varchar(255) NOT NULL,
  `xmlexport_shippingtag` text NOT NULL,
  `shipping_element_name` varchar(255) NOT NULL,
  `xmlexport_orderitemtag` text NOT NULL,
  `orderitem_element_name` varchar(255) NOT NULL,
  `xmlexport_stocktag` text NOT NULL,
  `stock_element_name` varchar(255) NOT NULL,
  `xmlexport_prdextrafieldtag` text NOT NULL,
  `prdextrafield_element_name` varchar(255) NOT NULL,
  PRIMARY KEY (`xmlexport_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP XML Export';



# Dump of table #__redshop_xml_export_ipaddress
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_xml_export_ipaddress`;

CREATE TABLE `#__redshop_xml_export_ipaddress` (
  `xmlexport_ip_id` int(11) NOT NULL AUTO_INCREMENT,
  `xmlexport_id` int(11) NOT NULL,
  `access_ipaddress` varchar(255) NOT NULL,
  PRIMARY KEY (`xmlexport_ip_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP XML Export Ip Address';



# Dump of table #__redshop_xml_export_log
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_xml_export_log`;

CREATE TABLE `#__redshop_xml_export_log` (
  `xmlexport_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `xmlexport_id` int(11) NOT NULL,
  `xmlexport_filename` varchar(255) NOT NULL,
  `xmlexport_date` int(11) NOT NULL,
  PRIMARY KEY (`xmlexport_log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP XML Export log';



# Dump of table #__redshop_xml_import
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_xml_import`;

CREATE TABLE `#__redshop_xml_import` (
  `xmlimport_id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) NOT NULL,
  `display_filename` varchar(255) NOT NULL,
  `xmlimport_url` varchar(255) NOT NULL,
  `section_type` varchar(255) NOT NULL,
  `auto_sync` tinyint(4) NOT NULL,
  `sync_on_request` tinyint(4) NOT NULL,
  `auto_sync_interval` int(11) NOT NULL,
  `override_existing` tinyint(4) NOT NULL,
  `add_prefix_for_existing` varchar(50) NOT NULL,
  `xmlimport_date` int(11) NOT NULL,
  `xmlimport_filetag` text NOT NULL,
  `xmlimport_billingtag` text NOT NULL,
  `xmlimport_shippingtag` text NOT NULL,
  `xmlimport_orderitemtag` text NOT NULL,
  `xmlimport_stocktag` text NOT NULL,
  `xmlimport_prdextrafieldtag` text NOT NULL,
  `published` tinyint(4) NOT NULL,
  `element_name` varchar(255) NOT NULL,
  `billing_element_name` varchar(255) NOT NULL,
  `shipping_element_name` varchar(255) NOT NULL,
  `orderitem_element_name` varchar(255) NOT NULL,
  `stock_element_name` varchar(255) NOT NULL,
  `prdextrafield_element_name` varchar(255) NOT NULL,
  `xmlexport_billingtag` text NOT NULL,
  `xmlexport_shippingtag` text NOT NULL,
  `xmlexport_orderitemtag` text NOT NULL,
  PRIMARY KEY (`xmlimport_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP XML Import';



# Dump of table #__redshop_xml_import_log
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_xml_import_log`;

CREATE TABLE `#__redshop_xml_import_log` (
  `xmlimport_log_id` int(11) NOT NULL AUTO_INCREMENT,
  `xmlimport_id` int(11) NOT NULL,
  `xmlimport_filename` varchar(255) NOT NULL,
  `xmlimport_date` int(11) NOT NULL,
  PRIMARY KEY (`xmlimport_log_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='redSHOP XML Import log';



# Dump of table #__redshop_zipcode
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__redshop_zipcode`;

CREATE TABLE `#__redshop_zipcode` (
  `zipcode_id` int(11) NOT NULL AUTO_INCREMENT,
  `country_code` varchar(10) NOT NULL DEFAULT '',
  `state_code` varchar(10) NOT NULL DEFAULT '',
  `city_name` varchar(64) DEFAULT NULL,
  `zipcode` varchar(255) DEFAULT NULL,
  `zipcodeto` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`zipcode_id`),
  KEY `zipcode` (`zipcode`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__template_styles
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__template_styles`;

CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__template_styles` WRITE;
/*!40000 ALTER TABLE `#__template_styles` DISABLE KEYS */;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`)
VALUES
	(2,'bluestork',1,'1','Bluestork - Default','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}'),
	(3,'atomic',0,'0','Atomic - Default','{}'),
	(4,'beez_20',0,'0','Beez2 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),
	(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),
	(6,'beez5',0,'0','Beez5 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"html5\":\"0\"}'),
	(7,'ja_purity',0,'0','ja_purity',''),
	(8,'jb_shopignition',0,'0','jb_shopignition',''),
	(9,'rhuk_milkyway',0,'0','rhuk_milkyway',''),
	(10,'jb_shopignition',0,'1','JB_Shopignition - Default','{\"debug\":\"0\",\"legacy\":\"1\",\"zenTranslate\":\"1\",\"removejblogo\":\"0\",\"customcopyright\":\"\",\"hilite\":\"hiliteBlue\",\"tiendaCSS\":\"0\",\"redshopCSS\":\"1\",\"overwriteCSS\":\"1\",\"firstcolorelement\":\"\",\"firstcolorAtt\":\"color\",\"firstcolor\":\"\",\"secondcolorelement\":\"\",\"secondcolorAtt\":\"color\",\"secondcolor\":\"\",\"thirdcolorelement\":\"\",\"thirdcolorAtt\":\"color\",\"thirdcolor\":\"\",\"fourthcolorelement\":\"\",\"fourthcolorAtt\":\"color\",\"fourthcolor\":\"\",\"fifthcolorelement\":\"\",\"fifthcolorAtt\":\"color\",\"fifthecolor\":\"\",\"sixthcolourelement\":\"\",\"sixthcolorAtt\":\"color\",\"sixthcolor\":\"\",\"extraCSS\":\"\",\"logoType\":\"image\",\"logoWidth\":\"four\",\"logoLink\":\"\",\"logoClass\":\"h1\",\"logoPosition\":\"above\",\"logoAlign\":\"zencenter\",\"logoText\":\"Shop Ignition\",\"fontStackLogo\":\"Rochester\",\"logoFontSize\":\"2em\",\"logoColour\":\"\",\"logoFile\":\"images\\/logo\\/logo.png\",\"logoAltTag\":\"\",\"enableTagline\":\"1\",\"tagline\":\"A shopping template for Joomla\",\"taglineTop\":\"-15px\",\"taglineLeft\":\"20px\",\"taglineCSS\":\"\",\"fonts\":\"1\",\"fontSize\":\"78%\",\"fontStackBody\":\"helvetica\",\"fontStackHeading\":\"gillsans\",\"fontStackNav\":\"helvetica\",\"fontStackSelector1\":\"\",\"fontStackCustom1\":\"helvetica\",\"fontStackSelector2\":\"\",\"fontStackCustom2\":\"helvetica\",\"fontStackSelector3\":\"\",\"fontStackCustom3\":\"helvetica\",\"typekit\":\"1\",\"typekitId\":\"\",\"bodyclassOption\":\"1\",\"bodyclassView\":\"1\",\"bodyclassLayout\":\"1\",\"bodyclassTask\":\"1\",\"bodyclassItem\":\"1\",\"bodyclassMainWidth\":\"1\",\"containerPosition\":\"center\",\"layoutType\":\"fixed\",\"tWidth\":\"980\",\"containerMargin\":\"0\",\"allEqual\":\"0\",\"controlMainArea\":\"1\",\"topEqual\":\"1\",\"top1Width\":\"six\",\"top2Width\":\"0\",\"top3Width\":\"0\",\"top4Width\":\"six\",\"headerEqual\":\"0\",\"header1Width\":\"three\",\"header2Width\":\"three\",\"header3Width\":\"three\",\"header4Width\":\"two\",\"grid1Equal\":\"0\",\"grid1Width\":\"nine\",\"grid2Width\":\"three\",\"grid3Width\":\"three\",\"grid4Width\":\"three\",\"grid4WidthPx\":\"\",\"grid4Height\":\"\",\"grid2Equal\":\"1\",\"grid5Width\":\"three\",\"grid6Width\":\"three\",\"grid7Width\":\"three\",\"grid8Width\":\"three\",\"grid3Equal\":\"0\",\"grid9Width\":\"twelve\",\"grid10Width\":\"four\",\"grid11Width\":\"four\",\"grid12Width\":\"four\",\"grid4Equal\":\"1\",\"grid13Width\":\"three\",\"grid14Width\":\"three\",\"grid15Width\":\"three\",\"grid16Width\":\"three\",\"grid5Equal\":\"1\",\"grid17Width\":\"three\",\"grid18Width\":\"three\",\"grid19Width\":\"three\",\"grid20Width\":\"three\",\"grid6Equal\":\"1\",\"grid21Width\":\"three\",\"grid22Width\":\"three\",\"grid23Width\":\"three\",\"grid24Width\":\"three\",\"bottomEqual\":\"0\",\"bottom1Width\":\"two\",\"bottom2Width\":\"two\",\"bottom3Width\":\"two\",\"bottom4Width\":\"two\",\"bottom5Width\":\"four\",\"bottom6Width\":\"four\",\"footerWidth\":\"eight\",\"navposition\":\"left\",\"navWidth\":\"twelve\",\"mainLayout\":\"two\",\"leftCols2L\":\"four\",\"midCols2L\":\"eight\",\"midCols2R\":\"nine\",\"rightCols2R\":\"three\",\"leftCols3LR\":\"three\",\"midCols3LR\":\"six\",\"rightCols3LR\":\"three\",\"leftCols4LRC\":\"three\",\"midCols4LRC\":\"six\",\"centerCols4LRC\":\"three\",\"rightCols4LRC\":\"three\",\"leftCols3LC\":\"three\",\"centerCols3LC\":\"three\",\"midCols3LC\":\"three\",\"midCols3RC\":\"three\",\"centerCols3RC\":\"three\",\"rightCols3RC\":\"three\",\"banner\":\"1\",\"bottom\":\"1\",\"closeContainer\":\"1\",\"footer\":\"1\",\"frontpage\":\"1\",\"grid1\":\"1\",\"grid2\":\"1\",\"grid3\":\"1\",\"grid4\":\"1\",\"grid5\":\"1\",\"grid6\":\"1\",\"header\":\"1\",\"main\":\"1\",\"nav\":\"1\",\"zentabs\":\"1\",\"openContainer\":\"1\",\"panel\":\"1\",\"top\":\"1\",\"superfish\":\"1\",\"sfEffect\":\"1\",\"sfSpeed\":\"normal\",\"sfhover\":\"1\",\"sfDelay\":\"800\",\"sfMinWidth\":\"14\",\"sfMaxWidth\":\"17\",\"panelMenu\":\"1\",\"splitMenu\":\"0\",\"splitMenuName\":\"mainmenu\",\"splitMenuNavPos\":\"none\",\"splitMenuNavStart\":\"0\",\"splitMenuNavEnd\":\"1\",\"splitMenuNav\":\"0\",\"splitMenuSubNavStart\":\"0\",\"splitMenuSubNavEnd\":\"1\",\"splitMenuAbove\":\"0\",\"splitMenuAboveStart\":\"0\",\"splitMenuAboveEnd\":\"1\",\"splitMenuLeft\":\"0\",\"splitMenuLeftTitle\":\"In this section ...\",\"splitMenuLeftStart\":\"1\",\"splitMenuLeftEnd\":\"2\",\"splitMenuRight\":\"0\",\"splitMenuRightTitle\":\"In this section ...\",\"splitMenuRightStart\":\"2\",\"splitMenuRightEnd\":\"3\",\"csscompress\":\"0\",\"k2CSS\":\"0\",\"combinescripts\":\"0\",\"bottomScripts\":\"0\",\"removeMootools\":\"0\",\"removeModal\":\"0\",\"removeK2\":\"0\",\"moduleslide\":\"0\",\"jQueryVersion\":\"1.7.0\",\"jQuerySource\":\"local\",\"noConflict\":\"1\",\"stripCustom\":\"0\",\"customScripts\":\"\",\"removeJgen\":\"0\",\"disableTP\":\"0\",\"analyticsPosition\":\"after\",\"analytics\":\"\",\"extraScripts\":\"\",\"pngfix\":\"0\",\"pngfixrules\":\".pathway img,#logo a img,.topInner,.jbLogo,#topShadow,.slideShowNav.indexNavButtons  a.activeSlide,#slideShowNav.indexNavButtons  a:hover,div.jbReadmore,.mbMoreFlat .readon,.itemRatingList,.itemRatingList a:hover,.itemRatingList .itemCurrentRating,.k2ReadMore\",\"ie6Warning\":\"0\",\"openPanel\":\"Customer Login\",\"closePanel\":\"Logout\",\"paneltype\":\"height\",\"panelHeight\":\"200\",\"panelWidth\":\"300\",\"tab1Title\":\"Featured\",\"jbTab1Icon\":\"heart\",\"tab2Title\":\"Shipping\",\"jbTab2Icon\":\"lightbulb\",\"tab3Title\":\"Orders\",\"jbTab3Icon\":\"email\",\"tab4Title\":\"Newsletter\",\"jbTab4Icon\":\"article\",\"socialicons\":\"1\",\"socialiconstitle\":\"\",\"socialiconsposition\":\"footer\",\"socialalign\":\"zenleft\",\"icon1Image\":\"twitter.png\",\"icon1Link\":\"#\",\"icon2Image\":\"flickr.png\",\"icon2Link\":\"#\",\"icon3Image\":\"facebook.png\",\"icon3Link\":\"#\",\"icon4Image\":\"-1\",\"icon4Link\":\"#\",\"icon5Image\":\"-1\",\"icon5Link\":\"#\",\"icon6Image\":\"-1\",\"icon6Link\":\"#\",\"lazyLoad\":\"1\",\"lazyloadSelector\":\"\",\"scrolltop\":\"0\",\"mediaqueries\":\"0\",\"mobileMeta\":\"0\",\"mobilemenu\":\"0\",\"topMob\":\"0\",\"headerMob\":\"0\",\"logoMob\":\"0\",\"navMob\":\"0\",\"bannerMob\":\"0\",\"tabMob\":\"0\",\"grid1Mob\":\"0\",\"grid2Mob\":\"0\",\"grid3Mob\":\"0\",\"grid4Mob\":\"0\",\"grid5Mob\":\"0\",\"grid6Mob\":\"0\",\"bottomMob\":\"0\"}');

/*!40000 ALTER TABLE `#__template_styles` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__usergroups
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__usergroups`;

CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__usergroups` WRITE;
/*!40000 ALTER TABLE `#__usergroups` DISABLE KEYS */;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`)
VALUES
	(1,0,1,20,'Public'),
	(2,1,6,17,'Registered'),
	(3,2,7,14,'Author'),
	(4,3,8,11,'Editor'),
	(5,4,9,10,'Publisher'),
	(6,1,2,5,'Manager'),
	(7,6,3,4,'Administrator'),
	(8,1,18,19,'Super Users');

/*!40000 ALTER TABLE `#__usergroups` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__viewlevels
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__viewlevels`;

CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__viewlevels` WRITE;
/*!40000 ALTER TABLE `#__viewlevels` DISABLE KEYS */;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`)
VALUES
	(1,'Public',0,'[1]'),
	(2,'Registered',1,'[6,2,8]'),
	(3,'Special',2,'[6,3,8]');

/*!40000 ALTER TABLE `#__viewlevels` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__weblinks
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__weblinks`;

CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;




/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
